#include <bits/stdc++.h>

using namespace std;

typedef long long ll;

const int maxn = (1 << 19);
const int inf = 1.5e9;

int rmax[2 * maxn + 10], rmaxpos[2 * maxn + 10];
int lmin[2 * maxn + 10], lminpos[2 * maxn + 10];

int n;
int a[maxn];
int dp[maxn];

pair <int, int> getrmax(int l, int r, int x = 1, int L = 0, int R = maxn) {
    if (r <= L || R <= l)
        return {-1, -1};
    if (l <= L && R <= r)
        return {rmax[x], rmaxpos[x]};
    pair <int, int> t1 = getrmax(l, r, 2 * x, L, (L + R) / 2);
    pair <int, int> t2 = getrmax(l, r, 2 * x + 1, (L + R) / 2, R);

    if (t1.first > t2.first)
        return t1;
    else
        return t2;
}

pair <int, int> getlmin(int l, int r, int x = 1, int L = 0, int R = maxn) {
    if (r <= L || R <= l)
        return {inf, inf};
    if (l <= L && R <= r)
        return {lmin[x], lminpos[x]};
    pair <int, int> t1 = getlmin(l, r, 2 * x, L, (L + R) / 2);
    pair <int, int> t2 = getlmin(l, r, 2 * x + 1, (L + R) / 2, R);

    if (t1.first <= t2.first)
        return t1;
    else
        return t2;
}

void fillrmax(int x = 1, int L = 0, int R = maxn) {
    if (R == L + 1) {
        //if (L < n) cout << L << " ";
        if (L >= n)
            rmax[x] = rmaxpos[x] = -1;
        else {
            rmax[x] = a[L];
            rmaxpos[x] = L;
        }
        return;
    }
    fillrmax(2 * x, L, (L + R) / 2);
    fillrmax(2 * x + 1, (L + R) / 2, R);
    if (rmax[2 * x] > rmax[2 * x + 1]) {
        rmax[x] = rmax[2 * x];
        rmaxpos[x] = rmaxpos[2 * x];
    }
    else {
        rmax[x] = rmax[2 * x + 1];
        rmaxpos[x] = rmaxpos[2 * x + 1];
    }
}

void filllmin(int x = 1, int L = 0, int R = maxn) {
    if (R == L + 1) {
        //if (L < n) cout << L << " ";
        if (L >= n)
            lmin[x] = lminpos[x] = inf;
        else {
            lmin[x] = a[L];
            lminpos[x] = L;
        }
        return;
    }
    filllmin(2 * x, L, (L + R) / 2);
    filllmin(2 * x + 1, (L + R) / 2, R);
    if (lmin[2 * x] <= lmin[2 * x + 1]) {
        lmin[x] = lmin[2 * x];
        lminpos[x] = lminpos[2 * x];
    }
    else {
        lmin[x] = lmin[2 * x + 1];
        lminpos[x] = lminpos[2 * x + 1];
    }
}

int minrazb(int l, int r) {
    pair <int, int> tmp = getrmax(l, r);
    if (tmp.second != r - 1)
        return minrazb(l, tmp.second + 1) + minrazb(tmp.second + 1, r);
    tmp = getlmin(l, r);
    if (tmp.second != l)
        return minrazb(l, tmp.second) + minrazb(tmp.second, r);
    return 1;
}

int main()
{
    //freopen("input.txt", "r", stdin);
    ios_base::sync_with_stdio(0);

    cin >> n;
    for (int i = 0; i < n; i++)
        cin >> a[i];
    fillrmax();
    filllmin();
    cout << minrazb(0, n);
    return 0;
}
