#define _CRT_SECURE_NO_WARNINGS

#include <iostream>
#include <stdio.h>
#include <vector>
#include <algorithm>

using namespace std;

typedef long long ll;

ll ans = 0;
int n;
vector <ll > a;

ll sum(int j, int i)
{
	if (i < j || i >= n)
		return 0;
	ll summ = a[i] * (n - i) + a[j] * (i - j);
	ans = max(summ, ans);
	return summ;
}

void get(int i)
{
	int l = i - 2, r = n + 1, m1, m2;
	while (l + 2 < r)
	{
		m1 = l + (r - l) / 3;
		m2 = r - (r - l) / 3;
		ll sum1 = sum(i, m1);
		ll sum2 = sum(i, m2);
		if (sum1 < sum2)
			l = m1;
		else
			r = m2;
	}
	ans = max(ans, max(sum(i, l + 2), max(sum(i, l), sum(i, l + 1))));
}

void play()
{
	for (int i = 0; i < n; i++)
		get(i);
}


int main()
{
	ios_base::sync_with_stdio(0), cin.tie(0);
	//freopen("input.txt", "r", stdin);
	//freopen("output.txt", "w", stdout);
	cin >> n;
	a.resize(n);
	for (int i = 0; i < n; i++)
		cin >> a[i] >> a[i];
	sort(a.begin(), a.end());

	play();

	cout << ans;
	return 0;
}