﻿#include "stdafx.h"

#pragma GCC optimize ("Ofast")

#include <fstream>
#include <vector>
#include <set>
#include <math.h>
#include <algorithm>
#include <stack>
#include <random>
#include <string>

using namespace std;

#ifdef _DEBUG
ifstream cin("input.txt");
ofstream cout("output.txt");
#else
#include <iostream>
#endif

typedef pair <int, int> pii;

#define mp make_pair
#define i_o ios_base::sync_with_stdio(false), cin.tie(NULL), cout.tie(NULL)
#define all(a) a.begin(), a.end()

int n;
vector <vector <int> > a;

bool cmp(int x, int y, int st) {
	for (int i = st; i < a[x].size(); i++) {
		if (a[x][i] != a[y][i]) return a[x][i] < a[y][i];
	}
	return true;
}

bool check(vector <int> ans) {
	vector <bool> take(ans.size(), false);
	for (int i = 0; i < ans.size(); i++) {
		int cnt = 0;
		for (int j = 0; j < n; j++) {
			if (!take[j]) cnt += a[j][i];
		}
		if (cnt == ans[i]) continue;
		if (cnt > ans[i]) return false;
		int v = -1;
		for (int j = 0; j < n; j++) {
			if (take[j]) continue;
			if (v == -1 || cmp(v, j, i + 1)) {
				v = j;
			}
		}
		if (v == -1) return true;
		take[v] = true;
	}
	return true;
}

int main() {
	cin >> n;
	int MAXL = -1;
	a.resize(n);
	for (int i = 0; i < n; i++) {
		string s;
		cin >> s;
		MAXL = max(MAXL, (int)s.size());
		for (auto c : s) a[i].push_back(c - '0');
	}
	MAXL++;
	for (int i = 0; i < n; i++) {
		reverse(all(a[i]));
		while (a[i].size() < MAXL) a[i].push_back(0);
		reverse(all(a[i]));
	}
	vector <int> ans(MAXL, 1);
	for (int i = 0; i < ans.size(); i++) {
		ans[i] = 0;
		if (!check(ans)) ans[i] = 1;
	}
	reverse(all(ans));
	while (ans.back() == 0 && ans.size() >= 2) ans.pop_back();
	reverse(all(ans));
	for (auto c : ans) cout << c;
}