#include <bits/stdc++.h>
using namespace std;

const int INF = 2000000000;
int n;
vector<int> a;
vector<int> xs;
vector<int> fv;

int count(int i, int s1, int s2) {
    int ans = 0;
    int ti = INF;
    if (s1 != -1) {
        ti = min(ti, a[i] + abs(i - s1));
        if (i <= s1) {
            ti = a[i];
        }
    }
    if (s2 != -1) {
        ti = min(ti, a[i] + abs(i - s2));
        if (i >= s2) {
            ti = a[i];
        }
    }

    for (int j = 0; j < n; j++) {
        int tj = INF;
        if (s1 != -1) {
            tj = min(tj, a[j] + abs(j - s1));
            if (j <= s1) {
                tj = a[j];
            }
        }
        if (s2 != -1) {
            tj = min(tj, a[j] + abs(j - s2));
            if (j >= s2) {
                tj = a[j];
            }
        }
        if (tj < ti) {
            ans++;
        }
    }

    return ans;
}

void clear() {
    fv.assign(xs.size(), 0);
}

inline int coord(int x) {
    return lower_bound(xs.begin(), xs.end(), x) - xs.begin();
}

void add(int x) {
    int i = coord(x);
    while (i < fv.size()) {
        fv[i]++;
        i = i | (i + 1);
    }
}

void rem(int x) {
    int i = coord(x);
    while (i < fv.size()) {
        fv[i]--;
        i = i | (i + 1);
    }
}

int get(int x) {
    int i = coord(x) - 1;
    int s = 0;
    while (i >= 0) {
        s += fv[i];
        i = (i & (i + 1)) - 1;
    }
    return s;
}

int main() {
#ifdef DEBUG
    freopen("input", "r", stdin);
#endif
    ios::sync_with_stdio(0);
    cin.tie(0);

    int p;
    cin >> n >> p;
    if (p == 1) {
        return 1;
    }
    a.resize(n);
    for (int i = 0; i < n; i++) {
        cin >> a[i];
    }

    vector<int> ans1(n), ans2(n);

    vector<pair<int, int>> ord(n);
    for (int i = 0; i < n; i++) {
        ord[i] = {a[i] + n - 1 - i, i};
    }
    sort(ord.begin(), ord.end());
    int eq = 0;
    for (int i = 0; i < ord.size(); i++) {
        if (i > 0 && ord[i].first == ord[i - 1].first) {
            eq++;
        } else {
            eq = 0;
        }

        if (ord[i].second < n / 2) {
            int j = ord[i].second;
            ans1[j] = i - eq;
        }
    }

    for (int i = 0; i < n; i++) {
        ord[i] = {a[i] + i, i};
    }
    sort(ord.begin(), ord.end());
    eq = 0;
    for (int i = 0; i < ord.size(); i++) {
        if (i > 0 && ord[i].first == ord[i - 1].first) {
            eq++;
        } else {
            eq = 0;
        }

        if (ord[i].second >= n / 2) {
            int j = ord[i].second;
            ans1[j] = i - eq;
        }
    }

    for (int i = 0; i < n; i++) {
        xs.push_back(a[i]);
        xs.push_back(a[i] - i);
        xs.push_back(a[i] + i);
    }
    sort(xs.begin(), xs.end());
    xs.resize(unique(xs.begin(), xs.end()) - xs.begin());

    clear();
    for (int i = 0; i < n / 2; i++) {
        ans2[i] += get(a[i] + i);
        add(a[i] + i);
    }
    clear();
    for (int i = 0; i < n; i++) {
        add(a[i]);
    }
    add(a[0] + n - 1 - 0);
    for (int i = 0; i < n / 2; i++) {
        ans2[i] += get(a[i] + i);
        if (i + 1 < n / 2) {
            rem(a[2 * i]);
            rem(a[2 * i + 1]);
            add(a[2 * i] + n - 1 - 2 * i);
            add(a[2 * i + 1] + n - 1 - 2 * i - 1);
            rem(a[i] + n - 1 - i);
        }
    }

    for (int i = n / 2; i < n; i++) {
        ans2[i] = count(i, n - 1 - 2 * (n - 1 - i), n - 1);
    }


    for (int i = 0; i < n; i++) {
        cout << max(ans1[i], ans2[i]) + 1 << "\n";
    }

    return 0;
}
