#include <bits/stdc++.h>
using namespace std;

int n;

bool cmp(string &s1, string &s2) {
    if (s1.length() != s2.length()) {
        return s1.length() < s2.length();
    }
    int l = s1.length();
    for (int i = l - 1; i >= 0; i--) {
        if (s1[i] != s2[i]) {
            return s1[i] < s2[i];
        }
    }
    return false;
}

bool check(int p, vector<vector<string>> &a) {
    auto b = a;
    int cmx = ((int) b.size()) - 1;
    for (int i = p; i >= 1; i--) {
        if (cmx > 0) {
            if (cmx > i) {
                return false;
            }

            if (cmx == i) {
                if (b[cmx].size() > 1) {
                    return false;
                }

                b[cmx][0].pop_back();
                while (!b[cmx][0].empty() && b[cmx][0].back() == '0') {
                    b[cmx][0].pop_back();
                }
                int sz1 = b[cmx][0].size();
                b[sz1].push_back(b[cmx][0]);
                b[cmx].pop_back();
                int j = b[sz1].size() - 1;
                while (j > 0 && cmp(b[sz1][j], b[sz1][j - 1])) {
                    swap(b[sz1][j], b[sz1][j - 1]);
                    j--;
                }

                while (cmx > 0 && b[cmx].empty()) {
                    b.pop_back();
                    cmx--;
                }
            } else {
                b[cmx].pop_back();
                while (cmx > 0 && b[cmx].empty()) {
                    b.pop_back();
                    cmx--;
                }
            }
        }
    }

    return cmx <= 0;
}

string get2(string s1, string s2) {
    int b = s1.length();
    while (s2.length() < s1.length()) {
        s2.push_back('0');
    }
    int v = 1;
    while (v != 0) {
        if (b < s2.length()) {
            if (s2[b] == '0') {
                s2[b] = '1';
                v = 0;
            } else {
                s2[b] = '0';
                b++;
            }
        } else {
            s2.push_back('1');
            v = 0;
        }
    }
    reverse(s2.begin(), s2.end());
    return s2;
}

int main() {
#ifdef DEBUG
    freopen("input", "r", stdin);
#endif
    ios::sync_with_stdio(0);
    cin.tie(0);

    vector<vector<string>> a;

    cin >> n;

    if (n == 2) {
        string s1, s2;
        cin >> s1 >> s2;
        reverse(s1.begin(), s1.end());
        reverse(s2.begin(), s2.end());

        if (cmp(s2, s1)) {
            swap(s1, s2);
        }
        bool ok = true;
        for (int i = 0; i < s1.length(); i++) {
            if (s1[i] == '1' && s2[i] == '1') {
                ok = false;
            }
        }
        if (ok) {
            string ans = s2;
            for (int i = 0; i < s1.length(); i++) {
                if (s1[i] == '1') {
                    ans[i] = '1';
                }
            }
            reverse(ans.begin(), ans.end());
            cout << ans << endl;
        } else {
            auto v1 = get2(s1, s2);
            auto v2 = get2(s2, s1);
            if (cmp(v1, v2)) {
                reverse(v1.begin(), v1.end());
                cout << v1 << endl;
            } else {
                reverse(v2.begin(), v2.end());
                cout << v2 << endl;
            }
        }

        return 0;
    }

    for (int i = 0; i < n; i++) {
        string s;
        cin >> s;
        reverse(s.begin(), s.end());
        while (a.size() <= s.length()) {
            a.push_back(vector<string> ());
        }

        a[s.length()].push_back(s);
    }

    int mxl = a.size() + n + 1;
    string ans;
    for (int i = mxl; i >= 1; i--) {
        if (check(i - 1, a)) {
            ans.push_back('0');
        } else {
            ans.push_back('1');

            int cmx = ((int) a.size()) - 1;
            if (cmx > 0) {
                if (cmx == i) {
                    a[cmx][0].pop_back();
                    while (!a[cmx][0].empty() && a[cmx][0].back() == '0') {
                        a[cmx][0].pop_back();
                    }
                    int sz1 = a[cmx][0].size();
                    a[sz1].push_back(a[cmx][0]);
                    a[cmx].pop_back();
                    int j = a[sz1].size() - 1;
                    while (j > 0 && cmp(a[sz1][j], a[sz1][j - 1])) {
                        swap(a[sz1][j], a[sz1][j - 1]);
                        j--;
                    }

                    while (cmx > 0 && a[cmx].empty()) {
                        a.pop_back();
                        cmx--;
                    }
                } else {
                    a[cmx].pop_back();
                    while (cmx > 0 && a[cmx].empty()) {
                        a.pop_back();
                        cmx--;
                    }
                }
            }
        }
    }

    int i = 0;
    while (ans[i] == '0') {
        i++;
    }
    cout << ans.substr(i) << endl;

    return 0;
}