import java.util.Scanner;

import static java.lang.Math.max;

public class D {
    public static void main(String[] args) {
        Scanner in = new Scanner(System.in);
        int n = in.nextInt();
        int m = in.nextInt();
        int k = in.nextInt();
        int mas[][] = new int[n][m];
        for (int i = 0; i < k; i++) {
            mas[in.nextInt() - 1][in.nextInt() - 1] = i + 1;
        }
        long step[] = new long[1 + max(n, m)];
        step[0] = 1;
        for (int i = 1; i < step.length; i++) {
            step[i] = 2 * step[i - 1];
        }
        long ans[][] = new long[n][m];
        long ans1[][] = new long[n][m];
        for (int i = 0; i < n; i++) {
            for (int j = 0; j < m; j++) {
                ans[i][j] = 1000_000_000_000_000l;
                for (int l = 0; l <= i; l++) {
                    for (int o = 0; o <= j; o++) {
                        if (ans[l][o] + step[max(i - l, j - o)] < ans[i][j] && mas[l][o] > 0) {
                            ans[i][j] = ans[l][o] + step[max(i - l, j - o)];
                            ans1[i][j] = ans1[l][o] + 1;
                        }
                    }
                }
                ans[0][0] = 0;
                ans1[0][0] = 1;
            }
        }
        System.out.println(ans1[n - 1][m - 1]);
        int x = n - 1;
        int y = m - 1;
        int uk = 1;
        int er[] = new int[k];
        er[0]=k;
        while (x != 0 || y != 0) {
            for (int i = 0; i <= x; i++) {
                for (int j = 0; j <= y; j++) {
                    if (ans[i][j] + step[max(x - i, y - j)] == ans[x][y] && mas[i][j] > 0) {
                        er[uk++] = mas[i][j];
                        x = i;
                        y = j;
                        j = y + 1;
                        i = x + 1;
                    }
                }
            }
        }
        for (int i = uk-1; i >= 0; i--) {
            System.out.print(er[i] + " ");
        }
    }
}
/*
4 5 3
1 1
2 3
4 5
 */