#include <bits/stdc++.h>
#define ll long long
#define mp make_pair
#define pb push_back
#define X first
#define Y second
#define pii pair<int, int>

using namespace std;

int solve();

int main()
{
    ios_base::sync_with_stdio(0); cin.tie(0); cout.tie(0);
    #ifdef DEBUG
        freopen("input.txt", "r", stdin);
        freopen("output.txt", "w", stdout);
    #endif // DEBUG
    solve();
    return 0;
}

const int MAXN = (int)2e5 + 10;

int w[MAXN];
int h[MAXN];
bool wf[MAXN];
bool hf[MAXN];
vector<vector<int>> a;

int solve()
{
    int n, m, q;
    cin >> n >> m >> q;
    a.resize(n + 1);
    for (int i = 0; i < n + 1; i++)
        a[i].resize(m + 1);
    for (int i = 1; i <= n; i++)
        for (int j = 1; j <= m; j++)
            cin >> a[i][j];
    for (int i = 1; i <= n; i++)
    {
        for (int j = 1; j <= m; j++)
            if (a[i][j] > a[i][w[i]])
                w[i] = j;
    }
    for (int j = 1; j <= m; j++)
    {
        for (int i = 1; i <= n; i++)
            if (a[i][j] > a[h[j]][j])
                h[j] = i;
    }
    int ans = 0;
    for (int i = 1; i <= n; i++)
        for (int j = 1; j <= m; j++)
            if (w[i] == j && h[j] == i)
            {
                ans += 2;
                wf[i] = 1;
                hf[j] = 1;
            }
    while(q--)
    {
        int i, j, x;
        cin >> i >> j >> x;
        if (h[j] == i && w[i] == j)
        {
            a[i][j] = x;
            cout << ans / 2 << endl;
            continue;
        }
        int max_i = w[i], max_j = h[j];
        ans -= wf[i]; ans -= hf[j];
        wf[i] = 0; hf[j] = 0;
        a[i][j] = x;
        if (a[i][j] > a[h[j]][j])
            h[j] = i;
        if (a[i][j] > a[i][w[i]])
            w[i] = j;
        if (w[i] == j && h[j] == i)
        {
            ans += 2;
            wf[i] = 1;
            hf[j] = 1;
        }
        else
            if (w[max_j] == j && h[j] == max_j)
            {
                ans += 2;
                wf[max_j] = 1;
                hf[j] = 1;
            }
            else
            if (w[i] == max_i && h[max_i] == i)
            {
                ans += 2;
                wf[i] = 1;
                hf[max_i] = 1;
            }
        cout << ans / 2 << endl;
    }
}

