import java.io.BufferedReader;
import java.io.IOException;
import java.io.InputStreamReader;
import java.io.StreamTokenizer;
import java.math.BigInteger;
import java.util.ArrayList;

public class Main {

    static StreamTokenizer in = new StreamTokenizer(new InputStreamReader(System.in));

    static int nextInt() throws IOException {
        in.nextToken();
        return (int)(in.nval);
    }

    public static void main(String[] args) throws IOException {
        int n = nextInt(), m = nextInt(), k = nextInt();
        n = Math.max(n, m);
        ArrayList<Integer> xs = new ArrayList<>(), ys = new ArrayList<>();
        for (int i = 0; i < k; i++) {
            int x = nextInt(), y = nextInt();
            xs.add(x);
            ys.add(y);
        }
        ArrayList<BigInteger> pow2 = new ArrayList<>();
        pow2.add(BigInteger.ONE);
        BigInteger two = new BigInteger("2");
        for (int i = 0; i < n; i++) {
            pow2.add(pow2.get(i).multiply(two));
        }
        ArrayList<ArrayList<BigInteger>> g = new ArrayList<>();
        for (int i = 0; i < k; i++) {
            g.add(new ArrayList<>());
            for (int j = 0; j < k; j++) {
                g.get(i).add(pow2.get(Math.max(Math.abs(xs.get(i) - xs.get(j)), Math.abs(ys.get(i) - ys.get(j)))));
            }
        }
        ArrayList<BigInteger> dist = new ArrayList<>();
        dist.add(BigInteger.ZERO);
        for (int i = 0; i < k - 1; i++) {
            dist.add(pow2.get(n));
        }
        ArrayList<Boolean> used = new ArrayList<>();
        for (int i = 0; i < k; i++) {
            used.add(false);
        }
        ArrayList<Integer> anc = new ArrayList<>();
        for (int i = 0; i < k; i++) {
            anc.add(-1);
        }
        for (int i = 0; i < k; i++) {
            int pos = -1;
            for (int j = 0; j < k; j++) {
                if (!used.get(j) && (pos == -1 || dist.get(pos).compareTo(dist.get(j)) > 0)) {
                    pos = j;
                }
            }
            used.set(pos, true);
            for (int j = 0; j < k; j++) {
                if (dist.get(j).compareTo(dist.get(pos).add(g.get(pos).get(j))) > 0) {
                    dist.set(j, dist.get(pos).add(g.get(pos).get(j)));
                    anc.set(j, pos);
                }
            }
        }
        ArrayList<Integer> way = new ArrayList<>();
        int pos = k - 1;
        while (pos != -1)
        {
            way.add(pos);
            pos = anc.get(pos);
        }
        System.out.println(way.size());
        for (int i = way.size() - 1; i >= 0; i--) {
            System.out.print(way.get(i) + 1);
            System.out.print(" ");
        }
    }
}
