#include <bits/stdc++.h>
using namespace std;
using ll = long long;
#define sz(a) (int)((a).size())
#define all(a) (a).begin(), (a).end()
const int INF = 1e9, maxn = 3e3;

struct segTree {
    int n; vector<int> t;
    segTree(int n) : n(n), t(2 * n, 0) {}
    void upd(int v, int x) {
        t[v += n] += x;
        for(v >>= 1; v; v >>= 1) t[v] = t[v * 2] + t[v * 2 + 1];
    }
    int get(int l, int r) {
        int ret = 0;
        for(l += n, r += n; l <= r; l = (l + 1) >> 1, r = (r - 1) >> 1) {
            if(l & 1) ret += t[l];
            if(!(r & 1)) ret += t[r];
        }
        return ret;
    }
};

int main() {
    ios::sync_with_stdio(0), cin.tie(0), cout.tie(0);
    //freopen("in.txt", "r", stdin);
    int n, p; cin >> n >> p;
    assert(p == 1);
    vector<int> a(n);
    map<int, int> re1, re2;
    for(int i = 0; i < n; i++) cin >> a[i], re1[a[i] - i], re2[a[i] + i];
    int dif1 = 0, dif2 = 0;
    for(auto it = re1.begin(); it != re1.end(); it++) it->second = dif1++;
    for(auto it = re2.begin(); it != re2.end(); it++) it->second = dif2++;
    segTree t1(dif1), t2(dif2);
    for(int i = 0; i < n; i++) t2.upd(re2[a[i] + i], 1);
    vector<int> opt(n, 1);
    for(int i = 0; i < n; i++) {
        t2.upd(re2[a[i] + i], -1);
        opt[i] = t1.get(0, re1[a[i] - i] - 1) + t2.get(0, re2[a[i] + i] - 1);
        t1.upd(re1[a[i] - i], 1);
    }
    for(int x : opt) cout << x + 1 << '\n';
}
