#include <iostream>
#include <algorithm>
#include <vector>
#include <cmath>
#include <bitset>


using namespace std;

#define all(a) a.begin(), a.end()

typedef long long ll;

int main() {
	int n, tmp;
	cin >> n;
	vector<int> a(n);
	for (int i = 0; i < n; ++i) {
		cin >> a[i] >> tmp;
	}
	sort(all(a));
	int imx = 0;
	vector<ll> money(n + 1, 0);
	for (int i = n - 1; i + 1; --i)
		money[i] = a[i] * 1ll * (n - i);
	for (int i = 1; i < n; ++i)
		if (money[i] > money[imx])
			imx = i;
	vector<pair<int, int>> stack;
	stack.push_back({ 0, imx });
	for (int i = imx - 1; i + 1; --i) {
		while (true) {
			int j = stack.back().second;
			if (money[i] >= money[j]) {
				stack.pop_back();
				continue;
			}
			int tmp = max(0 * 1ll, (money[j] - money[i] - 1) / (a[j] - a[i]) + 1);
			if (tmp <= stack.back().second) {
			stack.pop_back();
			continue;
			}
			if (tmp >= n)
				break;
			stack.push_back({ tmp, i });
			break;
		}
	}
	int j = 0;
	ll mx = 0;
	for (int i = 0; i <= n; ++i) {
		if (j != (int)stack.size() - 1 && stack[j + 1].second <= i)
			++j;
		int l = stack[j].second;
		mx = max(mx, money[n - i] + money[l] - i * 1ll * a[l]);
	}
	cout << mx;
	return 0;
}