#include <iostream>
#include <algorithm>
#include <vector>
#include <cmath>
#include <string>
#include <random>
#include <ctime>
#include <queue>
#include <deque>
#include <bitset>
#include <set>
#include <unordered_set>
#include <map>
#include <unordered_map>

#pragma comment(linker, "/STACK:256000000")
#pragma GCC optimize("O3")

using namespace std;

const int m = 3e5 + 4;

bool com(bitset<300010> & a, bitset<300010> & b, int l, int r) {
	for (int i = r; i >= l; --i) {
		if (a[i] ^ b[i])
			return a[i];
	}
	return true;
}

void print(bitset<300010> & a) {
	bool k = false;
	for (int i = 300009; i + 1; --i) {
		k |= a[i];
		if (k)
			cout << a[i];
	}
	cout << '\n';
}

void upd(bitset<300010> & a, int k) {
	for (int i = 0; i < k; ++i)
		a[i] = 0;
	a[k] = 1;
}
int main() {
	ios_base::sync_with_stdio(false);
	cin.tie(NULL);
	cout.tie(NULL);
	int n;
	cin >> n;
	if (n != 2)
		return 0;
	string s, t;
	cin >> s >> t;
	bitset<300010> a(s), b(t);
	auto c = a | b;
	int k = -1;
	int las = -1;
	for (int i = 0; i < m; ++i) {
		if (a[i] & b[i]) {
			las = i;
			continue;
		}
		if (!c[i]) {
			if (las == -1)
				continue;
			k = i;
			las = -1;
		}
	}
	if (k == -1) {
		print(a |= b);
		return 0;
	}
	if (com(a, b, 0, k - 1))
		upd(a, k);
	else
		upd(b, k);
	print(a |= b);
	return 0;
}