#include <iostream>
#include <vector>
#include <algorithm>
#include <string>
#include <deque>
#include <set>
#include <map>
#include <unordered_set>
#include <unordered_map>
#include <random>
#include <ctime>
using namespace std;

#define int int64_t
#define mp make_pair
#define pb push_back
#define pbb pop_back
#define pf pop_front
#define pff push_front
#define all(c) (c).begin(), (c).end()
#define rall(c) (c).rbegin(), (c).rend()
using ll = long long;
using ld = long double;
using pii = pair<int, int>;

int32_t main()
{
    ios_base::sync_with_stdio(false);
    cin.tie(0);
    cout.tie(0);

    int n, m, q;
    cin >> n >> m >> q;
    vector<vector<int>> plato(n, vector<int>(m));
    vector<int> max_row(n), max_column(m), row_pos(n), column_pos(m);
    for (int i = 0; i < n; ++i) {
        for (int j = 0; j < m; ++j) {
            cin >> plato[i][j];
            if (plato[i][j] > max_row[i]) {
                max_row[i] = plato[i][j];
                row_pos[i] = j;
            }
            if (plato[i][j] > max_column[j]) {
                max_column[j] = plato[i][j];
                column_pos[j] = i;
            }
        }
    }

    map<pii, int> counter_row, counter_column;
    for (int i = 0; i < n; ++i)
        counter_row[mp(max_row[i], row_pos[i])]++;
    for (int i = 0; i < m; ++i)
        counter_column[mp(max_column[i], column_pos[i])]++;

    for (int i = 0; i < q; ++i) {
        int r, c, x;
        cin >> r >> c >> x;
        r--;
        c--;

        if (x > max_row[r]) {
            counter_row[mp(max_row[r], row_pos[r])]--;
            max_row[r] = x;
            row_pos[r] = c;
            counter_row[mp(max_row[r], row_pos[r])]++;
        }
        if (x > max_column[c]) {
            counter_column[mp(max_column[c], column_pos[c])]--;
            max_column[c] = x;
            column_pos[c] = r;
            counter_column[mp(max_column[c], column_pos[c])]++;
        }

        int ans = 0;
        for (int i = 0; i < n; ++i)
            ans += counter_column[mp(max_row[i], i)];
        cout << ans << "\n";
    }

    return 0;
}
