#include <iostream>
#include <vector>
#include <algorithm>
#include <string>
#include <deque>
#include <set>
#include <map>
#include <unordered_map>
#include <unordered_set>
#include <random>
#include <ctime>
//#include <ext/pb_ds/assoc_container.hpp>
//using namespace __gnu_pbds;
using namespace std;

//#define int int64_t
#define mp make_pair
#define pb push_back
#define pbb pop_back
#define pf pop_front
#define pff push_front
#define all(c) (c).begin(), (c).end()
#define rall(c) (c).rbegin(), (c).rend()
using ld = long double;
using ll = long long;
using pii = pair<int, int>;
//using treap = tree<pii, null_type, less<pii>, rb_tree_tag, tree_order_statistics_node_update>;

const int INF = 1e9;

int32_t main()
{
    int n, p;
    cin >> n >> p;
    vector<int> nums(n);
    for (int i = 0; i < n; ++i)
        cin >> nums[i];

    vector<int> worst(n);
    for (int mask = 1; mask < (1 << n); ++mask) {
        vector<int> delay(n, INF);
        int now = INF;
        for (int j = 0; j < n; ++j) {
            if (mask & (1 << j))
                now = j;
            delay[j] = min(delay[j], abs(now - j));
        }
        now = INF;
        for (int j = n - 1; j > -1; --j) {
            if (mask & (1 << j))
                now = j;
            delay[j] = min(delay[j], abs(now - j));
        }

        set<pii> run;
        for (int i = 0; i < n; ++i)
            run.insert(mp(nums[i] + delay[i], i));
        int counter = 0, place = 1, prev = -1;
        for (auto &elem : run) {
            if (elem.first != prev) {
                place = counter + 1;
                prev = elem.first;
            }
            worst[elem.second] = max(worst[elem.second], place);
            counter++;
        }
    }

    for (int elem : worst)
        cout << elem << "\n";

    return 0;
}
