#include <bits/stdc++.h>

using namespace std;

const int maxN = 400005;
const int INF = 1e9;

int arr[maxN];

string intToStr(int x) {
    string res;
    while (x > 0) {
        res += (x & 1) + '0';
        x >>= 1;
    }
    reverse(res.begin(), res.end());
    return res;
}

int main() {
    #ifdef DEBUG
        freopen("in.in", "r", stdin);
    #endif // DEBUG

    cin.tie(0);
    ios_base::sync_with_stdio(0);

    int n;
    cin >> n;

    assert(n == 2);

    for (int i = 0; i < n; i++) {
        string s;
        cin >> s;
        reverse(s.begin(), s.end());
        for (int j = 0; j < s.size(); j++) {
            arr[i] |= ((s[j] - '0') << j);
        }
    }

    int best = INF;
    string ans;
    for (int a = 0; a < best; a++) {
        for (int b = 0; b <= a; b++) {
            if ((arr[0] + a) | (arr[1] + b) == arr[0] + arr[1] + a + b) {
                if (best > a + b) {
                    best = a + b;
                    ans = intToStr(arr[0] + arr[1] + a + b);
                }
            }
        }
    }
    cout << ans << endl;

    return 0;
}
