#include <bits/stdc++.h>
using namespace std;
#define rep(i, a, b) for(int i = a; i < b; ++i)

int debug = 0;

const int N = 1 << 19, LG = 19;
int n, a[N], dp[N], dg[N], sp[LG][N], t[N << 1];

int get_max(int l, int r) {
    int d = dg[r - l + 1];
    return max(sp[d][l], sp[d][r - (1 << d) + 1]);
}

int get(int l, int r) {
    l += N - 1, r += N - 1;
    int res = N;
    while (l < r) {
        if (l % 2 == 0) res = min(res, t[l]);
        if (r % 2 == 1) res = min(res, t[r]);
        l = l / 2, r = (r - 2) / 2;
    }
    if (l == r) res = min(res, t[l]);
    return res;
}

void update(int v, int val) {
    v += N - 1;
    t[v] = val;
    while (v) {
        v = (v - 1) / 2;
        t[v] = min(t[v * 2 + 1], t[v * 2 + 2]);
    }
}

main() {
    scanf("%d", &n);
    rep(i, 1, n + 1) {
        scanf("%d", &a[i]);
        sp[0][i] = a[i];
    }
    rep(j, 1, LG) for (int i = 0; i + (1 << j) <= n + 1; ++i) {
        sp[j][i] = max(sp[j - 1][i], sp[j - 1][i + (1 << (j - 1))]);
    }
    rep(i, 2, N) dg[i] = dg[i >> 1] + 1;
    vector <int> st = {0};
    fill(dp, dp + N, N);
    fill(t, t + N + N, N);
    dp[0] = 0;
    update(0, dp[0]);
    rep(i, 1, n + 1) {
        int x = a[i];
        int l = 0, r = i;
        while (r - l > 1) {
            int mid = (l + r) >> 1;
            if (get_max(mid, i) == x) r = mid;
            else l = mid;
        }
        if (debug) {
            cerr << " i=" << i << " r=" << r << " get=" << get(l, i - 1) << endl;
            cerr << " st=";
            for (int j : st) cerr << j << ' '; cerr <<'\n';
            cerr << " get_max(1,4)=" << get_max(1, 4) << '\n';
        }
        dp[i] = get(l, i - 1) + 1;
        update(i, dp[i]);
        while (x < a[st.back()]) {
            update(st.back() - 1, N);
            st.pop_back();
        }
        st.push_back(i);
    }
    printf("%d\n", dp[n]);
}

/**

5
5 4 3 2 1

4
1 3 2 4

6
2 3 1 1 5 1

*/