#ifdef _DEBUG
#define _GLIBCXX_DEBUG
#endif

#include <bits/stdc++.h>

using namespace std;

typedef long long ll;
typedef vector<int> vi;
typedef pair<int, int> pii;

#define X first
#define Y second
#define inb push_back
#define mk make_pair
#define all(v) (v).begin(), (v).end()

int solve();

int main()
{
	ios_base::sync_with_stdio(0);
	cin.tie(0);
	solve();
	return 0;
}

const ll INF = 2e9;

int solve()
{
	int n, m, k;
	cin >> n >> m >> k;
	vector<pii> a(k);
	for (int i = 0; i < k; ++i)
	{
		cin >> a[i].X >> a[i].Y;
	}
	n = k;
	vector<vi> dp(n, vi(1 << n, INF));
	vector<vi> p(n, vi(1 << n, -1));
	dp[0][1] = 0;
	for (int msk = 0; msk < (1 << n); ++msk)
	{
		for (int i = 0; i < n; ++i)
		{
			if (dp[i][msk] == INF)
				continue;
			for (int j = 0; j < n; ++j)
			{
				if ((msk >> j) & 1)
					continue;
				int st = max(abs(a[i].X - a[j].X), abs(a[i].Y - a[j].Y));
				int w = 1 << st;
				if (dp[i][msk] + w < dp[j][msk | (1 << j)])
				{
					dp[j][msk | (1 << j)] = dp[i][msk] + w;
					p[j][msk | (1 << j)] = i;
				}
			}
		}
	}
	int mskans = 0;
	for (int i = 0; i < (1 << n); ++i)
	{
		if (dp[n - 1][mskans] > dp[n - 1][i])
		{
			mskans = i;
		}
	}
	vi ans;
	//printf("%d\n", mskans);
	int cur = n - 1;
	while (cur != -1)
	{
		//printf("%d %d\n", mskans, cur);
		ans.inb(cur + 1);
		int ncur = p[cur][mskans];
		int nmsk = (mskans ^ (1 << cur));
		cur = ncur;
		mskans = nmsk;
	}
	printf("%d\n", (int)ans.size());
	reverse(all(ans));
	for (int x : ans)
		printf("%d ", x);
	puts("");
	return 0;
}