#ifdef _DEBUG
#define _GLIBCXX_DEBUG
#endif

#include <bits/stdc++.h>

using namespace std;

typedef long long ll;
typedef vector<int> vi;
typedef pair<int, int> pii;

#define X first
#define Y second
#define inb push_back
#define mk make_pair
#define all(v) (v).begin(), (v).end()

int solve();

int main()
{
	ios_base::sync_with_stdio(0);
	cin.tie(0);
	solve();
	return 0;
}

const int INF = 1e9;

int solve()
{
	int n, m, k;
	cin >> n >> m >> k;
	vector<pii> a(k);
	for (int i = 0; i < k; ++i)
	{
		cin >> a[i].X >> a[i].Y;
	}
	n = k;
	vi dst(n, INF);
	dst[0] = 0;
	vi p(n, -1);
	vi was(n);
	for (int it = 0; it < n; ++it)
	{
		int u = -1;
		for (int j = 0; j < n; ++j)
		{
			if (dst[j] == INF || was[j])
				continue;
			if (u == -1 || dst[j] < dst[u])
				u = j;
		}
		if (u == -1)
			continue;
		was[u] = 1;
		for (int to = 0; to < n; ++to)
		{
			int st = max(abs(a[u].X - a[to].X), abs(a[u].Y - a[to].Y));
			int w = 1 << st;
			if (dst[u] + w < dst[to])
			{
				p[to] = u;
				dst[to] = dst[u] + w;
			}
		}
	}
	int u = n - 1;
	vi ans;
	while (u != -1)
	{
		ans.inb(u + 1);
		u = p[u];
	}
	printf("%d\n", (int)ans.size());
	reverse(all(ans));
	for (int x : ans)
		printf("%d ", x);
	puts("");
	return 0;
}