#include <stdio.h>

const int MAX = 300001;
int MAX1;

void _print(bool *s) {
	bool print = false;
	for (int i = 0; i < MAX1; i++) {
		if (s[i]) {
			print = true;
		}
		if (print) {
			printf("%d", s[i] == true);
		}
	}
}

void merge(bool *ss1, bool *ss2) {
	bool *s1 = new bool[MAX1], *s2 = new bool[MAX1];
	for (int i = 0; i < MAX1; i++) {
		s1[i] = ss1[i];
		s2[i] = ss2[i];
	}
	int ind = -1;
    for (int i = MAX1 - 1; i >= 0; i--) {
        if (s1[i] && s2[i]) {
            ind = i;
        }
    }
    if (ind == -1) {
        for (ind = 0; ind < MAX1 && !s1[ind] && !s2[ind]; ind++) {
			ss1[ind] = false;
		}
        for (; ind < MAX1; ind++) {
            ss1[ind] = s1[ind] || s2[ind];
        }
        return;
    }
    if (!s1[ind - 1] && !s2[ind - 1]) {
        int ii;
        for (ii = ind; ii < MAX1 && (s1[ii] == s2[ii]); ii++);
        if (ii != MAX1 && s2[ii]) {
            bool *tmp = s2;
            s2 = s1;
            s1 = tmp;
        }
        s1[ind - 1] = true;
        for (int i = ind; i < MAX1; i++) {
            s1[i] = false;
        }
        for (ind = 0; ind < MAX1 && !s1[ind] && !s2[ind]; ind++) {
			ss1[ind] = false;
		}
        for (; ind < MAX1; ind++) {
            ss1[ind] = s1[ind] || s2[ind];
        }
        return;
    }
    if (s2[ind - 1]) {
        bool *tmp = s2;
        s2 = s1;
        s1 = tmp;
    }
    while (s1[ind]) {
        ind--;
        if (s2[ind]) {
            bool *tmp = s2;
            s2 = s1;
            s1 = tmp;
        }
    }
    ind++;
    s1[ind - 1] = true;
    for (int i = ind; i < MAX1; i++) {
        s1[i] = false;
    }
    for (ind = 0; ind < MAX1 && !s1[ind] && !s2[ind]; ind++) {
		ss1[ind] = false;
	}
    for (; ind < MAX1; ind++) {
        ss1[ind] = s1[ind] || s2[ind];
    }
}

void read(bool *s) {
	char ss1[MAX + 1];
	scanf("\n%s", ss1);
	int len1;
	for (len1 = 0; ss1[len1]; len1++);
	for (int i = 0; i < MAX1 - len1; i++) {
		s[i] = false;
	}
	for (int i = 0; i < len1; i++) {
		s[MAX1 - len1 + i] = ss1[i] == '1';
	}
}

int main() {
	int n;
	scanf("%d", &n);
	MAX1 = MAX + n;
	bool *s1 = new bool[MAX1], *s2 = new bool[MAX1];
	read(s1);
	for (int i = 0; i < n - 1; i++) {
		read(s2);
		merge(s1, s2);
	}
	_print(s1);
	return 0;
}
