 #include <bits/stdc++.h>


using namespace std;
template<typename T1, typename T2> inline void chkmin(T1 & x, const T2 &y) {if (x > y)  x = y;}
template<typename T1, typename T2> inline void chkmax(T1 & x, const T2 &y) {if (x < y)  x = y;}
#define all(c) (c).begin(), (c).end()
#define sz(c) (int)(c).size()
#define pb push_back
const int MAXN = 150001;


struct line
{
	long long k, b;
	line(){}
	line(long long _k, long long _b) {
		k = _k;
		b = _b;
	}
	long long getval(long long x) {
		return k * x + b;
	}
};


struct convexhull{
	vector<line> st;
	bool better(line a, line b, line c) {
		return (b.b - a.b) * (a.k - c.k) >= (c.b - a.b) * (a.k - b.k);
	}
	void addline(line l) {
		// while (sz(st) >= 2 && better(st[sz(st) - 2], st[sz(st) - 1], l)) {
		// 	st.pop_back();
		// }
		st.pb(l);
	}
	long long getmax(long long x) {
		if (sz(st) == 0) {
			return -1e18;
		}
		if (sz(st) == 1) {
			return st[0].getval(x);
		}
		int l = 0;
		int r = sz(st) - 1;
		// while (l < r) {
		// 	int mid = (l + r) >> 1;
		// 	if ((st[mid + 1].b - st[mid].b) < x * (st[mid].k - st[mid + 1].k)) {
		// 		l = mid + 1;
		// 	}  else {
		// 		r = mid;
		// 	}
		// }
		long long res = -1e18;
		for (int i = l; i <= r; i++) {
			chkmax(res, st[i].getval(x));
		}
		return res;
	}
};


bool operator <(line a, line b) {
	return a.k < b.k;
}


int n;
int a[MAXN], b[MAXN];
vector<int> vx;
vector<line> g[MAXN * 4];
convexhull as[MAXN * 4];

void doconvex(int i) {
	for (auto x: g[i]) {
		as[i].addline(x);
	}
}


long long rmq(int v, int vl, int vr, int l, int r, long long x) {
	if (vl > r || vr < l) {
		return -1e18;
	}
	if (l <= vl && vr <= r) {
		return as[v].getmax(x);
	}
	return max(rmq(v * 2, vl, (vl + vr) / 2, l, r, x), rmq(v * 2 + 1, (vl + vr) / 2 + 1, vr, l, r, x));
}


int main() {
	ios_base::sync_with_stdio(false);
	cin.tie(0);
	cout.tie(0);
//	assert(freopen("input.in", "r", stdin));
	cin >> n;
	vector<pair<int, int> > st;
	st.resize(n);
	for (int i = 0; i < n; i++) {
		cin >> st[i].first >> st[i].second;
	}
	sort(all(st));
	vector<int> vx;
	for (int i = 0; i < n; i++) {
		a[i] = st[i].first;
		b[i] = st[i].second;
		vx.pb(b[i]);
	}
	sort(all(vx));
	int ss = 1;
	while (ss < n) {
		ss <<= 1;
	}
	for (int i = n - 1; i >= 0; i--) {
		//cout << a[i] << ' ' << b[i] << endl;
		g[ss + i].pb(line(-(n - i), 1LL * a[i] * (n - i)));
		doconvex(i);
	}
	for (int i = ss - 1; i >= 1; i--) {
		if (g[i * 2].empty() || g[i * 2 + 1].empty()) continue;
		g[i].resize(sz(g[i * 2]) + sz(g[i * 2 + 1]));
		merge(all(g[i * 2]), all(g[i * 2 + 1]), g[i].begin());
		doconvex(i);
	}
	long long ans = 0;
	for (int i = 0; i < n; i++) {
		int l = 0;
		int r = n - 1;
		while (l != r) {
			int mid = (l + r) >> 1;
			if (a[mid] < vx[i]) {
				l = mid + 1;
			} else {
				r = mid;
			}
		}
		long long res = vx[i] * (n - l);
		//cout << res << endl;
		res += rmq(1, 1, ss, l + 1, n, vx[i]);
		//cout << vx[i] << ' ' << res << endl;
		chkmax(ans, res);
	}
	cout << ans << endl;
}
