#include <bits/stdc++.h>
#define err(...) fprintf(stderr, __VA_ARGS__), fflush(stderr)

using namespace std;

typedef long long ll;

map<int, set<int>> M;
const int dd = (int)3e2 + 7;

struct segment {
    pair<int, int> T[4 * dd];

    void build(int v, int tl, int tr, vector<int> &A) {
        if (tl == tr) T[v] = { A[tl], tl };
        else {
            int tm = (tl + tr) / 2;
            build(v * 2, tl, tm, A);
            build(v * 2 + 1, tm + 1, tr, A);
            T[v] = max(T[v * 2], T[v * 2 + 1]);
        }
    }

    pair<int, int> get(int v, int tl, int tr, int l, int r) {
        if (tl == l && tr == r) return T[v];
        int tm = (tl + tr) / 2;
        if (r <= tm) return get(v * 2, tl, tm, l, r);
        if (l > tm) return get(v * 2 + 1, tm + 1, tr, l, r);
        return max(get(v * 2, tl, tm, l, tm), get(v * 2 + 1, tm + 1, tr, tm + 1, r));
    }

} T;

int main() {
    ios_base::sync_with_stdio(0);
    cin.tie(0);

    set<pair<int, int> > S;
    int n; cin >> n;

    vector<int> A(n);

    for (int i = 0; i < n; i++) {
        int x; cin >> x;
        S.insert({ x, i });
        M[x].insert(i);
        A[i] = x;
    }

    T.build(1, 0, n - 1, A);

    vector<int> st, nxt(n, n);
    for (int i = 0; i < n; i++) {
        while (st.size() && A[st.back()] > A[i]) nxt[st.back()] = i, st.pop_back();
        st.push_back(i);
    }

    int ans = 0;
    int lt = 0;
    while (S.size()) {
        int r = nxt[lt] - 1;

        int pos = T.get(1, 0, n - 1, lt, r).second;

        ans++;
        for (int cur = lt; cur <= pos; cur++) S.erase({ A[cur], cur });
        lt = pos + 1;
    }
    cout << ans << "\n";
    return 0;
}
