#include <bits/stdc++.h>
//#include <windows.h>

#define ll long long
#define pii pair<int, int>
#define f first
#define s second
#define all(a) a.begin(), a.end()
#define rall(a) a.rbegin(), a.rend()
#define sz(a) int(a.size())

using namespace std;

const int INF = 1e9;

/*bool ok(vector<int>& a, int left, int right) {
    return a[left] == *min_element(a.begin() + left, a.begin() + right + 1) && a[right] == *max_element(a.begin() + left, a.begin() + right + 1);
}*/

struct tree {
    vector<pii> t;
    int sz = 1;

    tree() {}

    pii merge(const pii& a, const pii& b) {
        return {max(a.f, b.f), (a.f == b.f ? max(a.s, b.s) : (a.f > b.f ? a.s : b.s))};
    }

    tree(vector<int>& a) {
        int n = sz(a);
        while (sz < n) {
            sz *= 2;
        }
        t.resize(sz * 2);
        for (int i = sz; i < sz + n; ++i) {
            t[i] = {a[i - sz], i - sz};
        }
        for (int i = sz - 1; i >= 1; --i) {
            t[i] = merge(t[i * 2], t[i * 2 + 1]);
        }
        /*for (int i = 1; i < 2 * sz; ++i) {
            cout << t[i].f << ' ' << t[i].s << '\n';
        }*/
    }

    pii ans(int v, int left, int right, const int L, const int R) {
        if (left > R || right < L) {
            return {0, 0};
        }
        if (left >= L && right <= R) {
            return t[v];
        }
        int mid = (left + right) / 2;
        return merge(ans(v * 2, left, mid, L, R), ans(v * 2 + 1, mid + 1, right, L, R));
    }
};

int main() {
    int n;
    cin >> n;
    vector<int> a(n);
    for (int i = 0; i < n; ++i) {
        cin >> a[i];
    }
    vector<int> rs(n);
    set<pii> q;
    for (int i = 0; i < n; ++i) {
        while (!q.empty() && q.rbegin()->f > a[i]) {
            rs[q.rbegin()->s] = i - 1;
            q.erase(prev(q.end()));
        }
        q.emplace(a[i], i);
    }
    for (auto& el : q) {
        rs[el.s] = n - 1;
    }
    tree t(a);
    int st = 0, c = 0;
    while (st != n) {
        //cout << st << ' ' << rs[st] << '\n';
        st = t.ans(1, 1, t.sz, st + 1, rs[st] + 1).s + 1;
        //cout << st << '\n';
        //Sleep(5500);
        ++c;
    }
    cout << c;
    /*int c = 0, mn = INF, mx = 0;
    for (int i = 0; i < n; ++i) {
        int el;
        cin >> el;
        if (el < mn) {
            mn = el;
            mx = el;
            ++c;
        }
        if (el > mx) {
            mx = el;
        }
    }
    while (st != n) {
        for (int i = n - 1; i >= st; --i) {
            if (ok(a, st, i)) {
                ++c;
                st = i + 1;
                break;
            }
        }
    }
    cout << c;*/
    return 0;
}
