#include <iostream>
#include <vector>
#include <algorithm>
#include <set>
#include <map>
#include <unordered_map>
#include <string>
#include <bitset>
#include <cassert>
using namespace std;
#define all(v) v.begin(), v.end()
typedef long long ll;

bool comp(string &s1, string &s2) {
	if (s1.size() < s2.size()) return 1;
	if (s1.size() > s2.size()) return 0;
	for (int i = 0; i < s1.size(); i++) {
		if (s1[i] < s2[i]) return 1;
		if (s1[i] > s2[i]) return 0;
	}
	return 0;
}
const int N = 10000;

int main() {
	ios_base::sync_with_stdio(0);
	int n;
	cin >> n;
	vector<string> vs(n);
	for (int i = 0; i < n; i++)
		cin >> vs[i];
	sort(all(vs), comp);
	vector<vector<bool>> vvb(n);
	for (int i = 0; i < n; i++) {
		vvb[i].resize(vs[i].size());
		for (int j = 0; j < vs[i].size(); j++) {
			vvb[i][j] = vs[i][j] - '0';
		}
	}
	if (n == 2) {
		int k = vvb[0].size();
		vector<bool> ans(vvb[1].size() + 10);
		for (int i = 0; ; i++) {
			int a = (int)vvb[0].size() - k + i, 
				b = (int)vvb[1].size() - k + i;
			if (a >= vvb[0].size()) break;
			if (vvb[0][a] && vvb[1][b]) {
				for (int j = i; ; j--) {
					int c = (int)vvb[0].size() - k + j,
						d = (int)vvb[1].size() - k + j;
					int e = (int)ans.size() - k + j;
					if (c < 0 && d < 0) {
						ans[e] = 1;
						for (int i = 0; i < vvb[1].size(); i++)
							vvb[1][i] = 0;
						break;
					}
					if (c < 0 && !vvb[1][d]) {
						ans[e] = 1;
						vvb[1][d++] = 1;
						for (; d < vvb[1].size(); d++)
							vvb[1][d] = 0;
						break;
					}
					if (!vvb[0][c] && !vvb[1][d]) {
						ans[e] = 1;
						vvb[1][d++] = 1;
						for (; d < vvb[1].size(); d++)
							vvb[1][d] = 0;
						break;
					}
				}
				break;
			}
		}
		for (int i = 0; i < vvb[0].size(); i++) {
			int a = (int)ans.size() - vvb[0].size() + i;
			ans[a] = ans[a] | vvb[0][i];
		}
		for (int i = 0; i < vvb[1].size(); i++) {
			int a = (int)ans.size() - vvb[1].size() + i;
			ans[a] = ans[a] | vvb[1][i];
		}
		bool must = false;
		for (int i = 0; i < ans.size(); i++) {
			if (ans[i] || i == ans.size() - 1) must = true;
			if (must) cout << ans[i];
		}
	}
}