#include <iostream>
#include <vector>
#include <algorithm>
#include <fstream>

using namespace std;

struct line{
    long long a, b;
};

bool bad(line l1, line l2, line l3) {
    long double x1, x2;
    x1 = (long double)(l1.b - l2.b) / (long double)(l2.a - l1.a);
    x2 = (long double)(l2.b - l3.b) / (long double)(l3.a - l2.a);
    return x1 > x2;
}

long long get(vector <line> &lines, long long x) {
    int l, r, mid;
    line l1, l2;
    l = 0;
    r = lines.size();
    while (r - l > 1) {
        mid = (l + r) / 2;
        l1 = lines[mid - 1];
        l2 = lines[mid];
        if (l1.b - l2.b < x * (l2.a - l1.a)) {
            l = mid;
        }
        else {
            r = mid;
        }
    }
    return lines[l].a * x + lines[l].b;
}

int main() {
    int n;
    long long best, tmp, add;
    line l;
    cin >> n;
    vector <long long> v(n);
    for (int i = 0; i < n; i++) {
        cin >> v[i] >> v[i];
    }
    sort(v.begin(), v.end());
    vector <line> lines;
    lines.reserve(n);
    best = v[0] * n;
    l.a = v[0];
    l.b = v[0];
    lines.push_back(l);
    for (int i = 1; i < n; i++) {
        //cout << i << ":\n";
        tmp = v[i] * (n - i);
        add = get(lines, i - 1);
/*
        cout << tmp << ' ' << add << '\n';
        for (int j = 0; j < lines.size(); j++) {
            cout << lines[j].a << ' ' << lines[j].b << "   ";
        }
        cout << '\n';
*/
        best = max(best, tmp + add);
        l.a = v[i];
        l.b = v[i] * (1 - i);
        while (lines.size() > 1 && bad(lines[lines.size() - 2], lines[lines.size() - 1], l)) {
            lines.pop_back();
        }
        lines.push_back(l);
    }
    cout << best << '\n';
}
