#include <iostream>
#include <map>

long long GetLocalBestRes(std::map <int, int>::iterator &itA, int *a, int *b, int aBuy, int n);

int main(void) {
    int n = 0;
    std::cin >> n;
    int *a = new int[n];
    int *b = new int[n];
    std::map <int, int> aSteps;
    std::map <int, int> bSteps;
    bool bStepsNotEmpty = 0;
    for (int i = 0; i < n; i++) {
        std::cin >> a[i] >> b[i];
        aSteps[a[i]]++;
        bSteps[b[i]]++;
        if (b[i] != 0)
            bStepsNotEmpty = 1;
    }
    //aSteps[0] = bSteps[0] = 0;
    if (!bStepsNotEmpty) {
        long long bestRes = 0;
        long long aBuy = n;
        for (std::map <int, int>::iterator itA = aSteps.begin(); itA != aSteps.end(); itA++) {
            long long curRes = aBuy * (itA->first);
            aBuy -= itA->second;
            if (curRes > bestRes)
                bestRes = curRes;
        }
        std::cout << bestRes << std::endl;
    }
    else {
        long long bestRes = 0;
        long long aBuy = n;
        int l = 0, r = n + 1;
        //while (r - l > 1) {
            for (std::map <int, int>::iterator itA = aSteps.begin(); itA != aSteps.end(); itA++) {
                long long localBestRes = GetLocalBestRes(itA, a, b, aBuy, n);
                aBuy -= itA->second;
                if (localBestRes > bestRes)
                    bestRes = localBestRes;
            }
        //}
        std::cout << bestRes << std::endl;
    }
    return 0;
}

long long GetLocalBestRes(std::map <int, int>::iterator &itA, int *a, int *b, int aBuy, int n) {
    long long localBestRes = 0;
    std::map <int, int> bSteps;
    long long bBuy = 0;
    for (int i = 0; i < n; i++)
        if (itA->first > a[i]) {
            bSteps[b[i]]++;
            bBuy++;
        }
    //std::cout << itA->first << " " << bBuy << std::endl;
    for (std::map <int, int>::iterator itB = bSteps.begin(); itB != bSteps.end() && (itB->first <= itA->first); itB++) {
        long long curRes = aBuy * (itA->first) + bBuy * (itB->first);
        //std::cout << curRes << std::endl;
        if (curRes > localBestRes)
            localBestRes = curRes;
        bBuy -= itB->second;
    }
    long long curRes = aBuy * (itA->first);
    if (curRes > localBestRes)
        localBestRes = curRes;
    return localBestRes;
}
