#include <bits/stdc++.h>
#define x first
#define y second
#define pb push_back
using namespace std;

const int MAXN = 4e5 + 1;

int a[3][MAXN];
vector<int> v[3];

int get_id(int c, int i) {
	return lower_bound(v[c].begin(), v[c].end(), i) - v[c].begin();
}

void clear(int c) {
	for (int i = 0; i < v[c].size(); ++i) {
		a[c][i] = 0;
	}
}

void add(int c, int i, int w = 1) {
	i = get_id(c, i);
	while (i < v[c].size()) {
		a[c][i] += w;
		i |= (i + 1);
	}
}

int get(int c, int i) {
	i = get_id(c, i) - 1;
	int ans = 0;
	while (i >= 0) {
		ans += a[c][i];
		i &= (i + 1);
		--i;
	}
	return ans;
}

int n, p;
int w[MAXN];
int ans[MAXN];


int main() {
	ios::sync_with_stdio(0);
	//assert(freopen("input.in", "r", stdin));
	cin >> n >> p;
	for (int i = 0; i < n; ++i) {
		cin >> w[i];
		v[2].pb(w[i] + i);	
		v[0].pb(w[i] - i);
		v[1].pb(w[i]);
		ans[i] = 0;
	}
	for (int t = 0; t < 3; ++t) {
		sort(v[t].begin(), v[t].end());
	} 
	int lstL = 0;
	for (int i = 0; i < n; ++i) {
		int Lc = 0, Rc = n - 1;
		if (abs(Lc - i) > abs(Rc - i)) {
			Lc = i - abs(Rc - i);
		}
		int speed = w[i] + abs(Lc - i);
		add(2, w[i] + i);
		while (lstL < Lc) {
			add(2, w[lstL] + lstL, -1);
			add(1, w[lstL]);
			++lstL;
		}
		ans[i] += get(2, speed + lstL);
		ans[i] += get(1, speed);
	}
	clear(1);
	int lstR = n - 1;
	for (int i = n; i--;) {
		int Lc = 0, Rc = n - 1;
		if (abs(Lc - i) < abs(Rc - i)) {
			Rc = i + abs(Lc - i);
		}
		int speed = w[i] + abs(Rc - i);
		add(0, w[i] - i);
		while (lstR > Rc) {
			add(0, w[lstR] - lstR, -1);
			add(1, w[lstR]);
			--lstR;
		}
		ans[i] += get(1, speed);
		ans[i] += get(0, speed - lstR);
	}
	for (int i = 0; i < n; ++i) {
		cout << max(ans[i], max(get_id(2, w[i] + i), get_id(0, w[i] - i))) + 1 << '\n';
	}
}