#include <bits/stdc++.h>
using namespace std;

void doRoutine() {
#ifdef LOCAL
    freopen("/home/roi/clion_main/input.txt", "r", stdin);
    freopen("/home/roi/clion_main/output.txt", "w", stdout);
#endif
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    cout.tie(nullptr);
}

#define pii pair<int, int>
#define fi first
#define se second
#define vc vector
#define vi vc<int>
#define vvi vc<vi>
#define all(x) x.begin(), x.end()
#define vb vc<bool>
#define pb push_back

//#define int long long
#define D double
#define map unordered_map

// ----------------------------------- CODE NOW ------------------------

const int MAXN = 400005;
int n, p;
int a[MAXN];
int ans[MAXN];
int arr[MAXN];

struct str {
    int lb, rb;
    str *cl;
    str *cr;
    int val;

    str(int l, int r) {
        lb = l, rb = r, cl = cr = nullptr;
        if (l + 1 == r) {
            val = 0;
        }
        else {
            int m = (l + r) / 2;
            cl = new str(l, m);
            cr = new str(m, r);
            val = cl->val + cr->val;
        }
    }

    int get(int l, int r) {
        if (l >= r) {
            return 0;
        }
        if (l == lb && r == rb) {
            return val;
        }
        else {
            int m = (lb + rb) / 2;
            if (r <= m) {
                return cl->get(l, r);
            }
            else if (l >= m) {
                return cr->get(l, r);
            }
            else {
                return cl->get(l, m) + cr->get(m, r);
            }
        }
    }

    int add(int i, int x) {
        if (lb + 1 == rb) {
            val += x;
        }
        else {
            int m = (lb + rb) / 2;
            if (i < m) {
                cl->add(i, x);
            }
            else {
                cr->add(i, x);
            }
            val = cl->val + cr->val;
        }
    }
};

void add_ans(bool rev = false) {
    set<int> st;
    for (int i = 0; i < n; ++i) {
        st.insert(arr[i]);
    }
    map<int, int> comp;
    int id = 0;
    for (auto el : st) {
        comp[el] = id;
        ++id;
    }
    for (int i = 0; i < n; ++i) {
        arr[i] = comp[arr[i]];
    }

    str tr(0, n);
    for (int i = 0; i < n; ++i) {
        int id = i;
        if (rev) {
            id = n - i - 1;
        }
        ans[id] += tr.get(0, arr[id]);
        tr.add(arr[id], 1);
    }
}

signed main() {
    doRoutine();

    cin >> n >> p;
    for (int i = 0; i < n; ++i) {
        cin >> a[i];
    }

    if (p == 1) {
        for (int i = 0; i < n; ++i) {
            arr[i] = a[i] - i;
        }
        add_ans();
        for (int i = 0; i < n; ++i) {
            arr[i] = a[i] + i;
        }
        add_ans(true);
    }

    for (int i = 0; i < n; ++i) {
        cout << ans[i] + 1 << endl;
    }

    return 0;
}