#include <bits/stdc++.h>

#define __int64 long long

using namespace std;
const int N = 300000;
int ar[N];
int szar = 0;
map<int, set<int> > mp;


int n;
int sgmin[N * 4];
int sgmax[N * 4];

void build(int v = 1, int tl = 0, int tr = n - 1) {
    if (tl == tr) {
        sgmin[v] = ar[tl];
        sgmax[v] = ar[tl];
        return;
    }
    int m = (tl + tr) / 2;
    build(v * 2, tl, m);
    build(v * 2 + 1, m + 1, tr);
    sgmin[v] = min(sgmin[v * 2], sgmin[v * 2 + 1]);
    sgmax[v] = max(sgmax[v * 2], sgmax[v * 2 + 1]);
}


int getMinak(int l, int r, int v = 1, int tl = 0, int tr = n - 1) {
    if (tl == l && tr == r) {
        return sgmin[v];
    }
    int m = (tl + tr) / 2;
    if (m >= r) {
        return getMinak(l, r, v * 2, tl, m);
    }
    if (m < l) {
        return getMinak(l, r, v * 2 + 1, m + 1, tr);
    }

    return min(getMinak(l, m, v * 2, tl, m), getMinak(m + 1, r, v * 2 + 1, m + 1, tr));
}

int getMax(int l, int r, int v = 1, int tl = 0, int tr = n - 1) {
    if (tl == l && tr == r) {
        return sgmax[v];
    }
    int m = (tl + tr) / 2;
    if (m >= r) {
        return getMax(l, r, v * 2, tl, m);
    }
    if (m < l) {
        return getMax(l, r, v * 2 + 1, m + 1, tr);
    }

    return max(getMax(l, m, v * 2, tl, m), getMax(m + 1, r, v * 2 + 1, m + 1, tr));
}

set<int> keksasis;
map<int, int> ids;

int main() {
#ifdef DEBUG
    freopen("test.in", "r", stdin);
#endif
    //ios::sync_with_stdio(0);
    scanf("%d", &n);
    multiset<int> keks;
    for (int i = 0; i < n; ++i) {
        int t = 0;
        scanf("%d", &t);
        t = n - i;
        ar[szar++] = t;

        mp[t].insert(i);
        keksasis.insert(t);
    }

    int curida = 0;
    for (auto i:keksasis)
        ids[i] = curida++;


    build();
    int suma = 0;
    int cd = 0;

    while (cd < n) {
        auto cur = ar[cd];

        int r = n - 1;

        int ll = cd;
        int rrar = n - 1;
        int curid=ids[i];
//        while (ll < rrar) {
//            int m = (ll + rrar + 1) / 2;
//            if (getMin(cd, m) != cur)
//                rrar = m - 1;
//            else
//                ll = m;
//        }
        r = ll;


        auto maxi = getMax(cd, r);
        auto rr = *(--mp[maxi].upper_bound(r));

        cd = rr + 1;
        ++suma;
    }
    printf("%d", suma);
    return 0;
}