#include <algorithm>
#include <iostream>
#include <utility>
#include <vector>
#include <cmath>
#include <list>

using namespace std;

int main() {
    cin.tie(nullptr);
    cout.tie(nullptr);
    cin.sync_with_stdio(false);
    cout.sync_with_stdio(false);

    int n, p;
    cin >> n >> p;

    vector<int> a(n);
    for (int i = 0; i < n; i++)
        cin >> a[i];

    if (p == 1) {
        vector<int> r(a);
        for (int i = 0; i < n; i++){
            for (int j = 0; j < n; j++)
                r[j] = a[j] + abs(j - i);
            sort(r.begin(), r.end());
            cout << distance(r.begin(), find(r.begin(), r.end(), a[i])) + 1 << endl;
        }
    }
    else {
        vector<int> r(a), ra(a), rb(a);

        for (int j = 0; j < n; j++)
            ra[j] = a[j] - j;
        sort(ra.begin(), ra.end());

        for (int j = 0; j < n; j++)
            rb[j] = a[j] + j;
        sort(rb.begin(), rb.end());

        for (int i = 0; i < n; i++){
            int d;
            if (i == 0) {
                const int t = a[i] - i;
                d = distance(r.begin(), find(r.begin(), r.end(), t));
            } else if (i == n - 1) {
                const int t = a[i] + i;
                d = distance(r.begin(), find(r.begin(), r.end(), t));
            }
            else {
                {
                    int m = min(i, n - i - 1);
                    for (int j = 0; j < n; j++)
                        r[j] = a[j] - min(abs(j - i), m);

                    const int t = r[i];

                    sort(r.begin(), r.end());
                    d = distance(r.begin(), find(r.begin(), r.end(), t));
                }
                {
                    for (int j = 0; j < n; j++)
                        r[j] = a[j] - j;

                    const int t = r[i];

                    sort(r.begin(), r.end());
                    d = max(d, (int)distance(r.begin(), find(r.begin(), r.end(), t)));
                }
                {
                    for (int j = 0; j < n; j++)
                        r[j] = a[j] - n + 1 + j;

                    const int t = r[i];

                    sort(r.begin(), r.end());
                    d = max(d, (int)distance(r.begin(), find(r.begin(), r.end(), t)));
                }
            }
            cout << d + 1 << endl;
        }
    }

    return 0;
}