#include <iostream>
#include <fstream>

using namespace std;

const bool debug = false;

int main()
{
    int n, m, q;
    if (debug) {
        fin >> n >> m >> q;
    }
    else {
        cin >> n >> m >> q;
    }
    int f[n][m];
    for (int i = 0; i < n; i++) {
        for (int j = 0; j < m; j++) {
            if (debug) {
                fin >> f[i][j];;
            }
            else {
                cin >> f[i][j];
            }
        }
    }
    int mxn[n], mxm[m];
    for (int i = 0; i < n; i++) {
        int ind = 0;
        for (int j = 0; j < m; j++) {
            if (f[i][j] > f[i][ind]) {
                ind = j;
            }
        }
        mxn[i] = ind;
    }
    for (int i = 0; i < m; i++) {
        int ind = 0;
        for (int j = 0; j < n; j++) {
            if (f[j][i] > f[ind][i]) {
                ind = j;
            }
        }
        mxm[i] = ind;
    }
    int ans = 0;
    for (int i = 0; i < n; i++) {
        if (mxm[mxn[i]] == i) {
            ans++;
        }
    }
    for (int iii = 0; iii < q; iii++) {
        int r, c, x;
        if (debug) {
            fin >> r >> c >> x;
        }
        else {
            cin >> r >> c >> x;
        }
        r--; c--;
        if (mxm[c] == r && mxn[r] == c) {
            f[r][c] = x;
            cout << ans << endl;
            continue;
        }
        if (f[r][mxn[r]] < x) {
            if (mxm[mxn[r]] == r) {
                ans--;
            }
        }
        if (f[mxm[c]][c] < x) {
            if (mxn[mxm[c]] == c) {
                ans--;
            }
        }
        if (f[r][mxn[r]] < x) {
            mxn[r] = c;
        }
        if (f[mxm[c]][c] < x) {
            mxm[c] = r;
        }
        if (mxn[mxm[c]] == c) {
            ans++;
        }
        f[r][c] = x;
        cout << ans << endl;
    }
}
