#include <algorithm>
#include <iostream>
#include <vector>
#include <cmath>
using namespace std;

int main(){
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);
    unsigned int r, c, n;
    cin >> r >> c >> n;
    vector<pair<int, int> > a(n);
    for(int i = 0; i<n; i++)
        cin >> a[i].first >> a[i].second;
    vector<pair<unsigned int, int> > d(n, make_pair((1<<32-1), -1));
    d[0] = make_pair(0, -1);
    for(int i = 0; i<n; i++){
        for(int j = i+1; j<n; j++){
            unsigned int dist = max(abs(a[i].first-a[j].first), abs(a[i].second-a[j].second));
            if(dist>32)
                continue;
            d[i] = min(d[i], make_pair(d[j].first+(1<<dist), j));
            d[j] = min(d[j], make_pair(d[i].first+(1<<dist), i));
        }
    }
    vector<int> ans;
    int it = n-1;
    while(it!=-1){
        ans.push_back(it);
        it = d[it].second;
    }
    cout << ans.size() << '\n';
    for(int i = ans.size(); i>0; i--)
        cout << ans[i-1]+1 << ' ';

    return 0;
}
/*
4 5 3
1 1
2 3
4 5

5 6 9
1 1
4 3
4 6
2 5
3 1
3 3
3 6
5 4
5 6

4 4 6
1 1
2 2
3 3
2 3
3 2
4 4
*/
