#include <bits/stdc++.h>
#include <ext/pb_ds/assoc_container.hpp>
#include <ext/pb_ds/tree_policy.hpp>

using namespace std;
using namespace __gnu_pbds;

#ifndef LOCAL
#define endl "\n"
#endif

template<typename t>
istream &operator>>(istream &in, vector<t> &a) {
    for (auto &x : a) {
        in >> x;
    }
    return in;
}

template<typename t1, typename t2>
ostream &operator<<(ostream &out, const pair<t1, t2> &a) {
    out << a.first << " " << a.second;
    return out;
};

template<typename t>
ostream &operator<<(ostream &out, const vector<t> &a) {
    for (auto &x : a) {
        out << x << endl;
    }
    return out;
}

ostream &operator<<(ostream &out, const vector<int> &a) {
    for (auto &x : a) {
        out << x << " ";
    }
    return out;
}

void s(vector<int> &a, int x, int y) {
    vector<int> a1;
    vector<int> a2;
    for (int i = x + 1; i <= y; i += 2) {
        a2.push_back(a[i]);
    }
    for (int i = x; i <= y; i += 2) {
        a1.push_back(a[i]);
    }
    for (int i = 0; i < a2.size(); ++i) {
        a[x + i] = a2[i];
    }
    for (int i = 0; i < a1.size(); ++i) {
        a[x + i + a2.size()] = a1[i];
    }
}

void swap1(int i1, int i2, vector<pair<int, int> > &ans, vector<int> &a) {
    if ((i2 - i1) % 2 == 0) {
        swap1(i1 + 1, i2, ans, a);
        ans.push_back({i1 + 1, i1 + 2});
        swap(a[i1], a[i1 + 1]);
        return;
    }
    ans.push_back({i1 + 1, i2 + 1});
    s(a, i1, i2);
    if ((i2 - i1) / 2 != 0) {
        swap1(i1, i1 + (i2 - i1) / 2, ans, a);
    }
}

vector<pair<int, int> > f1(int n, vector<int> a) {
    vector<pair<int, int> > ans;
    for (int i = 0; i < n; ++i) {
        int max_ind = i;
        for (int j = i + 1; j < n; ++j) {
            if (a[j] < a[max_ind]) {
                max_ind = j;
            }
        }
        if (max_ind != i) {
            swap1(i, max_ind, ans, a);
        }
    }
    return ans;
}

vector<pair<int, int> > f2(int n, vector<int> a) {
    vector<pair<int, int> > ans;
    for (int i = 0; i < n; ++i) {
        for (int j = 0; j + 1 < n; ++j) {
            if (a[j] > a[j + 1]) {
                swap(a[j], a[j + 1]);
                ans.push_back(make_pair(j + 1, j + 2));
            }
        }
    }
    return ans;
}

void swap3(int i1, int i2, vector<pair<int, int> > &ans, vector<int> &a) {
    if ((i2 - i1) % 2 == 0) {
        swap3(i1, i2 - 1, ans, a);
        ans.push_back({i2, i2 + 1});
        swap(a[i2 - 1], a[i2]);
        return;
    }
    ans.push_back({i1 + 1, i2 + 1});
    s(a, i1, i2);
    if ((i2 - i1) / 2 != 0) {
        swap3(i1, i1 + (i2 - i1) / 2, ans, a);
    }
}

vector<pair<int, int> > f3(int n, vector<int> a) {
    vector<pair<int, int> > ans;
    for (int i = n - 1; i >= 0; --i) {
        int max_ind = i;
        for (int j = i - 1; j >= 0; --j) {
            if (a[j] > a[max_ind]) {
                max_ind = j;
            }
        }
        if (max_ind != i) {
            swap3(max_ind, i, ans, a);
        }
    }
    return ans;
}

signed main() {
    ios::sync_with_stdio(false);
    cin.tie(0);
    cout.tie(0);
#ifdef LOCAL
    freopen("/home/roi/CLionProjects/A/input.txt", "rt", stdin);
#endif
    int n;
    cin >> n;
    vector<int> a(n);
    cin >> a;
    vector<vector<pair<int, int> > > ans;
    ans.push_back(f1(n, a));
    ans.push_back(f2(n, a));
    ans.push_back(f3(n, a));
    sort(ans.begin(), ans.end(), [](const vector<pair<int, int> > &a, const vector<pair<int, int> > &b) {
        return a.size() < b.size();
    });
    cout << ans[0].size() << endl << ans[0] << endl;
    return 0;
}