#include <bits/stdc++.h>
 
using namespace std;

string mn(string a, string b) {
	if (a.size() == b.size())
		return (a < b ? a : b);
	return (a.size() < b.size() ? a : b);
}

string normal(string s) {
	int carry = 0;
	for (int i = 0; i != s.size(); ++i) {
		s[i] += carry;
		carry = 0;
		if (s[i] > '1') {
			carry = 1;
			s[i] = '1';
		}
		if (i + 1 == s.size() && carry == 1) {
			s.push_back('0');
		}
	}
	while (s.back() == '0')
		s.pop_back();
	reverse(s.begin(), s.end());
	return s;
}

string solve(string a, string b) {
	reverse(a.begin(), a.end());
	reverse(b.begin(), b.end());
	string s1 = a;
	while (s1.size() <= b.size())
		s1.push_back('0');
	s1[b.size()]++;
	s1 = normal(s1);
	string s2 = a;
	for (int i = 0; i < b.size(); ++i) {
		if (s2.size() == i) {
			s2.push_back('0');
		}
		s2[i] += (b[i] - '0');
	}
	s2 = normal(s2);
	return mn(s1, s2);
}

signed main() {
    int n = 0;
    string a, b;
    cin >> n >> a >> b;
    string a1 = solve(a, b);
    string a2 = solve(b, a);
    cout << mn(a1, a2) << endl;
    return 0;
}