#include <vector>
#include <iostream>
#include <algorithm>
#include <unordered_map>

using namespace std;

int n;

int atack(vector<int> &now, vector<vector<int> > &arr) {
	int vira, virb;
	for (int i = 0; i < n; i++) {
		for (int j = 0; j < n; j++) {
			vira = now[i];
			virb = now[j];
			if (arr[vira][j] < arr[virb][j]) return 1;
		}
	}
	return 0;
}

void gen(vector<int> &now, vector<vector<int> > &arr, vector<int> &can, int deep) {
	if (atack(now, arr) == 0 || deep >= 5) {
		for (int i = 0; i < n; i++) can[now[i]] = 1;
		return;
	}
	int vira, virb;
	for (int i = 0; i < n; i++) {
		for (int j = 0; j < n; j++) {
			vira = now[i];
			virb = now[j];
			if (arr[vira][j] < arr[virb][j]) {
				now[j] = vira;
				gen(now, arr, can, deep + 1);
				now[j] = virb;
			}
		}
	}
}

int main() {
	ios_base::sync_with_stdio(0);
	cin.tie(0);
	cin >> n;
	vector<vector<int> > arr(n);
	vector<vector<int> > arr1(n);
	for (int i = 0; i < n; i++) {
		for (int j = 0; j < n; j++) {
			arr[i].push_back(0);
		}
	}
	int el;
	for (int i = 0; i < n; i++) {
		for (int j = 0; j < n; j++) {
			cin >> el;
			el--;
			arr1[i].push_back(el);
			arr[el][i] = j;
		}
	}
	int p;
	cin >> p;
	if (p == 1) {
		vector<int> ans;
		for (int i = 0; i < n; i++) {
			if (arr1[i][0] == i) ans.push_back(i);
		}
		cout << ans.size() << endl;
		for (auto elem : ans) cout << elem + 1 << " ";
		cout << endl;
		//cin >> n;
		return 0;
	}
	vector<int> now(n);
	vector<int> can(n);
	for (int i = 0; i < n; i++) {
		now[i] = i;
		can[i] = 0;
	}
	/*for (int i = 0; i < n; i++) {
		for (int j = 0; j < n; j++) {
			cout << arr[i][j] << " ";
		}
		cout << endl;
	}*/
	gen(now, arr, can, 0);
	vector<int> ans;
	for (int i = 0; i < n; i++) {
		if (can[i] == 1) ans.push_back(i + 1);
	}
	cout << ans.size() << endl;
	for (auto elem : ans) cout << elem << " ";
	cout << endl;
	//cin >> n;
}