#define _CRT_SECURE_NO_WARNINGS
#include <iostream>
#include <algorithm>
#include <vector>
#include <queue>
#include <set>

using namespace std;

#define LL long long

int main()
{
	//freopen("input.txt", "r", stdin);
	//freopen("output.txt", "w", stdout);

	ios_base::sync_with_stdio(NULL); cin.tie(0); cout.tie(0);

	int n;
	cin >> n;

	vector< vector < int > > vosp(n, vector < int >(n)), id(n, vector< int > (n));

	for (size_t i = 0; i < n; i++)
	{
		bool f = 0;
		for (size_t j = 0; j < n; j++)
		{
			cin >> vosp[i][j];
			vosp[i][j]--;
			id[i][vosp[i][j]] = j;
		}
	}

	int p;
	cin >> p;

	if (p == 1)
	{
		int ans = 0;
		queue<int> q;

		for (size_t i = 0; i < n; i++)
		{
			if (vosp[i][0] == i)
			{
				q.push(i + 1);
				ans++;
			}
		}

		cout << ans << "\n";

		while (!q.empty())
		{
			cout << q.front() << " ";
			q.pop();
		}
	}
	else
	{
		int ans = 0;
		queue<int> que;

		for (size_t vr = 0; vr < n; vr++)
		{
			for (size_t i = 0; i < n; i++)
			{
				if (id[i][vr] > id[i][i])
					continue;

				bool p = 1;

				for (size_t kl = 0; kl < id[i][vr]; kl++)
				{
					bool f = 0;

					for (size_t j = id[i][vr]; j < n; j++)
					{
						if (id[vosp[i][kl]][vosp[i][j]] < id[vosp[i][kl]][vosp[i][kl]])
						{
							f = 1;
							break;
						}
					}

					if (!f)
					{
						p = 0;
						break;
					}
				}
				
				if (p)
				{
					ans++;
					que.push(vr + 1);
					break;
				}
			}
		}

		cout << ans << "\n";

		while (!que.empty())
		{
			cout << que.front() << " ";
			que.pop();
		}
	}

	return 0;
}