#include <bits/stdc++.h>
#define forn(i, j, n) for(int i = j; i < n; ++i)
#define forn_(i, j, n) for(int i = n-1; i >= j; --i)
#define pb push_back
#define mp make_pair
#define ll long long
#define pii pair < int, int >
#define f first
#define s second

using namespace std;

int a[300000];
pii tree[4*300000];
int mn[600000][20];

inline void build(int v, int tl, int tr) {
    if (tl == tr) tree[v] = mp(a[tl], tl);
    else {
        int m = (tl+tr)/2;
        build(v*2, tl, m);
        build(v*2+1, m+1, tr);
        tree[v] = max(tree[v*2], tree[v*2+1]);
    }
}

inline void buildm(int n) {
    forn(i, 0, n) mn[i][0] = a[i];
    forn(j, 1, 20) forn(i, 0, n) mn[i][j] = min(mn[i][j-1], mn[i+(1<<(j-1))][j-1]);
}

inline pii get_max(int v, int tl, int tr, int l, int r) {
    if (l > r) return mp(0, -1);
    if (l == tl && r == tr) return tree[v];
    int m = (tl+tr)/2;
    return max(get_max(v*2, tl, m, l, min(r, m)), get_max(v*2+1, m+1, tr, max(l, m+1), r));
}

inline int get_min(int l, int r) {
    int lg = log2(r-l+1);
    return min(mn[l][lg], mn[r-(1<<lg)+1][lg]);
}

int main() {
    ios::sync_with_stdio(false);
    cin.tie();
    int n, ans = 0; cin >> n;
    forn(i, 0, n) cin >> a[i];
    build(1, 0, n-1);
    buildm(n);
    int cnt = 0;
    while(cnt < n) {
        int l = cnt, r = n;
        while(r-l != 1) {
            int m = (l+r)/2;
            if (get_min(cnt, m) < a[cnt]) r = m;
            else l = m;
        }
        cnt = min(r, get_max(1, 0, n-1, cnt, r-1).s+1);
        ++ans;
    }
    cout << ans;
}
