#define _CRT_SECURE_NO_WARNINGS

#include <iostream>
#include <algorithm>
#include <vector>

using namespace std;

#define int long long

vector<pair<int, int>> ab;
vector<vector<int>> t;

void build(int v, int l, int r)
{
	if (r - l == 1)
		t[v].push_back(ab[l].second);
	else {
		int m = (l + r) >> 1;
		build(2 * v + 1, l, m);
		build(2 * v + 2, m, r);
		t[v].resize(t[2 * v + 1].size() + t[2 * v + 2].size());

		merge(t[2 * v + 1].begin(), t[2 * v + 1].end(),
			t[2 * v + 2].begin(), t[2 * v + 2].end(),
			t[v].begin());

		m = m;
	}
}

int cnt_low_x(int v, int l, int r, int ql, int qr, int x)
{
	if (qr <= l || r <= ql)
		return 0;
	else if (ql <= l && r <= qr)
		return t[v].end() - lower_bound(t[v].begin(), t[v].end(), x);
	else {
		int m = (l + r) >> 1;
		return cnt_low_x(2 * v + 1, l, m, ql, qr, x) + cnt_low_x(2 * v + 2, m, r, ql, qr, x);
	}
}

signed main()
{
	//freopen("input.txt", "r", stdin);

	int n;
	cin >> n;

	vector<int> a(n), b(n);
	ab.resize(n);

	for (int i = 0; i < n; i++) {
		cin >> a[i] >> b[i];
		ab[i] = { a[i], b[i] };
	}

	sort(a.begin(), a.end());
	sort(b.begin(), b.end());
	sort(ab.begin(), ab.end());
	t.resize(4 * n);
	build(0, 0, n);

	int ans = 0;

	for (int i = 0; i < n; i++)
		for (int j = 0; j < n; j++) 
			if (a[j] >= b[i]) {
				int resa = a[j] * (n - j);
				int resb = b[i] * (n - i - cnt_low_x(0, 0, n, j, n, b[i]));

				ans = max(ans, resa + resb);
			}

	cout << ans;
}
