#include <iostream>
#include <algorithm>
#include <vector>
#include <set>
#include <stack>

using namespace std;

vector<int> a;

int main()
{
	ios_base::sync_with_stdio(0), cin.tie(0);

	int n;
	cin >> n;
	a.resize(n);

	for (int i = 0; i < n; i++)
		cin >> a[i];

	set<pair<int, int>> s;

	for (int i = 0; i < n; i++)
		if (s.size() == 0 || a[i] < a[i - 1])
			s.insert({ i, i });
		else {
			int l = s.rbegin()->first;
			s.erase(--s.end());
			s.insert({ l, i });
		}

	for (auto it = s.begin(); it != s.end(); ) {
		if (it == s.begin())
			it++;
		else {
			int l2 = it->first, r2 = it->second;
			--it;
			auto it1 = it;
			int l1 = it->first, r1 = it->second;
			++it;

			if (a[l1] <= a[l2] && a[r2] >= a[r1]) {
				s.erase(it);
				s.erase(it1);
				s.insert({ l1, r2 });
				it = s.find({ l1, r2 });
			}
			else
				it++;
		}
	}

	cout << s.size();
}

/*
4
1 3 2 4
*/