#ifdef _DEV
#define DEV 1
#else
#define DEV 0
#pragma GCC optimize("Ofast")
#endif
#define _CRT_SECURE_NO_WARNINGS
#include <iostream>
#include <vector>
#include <algorithm>
#include <queue>
#include <functional>
#include <set>
using namespace std;
void entry(int testId);
int main() {
	if (DEV) {
		string fileName = "pub";
		string fin = fileName + ".txt";
		string fout = fileName + "-out.txt";
		freopen(fin.c_str(), "r", stdin);
		freopen(fout.c_str(), "w", stdout);
	}
	else {
		ios_base::sync_with_stdio(false);
		cin.tie(nullptr);
	}
	int i = 0;
	int k = 1e8;
	if (!DEV) k = 1;
	while (!cin.eof() && (k--)) {
		entry(i++);
		if (DEV) {
			cout << "--------\n";
		}
	}
}
using ll = long long;
#define endl "\n"
using TTT = tuple<int ,int, int>;
void entry(int testId) {
	int n, m, k;
	cin >> n >> m >> k;
	vector<pair<int, int>> p;
	p.reserve(k);
	for (int i = 0; i < k; ++i) {
		int x, y;
		cin >> x >> y;
		--x;
		--y;
		p.emplace_back(x, y);
	}
	vector<vector<ll>> g(k, vector<ll>(k));
	for (int i = 0; i < k; ++i) {
		for (int j = 0; j < k; ++j) {
			int dx = abs(p[i].first - p[j].first);
			int dy = abs(p[i].second - p[j].second);
			ll d = max(dx, dy);
			ll dist = (1 << d);
			g[i][j] = dist;
		}
	}
	vector<ll> dist(k, 1e18);
	vector<ll> prev(k, -1);
	prev[0] = -2;
	set<TTT> q;
	q.emplace(-2, 0, 0);
	while (q.size()) {
		auto ev = *q.begin();
		int u;
		ll d;
		int v;
		tie(u, d, v) = ev;
		q.erase(ev);
		if (d >= dist[v]) continue;
		dist[v] = d;
		prev[v] = u;
		for (int w = 0; w < k; ++w) {
			auto nd = d + g[v][w];
			if (nd < dist[w]) {
				q.emplace(v, nd, w);
			}
		}
	}
	vector<int> ans;
	int ci = k - 1;
	while (ci != -2) {
		ans.push_back(ci);
		ci = prev[ci];
	}
	if (DEV) cout << dist[k - 1] << endl;
	cout << ans.size() << endl;
	reverse(ans.begin(), ans.end());
	for (auto x : ans) cout << x + 1 << " ";
	cout << endl;
}