#ifdef _DEV
#define DEV 1
#else
#define DEV 0
#endif
#define _CRT_SECURE_NO_WARNINGS
#include <iostream>
#include <vector>
#include <algorithm>
#include <utility>
#include <string>
#include <unordered_map>
#include <map>
#include <set>
using namespace std;

void entry(int testId);

int main() {
	if (DEV) {
		freopen("roi.txt", "r", stdin);
		freopen("roi-o.txt", "w", stdout);
	}
	else {
		ios_base::sync_with_stdio(false);
		cin.tie(nullptr);
	}
	int k = 0;
	int kostyl = 1e8;
	if (!DEV) kostyl = 1;
	while (kostyl-- && !cin.eof()) {
		entry(k++);
	}

	return 0;
}
#define endl "\n"
using ll = long long;
using ld = long double;


//cut here
void entry(int testId) {
#define int ll
	int n, p;
	cin >> n >> p;
	if (n == -1) exit(0);
	vector<int> a(n);
	for (int i = 0; i < n; ++i) {
		cin >> a[i];
	}
	auto solve = [&](int i, int j)->ll {
		return (ll) abs(j - i) + (ll) a[j];
	};
	for (int f = 0; f< n; ++f) {
		int itAns = -1;
		for (int l = 0; l <= n; ++l) {
			for (int r = 0; r <= n; ++r) {
				if (l == 0 && r == n) continue;
				vector<ll> res(n, 2 * n + 1e16);
				for (int k = 0; k < n; ++k) {
					if (k >= l && k < r) continue;
					for (int i = 0; i < n; ++i) {
						res[i] = min(res[i], solve(k, i));
					}
				}
				ll resCur = res[f];
				int ans = 0;
				for (int it = 0; it < n; ++it) {
					if (res[it] < res[f]) ++ans;
				}
				itAns = max(itAns, ans);
			}
		}
		cout << itAns + 1 << endl;
	}
	cout << endl;
}
