#include <bits/stdc++.h>

using namespace std;

typedef long long ll;

vector<int> num;
int n;

int find_min(int x)
{
    int ans = x;
    for (int i = x; i < n; i++)
        if (num[i] < num[ans])
            ans = i;

    return ans;
}

void reorder(int a, int b)
{
    vector<int> newnum = num;

    int cur = a;
    for (int i = a + 1; i < b; i += 2)
    {
        newnum[cur] = num[i];
        cur++;
    }

    for (int i = a; i < b; i += 2)
    {
        newnum[cur] = num[i];
        cur++;
    }

    num = newnum;
}

int main()
{
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);

    int i;
    cin >> n;

    num.resize(n);
    for (i = 0; i < n; i++)
        cin >> num[i];

    vector<pair<int, int>> ans;
    for (i = 0; i < n - 1; i++)
    {
        int p = find_min(i);
        int minnum = num[p];

        while (num[i] != minnum)
        {
            p = find_min(i);

            if ((p - i) % 2 == 1)
            {
                ans.push_back({i + 1, n});
                reorder(i, n);
            }
            else
            {
                ans.push_back({i + 2, n});
                reorder(i + 1, n);
            }
        }
    }

    cout << ans.size() << endl;
    for (auto elem : ans)
        cout << elem.first << " " << elem.second << endl;

    return 0;
}
