#include <bits/stdc++.h>
#include <ext/pb_ds/assoc_container.hpp>

#pragma GCC optimize("Ofast")

using namespace std;
using namespace __gnu_pbds;

typedef long long ll;
typedef tree<pair<int, int>, null_type, less<pair<int, int>>, rb_tree_tag,
             tree_order_statistics_node_update> treap;

int main()
{
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);

    int n, p, i;
    cin >> n >> p;

    vector<int> num(n);
    treap left;
    treap right;
    int k;
    for (i = 0; i < n; i++)
    {
        cin >> num[i];
        num[i] += i;

        if (i > 0)
            right.insert({num[i], i});
        else
            k = num[i];
    }

    int offs = 0;

    for (i = 0; i < n; i++)
    {
        cout << left.order_of_key({k - offs, -1})
                + right.order_of_key({k + offs, -1}) + 1 << endl;

        if (i == n - 1)
            break;

        left.insert({k - offs, i});
        k = num[i + 1] - offs - 1;
        right.erase({num[i + 1], i + 1});
        offs++;
    }

    return 0;
}
