#include <bits/stdc++.h>

using namespace std;

typedef long long ll;

int main()
{
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);

    int n, i;
    cin >> n;

    vector<string> strings(n);
    int maxl = 0;
    for (i = 0; i < n; i++)
    {
        cin >> strings[i];
        reverse(strings[i].begin(), strings[i].end());
        maxl = max(maxl, (int)strings[i].size());
    }

    vector<set<int>> zeroes(n);
    for (i = 0; i < n; i++)
    {
        zeroes[i].insert(strings[i].size());

        for (int j = 0; j < strings[i].size(); j++)
            if (strings[i][j] == '0')
                zeroes[i].insert(j);
    }

    string ans;
    for (int pos = 0; pos < maxl * maxl; pos++)
    {
        int maxidx = -1;
        int cnt = 0;
        bool have_size = false;

        for (i = 0; i < n; i++)
        {
            zeroes[i].erase(pos);

            if (pos < strings[i].size() && strings[i][pos] == '1')
            {
                cnt++;

                if (maxidx == -1 || *zeroes[i].begin() > *zeroes[maxidx].begin())
                    maxidx = i;
            }

            if (pos < strings[i].size())
                have_size = true;
        }

        if (!have_size)
            break;

        if (cnt == 0)
        {
            ans += "0";
            continue;
        }
        else if (cnt == 1)
        {
            ans += "1";
            continue;
        }
        else
            ans += "1";

        int w = *zeroes[maxidx].begin();
        for (i = pos; i < w; i++)
            strings[maxidx][i] = '0';

        if (w < strings[maxidx].size())
            strings[maxidx][w] = '1';
        else
        {
            strings[maxidx] += "1";
            zeroes[maxidx].insert(w + 1);
        }

        zeroes[maxidx].erase(w);
    }

    reverse(ans.begin(), ans.end());
    cout << ans << endl;

    return 0;
}
