import java.util.*;
import java.io.*;
public class Main {
    static Point a[];
    public static void main(String args[]) throws IOException{
        InReader in=new InReader();
        int n=in.nextInt();
        a=new Point[n];
        for (int i = 0; i < n; i++) {
            a[i]=new Point();
            a[i].value=in.nextInt();
            a[i].place=i;
        }
        TreeSet<Point> find=new TreeSet<>();
        find.add(a[0]);
        for (int i = 1; i < n; i++) {
            while (!find.isEmpty() && find.first().compareTo(a[i])<0){
                find.pollFirst().lower=i;
            }
            find.add(a[i]);
        }
        find=new TreeSet<>();
        find.add(a[n-1]);
        for (int i = n-2; i >=0; i--) {
            while (!find.isEmpty() && find.last().compareTo(a[i])>0){
                find.pollLast().bigger=i;
            }
            find.add(a[i]);
        }
        System.out.print(get(0,n-1));


    }
    static int get(int l,int r){
        int sum=0;
        if(l==r){
            return 1;
        }else {
            while (a[l].lower<=r){
                sum+=get(l,a[l].lower-1);
                l=a[l].lower;
            }
            while (a[r].bigger>=l){
                sum+=get(a[r].bigger+1,r);
                r=a[r].bigger;
            }
           sum++;
            return sum;
        }
    }
    static class Point implements Comparable<Point>{
        int value;
        int place;
        int type=0;
        int bigger=-100000;
        int lower=Integer.MAX_VALUE;

        @Override
        public int compareTo(Point o) {
            if(value==o.value){
                return -place+o.place;
            }
            else {
                return o.value-value;
            }
        }
    }
    static class InReader{
        BufferedReader in=new BufferedReader(new InputStreamReader(System.in));
        StringTokenizer token=new StringTokenizer("");
        void update()throws IOException{
            if(!token.hasMoreTokens()){
               String a=in.readLine();
               if(a!=null){
                   token=new StringTokenizer(a);
               }
            }
        }
        int nextInt()throws IOException{
            update();
            return Integer.parseInt(token.nextToken());
        }
    }
}
