#include<bits/stdc++.h>
#define F first
#define S second
#define int long long
#define all(a) a.begin(), a.end()
#define pii pair<int, int>
#define vii vector<pii>

using namespace std;
struct vrtx
{
    int l, r, ans;
    vrtx()
    {
        l = r = -1;
        ans = 0;
    }
};
const int N = 50000;
vrtx seg[N];
int sz = 1;

int get(int now, int l, int r, int b, int e)
{
    if(b > e)
    {
        return 0;
    }
    if(l == b && r == e)
    {
        return seg[now].ans;
    }
    if(seg[now].l == -1)
    {
        seg[now].l = sz++;
    }
    if(seg[now].r == -1)
    {
        seg[now].r = sz++;
    }
    int mid = (l + r) / 2;
    return get(seg[now].l, l, mid, b, min(mid, e)) + get(seg[now].r, mid + 1, r, max(mid + 1, b), e);
}

void add(int now, int l, int r, int x, int val)
{
    if(l == r)
    {
        seg[now].ans += val;
        return;
    }
    if(seg[now].l == -1)
    {
        seg[now].l = sz++;
    }
    if(seg[now].r == -1)
    {
        seg[now].r = sz++;
    }
    int mid = (l + r) / 2;
    if(x <= mid)
    {
        add(seg[now].l, l, mid, x, val);
    }
    else
    {
        add(seg[now].r, mid + 1, r, x, val);
    }
    seg[now].ans = seg[seg[now].l].ans + seg[seg[now].r].ans;
}

void solve()
{
    int n, p;
    cin >> n >> p;
    int a[n], ans[n];
    for(int i = 0; i < n; i++)
    {
        cin >> a[i];
        ans[i] = 1;
    }
    if(p == 1)
    {
        for(int i = n - 1; i >= 0; i--)
        {
            ans[i] += get(0, 0, (int)2e9, 0, a[i] + i - 1);
            add(0, 0, (int)2e9, a[i] + i, 1);
        }
        for(int i = 0; i < n; i++)
        {
            add(0, 0, (int)2e9, a[i] + i, -1);
        }
        for(int i = 0; i < n; i++)
        {
            ans[i] += get(0, 0, (int)2e9, 0, a[i] + n - i - 1);
            add(0, 0, (int)2e9, a[i] + n - i, 1);
        }
    }
    for(int i = 0; i < n; i++)
    {
        cout << ans[i] << "\n";
    }
}

signed main()
{
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);
    int t = 1;
    while(t--)
    {
        solve();
    }
    return 0;
}
/*
5 1
8 5 5 7 7
*/
/*
3 1
1000000000
1000000000
1000000000
*/

