#include <iostream>
#include <vector>
#include <algorithm>


using namespace std;


int main() {
    int n, p;
    cin >> n >> p;

    vector<pair<int, int>> a(n);
    for (int i = 0; i < n; ++i) {
        cin >> a[i].first;
        a[i].second = i;
    }

    vector<pair<int, int>> np;
    for (int i = 0; i < n; ++i) {
        np = a;

        for (int j = i - 1; j >= 0; --j) {
            np[j].first += i - j;
        }

        for (int j = i + 1; j < n; ++j) {
            np[j].first += j - i;
        }

        sort(np.begin(), np.end());

        int last = -1, place = 1;
        for (int j = 0; j < n; ++j) {
            if (np[j].first != last) {
                place = j;
                last = np[j].first;
            }

            if (np[j].second == i) {
                cout << place + 1 << '\n';

                break;
            }
        }
    }

    return 0;
}