#include <iostream>
#include <vector>
#include <set>
#include <map>
#include <string>
#include <iomanip>
#include <algorithm>
#include <cmath>
#include <stack>
using namespace std;

int x;
const int len = 3e5;
int a[len];
int dp[len];

pair < int, int > t[len * 4];
void build(int v, int l, int r){
	if(l == r - 1){
		t[v] = { a[l], l };
		return;
	}
	int m = l + r >> 1;
	build(2 * v + 1, l, m);
	build(2 * v + 2, m, r);
	t[v] = min(t[2 * v + 1], t[2 * v + 2]);
}

pair < int, int > gt(int v, int l, int r, int from, int to){
	if(from <= l && r <= to)
		return t[v];
	if(from >= r || to <= l)
		return { 1ll << 30, 1ll << 30 };
	int m = l + r >> 1;
	return min(gt(2 * v + 1, l, m, from, to), gt(2 * v + 2, m, r, from, to));
}

int main(){
	scanf("%d", &x);
	for(int i = 0;i < x;i++){
		scanf("%d", &a[i]);
	}
	build(0, 0, x);

	for(int i = 0;i <= x;i++){
		dp[i] = 1 << 20;
	}

	dp[0] = 0;

	int mn = 1ll << 30;
	int pos = -1;

	stack < pair < int, int > > s;

	for(int i = 0;i < x;i++){
		while(!s.empty() && s.top().first <= a[i])
			s.pop();

		if(s.empty()){
			auto kek = gt(0, 0, x, 0, i + 1);
			dp[i + 1] = min(dp[i + 1], dp[kek.second] + 1);
		} else {
			int from = s.top().second;
			auto kek = gt(0, 0, x, from + 1, i + 1);
			dp[i + 1] = min(dp[i + 1], dp[kek.second] + 1);
		}

		s.push({ a[i], i });
		/*int mn = 1ll << 30;
		int mx = 0;
		int pos = i;
		for(int j = i;j >= 0;j--){
			mn = min(mn, a[j]);
			mx = max(mx, a[j]);
			if(mn == a[j] && mx == a[i])
				pos = j;
		}
		dp[i + 1] = min(dp[i + 1], dp[pos] + 1);*/
	}
	cout << dp[x];
}
