#include <bits/stdc++.h>

using namespace std;

typedef long long ll;

const int MAXN = (int) 1e6;

struct Tree {
    int n = MAXN;
    int t[2 * MAXN];

    int get(int l, int r) {
        int res = 0;
        for (l += n, r += n; l <= r; l /= 2, r /= 2) {
            if (l % 2 == 1) res += t[l++];
            if (r % 2 == 0) res += t[r--];
        }
        return res;
    }

    void upd(int v, int d) {
        v += n, t[v] += d, v /= 2;
        for (; v; v /= 2) t[v] += d;
    }

    Tree() {
        fill_n(t, 2 * MAXN, 0);
    }
};

const int INF = (int) 2e9;

int main() {
//    freopen("in.txt", "r", stdin);
    ios_base::sync_with_stdio(0);
    cin.tie(NULL);
    int n;
    cin >> n;
    vector<int> a(n), b(n);
    vector<int> was;
    for (int i = 0; i < n; ++i) {
        cin >> a[i] >> b[i];
        was.push_back(b[i]);
    }
    was.push_back(INF);
    sort(was.begin(), was.end());
    was.erase(unique(was.begin(), was.end()), was.end());
    auto ind = [&](int x) {
        return lower_bound(was.begin(), was.end(), x) - was.begin();
    };
    vector<int> ord(n);
    iota(ord.begin(), ord.end(), 0);
    sort(ord.begin(), ord.end(), [&](int p, int q) {
        return a[p] < a[q];
    });
    ll ans = 0;
    Tree t;
    ll cnt = n;
    auto update = [&](ll ca) {
        auto check = [&](int m) {
            int num = t.get(m, MAXN - 1);
            ll here = cnt * (ll) ca + (ll) num * (ll) was[m];
            ans = max(ans, here);
            return here;
        };
        ll l = 0, r = ind(ca);
//        cout << ca << "\n";
        while (l < r - 2) {
//            int m = (l + r) / 2;
//            cout << was[m] << ":\n";
//            cout << check(m) << "\n";
            int m1 = l + (r - l) / 3, m2 = r - (r - l) / 3;
            if (check(m1) < check(m2)) {
                l = m1;
            } else {
                r = m2;
            }
        }
        check(l);
        if (l + 1 < r) check(l + 1);
        if (was[r] <= ca) check(r);
//        cout << ca << " fin, ans is " << ans << "\n";
    };
    for (int j = 0; j < n; ++j, --cnt) {
        int i = ord[j];
        update(a[i]);
        while (j < n - 1 && a[ord[j]] == a[ord[j + 1]]) {
            t.upd(ind(b[ord[j]]), 1);
            --cnt;
            ++j;
        }
        t.upd(ind(b[ord[j]]), 1);
    }
    update(INF);
    cout << ans << "\n";
    return 0;
}
