#include <bits/stdc++.h>

using namespace std;

const int MAXN = (int) 4e5;
const int INF = (int) 1e9;
//
//struct Tree {
//    struct Node {
//        int key, priority;
//        int size;
//        Node *left, *right;
//
//        Node(int key):
//            key(key), priority(rand()),
//            left(nullptr), eight(nullptr) { }
//    };
//};

int main() {
    ios_base::sync_with_stdio(0);
    cin.tie(NULL);
    int n, p;
    cin >> n >> p;
    int a[n];
    for (int i = 0; i < n; ++i) {
        cin >> a[i];
    }
    if (p == 1) {
        for (int i = 0; i < n; ++i) {
            vector<int> buf(n + 1, 0);
            auto add = [&](int l, int r) {
                buf[l]++;
                buf[r]--;
            };
//            cout << i << ":\n";
            for (int j = 0; j < n; ++j) {
                if (j == i) continue;
//                cout << j << " - ";
                if (a[j] + j < a[i] + i) {
                    add(0, min(j, i));
//                    cout << "+(0, " << min(j, i) << ") ";
                }
                if (a[j] - j < a[i] - i) {
                    add(max(i, j), n);
//                    cout << "+(" << max(i, j) << ", " << n << ") ";
                }
                if (j < i) {
                    int k = (a[i] - a[j] + i + j) / 2;
                    if (2 * k == a[i] - a[j] + i + j) {
                        --k;
                    }
                    if (2 * (k + 1) < a[i] - a[j] + i + j) {
                        ++k;
                    }
                    k = min(k, i);
//                    cout << k << " ";
                    if (k > j) {
                        add(j, k);
//                        cout << "+(" << j << ", " << k << ") ";
                    }
                } else {
                    int k = (a[j] - a[i] + j + i) / 2 + 1;
                    if (2 * k == a[j] - a[i] + j + i) {
                        ++k;
                    }
                    if (2 * (k - 1) > a[j] - a[i] + j + i) {
                        --k;
                    }
                    k = max(k, i);
//                    cout << k << " ";
                    if (k < j) {
                        add(k, j);
//                        cout << "+(" << k << ", " << j << ") ";
                    }
                }
//                cout << "\n";
            }
            int cnt = 0;
            int mini = INF;
            for (int i = 0; i < n; ++i) {
                cnt += buf[i];
//                cout << i << " " << cnt << "\n";
                mini = min(mini, cnt);
            }
            cout << mini + 1 << "\n";
        }
//        cout << "\n";
    } else {
        int ans[n];
        fill_n(ans, n, 0);
        for (int mask = 1; mask < (1 << n); ++mask) {
            int d[n];
            fill_n(d, n, n);
            queue<int> q;
            for (int i = 0; i < n; ++i) {
                if ((mask >> i) & 1) {
                    d[i] = 0;
                    q.push(i);
                }
            }
            while (!q.empty()) {
                int v = q.front();
                q.pop();
                if (v - 1 >= 0 && d[v - 1] > d[v] + 1) {
                    d[v - 1] = d[v] + 1;
                    q.push(v - 1);
                }
                if (v + 1 < n && d[v + 1] > d[v] + 1) {
                    d[v + 1] = d[v] + 1;
                    q.push(v + 1);
                }
            }
            map<int, vector<int>> tms;
            for (int i = 0; i < n; ++i) {
                tms[d[i] + a[i]].push_back(i);
            }
            int now = 1;
            for (auto &p : tms) {
                for (auto v : p.second) {
                    ans[v] = max(ans[v], now);
                }
                now += p.second.size();
            }
        }
        for (auto v : ans) {
            cout << v << "\n";
        }
    }
    return 0;
}
/*
5 1
8 5 5 7 7
4 1
100 1 1 1
*/
