#define _CRT_SECURE_NO_WARNINGS
#define _USE_MATH_DEFINES
#include <iostream>
#include <vector>
#include <stack>
#include <algorithm>
#include <set>
#include <map>
#include <cmath>
#include <unordered_map>
#include <unordered_set>
#include <bitset>
#include <complex>
#include <iomanip>
#include <utility>

#define pb push_back
#define mp make_pair
#define eb emplace_back

using namespace std;
typedef long long ll;
typedef long double ld;
typedef unsigned long long ull;

int n, x, b[3000], obr[3000];
vector <int> a;
vector <pair<int, int>> ans;

void swapp(int l, int r)
{
	vector <int> prom;
	for (int i = l + 1; i <= r; i += 2)
		prom.pb(a[i]);
	for (int i = l; i <= r; i += 2)
		prom.pb(a[i]);
	for (int i = l; i <= r; i++)
		a[i] = prom[i - l];
	for (int i = 1; i <= n; i++)
		obr[a[i]] = i;
}

int  main()
{
#ifdef _DEBUG
	freopen("input.txt", "r", stdin);
	freopen("output.txt", "w", stdout);
#endif
	ios_base::sync_with_stdio(false);
	cin.tie(0);
	cin >> n;
	a.pb(0);
	for (int i = 1; i <= n; i++)
	{
		cin >> x;
		a.pb(x);
		obr[x] = i;
	}
	bool t = true;
	for (int i = 1; i <= n; i++)
		if (a[i] != i)
			t = false;
	if (t)
	{
		cout << 0;
		return 0;
	}
	if (n > 1000)
	{
		ans.pb({ 1, n });
		swapp(1, n);
	}

	for (int i = 1; i <= n; i++)
	{
		int x = obr[i];
		while (x != i)
		{
			if ((x - i) & 1)
			{
				ans.pb({ i, x });
				swapp(i, x);
				x = obr[i];
			}
			else
			{
				ans.pb({ i + 1, x });
				swapp(i + 1, x);
				x = obr[i];
			}
		}
	}
	cout << ans.size() << '\n';
	for (int i = 0; i < ans.size(); i++)
		cout << ans[i].first << ' ' << ans[i].second << '\n';
	return 0;
	
	
}