#include <stdio.h>
#include <bits/stdc++.h>

using namespace std;

int run();

int main() {
    ios_base::sync_with_stdio(0);
    cin.tie(nullptr);
    run();
    return 0;
}

const int MX = 2e5 + 10;

vector<set<pair<int, int> > > x(MX), y(MX);

set<int> good;
void upd(int i) {
    pair<int, int> cur = *x[i].rbegin();
    if ((*y[cur.second].rbegin()).first == cur.first)
        good.insert(i);
}

int run() {
    int n, m, q;
    cin >> n >> m >> q;
    vector<vector<int> > a(n + 1, vector<int> (m + 1));
    for (int i = 1; i <= n; ++i) {
        for (int j = 1; j <= m; ++j) {
            cin >> a[i][j];
            x[i].insert({a[i][j], j});
            y[j].insert({a[i][j], i});
        }
    }

    while (q--) {
        int r, c, val;
        cin >> r >> c >> val;
        x[r].erase({a[r][c], c});
        y[c].erase({a[r][c], r});
        a[r][c] = val;
        x[r].insert({a[r][c], c});
        y[c].insert({a[r][c], r});

        good.clear();
        for (int i = 1; i <= n; ++i)
            upd(i);

        cout << (int)good.size() << '\n';
    }
}


/*
2 3 3
1 4 3
6 5 2
2 2 9
1 3 5
2 2 10
*/
