#include <stdio.h>
#include <bits/stdc++.h>

using namespace std;

int run();

int main() {
    ios_base::sync_with_stdio(0);
    cin.tie(nullptr);
    run();
    return 0;
}

typedef long long ll;

vector<pair<int, int> > a;

ll get(ll A, ll B) {
    ll cur = 0;
    for (int t = 0; t < (int)a.size(); ++t) {
        if (a[t].first >= A)
            cur += A;
        else if (a[t].second >= B)
            cur += B;
    }
    return cur;
}

ll func(ll B, int ind) {
    ll cnt = 0;
    for (int i = 0; i < ind; ++i)
        cnt += (ll)(a[i].second >= B) * B;
    return cnt;
}

int run() {
    int n;
    cin >> n;
    for (int i = 0; i < n; ++i) {
        int x, y;
        cin >> x >> y;
        a.push_back({x, y});
    }
    sort(a.begin(), a.end());
    /*cout << "sorted : " << endl;
    for (int i = 0; i < n; ++i) {
        cout << a[i].first << ' ' << a[i].second << endl;
    }*/
    ll ans = 0;
    /*for (int i = 0; i < n; ++i) for (int j = 0; j < n; ++j) if (a[i].first >= a[j].second) {
        ll A = a[i].first;
        ll B = a[j].second;
        ll cur = get(A, B);
        ans = max(ans, cur);
    }*/
    for (int i = 0; i < n; ++i) {
        ll A = a[i].first;
        //cout << A << endl;
        ll cur = A * (n - i);
        //cout << cur << endl;
        ll L = 1, R = 1e9 + 10;
        while (L + 2 < R) {
            ll M1 = L + (R - L) / 3;
            ll M2 = R - (R - L) / 3;
            if (func(M1, i) < func(M2, i))
                L = M1;
            else
                R = M2;
        }
        //cout << L << ' ' << R << ' ' << func(40, i) << endl;
        ll best = func(L, i);
        for (ll x = L + 1; x <= R; ++x) {
            best = max(best, func(x, i));
        }
        ans = max(ans, cur + best);
    }
    cout << ans;
}

/*
5
80 20
60 50
40 40
15 10
70 30
*/
