#include <stdio.h>
#include <bits/stdc++.h>

using namespace std;

int run();

int main() {
    ios_base::sync_with_stdio(0);
    cin.tie(nullptr);
    run();
    return 0;
}

typedef long long ll;

int n, m, k;

const int maxn = 501;
const ll inf = 1e18;

ll dist(pair<int, int> x, pair<int, int> y) {
    ll pw = max(abs(x.first - y.first), abs(x.second - y.second));
    return (1LL << pw);
}

ll d[maxn];
int pr[maxn];
bool used[maxn];

vector<pair<int, int> > a;

int run() {
    cin >> n >> m >> k;
    for (int i = 0; i < k; ++i) {
        int x, y;
        cin >> x >> y;
        a.push_back({x, y});
    }
    for (int i = 0; i < k; ++i) d[i] = inf;
    pr[0] = -1;
    d[0] = 0;
    priority_queue<pair<ll, int>, vector<pair<ll, int> >, greater<pair<ll, int> > > q;
    q.push({0, 0});
    for (int i = 0; i < k; ++i) {
        if (q.empty())
            break;
        auto p = q.top();
        q.pop();
        while (!q.empty() && used[p.second]) {
            p = q.top();
            q.pop();
        }
        if (used[p.second])
            break;
        int v = p.second;
        //cout << v << ' ' << d[v] << endl;
        used[v] = 1;
        for (int j = 0; j < k; ++j) {
            if (d[j] > d[v] + dist(a[v], a[j])) {
                d[j] = d[v] + dist(a[v], a[j]);
                q.push({d[j], j});
                pr[j] = v;
            }
        }
    }
    vector<int> ans;
    int v = k - 1;
    while (v != -1) {
        ans.push_back(v);
        v = pr[v];
    }
    reverse(ans.begin(), ans.end());
    cout << (int)ans.size() << '\n';
    for (int i : ans)
        cout << i + 1 << ' ';
}

/*
4 5 3
1 1
2 3
4 5

5 6 9
1 1
4 3
4 6
2 5
3 1
3 3
3 6
5 4
5 6
*/
