#include <stdio.h>
#include <bits/stdc++.h>

using namespace std;

int N;
vector<string> mas;

int solve();
string run(string a, string b);

int main() {
    ios_base::sync_with_stdio(0);
    cin.tie(nullptr);
    cin >> N;
    for (int i = 0; i < N; ++i) {
        string cur;
        cin >> cur;
        mas.push_back(cur);
    }
    solve();
    return 0;
}

const int maxn = 3e5 + 10;

bool operator < (bitset<maxn> x, bitset<maxn> y) {
    for (int i = maxn - 1; i >= 0; --i) {
        if (x[i] && !y[i])
            return false;
        else if (!x[i] && y[i])
            return true;
    }
    return false;
}

int n, m;

bitset<maxn> getAns(bitset<maxn> x, bitset<maxn> y) {
    int last = -1;
    for (int i = 0; i < n; ++i) {
        if (x[i] == y[i] && x[i])
            x[i] = 0, last = i;
    }

    if (last != -1) {
        int bit = -1;
        for (int i = last + 1; i < maxn; ++i) {
            if (!y[i] && !x[i]) {
                x[i] = 1;
                bit = i;
                break;
            }
        }
        for (int i = bit - 1; i >= 0; --i)
            x[i] = 0;
    }
    x = x | y;
    return x;
}

string run(string a, string b) {
    reverse(a.begin(), a.end());
    reverse(b.begin(), b.end());

    bitset<maxn> x, y;
    n = (int)a.size();
    m = (int)b.size();
    for (int i = 0; i < a.size(); ++i) {
        if (a[i] == '1')
            x[i] = 1;
    }
    for (int i = 0; i < b.size(); ++i) {
        if (b[i] == '1')
            y[i] = 1;
    }

    bitset<maxn> ans1 = getAns(x, y);
    bitset<maxn> ans2 = getAns(y, x);
    if (ans2 < ans1)
        ans1 = ans2;

    bool st = false;
    string s = "";
    for (int i = maxn - 1; i >= 0; --i) {
        if (ans1[i]) st = true;
        if (st)
            s += char((int)ans1[i] + '0');
    }
    return s;
}

int solve() {
    string ans = run(mas[0], mas[1]);
    for (int i = 2; i < N; ++i)
        ans = run(ans, mas[i]);
    cout << ans;
}

/*
2
10
10

2
10100
1001

3
1
1
110
*/
