#include <iostream>
#include <vector>
#include <algorithm>
#include <set>
#include <stdio.h>
#include <map>


using namespace std;

int s[3000];
int lst[3000];

void get(int l, int r){
    int cur = l;
    for (int i = l + 1; i < r + 1; i += 2)
        lst[cur++] = s[i];
    for (int i = l; i < r + 1; i += 2)
        lst[cur++] = s[i];
    for (int i = l; i < r + 1; i++)
        s[i] = lst[i];
}

int main()
{
    #ifdef ONPC
        freopen("test.in", "r", stdin);
    #endif // ONPC
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    int n;
    cin >> n;
    for (int i = 0; i < n; i++){
        cin >> s[i];
        s[i]--;
    }
    vector<pair<int, int> > answer;
    for (int i = 0; i < n; i++){
        int x = 0;
        for (int j = 0; j < n; j++)
            if (s[j] == i)
                x = j;
        while (x != i){
            if ((x - i) % 2 == 1){
                answer.push_back(make_pair(i, x));
                get(i, x);
                x -= (x - i + 1) / 2;
            }
            else{
                answer.push_back(make_pair(i + 1, x));
                get(i + 1, x);
                x -= (x - i) / 2;
            }
        }
    }
    cout << answer.size() << "\n";
    for (int i = 0; i < answer.size(); i++)
        cout << answer[i].first + 1 << " " << answer[i].second + 1 << "\n";
    return 0;
}
