#define _CRT_SECURE_NO_DEPRECATE
#include <iostream>
#include <algorithm>
#include <vector>
#include <set>
#include <cmath>
#include <string>
#include <iomanip>
using namespace std;
typedef long long int int64;
typedef long double ld;
typedef vector <int> vint;
typedef vector <vint> vvint;
vector <pair <int, int>> ans;
vector <pair<int,int>> t1, t2;
#define inf 200000000
pair <int, int> getmin(int v, int tl, int tr, int l, int r)
{
	if (tl > r || tr < l)
		return { inf, -1 };
	if (tl == tr || (tl == l && tr == r))
		return t1[v];
	pair <int, int> f, s;
	f = getmin(v*2, tl, (tl+tr)/2, l, r);
	s = getmin(v*2+1, (tl+tr)/2+1, tr, l, r);
	if ((f.first < s.first) || (f.first == s.first && f.second < s.second))
		return f;
	else
		return s;
}
pair <int, int> getmax(int v, int tl, int tr, int l, int r)
{
	if (tl > r || tr < l)
		return { -inf, -1 };
	if ((tl == tr) || (tl ==l && tr == r))
		return t2[v];
	pair <int, int> f, s;
	f = getmax(v*2, tl, (tl+tr)/2, l, r);
	s = getmax(v*2+1, (tl+tr)/2+1, tr, l, r);
	if ((f.first > s.first) || (f.first == s.first) && (f.second > s.second))
		return f;
	else
		return s;
}
void updatemin(int v, int tl, int tr, int pos, int val)
{
	if (tl > pos || tr < pos)
		return;
	if (tl == tr)
	{
		t1[v].first = val;
		t1[v].second = tl;
		return;
	}
	updatemin(v*2, tl, (tl+tr)/2, pos, val);
	updatemin(v*2+1, (tl+tr)/2+1, tr, pos, val);
	pair <int, int> f, s;
	f = getmin(v*2, tl, (tl+tr)/2, tl, (tl+tr)/2);
	s = getmin(v*2+1, (tl+tr)/2+1, tr, (tl+tr)/2+1, tr);
	if (f.first < s.first || (f.first == s.first && f.second < s.second))
		t1[v] = f;
	else
		t1[v] = s;

}
void updatemax(int v, int tl, int tr, int pos, int val)
{
	if (tl > pos || tr < pos)
		return;
	if (tl == tr)
	{
		t2[v].first = val;
		t2[v].second = tl;
		return;
	}
	updatemax(v*2, tl, (tl+tr)/2, pos, val);
	updatemax(v*2+1, (tl+tr)/2 + 1, tr, pos, val);
	pair <int, int> f, s;
	f = getmax(v*2, tl, (tl+tr)/2, tl, (tl+tr)/2);
	s = getmax(v*2+1, (tl+tr)/2+1, tr, (tl+tr)/2+1, tr);
	if (f.first < s.first || (f.first == s.first && f.second < s.second))
		t2[v] = s;
	else
		t2[v] = f;
}
int main()
{
	//freopen("input.txt", "r", stdin);
	//freopen("output.txt", "w", stdout);
	int n;
	cin >> n;
	vint a(n);
	for (int i = 0; i < n; ++i)
		cin >> a[i];
	t1.resize(4 * n, { inf,-1 });
	t2.resize(4 * n, {-inf, - 1});
	for (int i = 0; i < n; ++i)
	{
		updatemax(1, 0, n-1, i, a[i]);
		updatemin(1, 0, n - 1, i, a[i]);
	}
	int l = 0, cnt = 0;
	while (l < n)
	{
		int r = n - 1;
		while (true)
		{
			pair <int, int> min1 = getmin(1, 0, n - 1, l, r);
			if (min1.first < a[l])
				r = min1.second-1;
			else
				break;
		}
		pair <int, int> nw = getmax(1, 0, n - 1, l, r);
		l = nw.second + 1;
		cnt++;
	}
	cout << cnt;
}