#define _CRT_SECURE_NO_DEPRECATE

#include <iostream>
#include <set>
#include <map>
#include <string>
#include <vector>
#include <algorithm>

using namespace std;

void solve();

int main() {
#ifdef _DEBUG
	freopen("input.txt", "r", stdin);
	freopen("output.txt", "w", stdout);
#endif
	ios_base::sync_with_stdio(false);
	cin.tie(0);
	cout.tie(0);
	solve();
	return 0;
}

const int maxn = 3000;
int n;
int a[maxn];
vector<int> ansL;
vector<int> ansR;
vector<int> ord;
multiset<int> s;
void qqsort(int l, int r) {
	if (r - l <= 1)return;
	ord.clear();
	for (int i = l + 1; i < r; i += 2)ord.push_back(a[i]);
	for (int i = l; i < r; i += 2)ord.push_back(a[i]);
	ansL.push_back(l + 1);
	ansR.push_back(r);
	for (int i = 0; i < r - l; ++i)
		a[l + i] = ord[i];
	s.clear();
	for (int i = l; i < r; ++i)
		s.insert(a[i]);
	int mx = a[0];
	for (int i = l; i < r; ++i) {
		if (*s.begin() >= a[i] && a[i] >= mx) {
			qqsort(l, i);
			qqsort(i + 1, r);
			return;
		}
		s.erase(s.find(a[i]));
		mx = max(mx, a[i]);
	}
	qqsort(l, r);
}
void solve() {
	cin >> n;
	for (int i = 0; i < n; ++i)
		cin >> a[i];
	qqsort(0, n);
	cout << ansL.size() << endl;
	for (int i = 0; i < ansL.size(); ++i)
		cout << ansL[i] << ' ' << ansR[i] << endl;
}
