#include <bits/stdc++.h>
#define ll long long

using namespace std;

const int INF = 1e9 + 7;
const int MAXN = 1e6 + 7;
const double EPS = 1e-7;

vector <int> a;
int n;

vector <pair <int, int> > res;

void S(int l, int r) {
    res.push_back({l, r});
    vector <int> b;
    for (int i = l + 1; i <= r; i += 2) {
        b.push_back(a[i]);
    }
    for (int i = l; i <= r; i += 2) {
        b.push_back(a[i]);
    }
    for (int i = l; i <= r; i++) {
        a[i] = b[i - l];
    }
}

int findp(int x) {
    for (int i = 0; i < n; i++) {
        if (a[i] == x) {
            return i;
        }
    }
    assert(false);
}

int main() {
    #ifdef MY
        freopen("input.txt", "r", stdin);
    #else
        ios_base::sync_with_stdio(false);
        cin.tie(0);
        cout.tie(0);
    #endif // MY
    cin >> n;
    a.resize(n);
    for (int i = 0; i < n; i++) {
        cin >> a[i];
        a[i]--;
    }
    for (int v = 0; v < n; v++) {
        int iter = 0;
        while (findp(v) != v) {
            int pos = findp(v);
            if (pos % 2 == v % 2) {
                S(v + 1, n - 1);
            } else {
                S(v, n - 1);
            }
        }
        assert(iter < 13);
    }
    cout << res.size() << "\n";
    for (auto p : res) {
        cout << p.first + 1 << " " << p.second + 1 << "\n";
    }
}
