#define _CRT_SECURE_NO_WARNINGS

#pragma GCC optimize("Ofast,unroll-loops")
#pragma GCC target("sse4,popcnt,tune=native")

#include <iostream>
#include <vector>
#include <algorithm>
#include <string>
#include <set>
#include <map>
#include <cstdlib>
#include <cassert>
#include <iterator>
#include <functional>
#include <numeric>

using namespace std;

typedef long long ll;
typedef long double ld;

//#define int long long
#define all(v) v.begin(),v.end()
#define rall(v) v.rbegin(),v.rend()
#define sz(v) (int)v.size()

void run();

signed main() {
	iostream::sync_with_stdio(false);
	cin.tie(0);
	cout.tie(0);
#ifdef _DEBUG
	freopen("input.txt", "r", stdin);
#endif
	run();
#ifdef _DEBUG
	cerr << "\nOK\n";
	while (1);
#endif
}

void run() {
	int n;
	cin >> n;
	vector<pair<int, int>> mas(n);
	for (int i = 0; i < n; i++) {
		cin >> mas[i].first >> mas[i].second;

	}
	sort(all(mas));
	ll ans = 0;
	vector<int> cur_b;
	for (int i = 0; i < n; i++) {
		int rcnt = n - i;
		ll cur_ans = 1LL * mas[i].first * rcnt;
		ll add_ans = 0;
		for (int j = 0; j < i; j++) {
			if (mas[j].second > mas[i].first)
				continue;
			auto it = upper_bound(all(cur_b), mas[j].second, greater<int>());
			int lcnt = (int)(it - cur_b.begin());
			add_ans = max(add_ans, 1LL * mas[j].second * lcnt);
		}
		ans = max(ans, add_ans + cur_ans);
		cur_b.push_back(mas[i].second);
		int k = sz(cur_b) - 1;
		while (k > 0 && cur_b[k - 1] < cur_b[k]) {
			swap(cur_b[k - 1], cur_b[k]);
			k--;
		}
	}

	cout << ans;
}