#define _CRT_SECURE_NO_WARNINGS
//
//#pragma GCC optimize("Ofast,unroll-loops")
//#pragma GCC target("sse,sse2,sse3,sse4,popcnt,tune=native")

#include <iostream>
#include <vector>
#include <algorithm>
#include <set>
#include <map>
#include <queue>
#include <deque>
#include <unordered_map>
#include <string>
#include <cassert>

using namespace std;

typedef long long ll;
typedef long double ld;

#define int long long
#define sz(v) (int)v.size()
#define all(v) v.begin(),v.end()
#define rall(v) v.rbegin(),v.rend()

void run();

signed main() {
#ifdef _DEBUG
	freopen("input.txt", "r", stdin);
#endif
	iostream::sync_with_stdio(false);
	cin.tie(0);
	cout.tie(0);
	run();
#ifdef _DEBUG
	cerr << "\nOK\n";
	while (1);
#endif
}

const int MAXN = 3e5 + 123;
const int INF = 1e9 + 123;

void run() {
	int n;
	cin >> n;
	vector<int> mas(n);
	for (int i = 0; i < n; i++) {
		cin >> mas[i];
	}

	vector<pair<int, int>> ans;
	while (1) {
		bool ok = false;
		for (int i = 0; i < n - 1; i++) {
			if (mas[i] > mas[i + 1]) {
				ans.push_back({ i + 1, i + 2 });
				swap(mas[i], mas[i + 1]);
			}
		}
		if (!ok) break;
	}

	cout << sz(ans) << endl;
	for (auto p : ans)
		cout << p.first << ' ' << p.second << endl;;
}