#include <iostream>
#include <vector>
#include <map>
#include <algorithm>

#define fi first
#define se second
#define re return
#define pb push_back

#define F(i, a, b) for (int (i) = (a); (i) < (b); (i)++)
#define f(i, n) F(i, 0, n)

#define all(v) (v).begin(), (v).end()

using namespace std;

typedef pair<int, int> pii;
typedef long long ll;
typedef long double ld;

int run();

int main() {
#ifdef home
    freopen("i", "r", stdin);
    freopen("d", "w", stderr);
#endif
    ios::sync_with_stdio(false);
    cin.tie(nullptr);
    cout.tie(nullptr);
    run();
}

ll a[150500];
ll b[150500];

struct node {
    ll val;
    node *l, *r;

    int cnt = 0;

    node(int cnt = 0) {
        l = r = 0;
        val = 0;
        this->cnt = cnt;
    }
} *root = new node();

ll get() {
    re root->val;
}

int sz = 1e9 + 7;

map<int, vector<int>> p;

void add(node *cur, int rb, int l = 0, int r = sz) {
    if (l == r - 1) {
        cur->cnt++;
        cur->val = cur->cnt * l;
        return;
    }
    int mid = (l + r) / 2;
    if (rb < mid) {
        if (!cur->l) {
            cur->l = new node(cur->cnt);
        }
        add(cur->l, rb, l, mid);
    } else {
        cur->cnt++;
        if (!cur->r) {
            cur->r = new node();
        }
        if (cur->l && cur->l->val > cur->r->val) {
            add(cur->l, rb, l, mid);
        }
        add(cur->r, rb, mid, r);
    }
    if (cur->l) {
        cur->val = max(cur->val, cur->l->val);
    }
    if (cur->r) {
        cur->val = max(cur->val, cur->r->val);
    }
}


int run() {
    ll n;
    cin >> n;
    f(i, n) {
        cin >> a[i] >> b[i];
        p[a[i]].pb(i);
    }

    ll cnt = n;

    ll ans = 0;

    for (const auto &x : p) {
        ans = max(ans, get() + cnt * x.fi);
//        cerr << x.fi << ' ' << get << "\n";
        for (const auto &y : x.second) {
            add(root, b[y]);
        }
        cnt -= x.second.size();
    }

    cout << ans;

    return 0;
}