#include <iostream>

#define fi first
#define se second
#define re return
#define pb push_back

#define F(i, a, b) for (int (i) = (a); (i) < (b); (i)++)
#define f(i, n) F(i, 0, n)

using namespace std;

typedef long long ll;
typedef pair<int, int> pii;
typedef long double ld;

int run();

int main() {
#ifdef home
  freopen("i", "r", stdin);
  freopen("d", "w", stderr);
#endif
  ios::sync_with_stdio(false);
  cin.tie(nullptr);
  cout.tie(nullptr);

  run();
}

int a[300500];

pii mx[1500000];
pii mn[1500000];

int n;

void add(int cur, int to, int val, int l = 0, int r = n) {
  if (l == r - 1) {
    mx[cur] = {val, l};
    mn[cur] = {val, l};
    re;
  }
  int mid = (l + r) / 2;

  if (to < mid) {
    add(cur * 2, to, val, l, mid);
  } else {
    add(cur * 2 + 1, to, val, mid, r);
  }

  mx[cur] = max(mx[cur * 2], mx[cur * 2 + 1]);
  mn[cur] = min(mn[cur * 2], mn[cur * 2 + 1]);
}

pii min_val = {0, 0};

pii get_max(int cur, int lb, int rb, int l = 0, int r = n) {
  if (lb <= l && rb >= r) {
      re mx[cur];
  }
  if (lb >= r || rb <= l) {
    re min_val;
  }
  int mid = (l + r) / 2;
  auto v1 = get_max(cur * 2, lb, rb, l, mid);
  auto v2 = get_max(cur * 2 + 1, lb, rb, mid, r);
  if (v2 < v1) {
    re v1;
  }
  re v2;
}

pii max_val = make_pair(1000000500, -1);

pii get_min(int cur, int lb, int rb, int l = 0, int r = n) {
  if (lb <= l && rb >= r) {
    re mn[cur];
  }
  if (lb >= r || rb <= l) {
    re max_val;
  }
  int mid = (l + r) / 2;
  auto v1 = get_min(cur * 2, lb, rb, l, mid);
  auto v2 = get_min(cur * 2 + 1, lb, rb, mid, r);
  if (v1 < v2) {
    re v1;
  }
  re v2;
}

int ans;

void solve(int l, int r) {
  if (l == r) return;
  ans++;
  int lb = get_min(1, l, r).second;
  int rb = get_max(1, lb, r).second;
//  cerr << l << ' ' << r << "  " << lb << ' ' << rb << endl;
  solve(l, lb);
  solve(rb + 1, r);
}

int run() {
  cin >> n;
  f(i, n) {
    cin >> a[i];
    add(1, i, a[i]);
  }

  solve(0, n);
  cout << ans;
  return 0;
}