#pragma GCC optimize("Ofast")
#pragma GCC target("sse,sse2,ssse3")
#include <bits/stdc++.h>
#include <ext/pb_ds/assoc_container.hpp>
#define ll long long
#define all(x) x.begin(), x.end()
#define F first
#define S second
#define pb push_back

using namespace std;
using namespace __gnu_pbds;

using ordered_set = tree<pair<int, int>, null_type, less<pair<int, int>>, rb_tree_tag, tree_order_statistics_node_update>;

void run();

int main()
{
    ios::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);
    run();
    return 0;
}

#define debug(x) debugdo(cout << x << endl)
#define debugs(x) debugdo(cout << x << " ")
#define debug_for(x) debug(#x":"); for (auto _x: x) debugs(_x); debug("")

#define DEBUG
#if defined DEBUG && defined LOCAL
    #define debugdo(x) x
#else
    #define debugdo(x)
#endif

void run()
{
    int n, p;
    cin >> n >> p;
    vector<int> a(n);
    for (auto &x: a)
        cin >> x;
    int t = 0;
    if (p == 1)
    {
        vector<int> ans(n);
        ordered_set p;
        int d = 0;
        for (int i = 0; i < n; i++)
        {
            d++;
            ans[i] += p.order_of_key({a[i] - d, 0});
            p.insert({a[i] - d, t++});
        }
        debug_for(ans);
        p.clear();
        d = 0;
        for (int i = n - 1; i >= 0; i--)
        {
            d++;
            ans[i] += p.order_of_key({a[i] - d, 0});
            p.insert({a[i] - d, t++});
        }
        for (auto x: ans)
            cout << x + 1 << "\n";
    }
    else
    {
        vector<int> ans(n);
        for (int i = 0; i < n; i++)
        {
            vector<pair<int, int>> e;
            int c = 0, l = 0, r = 0;
            for (int j = 0; j < n; j++)
            {
                if (a[j] >= a[i] && a[j] - a[i] >= abs(i - j))
                    continue;
                e.pb({a[j] - a[i] + 1, -1});
                if (j < i)
                    l++;
                else
                    r++;
            }
            e.pb({i, l});
            e.pb({n - 1 - i, r});
            sort(all(e));
            for (auto &x: e)
            {
                debug(i << " " << x.S << " " << x.F);
                c -= x.S;
                ans[i] = max(ans[i], c);
            }
        }
        for (auto x: ans)
            cout << x + 1 << "\n";
    }
}

/*
5 2
8 5 5 7 7
*/
