#include <bits/stdc++.h>

using namespace std;
using ll = long long;
using ld = long double;
using pii = pair<int, int>;
using pll = pair<ll, ll>;

#define mp make_pair
#define mt make_tuple
#define all(x) (x).begin(), (x).end()
#define X first
#define Y second
#define A(x) get<0>(x)
#define B(x) get<1>(x)
#define C(x) get<2>(x)
#define D(x) get<3>(x)

#ifdef REK
#define dbg(...) cout <<__VA_ARGS__
#else
#define dbg(...) ((void) 0)
#endif

inline void boost() {
	ios_base::sync_with_stdio(false);
	cin.tie(nullptr);
}
constexpr int N = 525;


bool operator<(const bitset<N> &b1, const bitset<N> &b2) {
	for (int i = N-1; i >= 0; i--) {
		if (b1[i] < b2[i]) {
			return true;
		}
		if (b1[i] > b2[i]) {
			return false;
		}
	}

	return false;
}

bitset<N> d [N];
int rec [N];
pii vert [N];
bool vis [N];

int n, m, k;

inline void add(bitset<N> &bs, int at) {
	dbg("add " << bs << " at " << at << endl);
		int cnt = 0;
		while (bs[at+cnt] == 1) {
			cnt++;
		}
		for (int i = at; i < at+cnt; i++) {
			bs[i] = 0;
		}
		bs[at+cnt] = 1;
}

void dijkstra(int start) {
	auto bs = bitset<N>();
	bs.set();
	fill_n(d, k, bs);

	d[start] = bitset<N>();
	for (int i = 0; i < k; i++) {
		int idx = -1;

		for (int j = 0; j < k; j++) {
			if (!vis[j] && (idx == -1 || d[j] < d[idx])) {
				idx = j;
			}
			//dbg(d[j] << endl);
		}

		if (idx == -1) break;

		vis[idx] = true;

		dbg("dickstrea " << idx << " " << vis[idx] << endl);

		for (int j = 0; j < k; j++) {
			if (j == idx) continue;

			auto best = d[idx];
			add(best, max(abs(vert[idx].X - vert[j].X), abs(vert[idx].Y - vert[j].Y)));
			dbg("res is " << best << endl);

			if (best < d[j]) {
				dbg("best for [" << j << "] is " << best << endl);
				d[j] = best;
				rec[j] = idx;
				dbg("rec " << j << ", " << idx << endl);
			}
		}
	}
}

int main(void) {
	boost();

	cin >> n >> m >> k;

	for (int i = 0; i < k; i++) {
		int x, y;
		cin >> x >> y;
		vert[i] = mp(x, y);
	}

	dijkstra(0);

	vector<int> ans;
	int at = k-1;
	ans.push_back(at);
	do {
		at = rec[at];
		ans.push_back(at);
	} while (at != 0);

	reverse(all(ans));

	cout << (int) ans.size() << "\n";

	for (int a : ans) {
		cout << a+1 << " ";
	}

	return 0;
}