#include<iostream>
#include<algorithm>
#include<vector>
#include<map>
using namespace std;

#pragma warning(disable : 4996)
#define ll long long int
#define all(vec) vec.begin(), vec.end()

const int N = 505;
int x[N], y[N];
ll dp[N][N], p[N][N];
vector<int> v;

void f(int a, int b) {
	if (p[a][b] == -1)
		return;
	f(a, p[a][b]);
	v.push_back(p[a][b]);
	f(p[a][b], b);
}

int main() {
#ifdef _DEBUG
	freopen("input.txt", "r", stdin);
	freopen("output.txt", "w", stdout);
#endif
	int n, m, k;
	scanf("%d%d%d", &n, &m, &k);


	for (int i = 0; i < k; i++) {
		scanf("%d%d", &x[i], &y[i]);
	}
	
	for (int i = 0; i < k; i++) {
		for (int j = 0; j < k; j++) {
			p[i][j] = -1;
			if (i != j)
				dp[i][j] = dp[j][i] = (1 << max(abs(x[i] - x[j]), abs(y[i] - y[j])));
		}
	}

	for (int t = 0; t < k; t++) {
		for (int j = 0; j < k; j++) {
			for (int i = 0; i < k; i++) {
				ll d = dp[i][t] + dp[t][j];
				if (d < dp[i][j]) {
					dp[i][j] = d;
					p[i][j] = t;
				}
			}
		}
	}


	v.push_back(0);
	f(0, k - 1);
	v.push_back(k - 1);

	printf("%d\n", v.size());

	for (int i : v)
		printf("%d ", i + 1);



	return 0;
}