#include <algorithm>
#include <bitset>
#include <complex>
#include <deque>
#include <exception>
#include <fstream>
#include <functional>
#include <iomanip>
#include <ios>
#include <iosfwd>
#include <iostream>
#include <istream>
#include <iterator>
#include <limits>
#include <list>
#include <locale>
#include <map>
#include <memory>
#include <new>
#include <numeric>
#include <ostream>
#include <queue>
#include <set>
#include <sstream>
#include <stack>
#include <stdexcept>
#include <streambuf>
#include <string>
#include <typeinfo>
#include <utility>
#include <valarray>
#include <vector>
using namespace std;

#pragma warning (disable : 4996)
#define ll long long int
#define all(vec) vec.begin(), vec.end()

const int N = 4e5 + 100, INF = 1e9;
int a[N], q[N];
pair<int, int> b[N];
int n, p;


int mn[N], mxpl[N], mnpl[N];

void brute() {
	for (int i = 0; i < n; i++) {
		mnpl[i] = 1e9;
	}

	for (int m = 1; m < (1 << n); m++) {
		for (int i = 0; i < n; i++)
			mn[i] = 1e9;
		int t = -1e9;
		for (int i = 0; i < n; i++) {
			if ((m >> i) & 1)
				t = i;
			mn[i] = min(mn[i], abs(i - t));
		}
		t = 1e9;
		for (int i = n - 1; i >= 0; i--) {
			if ((m >> i) & 1)
				t = i;
			mn[i] = min(mn[i], abs(i - t));
		}

		for (int i = 0; i < n; i++) {
			b[i] = { mn[i] + a[i], i };
		}
		sort(b, b + n);


		int cp = 1;
		for (int i = 0; i < n; i++) {
			if (i && b[i].first != b[i - 1].first)
				cp = i + 1;
			mxpl[b[i].second] = max(mxpl[b[i].second], cp);
			mnpl[b[i].second] = min(mnpl[b[i].second], cp);
		}
	}
}

int main() {
#ifdef _DEBUG
	freopen("input.txt", "r", stdin);
	freopen("output.txt", "w", stdout);
#endif
	
	scanf("%d%d", &n, &p);

	for (int i = 0; i < n; i++)
		scanf("%d", &a[i]);

	for (int i = -1; i < n; i++) {
		for (int j = 0; j <= n; j++) {
			if (i == -1 && j == n)
				continue;
			for (int k = 0; k < n; k++) {
				if (k <= i || k >= j)
					b[k] = { a[k], k };
				else
					b[k] = { min(j == n ? INF : abs(k - j), i == -1 ? INF : abs(k - i)) + a[k], k };
			}
			sort(b, b + n);
			int cp = 1;
			for (int i = 0; i < n; i++) {
				if (i && b[i].first != b[i - 1].first)
					cp = i + 1;
				q[b[i].second] = max(q[b[i].second], cp);
			}
		}
	}

	for (int i = 0; i < n; i++)
		printf("%d\n", q[i]);

	return 0;
}