#include <iostream>
#include <algorithm>
#include <vector>
#include <set>
using namespace std;

#define int long long

struct buy
{
	int a = 0, b = 0;
};

int find(const vector<int> &a, int x)
{
	int l = 0, r = a.size();
	if (x < a.front())
		return 1;
	if (x > a.back())
		return a.size() + 1;
	while (r - l > 1)
	{
		int m = (l + r) >> 1;
		if (a[m] >= x)
			r = m;
		else
			l = m;
	}
	return r + 1;
}

signed main()
{
	ios_base::sync_with_stdio(0);
	cin.tie(0); cout.tie(0);
	int n; cin >> n;
	vector<buy> v(n);
	vector<int> all, s;
	for (int i = 0; i < n; i++)
	{
		cin >> v[i].a >> v[i].b;
		s.push_back(v[i].a);
		all.push_back(v[i].a);
		all.push_back(v[i].b);
	}
	sort(all.begin(), all.end());
	sort(s.begin(), s.end());
	all.resize(unique(all.begin(), all.end()) - all.begin());

	int ans = 0;
	for (int i = 0; i < all.size(); i++)
	{
		//	for (int j = 0; j <= i; j++)
			//{
		/*int cur = 0, x = all[i], y = 0;
		for (int k = 0; k < n; k++)
			if (x <= v[k].a)
				cur += x;
			else if (y <= v[k].b)
				cur += y;
		ans = max(ans, cur);*/
		//}
		ans = max(ans, (s.size() - find(s, all[i]) + 1) * all[i]);
	}
	cout << ans << endl;
	system("pause");
}