#include <iostream>
#include <vector>
#include <set>
#include <fstream>

#define int long long

using namespace std;

void prt(vector<int> a){
    for (auto i : a){
        cout << i << ' ';
    }
    cout << endl;
}

void prt(vector<vector<int> > a){
    for (auto i : a){
        prt(i);
    }
    cout << endl;
}

vector<vector<int> > a;
vector<bool> used;

vector<int> color;

vector<vector<int> > pos;

int n;

void dfs(int v, int cur){
    used[v] = true;
    for (int i = 0; i < n; i++){
        if (i == cur){
            break;
        }
        if (color[i] != color[v]){
            if (pos[i][v] < pos[i][i]){
                color[i] = color[v];
                used[i] = true;
            }
        }
    }
}

dfs(int v){
    used[v] = true;
    for (int i = 0; i < n; i++){
        if (color[i] != color[v]){
            if (pos[i][color[v]] < pos[i][color[i]]){
                color[i] = color[v];
                used[i] = true;
            }
        }
    }
}

int main()
{
    //ifstream cin;
    //cin.open("input.txt");
    cin >> n;
    a.resize(n, vector<int> (n));
    for (int i = 0; i < n; i++){
        for (int j = 0; j < n; j++){
            cin >> a[i][j];
            a[i][j]--;
        }
    }
    pos.resize(n, vector<int>(n));
    for (int i = 0; i < n; i++){
        for (int j = 0; j < n; j++){
            pos[i][a[i][j]] = j;
        }
    }
    int p;
    cin >> p;
    vector<int> ans;
    if (p == 1){
        for (int i = 0; i < n; i++){
            if (a[i][0] == i){
                ans.push_back(i + 1);
            }
        }
    }else{
        vector<bool> life(n, false);
        for (int v = 0; v < n; v++){
            used.resize(0);
            used.resize(n, false);
            color.resize(n);
            for (int i = 0; i < n; i++){
                color[i] = i;
            }
            for (int i = 0; i < n; i++){
                if (a[v][i] != v){
                    if (!used[a[v][i]]){
                        dfs(a[v][i], v);
                    }
                }
            }
            dfs(v);
            used.resize(0);
            used.resize(n);
            for (int i = 0; i < n; i++){
                if (!used[i]){
                    dfs(i);
                }
            }
            //prt(color);
            for (int i = 0; i < n; i++){
                life[color[i]] = true;
            }
        }
        for (int i = 0; i < n; i++){
            if (life[i]){
                ans.push_back(i + 1);
            }
        }
    }
    cout << ans.size() << endl;
    for (auto i : ans){
        cout << i << ' ';
    }
    cout << endl;
    return 0;
}
