#include <iostream>
#include <vector>

using namespace std;

/*struct vertex{
    int mn;
    int mnp;
    int mx;
    int mxp;
    vertex(int pos, int val){
        mn = val;
        mx = val;
        mnp = pos;
        mxp = pos;
    }
    vertex(){
        mn = 0;
        mx = 0;
        mnp = 0;
        mxp = 0;
    }
};*/

struct st{
    int n;
    vector<pair<int, int> > t;
    void init(int _n){
        n = _n;
        t.resize(4 * n);
    }

    pair<int, int> get(int l, int r, int v, int dl, int dr){
        if (l > r){
            return make_pair(1000000000, 0);
        }
        if (l == dl && r == dr){
            return t[v];
        }
        int dm = (dl + dr) / 2;
        auto res1 = get(l, min(r, dm), 2 * v, dl, dm);
        auto res2 = get(max(l, dm + 1), r, 2 * v + 1, dm + 1, dr);
        return make_pair(min(res1.first, res2.first), max(res1.second, res2.second));
    }

    pair<int, int> get(int l, int r){
        return get(l, r, 1, 0, n - 1);
    }

    void update(int pos, int val, int v, int dl, int dr){
        if (dl == dr){
            t[v] = make_pair(val, val);
            return;
        }
        int dm = (dl + dr) / 2;
        if (pos <= dm){
            update(pos, val, 2 * v, dl, dm);
        }else{
            update(pos, val, 2 * v + 1, dm + 1, dr);
        }
        t[v] = make_pair(min(t[2 *v].first, t[2 * v + 1].first), max(t[2 * v].second, t[2 * v + 1].second));
    }

    void update(int pos, int val){
        update(pos, val, 1, 0, n - 1);
    }

};

int main()
{
    int n;
    cin >> n;
    vector<int> a(n);
    st t;
    t.init(n);
    for (int i = 0 ; i < n; i++){
        cin >> a[i];
        t.update(i, a[i]);
    }
    int ans = 0;
    int l = 0;
    while (l < n){
        int r = n - 1;
        auto sup = t.get(l, r);
        while (sup.first < a[l] || sup.second > a[r]){
            //cout << sup.first << ' ' << sup.second << endl;
            r--;
            sup = t.get(l, r);
        }
        ans++;
        l = r + 1;
    }
    cout << ans << endl;
    return 0;
}
