#include <iostream>
#include <vector>
#include <cmath>
#include <algorithm>
#include <stack>
#include <set>
#include <string>
#define fr first
#define sc second
#define ll long long
using namespace std;
bool comp(string a, string b) {
	if (a.size() != b.size())
		return a.size() < b.size();
	return a < b;
}
int main() {
	ios_base::sync_with_stdio(0);
	cin.tie(0);
	cout.tie(0);
	int n = 0;
	cin >> n;
	vector <int> k(300000);
	vector <string> s(n);
	//reverse(s.begin(), s.end());
	for (int i = 0; i < n; i++)
		cin >> s[i];
	sort(s.begin(), s.end(), comp);
	for (int i = 0; i < n; i++) {
		reverse(s[i].begin(), s[i].end());
		int l = 0;
		for (int j = s[i].size() - 1; j >= 0; j--) {
			if ((s[i][j] == '1') && (k[j] == 1)) {
				for (int t = 0; t < j; t++)
					if (s[i][t] == '1')
						k[t] = 0, s[i][t] = 0;
				int p = j + 1;
				while (k[p])
					p++;
				k[p] = 1;
				s[i][p] = 1;
				break;
			}
			else
				if (s[i][j] == '1')
					k[j] = 1;
		}
	}
	string ans;
	for (int i = 0; i < 300000; i++)
		if (k[i])
			ans += '1';
		else
			ans += '0';
	reverse(ans.begin(), ans.end());
	while ((ans.size() > 1) && (ans[0] == '0'))
		ans.erase(0, 1);
	cout << ans;
	return 0;
}