#include <iostream>
#include <vector>
#include <algorithm>

using namespace std;

vector<pair<int, int> > all;

void op(int l, int r, vector<int>& a) {
	vector<int> cur;
	for (int i = l + 1; i <= r; i+=2) {
		cur.push_back(a[i]);
	}
	for (int i = l; i <= r; i+=2) {
		cur.push_back(a[i]);
	}
	for (int i = l; i <= r; i++) {
		a[i] = cur[i - l];
	}
	all.push_back({ l, r });
}

int main()
{
	int n;
	cin >> n;
	vector<int> a(n);
	for (int i = 0; i < n; i++) {
		cin >> a[i];
	}
	for (int i = 0; i < n; i++) {
		int j = min_element(a.begin() + i, a.end()) - a.begin();
		while (j > i) {
			if ((j - i) % 2 == 0) {
				op(i + 1, n - 1, a);
				j = i + (j - i) / 2;
			}
			else {
				op(i, n - 1, a);
				j = i + (j - i) / 2;
			}
		}
	}
	cout << (int)all.size() << endl;
	for (auto elem : all) {
		cout << elem.first + 1 << ' ' << elem.second + 1 << '\n';
	}
    return 0;
}

