#include <iostream>
#include <algorithm>
#include <vector>

using namespace std;

const int MAX_N = 400000;
bool use[MAX_N];
int n;
int ans[MAX_N], a[MAX_N], dist[MAX_N];

void check(int num) {
    for (int i = 0; i < n; i++) dist[i] = n + 1;
    int last = n + 1;
    for (int i = 0; i < n; i++) {
        //if (num == 5) cout << i << ' ' << (num & (1 << i)) << endl;
        if (((num) & (1 << i)) > 0) last = i;
        dist[i] = i - last;
    }
    last = n + 1;
    for (int i = n - 1; i >= 0; i--) {
        if ((num & (1 << i)) > 0) last = i;
        dist[i] = min(dist[i], last - i);
    }
    vector <pair <int, int> > now;
    for (int i = 0; i < n; i++) now.push_back({dist[i] + a[i], i});
    sort(now.begin(), now.end());
    int place = 1;
    for (int i = 0; i < n; i++) {
        //cout << now[i].first << ' ' << now[i].second << endl;
        if (i != 0 && now[i].first != now[i - 1].first) place = i + 1;
        ans[now[i].second] = max(ans[now[i].second], place);
    }
    //cout << endl << endl;
}

void gen() {
    for (int i = 1; i < (2 << n); i++) check(i);
}

void solve_slow_p_is_2() {
    for (int i = 0; i < n; i++) ans[i] = -1;
    gen();
    for (int i = 0; i < n; i++) {
        cout << ans[i] << "\n";
    }
}

int main() {
    ios_base :: sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);
    int p;
    cin >> n >> p;
    for (int i = 0; i < n; i++) {
        cin >> a[i];
    }
    if (p == 2) {
        solve_slow_p_is_2();
        return 0;
    }
    int cnt = 0;
    for (int i = 0; i < n; i++) {
        cnt = 0;
        for (int j = 0; j < n; j++) {
            if (i == j) continue;
            if (a[j] + abs(i - j) < a[i]) cnt++;
        }
        ans[i] = cnt + 1;
    }
    for (int i = 0; i < n; i++) {
        cout << ans[i] << "\n";
    }
    return 0;
}
