#include <iostream>
#include <vector>
#include <algorithm>

using namespace std;

typedef long long ll;

vector<pair<int, int>> v;
vector<int> used, cans;
int n, m, k;

int f(int cv, int dist) {
    cans.push_back(cv);
    if (cv == k - 1) {
        return dist;
    }
    used[cv] = 0;
    int mind = 0, next = -1;
    for (int i = 0; i < k; ++i) {
        int cd = (1 << max(abs(v[i].first - v[cv].first),
                          abs(v[i].second - v[cv].second)));
        if (used[i]) {
            if (next == -1) {
                next = i;
                mind = cd;
            }
            else if (mind > cd) {
                next = i;
                mind = cd;
            }
        }
    }
    return f(next, dist + mind);
}

int main() {
    cin >> n >> m >> k;
    v.resize(k);
    used.resize(k);
    for (int i = 0; i < k; ++i) {
        cin >> v[i].first >> v[i].second;
    }
    int ansd = 2e6;
    vector<int> ans(k);
    for (int i = 0; i < (1 << (k - 2)); ++i) {
        cans.clear();
        used[0] = 1;
        used[k - 1] = 1;
        for (int j = 0; j < k - 2; ++j) {
            if (i & (1 << j)) {
                used[j + 1] = 1;
            }
            else {
                used[j + 1] = 0;
            }
        }
        int res = f(0, 0);
        if (res < ansd) {
            ansd = res;
            ans.clear();
            for (int j : cans) {
                ans.push_back(j);
            }
        }
    }
    cout << ans.size() << endl;
    for (int i : ans) {
        cout << i + 1 << " ";
    }
    cout << endl;
}