#include <bits/stdc++.h>

#define f first
#define s second
#define pb push_back
#define mp make_pair
#define IO ios_base::sync_with_stdio(false), cin.tie(0), cout.tie(0)
#define all(a) (a).begin(), (a).end()

using namespace std;

typedef long long ll;
typedef long double ld;
typedef pair<int, int> pii;

template<typename T1, typename T2> inline void chkmax(T1 & x, T2 y) {if (x < y) x = y;}

const int MAXN = 1 << 17;
int a[MAXN], b[MAXN];
int n;
vector<int> all_bs[MAXN];

ll solve() {
	vector<int> as(n), bs(n);
    unordered_map<int, int> cntB, cntA;
	for (int i = 0; i < n; ++i) {
        as[i] = a[i], bs[i] = b[i];
        cntA[a[i]]++;
        cntB[b[i]]++;
	}
    sort(all(as));
    sort(all(bs));
    int n1 = unique(all(as)) - as.begin();
    int n2 = unique(all(bs)) - bs.begin();
    unordered_map<int, int> da, db;
    for (int i = 0; i < n1; ++i)
        da[as[i]] = i;
    for (int i = 0; i < n2; ++i)
        db[bs[i]] = i;
    for (int i = 0; i < n; ++i)
        all_bs[da[a[i]]].pb(b[i]);

    vector<ll> val_b(n2);
    ll ccnt = 0;
    for (int i = n2 - 1; i >= 0; --i) {
        ccnt += cntB[bs[i]];
        val_b[i] = ccnt * bs[i];
    }
    //cout << n1 << endl;
    //for (int i = 0; i < n1; ++i)
      //  cout << as[i] << ' ';
    //cout << endl;
    ll ans = 0;
    ccnt = 0;
    for (int i = n1 - 1; i >= 0; --i) {
        //cout << "on " << i << ": ";
        ccnt += cntA[as[i]];
        for (int j : all_bs[i]) {
            //cout << j << ' ';
            for (int l = db[j]; l >= 0; --l)
                val_b[l] -= bs[l];
        }
        //cout << endl;
        for (int j = 0; j < n2; ++j) {
            //cout << j << ' ' << val_b[j] << endl;
            chkmax(ans, val_b[j] + ccnt * as[i]);
        }
        //cout << "\n---------------\n";
    }
    return ans;
}

void read() {
	cin >> n;
	for (int i = 0; i < n; ++i)
		cin >> a[i] >> b[i];
}

vector<ll> as;

ll get(int l, int r) {
    if (l >= as.size()) return 0;
    return (r - l + 1) * as[l];
}

struct func {
    ll k, b;
    func(ll _k = 0, ll _b = -1e18) {
        k = _k;
        b = _b;
    }
    ll get(ll x) {
        return k * x + b;
    }
};

func t[MAXN * 2];

void add(int v, int vl, int vr, func f) {
    if (t[v].get(vl) <= f.get(vl)) {
        t[v] = f;
        return;
    }
    if (f.get(vr) < t[v].get(vr))
        return;
    int vm = (vl + vr) / 2;
    if (f.get(vm + 1) >= t[v].get(vm + 1)) { // intersecting in the first half
        swap(t[v], f);
        add(v * 2, vl, vm, f);
    }
    else {
        add(v * 2 + 1, vm + 1, vr, f);
    }
}

ll get_mx(int v, int vl, int vr, int pos) {
    if (vl > pos || vr < pos) return 0;
    ll res = t[v].get(pos);
    if (vl == vr) return res;
    int vm = (vl + vr) / 2;
    chkmax(res, get_mx(v * 2, vl, vm, pos));
    chkmax(res, get_mx(v * 2 + 1, vm + 1, vr, pos));
    return res;
}

ll solve1() {
    vector<int> as(n);
    unordered_map<int, int> cnt;
    for (int i = 0; i < n; ++i) {
        as[i] = a[i];
        cnt[a[i]]++;
    }
    for (int i = 0; i < MAXN * 2; ++i)
        t[i] = func();
    sort(all(as));
    //cout << "good" << endl;
    int n1 = unique(all(as)) - as.begin();
    ll ccnt = 0;
    ll ans = 0;
    for (int i = 0; i < n1; ++i) {
        //cout << i << ": ";
        add(1, 0, MAXN - 1, func(as[i], -as[i] * ccnt));
        ccnt += cnt[as[i]];
        //cout << ccnt << ' ' << get_mx(1, 0, MAXN - 1, ccnt) << endl;
        ll cval = get_mx(1, 0, MAXN - 1, ccnt);
        if (i + 1 < n1) {
            cval += as[i + 1] * (n - ccnt);
        }
        chkmax(ans, cval);
    }
    return ans;
}

int main() {
    IO;
    //freopen("inputC.txt", "r", stdin);
    read();
   	cout << solve1();
    return 0;
}
