#include <bits/stdc++.h>

#define f first
#define s second
#define pb push_back
#define IO ios_base::sync_with_stdio(false), cin.tie(0), cout.tie(0)
#define all(a) (a).begin(), (a).end()
using namespace std;

template<typename T1, typename T2> inline void chkmin(T1 & x, T2 y) {if (x > y) x = y;}
template<typename T1, typename T2> inline void chkmax(T1 & x, T2 y) {if (x < y) x = y;}

const int MAXN = 4e5 + 100;
int a[MAXN], ans[MAXN];
int n;

struct fnw {
	int *t;
	fnw() {
		t = new int[MAXN];
		for (int i = 0; i < MAXN; ++i)
			t[i] = 0;
	}
	void add(int pos, int val) {
		for (int i = pos; i < MAXN; i |= (i + 1))
			t[i] += val;
	}
	int get_sum(int r) {
		int res = 0;
		for (int i = r; i > 0; i = (i & (i + 1)) - 1)
			res += t[i];
		return res;
	}
};

int get_less(fnw & a, int r) {
	return a.get_sum(r - 1);
}

int get(int i, int l, int r) {
    if (l <= -1 && r >= n) return 0;
    int ct = a[i], res = 0;
    if (r >= n) {
        ct += i - l;
        for (int i = 0; i <= l; ++i)
            res += a[i] < ct;
        for (int i = l + 1; i < n; ++i)
            res += (a[i] + i - l) < ct;
        return res;
    }
    if (l <= -1) {
        ct += r - i;
        for (int i = r; i < n; ++i)
            res += a[i] < ct;
        for (int i = 0; i < r; ++i)
            res += (a[i] + r - i) < ct;
        return res;
    }
    ct += min(i - l, r - i), res = 0;
    for (int i = 0; i <= l; ++i)
        res += a[i] < ct;
    for (int i = r; i < n; ++i)
        res += a[i] < ct;
    for (int i = l + 1; i < r; ++i)
        res += (a[i] + min(i - l, r - i)) < ct;
    return res;
}

int main() {
    IO;
    //freopen("inputC.txt", "r", stdin);
    int p;
    cin >> n >> p;
    vector<int> after_as(n), before_as(n);
    for (int i = 0; i < n; ++i) {
        cin >> a[i];
        after_as[i] = a[i] + i + 1;
        before_as[i] = a[i] - i;
    }

    unordered_map<int, int> dafter, dbefore;
    sort(all(after_as));
    sort(all(before_as));
    int nafter = unique(all(after_as)) - after_as.begin();
    int nbefore = unique(all(before_as)) - before_as.begin();

    for (int i = 0; i < nafter; ++i) {
    	dafter[after_as[i]] = i + 1;
    }
    for (int i = 0; i < nbefore; ++i) {
    	dbefore[before_as[i]] = i + 1;
    }

    if (p == 1) {
    	fnw after, before;

        for (int i = 0; i < n; ++i)
            after.add(dafter[a[i] + i + 1], 1);
        for (int i = 0; i < n; ++i) {
        	after.add(dafter[a[i] + i + 1], -1);

            ans[i] = get_less(before, dbefore[a[i] - i]) + get_less(after, dafter[a[i] + i + 1]) + 1;

            before.add(dbefore[a[i] - i], 1);
        }
    }
    else {
        for (int i = 0; i < n; ++i) {
            for (int dist = 0; dist < n; ++dist)
                chkmax(ans[i], get(i, i - dist, i + dist));
            ++ans[i];
        }
    }
    //cout << "ans" << endl;
    for (int i = 0; i < n; ++i)
        cout << ans[i] << '\n';
    return 0;
}
