#include <bits/stdc++.h>

#define f first
#define s second
#define pb push_back
#define IO ios_base::sync_with_stdio(false), cin.tie(0), cout.tie(0)
#define all(a) (a).begin(), (a).end()
using namespace std;

template<typename T1, typename T2> inline void chkmin(T1 & x, T2 y) {if (x > y) x = y;}
template<typename T1, typename T2> inline void chkmax(T1 & x, T2 y) {if (x < y) x = y;}

const int MAXN = 3e5;
int n;
vector<char> b[MAXN];

void read() {
    cin >> n;
    for (int i = 0; i < n; ++i) {
        string st;
        cin >> st;
        reverse(all(st));
        b[i].resize(st.size());
        for (int j = 0; j < st.size(); ++j)
            b[i][j] = st[j] - '0';
    }
}

vector<char> or1(const vector<char> & a, const vector<char> & b) {
    vector<char> res(max(a.size(), b.size()), 0);
    for (int i = 0; i < res.size(); ++i) {
        if (i < a.size())
            res[i] |= a[i];
        if (i < b.size())
            res[i] |= b[i];
    }
    return res;
}

vector<char> add(const vector<char> & a, const vector<char> & b) {
    vector<char> res(max(a.size(), b.size()), 0);
    int add = 0;
    for (int i = 0; i < res.size(); ++i) {
        res[i] = add, add = 0;
        if (i < a.size())
            res[i] += a[i];
        if (i < b.size())
            res[i] += b[i];
        if (res[i] > 1) {
            add = res[i] / 2;
            res[i] %= 2;
        }
    }
    if (add)
        res.pb(add);
    return res;
}

bool cmp(const vector<char> & a, const vector<char> & b) {
    return a.size() < b.size();
}

void solve_for_degs() {
    sort(b, b + n, cmp);
    vector<char> ans;
    for (int i = 0; i < n; ++i) {
        auto tmp = add(ans, b[i]);
        ans = or1(ans, tmp);
    }
    reverse(all(ans));
    for (auto i : ans)
        cout << (char)(i + '0');
}

int main() {
	IO;
	//freopen("inputD.txt", "r", stdin);
	read();
    solve_for_degs();
	return 0;
}
