#include <iostream>
#include <vector>
#include <cmath>
#include <cstdio>
#include <cstdlib>
#include <map>
#include <set>
#include <unordered_map>
#include <unordered_set>
#include <algorithm>
#include <string>
#include <ctime>
#include <cstring>
#include <bitset>

using namespace std;
const int MAXN = 510;

int n;
int mas[MAXN][MAXN];
int mp[MAXN][MAXN];
int p;

bool may_d(vector<int> v){
    set<int> st;
    for (auto e : v){
        st.insert(e);
    }

    for (auto e : v){
        bool fl = false;
        for (int j = 0; j < mp[e][e]; ++j){
            if (st.count(mas[e][j]) == 0){
                fl = true;
            }
        }

        if (!fl){
            return false;
        }
    }

    return true;
}

bool pr(int ind){
    for (int i = 0; i < n; ++i){
        if (mp[i][ind] < mp[i][i]){
            vector<int> vec;
            for (int j = 0; j < mp[i][ind]; ++j){
                vec.push_back(mas[i][j]);
            }

            if (may_d(vec)){
                return true;
            }
        }
    }
    return false;
}

int main(){
    ios::sync_with_stdio(false);
    cin.tie(0); cout.tie(0);

    cin >> n;
    for (int i = 0; i < n; ++i){
        for (int j = 0; j < n; ++j){
            cin >> mas[i][j];
            mas[i][j]--;
            mp[i][mas[i][j]] = j;
        }
    }
    cin >> p;

    if (p == 1){
        vector<int> ans;
        for (int i = 0; i < n; ++i){
            if (i == mas[i][0]){
                ans.push_back(i + 1);
            }
        }
        cout << ans.size() << endl;
        for (auto e : ans){
            cout << e << ' ';
        }
        cout << endl;
    } else {
        vector<int> ans;
        for (int i = 0; i < n; ++i){
            if (pr(i)){
                ans.push_back(i + 1);
            }
        }

        cout << ans.size() << endl;
        for (auto e : ans){
            cout << e << ' ';
        }
        cout << endl;
    }

    return 0;
}
