#include <algorithm>
#include <iostream>
#include <vector>

using namespace std;
#define set oethuteohu

const int N = 1 << 19;
int t[2 * N];
int get(int l, int r)
{
	l += N;
	r += N;
	int ans = 1e9;
	while (l < r)
	{
		if (l & 1)
			ans = min(ans, t[l++]);
		if (r & 1)
			ans = min(ans, t[--r]);
		l >>= 1, r >>= 1;
	}
	return ans;
}

void set(int x, int y)
{
	x += N;
	t[x] = y;
	while (x > 1)
		t[x >> 1] = min(t[x], t[x ^ 1]), x >>= 1;
}

int main()
{
	ios::sync_with_stdio(false);
	int n;
	cin >> n;
	vector<int> a(n);
	for (auto& x : a)
		cin >> x;
	vector<int> mn;
	vector<int> dp(n + 1, 1e9);
	vector<int> mx;
	dp[0] = 0;
	for (int i = 0; i <= n; ++i)
		set(i, 1e9);
	set(0, 0);
	for (int i = 0; i < n; ++i)
	{
		while (mn.size() && a[mn.back()] > a[i])
		{
			set(mn.back(), 1e9);
			mn.pop_back();
		}
		mn.push_back(i);
		int L = -1, R = mx.size();
		while (R - L > 1)
		{
			int M = (L + R) / 2;
			if (a[mx[M]] > a[i])
				L = M;
			else
				R = M;
		}
		int from;
		if (L == -1)
			from = 0;
		else
			from = mx[L] + 1;
		/*
		if (i == 3)
		{
			for (int x : mn)
				cerr << x << ' ';
			cerr << '\n';
		}
		*/
		dp[i + 1] = get(from, i + 1) + 1;
		set(i + 1, dp[i + 1]);
		while (mx.size() && a[mx.back()] <= a[i])
			mx.pop_back();
		mx.push_back(i);
	}
	cout << dp.back() << '\n'; 
}
