#include <queue>
#include <utility>
#include <fstream>
#include <algorithm>
#include <string>
#include <bitset>

using namespace std;

#include <iostream>
//const string FILENAME = "test";
//ifstream cin(FILENAME + ".in");
//ofstream cout(FILENAME + ".out");

template<class C> void chkmin(C& a, C b) { if (a > b) a = b; }
template<class C> void chkmax(C& a, C b) { if (a < b) a = b; }

typedef long long ll;
typedef long double ld;

const int MAXN = 10001;
bitset<MAXN> INF;

//priority_queue<pair<bitset<MAXN>, int>> q;
bitset<MAXN> d[MAXN];
bool used[MAXN];
int a[MAXN];
int b[MAXN];
int pr[MAXN];

template<const int N> bool operator< (bitset<N>& a, bitset<N>& b) {
	for (int i = N - 1; i >= 0; --i) {
		if (a[i] < b[i])
			return true;
		if (a[i] > b[i])
			return false;
	}
	return false;
}

bitset<MAXN> Add(bitset<MAXN> x, int y) {
	while (x[y] == 1) {
		x[y] = 0;
		++y;
	}
	x[y] = 1;
	return x;
}

int Dist(int i, int j) {
	return max(abs(a[i] - a[j]), abs(b[i] - b[j]));
}

int main() {
	for (int i = 0; i < MAXN; ++i)
		INF[i] = 1;
	int n, m, k;
	cin >> n >> m >> k;
	for (int i = 0; i < k; ++i) {
		cin >> a[i] >> b[i];
		if (i != 0) d[i] = INF;
		//q.push({ d[i], i });
	}
	while (!used[k - 1]) {
		int v = -1;
		//cout << (d[1] < d[2]);
		for (int i = 0; i < k; ++i) {
			if (used[i]) continue;
			if (v == -1 || d[i] < d[v])
				v = i;
		}
		//cout << v << '\n';
		used[v] = 1;
		for (int u = 0; u < k; ++u) {
			if (used[u]) continue;
			bitset<MAXN> nd = Add(d[v], Dist(u, v));
			if (nd < d[u]) {
				d[u] = nd;
				pr[u] = v;
			}
		}
	}
	vector<int> ans(1, k - 1);
	int v = k - 1;
	while (v) {
		v = pr[v];
		ans.push_back(v);
	}
	reverse(ans.begin(), ans.end());
	cout << ans.size() << '\n';
	for (int c : ans) {
		cout << c + 1 << ' ';
	}
	cout << '\n';
	//while (1) ++n;
}

