#include <fstream>
#include <vector>

using namespace std;

template<class C> void chkmin(C& a, C b) { if (a > b) a = b; }
template<class C> void chkmax(C& a, C b) { if (a < b) a = b; }

#include <iostream>
//ifstream cin("test.in");
//ofstream cout("test.out");

const int MAXN = 3e5 + 7;

int up[MAXN];
int down[MAXN];
int a[MAXN];

int main() {
	int n;
	cin >> n;
	for (int i = 0; i < n; ++i) {
		cin >> a[i];
	}
	vector<int> st;
	for (int i = n - 1; i >= 0; --i) {
		while (st.size() && a[st.back()] < a[i])
			st.pop_back();
		up[i] = st.size() ? st.back() : n;
		st.push_back(i);
	}
	st.clear();
	for (int i = n - 1; i >= 0; --i) {
		while (st.size() && a[st.back()] >= a[i])
			st.pop_back();
		down[i] = st.size() ? st.back() : n;
		st.push_back(i);
	}
	int res = 0;
	int j = 0;
	for (int i = 0; i < n; i = j + 1) {
		j = i;
		while (up[j] < down[i]) j = up[j];
		++res;
	}
	cout << res << '\n';
}

