#include <algorithm>
#include <string>
#include <bitset>
#include <map>
#include <set>
#include <queue>
#include <utility>
#include <cassert>
#include <cstdio>
#include <cmath>
#include <fstream>
#include <vector>

using namespace std;

typedef long long ll;
typedef long double ld;

template<class C> void chkmin(C& a, C b) { if (a > b) a = b; }
template<class C> void chkmax(C& a, C b) { if (a < b) a = b; }

#include <iostream>
//ifstream cin("test.in");
//ofstream cout("test.out");

const int MAXN = 5 + 7;

int a[MAXN];

bool GetBit(int a, int i) {
	return (a >> i) & 1;
}

int main() {
	ios_base::sync_with_stdio(false);
	int n;
	cin >> n;
	for (int i = 0; i < n; ++i) {
		string s;
		cin >> s;
		reverse(s.begin(), s.end());
		for (int w = 0; w < s.size(); ++w)
			if (s[i] == '1')
				a[i] |= 1 << w;
	}
	int cq = 1e9;
	int qwe = 10;
	for (int mask = 0; mask < (1 << n); ++mask) {
		for (int q = 0; q < 32; ++q) {
			if (q && GetBit(mask, 0)) break;
			if (!GetBit(mask, 0) && q < a[0]) continue;
			for (int w = 0; w < 32; ++w) {
				if (w && GetBit(mask, 1)) break;
				if (!GetBit(mask, 1) && w < a[1]) continue;
				for (int e = 0; e < 32; ++e) {
					if (e && GetBit(mask, 2)) break;
					if (!GetBit(mask, 2) && e < a[2]) continue;
					for (int r = 0; r < 32; ++r) {
						if (r && GetBit(mask, 3)) break;
						if (!GetBit(mask, 3) && r < a[3]) continue;
						for (int t = 0; t < 32; ++t) {
							if (t && GetBit(mask, 4)) break;
							if (!GetBit(mask, 4) && t < a[4]) continue;
							if ((q | w | e | r | t) == q + w + e + r + t) {
								int qqq = 0;
								qqq += GetBit(mask, 0);
								qqq += GetBit(mask, 1);
								qqq += GetBit(mask, 2);
								qqq += GetBit(mask, 3);
								qqq += GetBit(mask, 4);
								if (qwe > qqq || qwe == qqq && (q + w + e + r + t < cq)) {
									qwe = qqq;
									cq = q + w + e + r + t;
								}
							}
						}
					}
				}
			}
		}
	}
	//cout << cq << '\n';
	//cout << qwe << ' ' << cq << '\n';
	for (int i = 0; i < qwe; ++i) cout << '1';
	int i = 5;
	while (!GetBit(cq, i)) --i;
	for (; i >= 0; --i) {
		cout << GetBit(cq, i);
	}
	cout << '\n';
}

