#include <fstream>
#include <iostream>
#include <vector>
#include <algorithm>

using namespace std;

int main() {
    int n, m, q, count = 0;
    cin >> n >> m >> q;
    vector<vector<int>> matrix(n);
    vector<int> x_max(m, 0);
    vector<int> y_max(n, 0);
    for (int i = 0; i < n; i++)
        matrix[i].resize(m);
    for (int i = 0; i < n; i++) {
        for (int j = 0; j < m; j++) {
            cin >> matrix[i][j];
            x_max[j] = max(matrix[i][j], x_max[j]);
            y_max[i] = max(matrix[i][j], y_max[i]);
        }
    }
    for (int i = 0; i < n; i++)
        for (int j = 0; j < m; j++)
            if (matrix[i][j] == x_max[j] and matrix[i][j] == y_max[i])
                count++;
    int r, c, x;
    for (int i = 0; i < q; i++) {
        cin >> r >> c >> x;
        r--;
        c--;
        matrix[r][c] = x;
        x_max[c] = max(matrix[r][c], x_max[c]);
        y_max[r] = max(matrix[r][c], y_max[r]);
        count = 0;
        for (int i = 0; i < n; i++)
            for (int j = 0; j < m; j++)
                if (matrix[i][j] == x_max[j] and matrix[i][j] == y_max[i])
                    count++;
        cout << count << '\n';
    }
    return 0;
}