#include <bits/stdc++.h>

using namespace std;

int n, m;
vector<vector<int>> a;
//vector<vector<bool>> is_good;
set<pair<int, int>> good;
vector<int> max_in_str, max_in_row;

bool check(int i, int j) {
    for (int k = 0; k < n; k++) {
        if (a[k][j] > a[i][j])
            return false;
    }
    for (int k = 0; k < m; k++) {
        if (a[i][k] > a[i][j])
            return false;
    }
    return true;
}

int main() {
    #ifdef DEBUG
    assert(freopen("input.txt", "r", stdin));
    assert(freopen("output.txt", "w", stdout));
    #endif // DEBUG
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);
    int q;
    cin >> n >> m >> q;
    max_in_str.resize(n);
    max_in_row.resize(m);
    a.resize(n);
    //is_good.resize(n);
    for (int i = 0; i < n; i++) {
        a[i].resize(m);
        //is_good[i].resize(m, false);
        for (int j = 0; j < m; j++) {
            cin >> a[i][j];
        }
    }
    for (int i = 0; i < n; i++) {
        for (int j = 0; j < m; j++) {
            //is_good[i][j] = check(i, j);
            if (check(i, j))
                good.insert({i, j});
        }
    }
    for (int i = 0; i < n; i++) {
        for (int j = 0; j < m; j++) {
            if (a[i][max_in_str[i]] < a[i][j])
                max_in_str[i] = j;
            if (a[max_in_row[j]][j] < a[i][j])
                max_in_row[j] = i;
        }
    }
    for (int z = 0; z < q; z++) {
        int r, c, x;
        cin >> r >> c >> x;
        r--;
        c--;
        int cnt = 0;
        if (x > a[r][max_in_str[r]]) {
            a[r][max_in_str[r]] = x;
            good.erase({r, max_in_str[r]});
            cnt++;
        }
        if (x > a[max_in_row[c]][c]) {
            a[max_in_row[c]][c] = x;
            good.erase({max_in_row[c], c});
            cnt++;
        }
        if (cnt == 2) {
            good.insert({r, c});
        }
        a[r][c] = x;
        cout << good.size() << "\n";
    }
    return 0;
}
