#include <bits/stdc++.h>

using namespace std;
typedef long long ll;

const int MAX = 10010;
pair<int, int> a[MAX];
vector<pair<int, vector<bool>>> g[MAX];
vector<bool> dp[MAX];
ll p[MAX];
bool used[MAX];

vector<bool> sum(const vector<bool> &v1, const vector<bool> &v2) {
    vector<bool> res(MAX, false);
    int last = 0;
    for (int i = 0; i < MAX; i++) {
        int val = (int)v1[i] + (int)v2[i] + last;
        res[i] = val % 2;
        last = val / 2;
    }
    return res;
}

bool more(const vector<bool> &v1, const vector<bool> &v2) {
    for (int i = MAX - 1; i >= 0; i--) {
        if (v1[i] && !v2[i])
            return true;
        if (!v1[i] && v2[i])
            return false;
    }
    return false;
}

int main() {
    #ifdef DEBUG
    assert(freopen("input.txt", "r", stdin));
    assert(freopen("output.txt", "w", stdout));
    #endif // DEBUG
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);
    int n, m, k;
    cin >> n >> m >> k;
    for (int i = 0; i < k; i++) {
        cin >> a[i].first >> a[i].second;
        a[i].first--;
        a[i].second--;
    }
    for (int i = 0; i < k; i++) {
        for (int j = 0; j < i; j++) {
            vector<bool> cost(MAX, false);
            cost[max(abs(a[i].first - a[j].first), abs(a[i].second - a[j].second))] = true;
            g[i].push_back({j, cost});
            g[j].push_back({i, cost});
        }
    }
    vector<bool> INF(MAX, true);
    for (int i = 0; i < MAX; i++) {
        p[i] = -1;
        dp[i] = INF;
    }
    vector<bool> nl(MAX, false);
    dp[0] = nl;
    for (int i = 0; i < k; i++) {
        int cur = -1;
        for (int j = 0; j < k; j++) {
            if (used[j])
                continue;
            if (cur == -1 || more(dp[cur], dp[j]))
                cur = j;
        }
        used[cur] = true;
        for (auto edge : g[cur]) {
            vector<bool> vl = sum(dp[cur], edge.second);
            if (more(dp[edge.first], vl)) {
                dp[edge.first] = vl;
                p[edge.first] = cur;
            }
        }
    }
    vector<int> ans;
    int cur = k - 1;
    while (cur != -1) {
        ans.push_back(cur);
        cur = p[cur];
    }
    reverse(ans.begin(), ans.end());
    cout << ans.size() << "\n";
    for (auto i : ans) {
        cout << i + 1 << " ";
    }
    return 0;
}
