#include <bits/stdc++.h>
#pragma GCC optimize("O3")

typedef long long ll;

#define forn(i, n) for (int i = 0; i < n; ++i)
#define x first
#define y second
#define point pair<int, int>


using namespace std;

const int N = 3e5 + 3, BIG = 1e9 + 7, MOD = 1e9 + 7, P = 'z' - 'a' + 1;



mt19937 rnd(time(NULL));

int get(int L, int R) {
	return abs(int(rnd())) % (R - L) + L;
}

int n, ans;
vector<int> a;


struct Node{
	point min_v, max_v;
	int L, R;
	Node* left;
	Node* right;
	Node(int L2, int R2) {
		L = L2, R = R2;
		left = nullptr;
		right = nullptr;
	}
};

Node* build(int L, int R, vector<int> &b) {
	Node* v = new Node(L, R);
	if (L + 1 == R) {
		v->min_v = v->max_v = {b[L], L};
		return v;
	}
	int mid = (L + R) / 2;
	v->left = build(L, mid, b);
	v->right = build(mid, R, b);
	v->min_v = min(v->left->min_v, v->right->min_v);
	v->max_v = max(v->left->max_v, v->right->max_v);
	return v;
}


point get_min(Node* v, int L, int R) {
	if (R <= v->L || v->R <= L)
		return {BIG, BIG};
	if (L <= v->L && v->R <= R)
		return v->min_v;
	return min(get_min(v->left, L, R), get_min(v->right, L, R));
}

point get_max(Node* v, int L, int R) {
	if (R <= v->L || v->R <= L)
		return {-BIG, -BIG};
	if (L <= v->L && v->R <= R)
		return v->max_v;
	return max(get_max(v->left, L, R), get_max(v->right, L, R));
}


Node* tree;

int solve3(int L, int R) {
	if (L >= R)
		return 0;

	int min_v = BIG, ind_min = 0;
	auto p1 = get_min(tree, L, R);
	min_v = p1.x;
	ind_min = p1.y;
	/*/
	for (int i = L; i < R; ++i)
		if (min_v > a[i]) {
			min_v = a[i];
			ind_min = i;
		}
	//*/
	

	int max_v = 0, ind_max = 0;
	auto p2 = get_max(tree, ind_min, R);
	max_v = p2.x;
	ind_max = p2.y;	
	/*/
	for (int i = ind_min; i < R; ++i)
		if (max_v <= a[i]) {
			max_v = a[i];
			ind_max = i;
		}
	//*/ 
	// cout << L << " " << R << "\n";
	// cout << ind_min << " " << ind_max << " - mins\n";
	return solve3(L, ind_min) + 1 + solve3(ind_max + 1, R);
}


/*/
int norm_solve(){
    vector<int> dp(n, BIG);
    dp[0] = 1;
    for (int i = 1; i < n; ++i) {
        int L = i, min_v = a[i];
        dp[i] = dp[i - 1] + 1;
        while (L >= 0 && a[L] <= a[i]) {
            if (a[L] <= min_v) {
                dp[i] = min(dp[L], (L > 0 ? dp[L - 1] : 0) + 1);
            }
            min_v = min(min_v, a[L]);
            --L;    
        }
    }
    
    forn(i, n)
        cout << dp[i] << " ";
    cout << "\n";
    
    return dp[n - 1];
}

//*/


int main(){
	#ifdef ON_PC
	freopen("a.in", "r", stdin), freopen("a.out", "w", stdout);
	ios_base::sync_with_stdio(0), cin.tie(0), cout.tie(0);
	#endif

	//*/
	cin >> n;
	a.resize(n);
	forn(i, n)
		cin >> a[i];

	tree = build(0, n, a);
	cout << solve3(0, n);
	return 0;
	//*/

	/*/
	while (true) {
		// a.clear();
		n = get(3, 6);
		forn(i, n)
			a[i] = get(1, 10);
		if (solve2(0, n) != norm_solve())
			break; 
	}


	cout << n << "\n";
	forn(i, n)
		cout << a[i] << " ";

	cout << norm_solve() << " " << solve2(0, n);
	return 0;


	// cout << solve2(0, n) << "\n";


	cout << norm_solve();
	//*/
}