#define _CRT_SECURE_NO_WARNINGS

#include <iostream>
#include <vector>
#include <algorithm>

using namespace std;

#define X first
#define Y second

const int MAXN = 3010, INF = 1000000010;

int n;
int a[MAXN], p;

int kalmi(int v, int d)
{
	int ans = 0;
	for (int i = 0; i < n; i++)
	{
		if (a[i] + abs(i - d) < a[v] + abs(v - d))
			ans++;
	}
	return ans + 1;
}

int fimi(int v)
{
	int ans = n;
	for (int i = 0; i < n; i++)
	{
		if (v - i >= 0)
			ans = min(ans, kalmi(v, v - i));
		if (v + i < n)
			ans = min(ans, kalmi(v, v + i));
	}
	return ans;
}

int kalma(int v, int l, int r)
{
	int ans = 0;
	int rv, rt;

	int tc = n + INF;
	if (l != -1)
		tc = min(tc, max(0, (v - l)));
	if (r != -1)
		tc = min(tc, max(0, (r - v)));
	rv = a[v] + tc;

	for (int i = 0; i < n; i++)
	{
		tc = n + INF;
		if (l != -1)
			tc = min(tc, max(0, (i - l)));
		if (r != -1)
			tc = min(tc, max(0, (r - i)));
		rt = a[i] + tc;

		if (rt < rv)
			ans++;
	}
	return ans + 1;
}

int fima(int v)
{
	int ans = 1;
	int tl, tr;
	for (int i = 0; i < n; i++)
	{
		tl = -1;
		tr = -1;
		if (v + i < n)
			tr = v + i;
		if (v - i >= 0)
			tl = v - i;
		if (tl == -1 && tr == -1)
			break;
		ans = max(ans, kalma(v, tl, tr));
	}
	return ans;
}

int main()
{
#if _DEBUG
	freopen("input.txt", "r", stdin);
	freopen("output.txt", "w", stdout);
#endif
	ios_base::sync_with_stdio(0);
	cin >> n >> p;
	for (int i = 0; i < n; i++)
	{
		cin >> a[i];
	}
	for (int i = 0; i < n; i++)
	{
		if (p == 1)
		{
			cout << fimi(i) << endl;
		}
		else
		{
			cout << fima(i) << endl;
		}
	}

	return 0;
}