#include <bits/stdc++.h>

using namespace std;

const int maxn = 1e4 + 7;

typedef unsigned long long ll;

ll bin_pow(ll a, ll p){
    if (!p)
        return 1;
    if (p % 2)
        return a * bin_pow(a, p - 1);
    ll kek = bin_pow(a, p / 2);
    return kek * kek;
}

int x[maxn], y[maxn];
int pr[maxn];
bool u[maxn];
ll d[maxn];

int main()
{
    #ifdef ONPC
        ifstream cin("in.txt");
    #else
        ios_base::sync_with_stdio(0);
        cin.tie(0);
        cout.tie(0);
    #endif // ONPC

    for (int i = 0; i < maxn; ++i)
        d[i] = LLONG_MAX;
    int n, m, k;
    cin >> n >> m >> k;
    for (int i = 0; i < k; ++i){
        cin >> x[i] >> y[i];
        //sx[x[i]].push_back(i);
        //sy[y[i]].push_back(i);
    }

    d[0] = 0;
    pr[0] = -1;
    set<pair<ll, int> > se;
    se.insert({d[0], 0});
    for (int it = 0; it < k; ++it){
        if (!se.size())
            break;
        int v = se.begin()->second;
        u[v] = 1;
        se.erase(se.begin());

        for (int i = 0; i < k; ++i){
            if (!u[i]){
                if (d[i] > d[v] + bin_pow(2, max(abs(x[i] - x[v]), abs(y[i] - y[v])))){
                    se.erase({d[i], i});
                    d[i] = d[v] + bin_pow(2, max(abs(x[i] - x[v]), abs(y[i] - y[v])));
                    se.insert({d[i], i});
                    pr[i] = v;
                }
            }
        }
    }

    int v = k - 1;
    vector<int> ans;
    while (v != -1){
        ans.push_back(v);
        v = pr[v];
    }
    cout << ans.size() << '\n';
    for (auto it = ans.rbegin(); it != ans.rend(); ++it)
        cout << *it + 1 << ' ';
    cout << '\n';
    return 0;
}
