import java.util.PriorityQueue;
import java.util.Scanner;

public class A {
    class Elem implements Comparable<Elem>{
        int id;//Номер строки/столбца
        int val;//Значение в массиве a
        Elem(int id, int val){
            this.id = id;
            this.val = val;
        }

        @Override
        public int compareTo(Elem e) {
            return -Integer.compare(val, e.val);
        }
    }
    boolean[][] isGood;
    int ans,n,m,q;
    int[][] a;
    PriorityQueue<Elem>[] str, stolb;
    A(){
        Scanner in = new Scanner(System.in);
        n = in.nextInt();
        m = in.nextInt();
        q = in.nextInt();
        isGood = new boolean[n][m];
        a = new int[n][m];
        str = new PriorityQueue[n];
        stolb = new PriorityQueue[m];
        for(int i=0;i<n;i++){
            str[i] = new PriorityQueue<>();
        }
        for(int i=0;i<m;i++){
            stolb[i] = new PriorityQueue<>();
        }
        for(int i=0;i<n;i++){
            for(int j=0;j<m;j++){
                isGood[i][j] = false;
                int t = in.nextInt();
                a[i][j] = t;
                str[i].add(new Elem(j,t));
                stolb[j].add(new Elem(i,t));
            }
        }
        //Сначала посчитаем изначальное количество подходящих клеток
        ans = 0;
        for(int i=0;i<n;i++){
            Elem e = str[i].peek();//Макс. элемент в этой строке
            int st = e.id;//Столбец этого элемента
            Elem e2 = stolb[st].peek();//Макс. элемент в его столбце
            if(e.val==e2.val){
                //Если эти элементы одинаковы то он является подходящим
                ++ans;
                isGood[i][st] = true;
                //System.out.println(i+" "+st+" "+e.val+" лучший");
            }
        }
        //System.out.println("Изначально "+ans);
        for(int i=0;i<q;i++){
            int x = in.nextInt()-1;
            int y = in.nextInt()-1;
            int nval = in.nextInt();
            Elem strmax = str[x].peek();
            Elem stolbmax = stolb[y].peek();
            boolean bestInStr = false;
            boolean bestInStolb = false;
            if(nval>strmax.val){
                //System.out.println("Больше лучшего в строке");
                if(isGood[x][strmax.id]) {
                    isGood[x][strmax.id] = false;
                    --ans;
                }
                bestInStr = true;
            }
            if(nval>stolbmax.val){
                //System.out.println("Больше лучшего в столбце");
                if(isGood[stolbmax.id][y]) {
                    isGood[stolbmax.id][y] = false;
                    --ans;
                }
                bestInStolb = true;
            }
            if(bestInStolb && bestInStr){
                //System.out.println("Самый лучший");
                if(!isGood[x][y]){
                    isGood[x][y] = true;
                    ++ans;
                }
            }
            str[x].add(new Elem(y, nval));
            stolb[y].add(new Elem(x, nval));
            System.out.println(ans);
        }
    }
    public static void main(String[] args){
        new A();
    }
    /*
    2 3 3
    1 4 3
    6 5 2
    2 2 9
    1 3 5
    2 2 10
     */
}
