import java.io.InputStreamReader;
import java.io.StreamTokenizer;
import java.util.ArrayList;
import java.util.PriorityQueue;
import java.util.Scanner;

public class A {
    class Elem implements Comparable<Elem>{
        int id;
        int val;
        Elem(int id, int val){
            this.id = id;
            this.val = val;
        }

        @Override
        public int compareTo(Elem e) {
            return -Integer.compare(val, e.val);
        }
    }
    boolean[][] isGood;
    int ans,n,m,q;
    int[][] a;
    PriorityQueue<Elem>[] str, stolb;
    //StreamTokenizer in;
    Scanner in;
    ArrayList<Integer> parse(String s){
        ArrayList<Integer> arr = new ArrayList<>();
        int cur = 0;
        for(int i=0;i<s.length();i++){
            char c = s.charAt(i);
            if(c<='9' && c>='0'){
                cur = cur*10+(c-'0');
            }
            else{
                if(cur!=0){
                    arr.add(cur);
                    cur = 0;
                }
            }
        }
        if(cur!=0){
            arr.add(cur);
        }
        return arr;
    }
    A(){
        in = new Scanner(System.in);
        String line = in.nextLine();
        ArrayList<Integer> tm = parse(line);
        n = tm.get(0);
        m = tm.get(1);
        q = tm.get(2);
        isGood = new boolean[n][m];
        a = new int[n][m];
        str = new PriorityQueue[n];

        stolb = new PriorityQueue[m];
        for(int i=0;i<n;i++){
            str[i] = new PriorityQueue<>();
        }
        for(int i=0;i<m;i++){
            stolb[i] = new PriorityQueue<>();
        }
        for(int i=0;i<n;i++){
            line = in.nextLine();
            tm = parse(line);
            for(int j=0;j<m;j++){
                isGood[i][j] = false;
                int t = tm.get(j);

                a[i][j] = t;
                str[i].add(new Elem(j,t));
                stolb[j].add(new Elem(i,t));
            }
        }
        ans = 0;
        for(int i=0;i<n;i++){
            Elem e = str[i].peek();
            int st = e.id;
            Elem e2 = stolb[st].peek();
            if(e.val==e2.val){
                ++ans;
                isGood[i][st] = true;
            }
        }
        for(int i=0;i<q;i++){
            line = in.nextLine();
            tm = parse(line);
            int x = tm.get(0)-1;
            int y = tm.get(1)-1;
            int nval = tm.get(2);
            Elem strmax = str[x].peek();
            Elem stolbmax = stolb[y].peek();
            boolean bestInStr = false;
            boolean bestInStolb = false;
            if(nval>strmax.val){
                if(isGood[x][strmax.id]) {
                    isGood[x][strmax.id] = false;
                    --ans;
                }
                bestInStr = true;
            }
            if(nval>stolbmax.val){
                if(isGood[stolbmax.id][y]) {
                    isGood[stolbmax.id][y] = false;
                    --ans;
                }
                bestInStolb = true;
            }
            if(bestInStolb && bestInStr){
                if(!isGood[x][y]){
                    isGood[x][y] = true;
                    ++ans;
                }
            }
            str[x].add(new Elem(y, nval));
            stolb[y].add(new Elem(x, nval));
            System.out.println(ans);
        }
    }
    public static void main(String[] args){
        new A();
    }
    /*
    2 2 2
    2 2 2
    2 2 2
     */
}
