import java.util.ArrayList;
import java.util.Arrays;
import java.util.Scanner;

public class B {
    int n;
    int[][] arr;
    int[] defId;
    B(){
        Scanner in = new Scanner(System.in);
        n = in.nextInt();
        arr = new int[n][n];
        defId = new int[n];
        for(int i=0;i<n;i++){
            for(int j=0;j<n;j++){
                arr[i][j] = in.nextInt()-1;
                if(arr[i][j]==i){
                    defId[i] = j;
                }
            }
        }
        int p = in.nextInt();
        if(p==1){
            ArrayList<Integer> a = new ArrayList<>();
            int ans = 0;
            for(int i=0;i<n;i++) {
                if (arr[i][0] == i) {
                    ++ans;
                    a.add(i+1);
                }
            }
            System.out.println(ans);
            for(int i=0;i<ans;i++){
                System.out.print(a.get(i)+" ");
            }
        }
        else{
            boolean[][] canKill = new boolean[n][n];
            for(int i=0;i<n;i++){
                for(int j=0;j<n;j++){
                    canKill[i][j] = false;
                }
            }
            for(int i=0;i<n;i++){
                for(int j=defId[i]-1;j>=0;j--){
                    canKill[arr[i][j]][i] = true;
                    //System.out.println((arr[i][j]+1)+" kills "+(i+1));
                }
            }
            boolean[] isGood = new boolean[n];
            Arrays.fill(isGood, false);
            for(int i=0;i<n;i++){
                //System.out.println("cell "+(i+1));
                boolean[] killed = new boolean[n];
                Arrays.fill(killed, false);
                int killer = n-1;
                int killerId = arr[i][killer];
                int highestAlive = 0;
                isGood[arr[i][0]] = true;
                while(killer>highestAlive){
                    boolean allDead = true;
                    for(int j=highestAlive;j<killer;j++){
                        int id = arr[i][j];
                        if(allDead){
                            isGood[arr[i][j]] = true;
                        }
                        if(canKill[killerId][id]){
                            killed[id] = true;
                            if(allDead){
                                ++highestAlive;
                                isGood[arr[i][highestAlive]] = true;
                            }
                        }
                        else{
                            allDead = false;
                        }
                    }
                    //System.out.println("killer "+(killerId+1)+" isGood "+Arrays.toString(isGood));
                    --killer;
                    killerId = arr[i][killer];
                }
            }
            int kol = 0;
            for(int i=0;i<n;i++){
                if(isGood[i]) ++kol;
            }
            System.out.println(kol);
            for(int i=0;i<n;i++){
                if(isGood[i])System.out.print((i+1)+" ");
            }
        }
    }
    public static void main(String[] args){
        new B();
    }
    /*
    4
    3 2 4 1
    1 4 2 3
    3 1 2 4
    1 4 2 3
    2
     */
}
