import java.awt.*;
import java.util.Arrays;
import java.util.Scanner;

public class C {
    class PokA implements Comparable<PokA>{
        int a;
        int id;
        PokA(int a, int id){
            this.a=a;
            this.id=id;
        }
        @Override
        public int compareTo(PokA o) {
            return -Integer.compare(a, o.a);
        }
    }
    class PokB implements Comparable<PokB>{
        int b;
        int id;

        PokB(int b, int id){
            this.b=b;
            this.id=id;
        }
        @Override
        public int compareTo(PokB o) {
            return -Integer.compare(b, o.b);
        }
    }
    int n;
    PokA[] arrA;
    PokB[] arrB;
    C(){
        Scanner in = new Scanner(System.in);
        n = in.nextInt();
        arrA = new PokA[n];
        arrB = new PokB[n];
        for(int i=0;i<n;i++){
            int a = in.nextInt();
            int b = in.nextInt();
            arrA[i] = new PokA(a, i);
            arrB[i] = new PokB(b, i);
        }
        Arrays.sort(arrA);
        Arrays.sort(arrB);
        long maxCost = 0;
        Point[][] dp = new Point[n][n];
        boolean[] boughtA = new boolean[n];
        Arrays.fill(boughtA, false);
        int kolA = 0;
        for(int i=0;i<n;i++){
            boughtA[arrA[i].id] = true;
            ++kolA;
            int kolB = 0;
            for(int j=0;j<n;j++){
                int id = arrB[j].id;
                if(!boughtA[id]){
                    ++kolB;
                }
                int costA = arrA[i].a;
                int costB = arrB[j].b;
                if(costA>=costB)maxCost = Math.max(maxCost, kolA*costA + kolB*costB);
            }
        }
        System.out.println(maxCost);
    }
    public static void main(String[] args){
        new C();
    }
}
