typedef long long ll;
typedef long double ld;
#include<iostream>
#include<vector>
#include<string>
#include<iomanip>
#include<map>
#include<set>
#include<algorithm>

using namespace std;

ll INF = 1e9;

int main() {
	cin.tie(0);
	cout.tie(0);
	cin.sync_with_stdio(0);
	int n;
	cin >> n;
	vector<int>v(n);
	vector<int>more(n,-1), less(n,INF);
	for (int i = 0; i < n; i++) {
		cin >> v[i];
	}
	for (int i = 0; i < n; i++) {
		for (int j = i + 1; j < n; j++) {
			if (v[j] > v[i]) {
				more[i] = j;
				break;
			}
		}
	}
	for (int i = 0; i < n; i++) {
		for (int j = i + 1; j < n; j++) {
			if (v[j] < v[i]) {
				less[i] = j;
				break;
			}
		}
	}

	int ans = 0;

	for (int i = 0; i < n; i++) {
		int last = less[i];
		int cur = i;
		while (more[cur]!=-1 && more[cur] < less[i]) {
			cur = more[cur];
		}
		ans++;
		i = cur;
	}
	cout << ans;

	return 0;
}