#include <iostream>
#include <vector>
#include <bitset>

using namespace std;

int main()
{
    int n;
    cin >> n;
    int priorities[n][n];
    for(int i = 0; i < n; i++)
        for(int j = 0; j < n; j++)
        {
            cin >> priorities[i][j];
            priorities[i][j]--;
        }
    vector<bool> ans(n);
    bitset<500> groups[n];
    for(int i = 0; i < n; i++)
    {
        if(priorities[i][0] == i)
            ans[i] = true;
        for(int j = 0;; j++)
        {
            groups[i][priorities[i][j]] = true;
            if(priorities[i][j] == i)
                break;
        }
    }
    int q;
    cin >> q;
    if(q == 2)
    {
        vector<bool> stable = ans;
        //dk careglaz 47 hromosom a u kozlovoy net chlena
        for(int i = 0; i < n; i++)
            for(int j = 0; j < n; j++)
            {
                if(!groups[j][i])
                    continue;
                for(int k = 0; k < n; k++)
                    if(!groups[k][i] && (groups[k] & groups[j]) == groups[k])
                        goto fail;
                ans[i] = true;
            fail:;
            }
    }
    vector<int> ans_l;
    for(int i = 0; i < n; i++)
        if(ans[i])
            ans_l.push_back(i + 1);
    cout << ans_l.size() << endl;
    if(!ans_l.empty())
    {
        cout << ans_l[0];
        for(int i = 1; i < ans_l.size(); i++)
            cout << ' ' << ans_l[i];
    }
    cout << endl;
    return 0;
}
