#include <iostream>
#include <vector>
#include <algorithm>
const int MAXN = 502;

struct wtf{
    bool a[MAXN];
    wtf(int len){
        for (int i = 0; i < MAXN; i++){
            a[i] = false;
        }
        if (len != 0){
            a[MAXN - len] = true;
        }
    }
    wtf(){
        for (int i = 0; i < MAXN; i++){
            a[i] = false;
        }
    }
    bool operator <(wtf oth) const {
        for (int i = 0; i < MAXN; i++){
            if (a[i] < oth.a[i]){
                return true;
            }
            if (a[i] > oth.a[i]){
                return false;
            }
        }
        return false;
    }

    wtf operator +(wtf oth) const {
        wtf ans;
        bool flag = false;
        for (int i = MAXN - 1; i >= 0; i--){
            int cans = oth.a[i] + a[i] + flag;
            if (cans > 1){
                flag = true;
                cans -= 2;
            }
            else{
                flag = false;

            }
            ans.a[i] = cans;
        }
        return ans;
    }
};

const wtf INF = wtf(MAXN - 1);

wtf ans[MAXN];
bool used[MAXN];
int pred[MAXN];

int reb[MAXN][2];

using namespace std;

int main(){
    int n, m, k;
    cin >> n >> m >> k;
    for (int i = 0; i < MAXN; i++){
        ans[i] = INF;
    }
    int bg = 0;
    int ed = k - 1;
    for (int i = 0; i < k; i++){
        cin >> reb[i][0] >> reb[i][1];
    }

    ans[bg] = wtf();
    for (int z = 0; z < k; z++){
    /*
        cout << z << endl;

        for (int i = 0; i < k; i++){
            cout << i + 1 << endl;
            for (int j = 0; j < MAXN; j++){
                cout << ans[i].a[j];
            }
            cout << endl;
        }
*/
        wtf MN = INF;
        int mnid = -1;
        for (int i = 0; i < k; i++){
            if ((!used[i]) and (ans[i] < MN)){
                MN = ans[i];
                mnid = i;
            }
        }
        int v = mnid;
        used[v] = true;
        ///cout << "v" << ' ' << v + 1 << endl;

        for (int u = 0; u < k; u++){
            int ln = max(abs( reb[v][0] - reb[u][0] ),  abs(  reb[v][1] - reb[u][1] ));
            wtf val = wtf(ln);
            /*
            cout << u + 1 << ' ';
            for (int i = 0; i < MAXN; i++){
                cout << val.a[i];
            }
            cout << ' ';
            */
            val = val + MN;
            /*
            for (int i = 0; i < MAXN; i++){
                cout << val.a[i];
            }
            cout << ' ';
            cout << reb[v][0] << ' ' << reb[v][1] << ' ' << reb[u][0] << ' ' << reb[u][1];
            cout << ' ' << ln;
            cout << endl;
            */
            if (val < ans[u]){
                pred[u] = v;
                ans[u] = val;
            }
        }
        //cout << endl << endl;
    }

    vector <int> vost;
    int v = ed;
    while (v != bg){
        vost.push_back(v);
        v = pred[v];
    }
    vost.push_back(v);
    reverse(vost.begin(), vost.end());
    cout << vost.size() << endl;
    for (int i = 0; i < vost.size(); i++){
        cout << vost[i]  + 1 << ' ';
    }
}

