#pragma GCC optimize("O3")
#include <iostream>
#include <vector>
#include <algorithm>
#include <string>
#define ff first
#define ss second

using namespace std;

vector<string> s;
int L;

bool cmp(const string& s1, const string& s2) {
    if (s1.size() < s2.size()) return 1;
    if (s1.size() > s2.size()) return 0;
    return s1 < s2;
}

int n;

string solve() {
    vector<int> ans;
    ans.resize(L * n + 1);
    for (auto& el: s) {
        //cout << el << endl;
        bool log = 1;
        for (int j = 0, pos = (int)ans.size() - (int)el.size(); j < el.size(); j++, pos++) {
            if (el[j] == '0') continue;
            if (ans[pos] == 0) continue;
            log = 0;
        }
        if (log) {
            for (int j = 0, pos = (int)ans.size() - (int)el.size(); j < el.size(); j++, pos++) {
                ans[pos] += el[j] - '0';
            }
        } else {
            int j = ans.size() - el.size() - 1;
            while (ans[j] == 1) j--;
            ans[j] = 1;
        }
        /*for (auto el: ans) cout << el << " ";
        cout << endl;*/
    }
    string out = "";
    int i = 0;
    while (ans[i] == 0) i++;
    for (; i < ans.size(); i++) out.push_back('0' + ans[i]);
    return out;
}

int main() {
    cin >> n;
    s.resize(n);

    for (int i = 0; i < n; i++) {
        cin >> s[i];
        L = max(L, (int)s[i].size());
    }
    sort(s.begin(), s.end(), cmp);
    string ans = solve();
    for (int i = 0; i < 1000; i++) {
        random_shuffle(s.begin(), s.end());
        auto s1 = solve();
        if (cmp(s1, ans)) ans = s1;
    }
    cout << ans << endl;
    return 0;
}