#pragma GCC optimize("O3")
#include <bits/stdc++.h>

using namespace std;

#define fi first
#define se second
#define mp make_pair
#define endl '\n'

template <typename T1, typename T2>
ostream & operator << (ostream & out, pair <T1, T2> p) {
    out << p.fi << ' ' << p.se;
    return out;
}

template <typename T1, typename T2>
istream & operator >> (istream & in, pair <T1, T2> & p) {
    in >> p.fi >> p.se;
    return in;
}

template <typename T>
ostream & operator << (ostream & out, vector <T> arr) {
    for (auto x : arr)
        out << x << endl;
    out << endl;
    return out;
}

template <typename T>
istream & operator >> (istream & in, vector <T> & arr) {
    for (auto & x : arr)
        in >> x;
    return in;
}

signed main()
{
    ios::sync_with_stdio(false);
    cin.tie(0);
    cout.tie(0);

    int n;
    cin >> n;
    vector <bitset<300000>> arr(n);
    vector <int> st(n);
    for (int i = 0; i < n; ++i) {
        string s;
        cin >> s;
        st[i] = s.size();
        reverse(s.begin(), s.end());
        for (int j = 0; j < s.size(); ++j)
            arr[i][j] = s[j] - '0';
    }
    bitset<300000> ans;
    ans = ~ans;
    vector <int> cnt(n);
    for (int i = 0; i < n; ++i)
        cnt[i] = arr[i].count();
    for (int mask = 0; mask < (1 << n); ++mask) {
        bitset<300000> now;
        int cntt = 0;
        bool flag = true;
        multiset <int> pos;
        for (int i = 0; i < n; ++i) {
            if ((mask >> i) & 1) {
                now |= arr[i];
                if (cntt + cnt[i] != now.count()) {
                    flag = false;
                    break;
                }
                cntt += cnt[i];
            }
            else {
                pos.insert(st[i]);
            }
        }
        if (!flag)
            continue;

        for (int i = 0; i < 300000 && pos.size() > 0; ++i) {
            if (now[i])
                continue;
            if (i >= * pos.begin()) {
                now[i] = 1;
                pos.erase(pos.begin());
            }
        }

        bool flag2 = true;
        for (int i = 299999; i >= 0; --i) {
            if (now[i] < ans[i])
                break;
            if (now[i] > ans[i]) {
                flag2 = false;
                break;
            }
        }
        if (flag2)
            ans = now;
    }
    string ss;
    for (int i = 0; i < 300000; ++i) {
        ss.push_back(ans[i] + '0');
    }
    while (ss.size() > 0 && ss.back() == '0')
        ss.pop_back();
    reverse(ss.begin(), ss.end());
    cout << ss << endl;
    return 0;
}
