#pragma GCC optimize("O3")
#include <bits/stdc++.h>

using namespace std;

#define int int64_t
#define fi first
#define se second
#define mp make_pair
#define endl '\n'

template <typename T1, typename T2>
ostream & operator << (ostream & out, pair <T1, T2> p) {
    out << p.fi << ' ' << p.se;
    return out;
}

template <typename T1, typename T2>
istream & operator >> (istream & in, pair <T1, T2> & p) {
    in >> p.fi >> p.se;
    return in;
}

template <typename T>
ostream & operator << (ostream & out, vector <T> arr) {
    for (auto x : arr)
        out << x << endl;
    out << endl;
    return out;
}

template <typename T>
istream & operator >> (istream & in, vector <T> & arr) {
    for (auto & x : arr)
        in >> x;
    return in;
}

bool get(string & a, string b) {
    int n = max(a.size(), b.size());
    a.resize(n, '0');
    b.resize(n, '0');
    for (int i = 0; i < n; ++i) {
        if (a[i] == '1' && b[i] == '1') {
            return false;
        }
        else if (a[i] == '1' || b[i] == '1')
        {
            a[i] = '1';
        }
    }
    return true;
}

string get2(string a, string b) {
    if (a.size() < b.size())
        return a;
    if (b.size() < a.size())
        return b;
    for (int i = a.size() - 1; i >= 0; --i) {
        if (a[i] < b[i])
            return a;
        if (b[i] < a[i])
            return b;
    }
    return a;
}

string get3(pair <string, multiset<int> > p) {
    //cout << "p = " << p << endl;
    if (p.se.size() == 0)
        return p.fi;
    for (int i = 0; i < p.fi.size(); ++i) {
        if (p.se.size() == 0)
            break;
        if (p.fi[i] == '0' && i >= *p.se.begin()) {
            p.se.erase(p.se.begin());
            p.fi[i] = '1';
        }
    }
    while (p.se.size() > 0) {
        p.fi.push_back('0');
        if (p.fi.size() > *p.se.begin()) {
            p.fi[p.fi.size() - 1] = '1';
            p.se.erase(p.se.begin());
        }
    }
    //cout << "s = " << p.fi << endl;
    return p.fi;
}

ostream & operator << (ostream & out, multiset<int> s) {
    cout << "{";
    for (auto x : s)
        cout << x << " ";
    cout << "}" << endl;
    return out;
}

pair <int, int> get() {
    string s;
    cin >> s;
    int ans = 0;
    for (int i = 0; i < s.size(); ++i) {
        ans *= 2;
        ans += s[i] -'0';
    }
    int a = (1ll << ((int)s.size()));
    return mp(ans, a);
}

string get2(int a) {
    string ans;
    while (a > 0) {
        ans.push_back(a % 2 + '0');
        a /= 2;
    }
    reverse(ans.begin(), ans.end());
    return ans;
}

signed main()
{
    //ios::sync_with_stdio(false);
    //cin.tie(0);
    //cout.tie(0);

    int n;
    cin >> n;
    auto p = get();
    int a = p.fi;
    int b = p.se;
    p = get();
    int c = p.fi;
    int d = p.se;
    vector <int> arr1;
    vector <int> arr2;
    int ans = 1e18;
    for (int i = 0; i < 30; ++i) {
        arr1.push_back(b);
        b *= 2;
        arr2.push_back(d);
        d *= 2;
    }
    arr1.push_back(a);
    arr2.push_back(c);
    for (auto x : arr1) {
        for (auto y : arr2) {
            if ((x & y) == 0) {
                ans = min(ans, x | y);
            }
        }
    }
    cout << get2(ans) << endl;
    return 0;
}
