#define _CRT_SECURE_NO_WARNINGS

#pragma gcc ooptimize("Ofast,unroll-loops")
#pragma gcc options("sse,sse2,sse3,sse4,popcnt")

#include <iostream>
#include <iomanip>
#include <string>
#include <vector>
#include <set>
#include <unordered_set>
#include <map>
#include <unordered_map>
#include <bitset>
#include <math.h>
#include <deque>
#include <iterator>
#include <algorithm>
#include <climits>

using namespace std;
using ll = long long;
using ld = long double;
using ipair = pair<int, int>;

#define all(x) x.begin(), x.end()
#define rall(x) x.rbegin(), x.rend()
#define pb push_back
#define pf push_front
#define ppb pop_back
#define ppf pop_front
#define vect vector

signed main() {
	int n; scanf("%d%*c", &n);
	vect<vect<int>> virs(n, vect<int>(n));
	set<int> stab, life;
	vect<bitset<512>> stronger(n), ribs(n);
	bitset<512> exist;
	for (int i = 0; i < n; ++i) { exist[i] = 1; }

	for (int i = 0; i < n; ++i) {
		ribs[i] = exist;
		bool ca = 1;
		for (int j = 0; j < n; ++j) {
			scanf("%d%*c", &virs[i][j]); --virs[i][j];
			if (ca) { stronger[virs[i][j]][i] = 1; }
			if (virs[i][j] == i) { ca = 0;  }
			if (j == 0 && virs[i][j] == i) { stab.insert(i + 1); }
		}
	}


	int p; scanf("%d%*c", &p); --p;
	if (!p) {
		printf("%d\n", stab.size());
		for (auto it : stab) { printf("%d ", it); }
	}
	else {
		for (int i = 0; i < n; ++i) {
			bitset<512> curstr;
			for (int j = n - 1; j >= 0; --j) {
				curstr |= stronger[virs[i][j]];
				if (stronger[virs[i][j]][i] && ((ribs[i] & curstr) == ribs[i])) {
					life.insert(virs[i][j] + 1);
				}
			}
		}
		printf("%d\n", life.size());
		for (auto it : life) { printf("%d ", it); }
	}
}