#include <iostream>
#include <vector>
#include <map>
#include <set>
#include <random>
#include <time.h> 
#define int long long
#define pb push_back 
#define mp make_pair
#define pii pair<int, int>

using namespace std;
const int maxn = 3e5, inf = 1e18;
int n, cnt[maxn];

void solve() {
	cin >> n;
	for (int i = 0; i < n; ++i) cin >> cnt[i];
	vector<int> dp(n + 1, inf); 
	dp[0] = 0; 
	for (int i = 1; i <= n; ++i) {
		int min_el = inf, max_el = -inf; 
		for (int j = i; j >= 1; --j) {
			min_el = min(min_el, cnt[j - 1]);
			max_el = max(max_el, cnt[j - 1]);
			if (cnt[j - 1] == min_el && cnt[i - 1] == max_el) {
				dp[i] = min(dp[i], dp[j - 1] + 1); 
			} 				
		}
	}
	cout << dp[n]; 
}

signed main() {
	ios_base::sync_with_stdio(false); cin.tie(0); cout.tie(0); 
	#ifdef offline_judge
		freopen("TASK.in", "r", stdin);
		freopen("TASK.out", "w", stdout);
	#endif
	solve(); 
}