import java.io.BufferedReader;
import java.io.IOException;
import java.io.InputStreamReader;
import java.io.PrintWriter;
import java.lang.reflect.Executable;
import java.util.Arrays;
import java.util.Locale;
import java.util.StringTokenizer;

public class Main {
    public void solve() throws IOException{
        int n = nextInt(), type = nextInt();
        int a[] =new int[n];
        for (int i = 0; i < n; i++) {
            a[i] = nextInt();
        }
        int f[] = new int[n], b[] = new int[n], ty[] = new int[n], m[] = new int[n];
        Arrays.fill(m, n);
        for(int mask = 0; mask < n; mask++){

            Arrays.fill(f, -1);
            f[mask] = a[mask];

            Arrays.fill(b, n + 1);
            int last = -1, nxt = 0;
            while(nxt < n && f[nxt] == -1) nxt++;
            for(int i = 0; i < n; i++){
                if(f[i] == -1){
                    int l = last, r = nxt;
                    if(l != -1){
                        b[i] =  i - l;
                    }
                    if(r != n){
                        b[i] = Math.min(b[i], r - i);
                    }
                }else{
                    last = i;
                    nxt ++;
                    while(nxt < n && f[nxt] == -1) nxt++;
                }
            }
            for(int i = 0; i < n; i++){
                if(f[i] == -1){
                    f[i] = a[i] + b[i];
                }
            }

            for(int i = 0; i < n; i++){
                ty[i] = f[i];
            }
            Arrays.sort(ty);
            for(int i = 0; i < n; i++){
                int l = -1, r = n - 1;
                while(r - l > 1){
                    int mid = (l + r)/2;
                    if(ty[mid] >= f[i]){
                        r = mid;
                    }else{
                        l = mid;
                    }
                }
                m[i] = Math.min(m[i], r + 1);

            }

        }
        for(int i = 0; i < n; i++){
            out.println(m[i]);
        }
    }
    BufferedReader br;
    StringTokenizer sc;
    PrintWriter out;
    public static void main(String[] args) throws IOException{
        Locale.setDefault(Locale.US);
        new Main().run();
    }
    public void run() throws IOException{
        try {
            br = new BufferedReader(new InputStreamReader(System.in));
            out = new PrintWriter(System.out);
            solve();
            out.close();
        }catch (Exception e){
            e.printStackTrace();
            System.exit(1);
        }
    }
    public String nextToken() throws IOException{
        while (sc == null || !sc.hasMoreTokens()){
            try {
                sc = new StringTokenizer(br.readLine());
            }catch (Exception e){
                return null;
            }
        }
        return sc.nextToken();
    }
    public int nextInt() throws IOException{
        return Integer.parseInt(nextToken());
    }
}
