#include <iostream>
#include <algorithm>
#include <cstdio>
#include <cassert>
#include <vector>
#include <set>

using namespace std;

#define int int64_t

const int MAXN = 501;
const int INF = 1e18;

bool a[MAXN][MAXN];

int d[MAXN];
set <pair <int, int> > s;

vector <pair <int, int> > all;

int distk(int x, int y) {
    return max(abs(all[x].first - all[y].first), abs(all[x].second - all[y].second));
}

int parent[MAXN];
bool was[MAXN];

int32_t main() {
    //freopen("input.txt", "r", stdin);

    ios_base::sync_with_stdio(false);

    int n, m, k; cin >> n >> m >> k;
    for (int i = 0; i < k; i++) {
        int x, y; cin >> x >> y;
        all.push_back(make_pair(x, y));
    }

    d[0] = 0;
    s.insert(make_pair(d[0], 0));
    for (int i = 1; i < (int)all.size(); i++)
        d[i] = INF;
    int x = 0;
    while (!s.empty()) {
        was[x] = true;
        for (int i = 0; i < (int)all.size(); i++) {
            int curk = distk(x, i);
            int cur = d[x] + (1ll << curk);
            if (d[i] > cur) {
                d[i] = cur;
                parent[i] = x;
            }
        }

        x = -1;
        for (int i = 0; i < (int)all.size(); i++)
            if (!was[i] && (x == -1 || d[i] < d[x]))
                x = i;
    }

    int i = (int)all.size() - 1;
    vector <int> ans;
    while (i != 0) {
        ans.push_back(i);
        i = parent[i];
    }
    ans.push_back(0);

    reverse(ans.begin(), ans.end());

    cout << (int)ans.size() << endl;
    for (int i = 0; i < (int)ans.size(); i++)
        cout << ans[i] + 1 << " ";
    cout << endl;

    return 0;
}
