#include <bits/stdc++.h>

using namespace std;

typedef long long ll;

const int INF = (int) 1e9 + 1e6 + 123;
const ll LINF = (ll) 1e18 + 1e9 + 123;

#define rep(i, s, t) for (auto i = (s); i < (t); ++(i))
#define per(i, s, t) for (auto i = (s); i >= (t); --(i))
#define sz(x) ((int)(x).size())
#define all(x) (x).begin(), (x).end()
#define mp make_pair
#define pb push_back

bool mini(auto &x, const auto &y) {
	if (y < x) {
		x = y;
		return 1;
	}
	return 0;
}

bool maxi(auto &x, const auto &y) {
	if (y > x) {
		x = y;
		return 1;
	}
	return 0;
}

void run();

int main() {
	ios::sync_with_stdio(0);
	cin.tie(0);
	cout.tie(0);
	run();
	return 0;
}

const int N = (int) 2e5 + 123;

int n, m, q;
pair<int, int> ver[N], hor[N];

int ans;

bool check(int i, int j) {
	return ver[j].second == i && hor[i].second == j;
}

int check(vector<pair<int, int>> kek) {
	sort(all(kek));
	kek.resize(unique(all(kek)) - kek.begin());
	int ans = 0;
	for (auto &it : kek) {
		ans += check(it.first, it.second);
	}
	return ans;
}

void change(int i, int j, int x) {
	int j1 = hor[i].second;
	int i1 = ver[j].second;
	ans -= check({{i, j1}, {i1, j}});
	maxi(ver[j], mp(x, i));
	maxi(hor[i], mp(x, j));
	ans += check({{i, j1}, {i1, j}, {i, j}});
}

void run() {
	rep(i, 0, N) ver[i] = hor[i] = {-INF, -1};
	
	cin >> n >> m >> q;
	rep(i, 0, n) {
		rep(j, 0, m) {
			int x;
			cin >> x;
			maxi(ver[j], mp(x, i));
			maxi(hor[i], mp(x, j));
		}
	}
	
	rep(i, 0, n) {
		rep(j, 0, m) {
			ans += check(i, j);
		}
	}
	
	cerr << ans << "\n";
	
	while (q--) {
		int r, c, x;
		cin >> r >> c >> x;
		r--; c--;
		change(r, c, x);
		cout << ans << "\n";
	}
}
