#include <bits/stdc++.h>

using namespace std;

typedef long long ll;
const int INF = (int) 1e9 + 1e6 + 123;
const ll LINF = (ll) 1e18 + 1e9 + 123;

#define rep(i, s, t) for (auto i = (s); i < (t); ++(i))
#define per(i, s, t) for (auto i = (s); i >= (t); --(i))
#define sz(x) ((int)(x).size())
#define all(x) (x).begin(), (x).end()
#define pb push_back
#define mp make_pair

void run();

int main() {
	ios::sync_with_stdio(0);
	cin.tie(0);
	cout.tie(0);
	run();
	return 0;
}

const int N = (int) 3e5 + 123;

int n;
int a[N];
int nxt_gr[N], nxt_le[N];

int solve(int pos) {
	if (pos == n) {
		return 0;
	}
	
	int le = nxt_le[pos];
	int gr = nxt_gr[pos];
	while (gr < le) {
		pos = gr;
		gr = nxt_gr[pos];
	}
	return 1 + solve(pos + 1);
}

void run() {
	cin >> n;
	rep(i, 0, n) {
		cin >> a[i];
	}
	vector<int> st;
	per(i, n - 1, 0) {
		while (sz(st) && a[st.back()] > a[i]) {
			st.pop_back();
		}
		if (!sz(st)) {
			nxt_le[i] = n;
		} else {
			nxt_le[i] = st.back();
		}
		st.pb(i);
	}
	st.clear();
	per(i, n - 1, 0) {
		while (sz(st) && a[st.back()] < a[i]) {
			st.pop_back();
		}
		if (!sz(st)) {
			nxt_gr[i] = n;
		} else {
			nxt_gr[i] = st.back();
		}
		st.pb(i);
	}
	
	cout << solve(0) << "\n";
}
