#include <bits/stdc++.h>
 
using namespace std;
 
typedef long long ll;
const int INF = (int) 1e9 + 1e6 + 123;
const ll LINF = (ll) 1e18 + 1e9 + 123;
 
#define rep(i, s, t) for (auto i = (s); i < (t); ++(i))
#define per(i, s, t) for (auto i = (s); i >= (t); --(i))
#define sz(x) ((int)(x).size())
#define all(x) (x).begin(), (x).end()
#define pb push_back
#define mp make_pair
 
void run();
 
bool mini(auto &x, const auto &y) {
    if (y < x) {
        x = y;
        return 1;
    }
    return 0;
}
 
bool maxi(auto &x, const auto &y) {
    if (y > x) {
        x = y;
        return 1;
    }
    return 0;
}
 
int main() {
    ios::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);
    run();
    return 0;
}
 
const int N = 3003;
 
int n;
int a[N];
int tmp[N];
vector<pair<int, int>> res;
 
void make(int l, int r) {
    res.pb({l, r});
    int qq = l;
    for (int i = l + 1; i <= r; i += 2) {
        tmp[qq++] = a[i];
    }
    for (int i = l; i <= r; i += 2) {
        tmp[qq++] = a[i];
    }
    rep(i, l, r + 1) {
        a[i] = tmp[i];
    }
}
 
bool sorted() {
    rep(i, 1, n) {
        if (a[i] > a[i + 1]) {
            return 0;
        }
    }
    return 1;
}
 
void run() {
    cin >> n;
    rep(i, 1, n + 1) {
        cin >> a[i];
    }
	
	mt19937 rnd(4235277);
	
	rep(iter, 0, 1000) {
		int l = rnd() % n + 1;
		int r = rnd() % n + 1;
		if (l > r) {
			swap(l, r);
		}
		make(l, r);
	}
     
    multiset<int> odd, even;
     
    while (!sorted()) {
        int len = -1;
        int l = -1, r = -1;
        odd.clear();
        even.clear();
         
        int j = 0;
        for (int i = 1; i <= n; i += 2) {
            if (j < i) {
                odd.clear();
                even.clear();
                odd.insert(a[i]);
                j = i;
            }
             
            while (j + 1 <= n) {
                if ((j + 1) % 2 == i % 2) {
                    if (a[j + 1] > *even.rbegin()) {
                        odd.insert(a[j + 1]);
                        j++;
                    } else {
                        break;
                    }
                } else {
                    if (a[j + 1] < *odd.begin()) {
                        even.insert(a[j + 1]);
                        j++;
                    } else {
                        break;
                    }
                }
            }
                 
            if (maxi(len, j - i + 1)) {
                l = i;
                r = j;
            }
            odd.erase(odd.find(a[i]));
            if (i + 1 <= j) {
                even.erase(even.find(a[i + 1]));
            }
        }
         
        j = 0;
         
        for (int i = 2; i <= n; i += 2) {
            if (j < i) {
                odd.clear();
                even.clear();
                odd.insert(a[i]);
                j = i;
            }
             
            while (j + 1 <= n) {
                if ((j + 1) % 2 == i % 2) {
                    if (a[j + 1] > *even.rbegin()) {
                        odd.insert(a[j + 1]);
                        j++;
                    } else {
                        break;
                    }
                } else {
                    if (a[j + 1] < *odd.begin()) {
                        even.insert(a[j + 1]);
                        j++;
                    } else {
                        break;
                    }
                }
            }
                 
            if (maxi(len, j - i + 1)) {
                l = i;
                r = j;
            }
            odd.erase(odd.find(a[i]));
            if (i + 1 <= j) {
                even.erase(even.find(a[i + 1]));
            }
        }
         
        assert(len > 1);
        make(l, r);
    }
     
    //~ assert(sz(res) <= 5 * n);
     
    cout << sz(res) << "\n";
    for (auto &it : res) {
        cout << it.first << " " << it.second << "\n";
    }
}
