#include <iostream>
#include <vector>
#include <algorithm>

using namespace std;

vector <int> t;

void upd(int v, int x) {
    while (v > 0) {
        t[v] += x;
        v /= 2;
    }
}

int get_sum(int v, int l, int r, int tl, int tr) {
    int m = (r + l) / 2, u = v / 2, x;
    if (tl > tr)
        return 0;
    if (l == tl && r == tr)
        return t[v];
    return get_sum(2 * v, l, m, tl, min(m, tr)) + get_sum(2 * v + 1, m + 1, r, max(tl, m + 1), tr);
}

int main() {
    /*ios_base::sync_with_stdio(false);
    cin.tie(0);
    cout.tie(0);*/
    int n, m = 1, ind = 0, o;
    pair <int, int> p;
    vector <pair <int, int> > k;
    cin >> n >> o;
    while (n > m)
        m *= 2;
    vector <int> a(n);
    vector <int> ans(n, 0);
    t.resize(2 * m, 0);
    for (int i = 0; i < n; i++)
        cin >> a[i];
    for (int i = 0; i < n; i++) {
        k.push_back({a[i] - i, i});
    }
    sort(k.begin(), k.end());
    vector <pair <int, int> > q;
    while (ind != n) {
        q.clear();
        p = k[ind];
        q.push_back(p);
        ind++;
        if (ind != n)
            p = k[ind];
        while (ind != n && q.back().first == p.first) {
            q.push_back(p);
            ind++;
            if (ind != n)
                p = k[ind];
        }
        for (int i = 0; i < q.size(); i++) {
            p = q[i];
            ans[p.second] += get_sum(1, 0, m - 1, 0, p.second - 1);
        }
        for (int i = 0; i < q.size(); i++) {
            p = q[i];
            upd(p.second + m, 1);
        }
    }
    k.clear();
    for (int i = 0; i < 2 * m; i++)
        t[i] = 0;
    for (int i = 0; i < n; i++) {
        k.push_back({a[i] + i, i});
    }
    sort(k.begin(), k.end());
    while (ind != n) {
        q.clear();
        p = k[ind];
        q.push_back(p);
        ind++;
        if (ind != n)
            p = k[ind];
        while (ind != n && q.back().first == p.first) {
            q.push_back(p);
            ind++;
            if (ind != n)
                p = k[ind];
        }
        for (int i = 0; i < q.size(); i++) {
            p = q[i];
            ans[p.second] += get_sum(1, 0, m - 1, p.second + 1, m - 1);
        }
        for (int i = 0; i < q.size(); i++) {
            p = q[i];
            upd(p.second + m, 1);
        }
    }
    for (int i = 0; i < n; i++)
        cout << ans[i] + 1 << endl;
}
