import java.util.Scanner;

public class A {
    static int n, a[];
    static TreeRange tr;
    public static void main(String[] args) {
        Scanner in = new Scanner(System.in);
        n = in.nextInt();
        a = new int[n];
        for (int i = 0; i < n; i++) {
            a[i] = in.nextInt();
        }
        tr = new TreeRange(a);
        System.out.println(solve(0, n - 1));
    }
    static int solve(int l, int r){
        if(l > r){
            return 0;
        }
        if(l == r){
            return 1;
        }
        int max = tr.max(l, r);
        int min = tr.min(l, r);
        if(a[min] != a[l]){
            return solve(l, min - 1) + solve(min, r);
        }
        if(a[max] != a[r]){
            return solve(l, max) + solve(max + 1, r);
        }
        return 1;
    }
    static class TreeRange{
        int m;
        int x[];
        int y[];
        TreeRange(int a[]){
            m = init(a.length);
            x = new int[2 * m];
            y = new int[2 * m];
            for(int i = 0; i < n; i++){
                x[i + m] = a[i];
                y[i + m] = a[i];
            }
            for(int i = n; i < m; i++){
                x[i + m] = Integer.MAX_VALUE;
                y[i + m] = Integer.MIN_VALUE;
            }
            for(int i = m - 1; i >= 1; i--){
                x[i] = Math.min(x[2 * i], x[2 * i + 1]);
                y[i] = Math.max(x[2 * i], x[2 * i + 1]);
            }
        }
        int min(int l, int r){
            int ans = l;
            int min = a[l];
            for(int i = l; i <= r; i++){
               if(a[i] < min){
                   min = a[i];
                   ans = i;
               }
            }
            return ans;
        }
        int max(int l, int r){
            int ans = r;
            int max = a[r];
            for(int i = l; i <= r; i++){
                if(a[i] > max){
                    max = a[i];
                    ans = i;
                }
            }
            return ans;
        }
        int minFromTop(){
          return 0;
        }
        int maxFromTop(){
            return 0;
        }
        int init(int k){
            int ans = 1;
            while(ans < k){
                ans *= 2;
            }
            return ans;
        }
    }
}
