#include<bits/stdc++.h>

using namespace std;

typedef long long int ll;

#define sz(x) (long long int) (x.size())
#define pb push_back()
#define pii pair <int, int>

struct node {
    int val = 1e9 + 5;
    set <int> vals;
};

vector <pii> tree;
vector <node> treemn;
vector <int> a;
const int INF = 1e9 + 5;

void build(int i, int l, int r) {
    if (l == r) {
        tree[i].first = a[l - 1];
        tree[i].second = l - 1;
        return;
    }
    int m = (l + r) / 2;
    build (2 * i, l, m);
    build(2 * i + 1, m + 1, r);
    if (tree[2 * i].first > tree[2 * i + 1].first) {
        tree[i] = tree[2 * i];
    }
    else
        tree[i] = tree[2 * i + 1];
}

void upd (int i, int l, int r, int pos, int c, int val) {
    if (l > pos || r < pos)
        return;
    if (l == r && l == pos) {
        if(c > 0)
            treemn[i].vals.insert(val);
        else
            treemn[i].vals.erase(val);
        if (sz(treemn[i].vals))
            treemn[i].val = min(treemn[i].val, *(treemn[i].vals.begin()));
        else
            treemn[i].val = INF;
        return;
    }
    int m = (l + r) / 2;
    int v = 2 * i;
    int u = 2 * i + 1;
    upd(v, l, m, pos, c, val);
    upd(u, m + 1, r, pos, c, val);
    treemn[i].val = min(treemn[v].val, treemn[u].val);
}

int getmn(int i, int l, int r, int nl, int nr) {
    if (l > nr || r < nl)
        return INF;
    if (l >= nl && r <= nr) {
        return treemn[i].val;
    }
    int m = (l + r) / 2;
    int v = 2 * i;
    int u = 2 * i + 1;
    return min(getmn(v, l, m, nl, nr), getmn(u, m + 1, r, nl, nr));
}

pii getmx(int i, int l, int r, int nl, int nr) {
    if (l > nr || r < nl)
        return {-INF, -1};
    if (l >= nl && r <= nr)
        return tree[i];
    int m = (l + r) / 2;
    pii c = getmx(2 * i, l, m, nl, nr);
    pii d = getmx(2 * i + 1, m + 1, r, nl, nr);
    if (c.first > d.first)
        return c;
    return d;
}

int main() {
    ios::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);
    int n;
    cin >> n;
    a.resize(n);
    tree.resize(4 * n);
    treemn.resize(4 * n);
    vector <int> b(n), c(n);
    for (int i = 0; i < n; ++i) {
        cin >> a[i];
        b[i] = a[i];
    }
    sort(b.begin(), b.end());
    for (int i = 0; i < n; ++i)
        c[i] = lower_bound(b.begin(), b.end(), a[i]) - b.begin();
    for (int i = 0; i < n; ++i)
        upd(1, 0, n - 1, c[i], 1, i);
    build(1, 1, n);
    int i = 0, cnt = 0;
    while (i < n) {
        int j = i;
        int l;
        if (c[i] == 0)
            l = n;
        else
            l = getmn(1, 0, n - 1, 0, c[i] - 1);
        if (l == INF) {
            l = n;
        }
        //cout << l << endl;
        pii cc = getmx(1, 1, n, i + 1, l);
        ++cnt;
        i = cc.second + 1;
        //cout << j << " "<< i << endl;
        for (int k = j; k < i; ++k)
            upd(1, 0, n - 1, c[k], -1, k);
    }
    cout << cnt << endl;
}
