#include <iostream>
#include <cstdlib>
#include <cstdio>
#include <cassert>
#include <climits>
#include <algorithm>
#include <set>
#include <vector>

using namespace std;
typedef unsigned int index;

int main()
{
#ifdef ONPC
	assert(freopen("a.in", "r", stdin));
	assert(freopen("a.out", "w", stdout));
#else
#endif
	size_t n;
	cin >> n;
	vector<int> a(n);
	for (auto &i: a)
		cin >> i;
	vector<index> next(n, (index)-1);
	vector<pair<int, index>> opened;
	for (index i = 0; i < n; i++)
	{
		while (opened.size() > 0 and opened.back().first <= a[i])
		{
			next[opened.back().second] = i;
			opened.pop_back();
		}
		opened.push_back({a[i], i});
	}
	size_t ans = 0;
	index cur = 0;
	while (cur != n)
	{
		index sv = cur;
		while (next[cur] != (index)-1)
		{
			bool flag = false;
			for (index i = cur + 1; i < next[cur]; i++)
			{
				if (a[i] < a[sv])
				{
					flag = true;
					break;
				}
			}
			if (flag)
				break;
			cur = next[cur];
		}
		ans++;
		cur++;
	}
	cout << ans << endl;
}
