#define _CRT_SECURE_NO_WARNINGS
#include <iostream>
#include <vector>
#include <algorithm>
#include <iomanip>
//#include "Source.h"

using namespace std;

typedef long long ll;

void solve() {
	int n;
	cin >> n;
	vector<vector<int> > power(n, vector<int> (n));
	vector<vector<int> > to(n);

	for (int i = 0; i < n; ++i)
		for (int j = 0; j < n; ++j) {
			cin >> power[i][j];
			power[i][j]--;
		}

	vector<int> sum(n);
	for (int i = 0; i < n; ++i)
		for (int j = 0; j < n; ++j) {
			if (j == i)
				continue;
			for (int z = 0; z < n; ++z)
				if (power[j][z] == i) {
					to[i].push_back(j);
					sum[j]++;
					break;
				} else if (power[j][z] == j)
					break;
		}

	vector<int> output;
	for (int i = 0; i < n; ++i)
		if (power[i][0] == i)
			output.push_back(i + 1);
	int p;
	cin >> p;
	if (p == 1) {
		cout << output.size() << '\n';
		for (int a : output)
			cout << a << ' ';
		return;
	}
	output.clear();

	vector<bool> life(n, 0);

	for (int i = 0; i < n; ++i) {
		vector<int> tmp = sum;
		bool flag = true;
		vector<char> used(n, 0);
		for (int j = 0; j < n && flag; ++j) {
			int cur = power[i][j];
			life[cur] = 1;
			if (used[cur] || tmp[cur] == 0)
				break;
			used[cur] = 1;
			for (int a : to[cur]) {
				tmp[a]--;
				if (tmp[a] == 0 && used[a])
					flag = false;
			}
		}
	}
	for (int i = 0; i < n; ++i)
		if (life[i])
			output.push_back(i + 1);

	cout << output.size() << '\n';
	for (int a : output)
		cout << a << ' ';
}

int main() {
	ios_base::sync_with_stdio(0);
	cin.tie(0);
	cout.tie(0);
#ifdef Sam
	freopen("input.in", "r", stdin);
	freopen("output.out", "w", stdout);
#endif
	solve();
	return 0;
}