#include <iostream>
#include <algorithm>

using namespace std;

int main()
{
    int n, m, q;
    cin >> n >> m >> q;
    long long a[n][m], x;
    pair <long long, pair <int, int> > p[n*m];
    for (int i = 0; i < n; i++)
        for (int j = 0; j < m; j++) 
        {
            cin >> a[i][j];
            p[i*m+j] = {a[i][j], {i, j}};
        }
        
    int mw[n], mh[m], fw[n], fh[m];
    for (int i = 0; i < n; i++) 
    {
        mw[i] = 0;
        fw[i] = 0;
    }
    for (int i = 0; i < m; i++) 
    {
        mh[i] = 0;
        fh[i] = 0;
    }
    
    sort(p, p+n*m);
    
    long long ans = 0;
    
    for (int t = n*m-1; t >= 0; t--)
    {
        long long y = p[t].first;
        int i = p[t].second.first, j = p[t].second.second, c = 0;
        if (!mw[i])
        {
            mw[i] = y;
            c++;
        }
        if (!mh[j])
        {
            mh[j] = y;
            c++;
        }
        if (c == 2)
        {
            ans++;
            fw[i] = 1;
            fh[j] = 1;
        }
    }
    
    //cout << ans << "\n";
    
    while (q--)
    {
        int i, j, c = 0;
        long long tt = 0;
        cin >> i >> j >> x;
        i--;
        j--;
        a[i][j] = x;
        if (x > mw[i])
        {
            tt = mw[i];
            mw[i] = x;
            ans -= fw[i];
            fw[i] = 0;
            c++;
        }
        if (x > mh[j])
        {
            if (mh[j] != tt) ans -= fh[j];
            mh[j] = x;
            fh[j] = 0;
            c++;
        }
        if (c == 2)
        {
            ans++;
            fw[i] = 1;
            fh[j] = 1;
        }
        cout << ans << "\n";
    }
    return 0;
}