#include <bits/stdc++.h>

using namespace std;

mt19937 rnd(228);

const int N = 3e5 + 7;
const int LEN = 500;

string s[N];
int n;
int grab[LEN];
int last[N];

bool ok = false;

void rec(int i)
{
    if (i == n || ok)
    {
        ok = true;
        return;
    }
    bool bad = false;
    for (int j = 0; j < LEN; j++)
    {
        if (s[i][j] == '1')
        {
            if (grab[j])
            {
                bad = true;
            }
            grab[j]++;
        }
        else
        {
            if (!bad && !grab[j] && (i == 0 || last[i] >= last[i - 1]))
            {
                last[i] = j;
                grab[j]++;
                rec(i + 1);
                grab[j]--;
            }
        }
    }
    if (!bad)
    {
        last[i] = LEN;
        rec(i + 1);
    }
    for (int j = 0; j < LEN; j++)
    {
        if (s[i][j] == '1')
        {
            grab[j]--;
        }
    }
}

int main()
{
    ios::sync_with_stdio(0);
    cin.tie(0);
    cin >> n;
    for (int i = 0; i < n; i++)
    {
        cin >> s[i];
        while (s[i].size() < LEN) s[i].insert(s[i].begin(), '0');
    }
    sort(s, s + n);
    string ret = "";
    {
        string x = "";
        for (int i = 0; i < LEN; i++)
        {
            grab[i]++;
            ok = 0;
            rec(0);
            if (!ok)
            {
                grab[i]--;
                x += '1';
            }
            else
            {
                x += '0';
            }
        }
        ret = x;
    }
    {
        reverse(s, s + n);
        string x = "";
        for (int i = 0; i < LEN; i++)
        {
            grab[i]++;
            ok = 0;
            rec(0);
            if (!ok)
            {
                grab[i]--;
                x += '1';
            }
            else
            {
                x += '0';
            }
        }
        ret = min(ret, x);
    }
    while (ret.size() > 1 && ret[0] == '0') ret.erase(ret.begin());
    cout << ret << '\n';
}
