#include <iostream>
#include <vector>
#include <deque>
#include <algorithm>
#include <unordered_map>

using namespace std;

int n;
vector <int> a;

int main() {
	int p;
	cin >> n >> p;
	a.resize(n);
	for (int i = 0; i < n; i++) cin >> a[i];

	if (p == 1) {
		for (int i = 0; i < n; i++) a[i] += i;
		for (int i = 0; i < n; i++) {
			int cnt = 0;
			for (int j = 0; j < n; j++) if (a[j] < a[i]) cnt++;
			cout << cnt + 1 << '\n';
			for (int j = 0; j <= i; j++) a[j]++;
			for (int j = i + 1; j < n; j++) a[j]--;
		}
	}
	else {
		for (int i = 0; i < n; i++) {
			int cur_ans = 0;

			unordered_map <int, int> mp;
			for (int j = 0; j < n; j++) {
				if (a[j] < a[i]) cur_ans++;
				mp[a[j]]++;
			}

			int q = 0, mx = cur_ans;
			while (i - q > 0 && i + q < n - 1) {
				a[i]++;
				if (q == 0) mp[a[i] - 1]--;
				else mp[a[i - q]]--, mp[a[i + q]]--;
				cur_ans += mp[a[i] - 1];

				mx = max(cur_ans, mx);
				q++;
			}

			if (i - q > 0) {
				cur_ans = 0;
				for (int j = 0; j < i + q; j++)
					if (a[j] < a[i]) cur_ans++;
				for (int j = i + q; j < n && q != 0; j++) {
					if (a[j] + 1 + j - i + q < a[i]) cur_ans++;
					mp[a[j]]--;
				}
				while (i - q > 0) {
					a[i]++;
					if (q == 0) mp[a[i] - 1]--;
					else mp[a[i - q]]--;
					cur_ans += mp[a[i] - 1];

					mx = max(cur_ans, mx);
					q++;
				}
			}
			else if (i + q < n - 1) {
				cur_ans = 0;
				for (int j = n - 1; j > i - q; j--)
					if (a[j] < a[i]) cur_ans++;
				for (int j = i - q; j >= 0 && q != 0; j--) {
					if (a[j] + 1 - j + i - q < a[i]) cur_ans++;
					mp[a[j]]--;
				}
				while (i + q < n - 1) {
					a[i]++;
					if (q == 0) mp[a[i] - 1]--;
					else mp[a[i + q]]--;
					cur_ans += mp[a[i] - 1];

					mx = max(cur_ans, mx);
					q++;
				}
			}

			a[i] -= q;
			cout << mx + 1 << '\n';
		}
	}

	return 0;
}