#include <iostream>
#include <vector>
#include <deque>
#include <algorithm>
#include <unordered_map>
#include <string>
#include <random>

using namespace std;

int main() {
	int n;
	cin >> n;
	
	vector <vector <int>> d(n);
	int smsz = 0;
	for (int i = 0; i < n; i++) {
		string s;
		cin >> s;

		for (int j = 0; j < s.length(); j++)
			if (s[j] == '1') d[i].push_back(s.length() - 1 - j);
		smsz += d[i].size();
	}

	if (smsz == n) {
		unordered_map <int, int> q;
		for (int i = 0; i < n; i++) q[d[i][0]]++;

		string ans = "";
		for (int i = 0; i < 600000; i++) if (q[i] > 0) {
			ans = "1" + ans;
			q[i + 1] += q[i] - 1;
			q[i] = 1;
		}
		else ans = "0" + ans;

		bool go = false;
		for (int i = 0; i < ans.length(); i++) {
			if (!go && ans[i] == '0') continue;
			go = true;
			cout << ans[i];
		}
	}

	return 0;
}