#include <iostream>
#include <cstdio>
#include <vector>
#include <algorithm>
#include <set>
#include <map>
typedef long long ll;
using namespace std;

int main() {
	ios_base::sync_with_stdio(false);
	cin.tie(0); cout.tie(0);
	int n, m, q;
	cin >> n >> m >> q;
	vector<int> a(n), b(m);
	vector<ll> res(q);
	for (int i = 0; i < n; i++) {
		for (int j = 0; j < m; j++) {
			int x;
			cin >> x;
			a[i] = max(a[i], x);
			b[j] = max(b[j], x);
		}
	}
	bool fl = n < m;
	if (fl) {
		swap(n, m);
		a.swap(b);
	}
	map<int, int> s;
	for (int i = 0; i < n; i++)
		s[a[i]]++;
	for (int i = 0; i < q; i++) {
		int x, y, c;
		cin >> x >> y >> c;
		if (fl)
			swap(x, y);
		x--; y--;
		ll answ = 0;
		if (a[x] < c) {
			s[a[x]]--;
			s[c]++;
			a[x] = c;
		}
		b[y] = max(b[y], c);
		for (int i = 0; i < m; i++) {
			answ += s[b[i]];
		}
		res[i] = (answ);
	}
	for (int i : res) {
		cout << i << '\n';
	}
	return 0;
}