#define _CRT_SECURE_NO_WARNINGS
#include <iostream>
#include <cstdio>
#include <vector>
#include <algorithm>
#include <set>
#include <map>
typedef long long ll;
using namespace std;

int main() {
	int n, m, q;
	scanf("%d%d%d", &n, &m, &q);
	vector<int> a(n), b(m);
	vector<int> s;
	for (int i = 0; i < n; i++) {
		for (int j = 0; j < m; j++) {
			int x;
			scanf("%d", &x);
			s.push_back(x);
			a[i] = max(a[i], x);
			b[j] = max(b[j], x);
		}
	}
	bool fl = n < m;
	if (fl) {
		swap(n, m);
		a.swap(b);
	}
	vector<int> x(q), y(q), c(q);
	for (int i = 0; i < q; i++) {
		scanf("%d%d%d", &x[i], &y[i], &c[i]);
		x[i]--; y[i]--;
		if (fl)
			swap(x[i], y[i]);
		s.push_back(c[i]);
	}
	sort(s.begin(), s.end());
	vector<int> z(s.size());
	for (int i = 1; i < s.size(); i++) {
		if (s[i] == s[i - 1])
			z[i] = z[i - 1];
		else
			z[i] = z[i - 1] + 1;
	}
	for (int i = 0; i < n; i++) {
		a[i] = z[int(lower_bound(s.begin(), s.end(), a[i]) - s.begin())];
	}
	for (int i = 0; i < m; i++) {
		b[i] = z[int(lower_bound(s.begin(), s.end(), b[i]) - s.begin())];
	}
	for (int i = 0; i < q; i++) {
		c[i] = z[int(lower_bound(s.begin(), s.end(), c[i]) - s.begin())];
	}
	vector<int> cnt(z.back() + 1);
	for (int i = 0; i < n; i++)
		cnt[a[i]]++;
	for (int i = 0; i < q; i++) {
		if (a[x[i]] < c[i]) {
			cnt[a[x[i]]]--;
			cnt[c[i]]++;
		}
		a[x[i]] = max(a[x[i]], c[i]);
		b[y[i]] = max(b[y[i]], c[i]);
		ll res = 0;
		for (int i = 0; i < m; i++) {
			res += cnt[b[i]];
		}
		printf("%lld\n", res);
	}
	return 0;
}