#include <iostream>
#include <cstdio>
#include <vector>
#include <algorithm>
#include <set>
#include <cmath>
typedef  long long ll;
#define int long long
using namespace std;

struct Point {
	int x, y;
};

ll f(Point a, Point b) {
	return 1ll << max(abs(a.x - b.x), abs(a.y - b.y));
}

int32_t main() {
	ios_base::sync_with_stdio(false);
	cin.tie(0); cout.tie(0);
	int n, m, k;
	cin >> n >> m >> k;
	vector<int> pred(k, -1);
	vector<Point> v(k);
	for (int i = 0; i < k; i++) {
		cin >> v[i].x >> v[i].y;
	}
	vector<int> dist(k, 1e18);
	dist[0] = 0;
	vector<int> used(k);
	for (int i = 0; i < k; i++) {
		bool fl = false;
		int ind = -1;
		for (int j = 0; j < k; j++) {
			if (used[j])
				continue;
			if (!fl || dist[ind] > dist[j]) {
				ind = j;
				fl = true;
			}
		}
		used[ind] = 1;
		for (int t = 0; t < k; t++) {
			if (dist[t] > dist[ind] + f(v[ind], v[t])) {
				dist[t] = dist[ind] + f(v[ind], v[t]);
				pred[t] = ind;
			}
		}
	}
	vector<int> res;
	int cur = k - 1;
	while (cur != -1) {
		res.push_back(cur);
		cur = pred[cur];
	}
	cout << res.size() << '\n';
	for (int i = res.size() - 1; i >= 0; i--) {
		cout << res[i] + 1 << ' ';
	}
	return 0;
}