#include <iostream>
#include <vector>
#include <algorithm>
#include <cstdio>
#include <string>

using namespace std;

const long long L = 3e5 + 1;

struct num
{
	vector<long long> seq;
	num()
	{
		seq.assign(L, 0);
	}
};

bool operator < (num a, num b)
{
	bool flag = 0;
	for (long long i = 0; i < L; i++)
	{
		if (a.seq[i] > b.seq[i])
		{
			flag = 1;
			break;
		}
		else if (a.seq[i] < b.seq[i])
		{
			break;
		}
	}
	return !flag;
}

num operator + (num a, num b)
{
	for (long long i = 0; i < L; i++)
	{
		a.seq[i] |= b.seq[i];
	}
	return a;
}

void read(num &a)
{
	string s;
	cin >> s;
	long long cnt = 0;
	for (long long i = s.size() - 1; i >= 0; i--)
	{
		a.seq[L - 1 - cnt] = s[i] - '0';
		cnt++;
	}
}

void write(num a)
{
	bool flag = 0;
	for (long long i = 0; i < L; i++)
	{
		if (a.seq[i] == 1)
		{
			flag = 1;
		}
		if (flag)
			cout << a.seq[i];
	}
}

int main()
{
	long long n;
	cin >> n;
	if (n == 2)
	{
		num a, b;
		read(a), read(b);
		if (b < a)
			swap(b, a);

		num toa = a;
		for (long long i = 0; i < L; i++)
		{
			if (a.seq[i] == 1 && b.seq[i] == 1)
			{
				long long p = i - 1;
				while (b.seq[p] != 0)
					p--;
				toa.seq[p] = 1;
				for (long long j = p + 1; j < L; j++)
					toa.seq[j] = 0;
				break;
			}
		}
		write(toa + b);
	}
	cin >> n;
    return 0;
}