#include <bits/stdc++.h>
using namespace std;

using ll = long long;
using ld = long double;
using pii = pair<int, int>;
using pll = pair<ll, ll>;

#define all(x) (x).begin(), (x).end()
#define rep(i, n) for (int (i) = 0; (i) < (n); ++(i))

const int MAXN = 505;
int n;
int a[MAXN][MAXN];
int p;
int pos[MAXN];
vector<int> g[MAXN];
bool used[MAXN];
bool res[MAXN];

bool check(int v, int sz) {
	fill(used, used + n, false);
	for (int i = sz; i < n; ++i) {
		int u = a[v][i];
		for (auto to : g[u]) {
			used[to] = true;
		}
	}

	rep(i, sz) {
		if (!used[a[v][i]]) return false;
	}
	return true;
}

int main() {
	ios_base::sync_with_stdio(false);
	cin.tie(0);

	cin >> n;
	rep(i, n) {
		rep(j, n) {
			cin >> a[i][j];
			a[i][j]--;
		}
	}
	cin >> p;

	if (p == 1) {
		vector<int> ans;

		rep(i, n) {
			if (a[i][0] == i) {
				ans.push_back(i + 1);
			}
		}

		cout << ans.size() << endl;
		for (auto it : ans) {
			cout << it << ' ';
		}
		cout << endl;
	} else {
		rep(i, n) {
			rep(j, n) {
				if (a[i][j] == i) {
					pos[i] = j;
					break;
				}

				g[a[i][j]].push_back(i);
			}
		}

		// rep(i, n) {
		// 	rep(j, pos[i]) {
		// 		cout << check(i, j + 1) << ' ';
		// 	}
		// 	cout << endl;
		// }

		rep(i, n) {
			res[a[i][0]] = true;
			rep(j, pos[i]) {
				int sz = j + 1;
				if (!res[a[i][sz]] && check(i, sz)) {
					res[a[i][sz]] = true;
				}
			}
		}

		vector<int> ans;
		rep(i, n) {
			if (res[i]) {
				ans.push_back(i + 1);
			}
		}

		cout << ans.size() << endl;
		for (auto it : ans) {
			cout << it << ' ';
		}
		cout << endl;
	}
}
