#include <bits/stdc++.h>
using namespace std;
const int N = 800001;

struct dek {
    int l, r, pr, d, key, sz, cnt;
};

dek m[N];
int top, a[N], k[N];

void push(int u) {
    if (m[u].d != 0) {
        if (m[u].l != 0) {
            m[m[u].l].d += m[u].d;
            m[m[u].l].key += m[u].d;
        }
        if (m[u].r != 0) {
            m[m[u].r].d += m[u].d;
            m[m[u].r].key += m[u].d;
        }
        m[u].d = 0;
    }
}

void recalc(int u) {
    m[u].sz = m[u].cnt + m[m[u].l].sz + m[m[u].r].sz;
}

int merg(int a, int b) {
    if (a == 0)
        return b;
    if (b == 0)
        return a;
    if (m[a].pr > m[b].pr) {
        push(a);
        m[a].r = merg(m[a].r, b);
        recalc(a);
        return a;
    } else {
        push(b);
        m[b].l = merg(a, m[b].l);
        recalc(b);
        return b;
    }
}

void split(int root, int &a, int &b, int x) {
    if (root == 0) {
        a = 0;
        b = 0;
        return;
    }
    push(root);
    if (m[root].key > x) {
        split(m[root].l, a, m[root].l, x);
        recalc(root);
        b = root;
        return;
    } else {
        split(m[root].r, m[root].r, b, x);
        recalc(root);
        a = root;
        return;
    }
}

int newx(int x) {
    ++top;
    m[top].key = x;
    m[top].pr = rand() * rand();
    m[top].cnt = 1;
    m[top].sz = 1;
    return top;
}

int insert(int root, int top) {
    int a, b, c;
    split(root, b, c, m[top].key);
    split(b, a, b, m[top].key - 1);
    if (b == 0)
        b = top;
    else {
        m[b].cnt++;
        m[b].sz++;
    }
    return merg(a, merg(b, c));
}

bool flag = false;

int deletex(int root, int x) {
    int a, b, c;
    split(root, b, c, x);
    split(b, a, b, x - 1);
    if (m[b].cnt <= 1)
        return merg(a, c);
    else {
        m[b].cnt--;
        m[b].sz--;
        return merg(a, merg(b, c));
    }
}

int main() {
    int i, j, n, p;
    //freopen("input.txt", "r", stdin);
    ios_base::sync_with_stdio(false); cin.tie(0); cout.tie(0);
    cin >> n >> p;
    for (i = 1; i <= n; ++i)
        cin >> a[i];
    int root1 = 0, root2 = 0;
    for (i = 1; i <= n; ++i)
        root2 = insert(root2, newx(a[i] + i));
    for (i = 1; i <= n; ++i) {
        m[root2].d--;
        m[root2].key--;
        if (i == 2)
            flag = true;
        root2 = deletex(root2, a[i]);
        flag = false;
        int x, y;
        split(root2, x, y, a[i] - 1);
        k[i] = m[x].sz + 1;
        root2 = merg(x, y);
        split(root1, x, y, a[i] - 1);
        k[i] += m[x].sz;
        root1 = merg(x, y);
        root1 = insert(root1, newx(a[i]));
        m[root1].d++;
        m[root1].key++;
        cout << k[i] << "\n";
    }
}
