﻿//#include "stdafx.h"
#include <fstream>
#include <vector>
#include <algorithm>
#include <set>
#include <map>

using namespace std;

#ifdef _DEBUG
ifstream cin("input.txt");
ofstream cout("output.txt");
#else
#include <iostream>
#endif

typedef long long ll;

#define all(a) a.begin(), a.end()

int main() {
	int n, m, q;
	cin >> n >> m >> q;
	vector <vector <int> > a(n, vector <int>(m));
	for (int i = 0; i < n; i++) {
		for (int j = 0; j < m; j++) {
			cin >> a[i][j];
		}
	}
	vector <int> row(n), column(m);
	for (int i = 0; i < n; i++) {
		int mx = 0;
		for (int j = 0; j < m; j++) {
			mx = max(mx, a[i][j]);
		}
		row[i] = mx;
	}
	for (int j = 0; j < m; j++) {
		int mx = 0;
		for (int i = 0; i < n; i++) {
			mx = max(mx, a[i][j]);
		}
		column[j] = mx;
	}
	set <int> ans;
	for (int i = 0; i < n; i++) {
		for (int j = 0; j < m; j++) {
			if (row[i] == a[i][j] && column[j] == a[i][j]) {
				ans.insert(a[i][j]);
			}
		}
	}
	for (int i = 0; i < q; i++) {
		int r, c, x;
		cin >> r >> c >> x; r--, c--;
		if (column[c] < x && row[r] < x) {
			ans.erase(column[c]);
			ans.erase(row[r]);
			ans.erase(a[r][c]);
			a[r][c] = column[c] = row[r] = x;
			ans.insert(x);
			cout << ans.size() << '\n';
			continue;
		}
		a[r][c] = x;
		if (row[r] < x) {
			row[r] = x;
		}
		if (column[c] < x) {
			column[c] = x;
		}
		cout << ans.size() << '\n';
	}
    return 0;
}

