#include <bits/stdc++.h>
using namespace std;

const int INF = 2000000000;
int n;
vector<int> a;

int count(int i, int s1, int s2) {
    int ans = 0;
    int ti = INF;
    if (s1 != -1) {
        ti = min(ti, a[i] + abs(i - s1));
        if (i <= s1) {
            ti = a[i];
        }
    }
    if (s2 != -1) {
        ti = min(ti, a[i] + abs(i - s2));
        if (i >= s2) {
            ti = a[i];
        }
    }

    for (int j = 0; j < n; j++) {
        int tj = INF;
        if (s1 != -1) {
            tj = min(tj, a[j] + abs(j - s1));
            if (j <= s1) {
                tj = a[j];
            }
        }
        if (s2 != -1) {
            tj = min(tj, a[j] + abs(j - s2));
            if (j >= s2) {
                tj = a[j];
            }
        }
        if (tj < ti) {
            ans++;
        }
    }

    return ans;
}

int main() {
#ifdef DEBUG
    freopen("input", "r", stdin);
#endif
    ios::sync_with_stdio(0);
    cin.tie(0);

    int p;
    cin >> n >> p;
    if (p == 1) {
        return 1;
    }
    a.resize(n);
    for (int i = 0; i < n; i++) {
        cin >> a[i];
    }

    vector<int> ans1(n), ans2(n);

    vector<pair<int, int>> ord(n);
    for (int i = 0; i < n; i++) {
        ord[i] = {a[i] + n - 1 - i, i};
    }
    sort(ord.begin(), ord.end());
    for (int i = 0; i < ord.size(); i++) {
        if (ord[i].second < n / 2) {
            int j = ord[i].second;
            if (i > 0 && ord[i].first == ord[i - 1].first) {
                ans1[j] = ans1[ord[i - 1].second];
            } else {
                ans1[j] = i;
            }
        }
    }

    for (int i = 0; i < n; i++) {
        ord[i] = {a[i] + i, i};
    }
    sort(ord.begin(), ord.end());
    for (int i = 0; i < ord.size(); i++) {
        if (ord[i].second >= n / 2) {
            int j = ord[i].second;
            if (i > 0 && ord[i].first == ord[i - 1].first) {
                ans1[j] = ans1[ord[i - 1].second];
            } else {
                ans1[j] = i;
            }
        }
    }

    for (int i = 0; i < n / 2; i++) {
        ans2[i] = count(i, 0, 2 * i);
    }

    for (int i = n / 2; i < n; i++) {
        ans2[i] = count(i, n - 1 - 2 * (n - 1 - i), n - 1);
    }


    for (int i = 0; i < n; i++) {
        cout << max(ans1[i], ans2[i]) + 1 << "\n";
    }

    return 0;
}
