#include <bits/stdc++.h>
using namespace std;

vector<int> fv;

void add(int i, int x) {
    while (i < fv.size()) {
        fv[i] += x;
        i = i | (i + 1);
    }
}

int getp(int i) {
    int s = 0;
    while (i >= 0) {
        s += fv[i];
        i = (i & (i + 1)) - 1;
    }
    return s;
}

int main() {
#ifdef DEBUG
    freopen("input", "r", stdin);
#endif
    ios::sync_with_stdio(0);
    cin.tie(0);

    int n, p;
    cin >> n >> p;
    if (p == 2) {
        return 1;
    }
    vector<int> a(n);
    for (int i = 0; i < n; i++) {
        cin >> a[i];
    }

    vector<int> ans1(n), ans2(n);

    vector<int> xs;
    for (int i = 0; i < n; i++) {
        xs.push_back(a[i] - i);
        xs.push_back(a[i] + i);
    }
    sort(xs.begin(), xs.end());
    xs.resize(unique(xs.begin(), xs.end()) - xs.begin());

    fv.resize(xs.size());
    for (int i = 0; i < n; i++) {
        int ci = lower_bound(xs.begin(), xs.end(), a[i] - i) - xs.begin();
        ans1[i] = getp(ci - 1);
        add(ci, 1);
    }

    fv.assign(xs.size(), 0);
    for (int i = n - 1; i >= 0; i--) {
        int ci = lower_bound(xs.begin(), xs.end(), a[i] + i) - xs.begin();
        ans2[i] = getp(ci - 1);
        add(ci, 1);
    }

    for (int i = 0; i < n; i++) {
        cout << ans1[i] + ans2[i] + 1 << "\n";
    }

    return 0;
}