#include <bits/stdc++.h>
#define ll long long
#define mp make_pair
#define pb push_back
#define X first
#define Y second
#define pii pair<int, int>

using namespace std;

int solve();

int main()
{
    ios_base::sync_with_stdio(0); cin.tie(0); cout.tie(0);
    #ifdef DEBUG
        freopen("input.txt", "r", stdin);
        freopen("output.txt", "w", stdout);
    #endif // DEBUG
    solve();
    return 0;
}

const int MAXN = 3005;

int a[MAXN];
vector<pii> ans;

void update(int l, int r, int &ind, int x)
{
    vector<int> cur;
    for (int i = l + 1; i <= r; i += 2)
        cur.pb(a[i]);
    for (int i = l; i <= r; i += 2)
        cur.pb(a[i]);
    for (int i = l; i <= r; i++)
        a[i] = cur[i - l];
    for (int i = l; i <= r; i++)
        if (a[i] == x)
            ind = i;
}

void check(int n)
{
    bool f = true;
    for (int i = 1; i < n; i++)
        if (a[i] > a[i + 1])
        {
            f = false;
            break;
        }
    if (!f)
        return;
    cout << (int)ans.size() << endl;
    for (int i = 0; i < (int)ans.size(); i++)
        cout << ans[i].X << " " << ans[i].Y << endl;
    exit(0);
}

int solve()
{
    int n;
    cin >> n;
    for (int i = 1; i <= n; i++)
        cin >> a[i];
    for (int p = n; p > 0; p--)
    {
        int ind = -1;
        for (int i = 1; i <= p; i++)
            if (p == a[i])
                ind = i;
        int l = 1;
        int r = p;
        if (ind == p)
            continue;
        while(l + 1 < r)
        {
            if (l % 2 != ind % 2)
                l++;
            ans.pb(mp(l, r));
            update(l, r, ind, p);
            check(n);
            l = (l + r) / 2;
        }
        for (int j = ind; j < p; j++)
        {
            ans.pb(mp(j, j + 1));
            swap(a[j], a[j + 1]);
        }
        check(n);
    }
    check(n);
}

