#include <iostream>
#include <vector>
#include <algorithm>
#include <string>
#include <deque>
#include <set>
#include <map>
#include <unordered_map>
#include <unordered_set>
#include <random>
#include <ctime>
#include <conio.h>
using namespace std;

#define int int64_t
#define mp make_pair
#define pb push_back
#define pbb pop_back
#define pf pop_front
#define pff push_front
#define all(c) (c).begin(), (c).end()
#define rall(c) (c).rbegin(), (c).rend()
using ld = long double;
using ll = long long;
using pii = pair<int, int>;

vector<pii> rmq;
int real_size = 1;

pii get(int vert, int left, int right, int L, int R)
{
    if (L <= left && right <= R)
        return rmq[vert];
    if (right < L || R < left)
        return mp(0, 0);

    int middle = (left + right) / 2;
    pii get1 = get(2 * vert, left, middle, L, R);
    pii get2 = get(2 * vert + 1, middle + 1, right, L, R);
    //cout << vert << " " << get1.first << " " << get1.second << " " << get2.first << " " << get2.second << endl;
    return max(get1, get2);
}

int32_t main()
{
    int n;
    cin >> n;
    vector<int> nums(n);
    for (int i = 0; i < n; ++i)
        cin >> nums[i];

    vector<int> bright(n, n - 1), now;
    for (int i = 0; i < n; ++i) {
        while (!now.empty() && nums[now.back()] > nums[i]) {
            bright[now.back()] = i - 1;
            now.pbb();
        }
        now.pb(i);
    }

    while (real_size < n)
        real_size *= 2;
    rmq.resize(2 * real_size);
    for (int i = real_size; i < real_size + n; ++i)
        rmq[i] = mp(nums[i - real_size], i - real_size);
    for (int i = real_size - 1; i; --i)
        rmq[i] = max(rmq[2 * i], rmq[2 * i + 1]);

    int ans = 0, pos = 0;
    while (pos < n) {
        ans++;
        pii g = get(1, 0, real_size - 1, pos, bright[pos]);
        //cout << pos << " " << bright[pos] << " " << g.first << " " << g.second << endl;
        _getch();
        pos = g.second + 1;
    }
    cout << ans << endl;

    return 0;
}
