#include <iostream>
#include <vector>
#include <algorithm>
#include <string>
#include <deque>
#include <set>
#include <map>
#include <unordered_map>
#include <unordered_set>
#include <random>
#include <ctime>
using namespace std;

#define int int64_t
#define mp make_pair
#define pb push_back
#define pbb pop_back
#define pf pop_front
#define pff push_front
#define all(c) (c).begin(), (c).end()
#define rall(c) (c).rbegin(), (c).rend()
using ld = long double;
using ll = long long;
using pii = pair<int, int>;

int n;
vector<int> nums;

vector<int> shuffle(int l, int r)
{
    vector<int> ans;
    for (int i = 0; i < l; ++i)
        ans.pb(nums[i]);
    for (int i = l + 1; i <= r; i += 2)
        ans.pb(nums[i]);
    for (int i = l; i <= r; i += 2)
        ans.pb(nums[i]);
    for (int i = r + 1; i < n; ++i)
        ans.pb(nums[i]);

    return ans;
}

int32_t main()
{
    cin >> n;
    nums.resize(n);
    for (int i = 0; i < n; ++i)
        cin >> nums[i];

    vector<pii> answer;
    for (int i = 0; i < n; ++i) {
        while (nums[i] != i + 1) {
            int pos = -1;
            for (int j = i + 1; j < n; ++j) {
                if (nums[j] == i + 1) {
                    pos = j;
                    break;
                }
            }

            int l = pos - 1, r = pos;
            while (l >= i)
                l -= 2;
            l += 2;
            nums = shuffle(l, r);
            answer.pb(mp(l + 1, r + 1));
        }
    }

    cout << answer.size() << endl;
    for (auto &elem : answer)
        cout << elem.first << " " << elem.second << endl;

    return 0;
}
