#include <iostream>
#include <vector>
#include <algorithm>
#include <string>
#include <deque>
#include <set>
#include <map>
#include <unordered_map>
#include <unordered_set>
#include <random>
#include <ctime>
#include <ext/pb_ds/assoc_container.hpp>
using namespace __gnu_pbds;
using namespace std;

//#define int int64_t
#define mp make_pair
#define pb push_back
#define pbb pop_back
#define pf pop_front
#define pff push_front
#define all(c) (c).begin(), (c).end()
#define rall(c) (c).rbegin(), (c).rend()
using ld = long double;
using ll = long long;
using pii = pair<int, int>;
using treap = tree<pii, null_type, less<pii>, rb_tree_tag, tree_order_statistics_node_update>;

int32_t main()
{
    int n, p;
    cin >> n >> p;
    vector<int> nums(n);
    for (int i = 0; i < n; ++i)
        cin >> nums[i];

    vector<int> ans(n);
    for (int i = 0; i < n; ++i) {
        for (int del = 1; del < max(i + 1, n - i); ++del) {
            vector<int> delay(n);
            delay[i] = del;
            if (del <= i)
                for (int j = i - 1; j > -1; --j)
                    delay[j] = max(0, delay[j + 1] - 1);
            else
                for (int j = i - 1; j > -1; --j)
                    delay[j] = delay[j + 1] + 1;
            if (del <= n - i - 1)
                for (int j = i + 1; j < n; ++j)
                    delay[j] = max(0, delay[j - 1] - 1);
            else
                for (int j = i + 1; j < n; ++j)
                    delay[j] = delay[j - 1] + 1;

            /*cout << i << " " << del << endl;
            for (int elem : delay)
                cout << elem << " ";
            cout << endl;*/

            treap dd;
            for (int j = 0; j < n; ++j)
                dd.insert(mp(nums[j] + delay[j], j));
            int may_ans = dd.order_of_key(mp(nums[i] + del, 0)) + 1;
            ans[i] = max(ans[i], may_ans);
        }
    }

    for (int elem : ans)
        cout << elem << endl;

    return 0;
}
