#include <bits/stdc++.h>

using namespace std;

const int maxN = 3005;
const int INF = 1e9;

int arr[maxN];
vector<pair<int, int>> ans;
int process(int l, int r) {
    vector<int> arr2;

    for (int i = 1; i <= r - l; i += 2) arr2.push_back(arr[l + i]);
    for (int i = 0; i <= r - l; i += 2) arr2.push_back(arr[l + i]);

    for (int i = 0; i <= r - l; i++) arr[l + i] = arr2[i];

    ans.push_back({l, r});
}

void solve(int l1, int l2, int r, int n) {
    int x1 = arr[l1];
    int x2 = arr[l2];
    while (l2 != r) {
        if (l1 < l2 && (l2 - l1) % 2 == 0) process(l1, r);
        else process(l2, r);

        int j = 0;
        while (arr[j] != x1) j++;
        l1 = j;
        j = 0;
        while (arr[j] != x2) j++;
        l2 = j;

        //cout << l1 << " " << l2 << " " << r << endl;
    }
}

int main() {
    #ifdef DEBUG
        freopen("in.in", "r", stdin);
    #endif // DEBUG

    cin.tie(0);
    ios_base::sync_with_stdio(0);

    int n;
    cin >> n;

    for (int i = 0; i < n; i++) {
        cin >> arr[i];
        arr[i]--;
    }

    for (int i = n - 1; i >= 1; i--) {
        int j1 = 0;
        int j2 = 0;
        while (arr[j1] != i - 1) j1++;
        while (arr[j2] != i) j2++;

        solve(j1, j2, i, n);
    }

    for (int i = 0; i < n; i++) assert(arr[i] == i);

    cout << ans.size() << endl;
    for (auto p : ans) cout << p.first + 1 << " " << p.second + 1 << endl;

    return 0;
}
