#include "bits/stdc++.h"

#define mp make_pair
#define len(v) ((int)v.size())
#define pb push_back

using namespace std;

typedef pair<int, int> pii;
typedef long long ll;

int n;
vector<pii> v;
vector<int> bs;

struct Node {
	Node *l = NULL, *r = NULL;
	int tl, tr;
	int value = 0;
	int mod = 0;

	Node *get_left() {
		if (!l) {
			l = new Node(tl, (tl + tr) / 2);
		}
		return l;
	}

	Node *get_right() {
		if (!r) {
			r = new node((tl + tr) / 2, tr);
		}
		return r;
	}

	bool is_list() {
		return tl + 1 == tr;	
	}

	bool included_by(int ql, int qr) {
		return ql <= tl && tr <= qr;
	}

	bool intersects(int ql, int qr) {
		return !(tr <= ql || qr <= tl);
	}

	Node(int _tl, int _tr) {
		tl = _tl;
		tr = _tr;
	}

	int get_value() {
		return value + mod;
	}

	void push() {
		value += mod;	
		if (!is_list()) {
			get_left()->mod += mod;
			get_right()->mod += mod;
		}
		mod = 0;
	}

	void update() {
		if (!is_list()) {
			value = max(get_left()->get_value(), get_right()->get_value());
		}
	}

	void update(int ql, int qr, int d) {
		push();
		if (included_by(ql, qr)) {
			mod = d;
		} else {
			if (get_left()->intersects(ql, qr)) {
				get_left()->update(ql, qr, d);	
			}
			if (get_right()->intersects(ql, qr)) {
				get_right()->update(ql, qr, d);
			}
		}
		update();
	}
};


void add(int x) {
	bs.pb(x);
}


ll get_kek() {
	sort(bs.begin(), bs.end());
	ll _max = 0;
	for (int i = 0; i < len(bs); i++) {
		_max = max(_max, (ll)bs[i] * (ll)(len(bs) - i));
	}
	return _max;
}

signed main() {
	{
		cin >> n;
		v.resize(n);
		for (int i = 0; i < n; i++) {
			cin >> v[i].first >> v[i].second;
		}	
	}	
	ll rez = 0;
	{
		sort(v.begin(), v.end());
		for (int i = 0; i < len(v); i++) {
			rez = max(rez, (ll)v[i].first * (ll)(len(v) - i));
			add(v[i].second);
		}
	}
	{
		cout << rez << endl;
	}
}