#ifdef _DEBUG
#define _GLIBCXX_DEBUG
#endif

#include <bits/stdc++.h>

using namespace std;

typedef long long ll;
typedef vector<int> vi;
typedef pair<int, int> pii;

#define X first
#define Y second
#define inb push_back
#define mk make_pair
#define all(v) (v).begin(), (v).end()

int solve();

int main()
{
	ios_base::sync_with_stdio(0);
	cin.tie(0);
	solve();
	return 0;
}

int solve()
{
	int n, m, q;
	cin >> n >> m >> q;
	vector<vi> a(n, vi(m));
	for (int i = 0; i < n; ++i)
	{
		for (int j = 0; j < m; ++j)
		{
			cin >> a[i][j];
		}
	}
	vi mxs(n), mxc(m), poss(n), posc(m);
	int ans = 0;
	for (int i = 0; i < n; ++i)
	{
		for (int j = 0; j < m; ++j)
		{
			if (a[i][j] > mxs[i])
			{
				poss[i] = j;
				mxs[i] = a[i][j];
			}
			if (a[i][j] > mxc[j])
			{
				posc[j] = i;
				mxc[j] = a[i][j];
			}
		}
	}
	vector<vi> ok(n, vi(m));
	for (int i = 0; i < n; ++i)
	{
		for (int j = 0; j < m; ++j)
		{
			ok[i][j] = (mxs[i] == mxc[j]);
			ans += ok[i][j];
		}
	}
	while (q--)
	{
		int x, y, val;
		cin >> x >> y >> val;
		--x, --y;
		if (mxc[y] == a[x][y] && mxs[x] == a[x][y])
		{
			mxs[x] = val;
			mxc[y] = val;
			a[x][y] = val;
		}
		else
		{
			if (val > mxs[x])
			{
				//printf("POS MINUS X :: %d %d %d\n", x, poss[x], ok[x][poss[x]]);
				ans -= ok[x][poss[x]];
				ok[x][poss[x]] = 0;
				mxs[x] = val;
				poss[x] = y;
			}
			if (val > mxc[y])
			{
				//printf("POS MINUS Y :: %d %d %d\n", posc[y], y, ok[posc[y]][y]);
				ans -= ok[posc[y]][y];
				ok[posc[y]][y] = 0;
				mxc[y] = val;
				posc[y] = x;
			}
			ok[x][y] = (mxc[y] == mxs[x]);
			ans += ok[x][y];
		}
		/*puts("MXS :: ");
		for (int i = 0; i < n; ++i)
			printf("%d ", mxs[i]);
		puts("");
		puts("MXC :: ");
		for (int i = 0; i < m; ++i)
			printf("%d ", mxc[i]);
		puts("");//*/
		printf("%d\n", ans);
	}
	return 0;
}