#ifdef _DEBUG
#define _GLIBCXX_DEBUG
#endif

#include <bits/stdc++.h>

using namespace std;

typedef long long ll;
typedef vector<int> vi;
typedef pair<int, int> pii;

#define X first
#define Y second
#define inb push_back
#define mk make_pair
#define all(v) (v).begin(), (v).end()

int solve();

int main()
{
	ios_base::sync_with_stdio(0);
	cin.tie(0);
	solve();
	return 0;
}

int solve()
{
	int n;
	cin >> n;
	vi a(n);
	for (int i = 0; i < n; ++i)
	{
		cin >> a[i];
		int x;
		cin >> x;
	}
	sort(all(a), greater<int>());
	ll ans = 0;
	for (int i = 0; i <= n; ++i)
	{
		ll cans = 0;
		if (i)
			cans = 1ll * i * a[i - 1];
		ans = max(ans, cans);
		int l = i;
		int r = n - 1;
		while (r - l > 1000)
		{
			int m1 = l + (r - l) / 3;
			int m2 = r - (r - l) / 3;
			ll f1 = 1ll * a[m1] * (m1 - i + 1);
			ll f2 = 1ll * a[m2] * (m2 - i + 1);
			if (f1 == f2)
			{
				l++;
				--r;
			}
			else
			if (f1 < f2)
				l = m1;
			else
				r = m2;
		}
		for (; l <= r; ++l)
		{
			ans = max(ans, cans + 1ll * a[l] * (l - i + 1));
		}
	}
	printf("%lld\n", ans);
	return 0;
}