#include <stdio.h>
#include <algorithm>

int main() {
	int n;
	scanf("%d", &n);
	long long a[n];
	for (int i = 0; i < n; i++) {
		int tmp;
		scanf("%lld%d", &a[i], &tmp);
	}
	std::sort(a, a + n);
	long long ans = 0, cnt = 0;
	for (int i = n - 1; i >= 0; i--) {
		cnt++;
		int left = -1, right = i;
		while (left < right - 2) {
			int m1 = left + (right - left) / 3;
			int m2 = left + 2 * (right - left) / 3;
			if ((i - m1) * a[m1] > (i - m2) * a[m2]) {
				right = m2;
			} else {
				left = m1;
			}
		}
		for (int j = left + 1; j < right; j++) {
			if (ans < cnt * a[i] + (i - j) * a[j]) {
				ans = cnt * a[i] + (i - j) * a[j];
			}
		}
		if (ans < cnt * a[i]) {
			ans = cnt * a[i];
		}
	}
	printf("%lld", ans);
	return 0;
}
