#include <bits/stdc++.h>

using namespace std;
template <typename T1, typename T2> inline void chkmin(T1 &x, const T2 &y) {if (x > y) x = y;}
template <typename T1, typename T2> inline void chkmax(T1 &x, const T2 &y) {if (x < y) x = y;}
#define all(c) (c).begin(), (c).end()
#define sz(c) (int)(c).size()
#define pb push_back
const int MAXN = 300003;  


int n;
string a[MAXN];
bool need[MAXN];
vector<int> have;
multiset<pair<int, string> > t; 


bool proceed(int pos) {
	if (t.empty()) return true;
	pair<int, string> b = *t.rbegin();
	t.erase(t.find(b));
	//cout << b.second << endl;
	if (sz(b.second) <= pos) {
		return true;
	}
	if (sz(b.second) > pos + 1) {
		return false;
	}
	string f;
	bool was = false;
	for (int i = 1; i < sz(b.second); i++) {
		if (b.second[i] == '1') {
			f += '1';
			was = true; 
		} else {
			if (was) {
				f += '0';
			}
		}
	}
	if (sz(f)) {
		t.insert({sz(f), f});
	}
	return true;
}


int can() {
	t.clear();
	for (int i = 0; i < n; i++) {
		if (sz(a[i]) == 1 && a[i] == "0") {
			continue;
		}
		t.insert({sz(a[i]), a[i]});
	}
	for (auto x: have) {
		if (!proceed(x)) return 0;
		if (t.empty()) {
			return 2;
		}
	}
	//cout << sz(t) << endl;
	if (t.empty()) {
		return 2;
	}
	for (int i = have.back() - 1; i >= 0; i--) {
		if (!proceed(i)) return 0;
		///cout << sz(t) << endl;
		if (t.empty()) {
			return 1;
		}
	}
	return 0;
}


int main() {
	ios_base::sync_with_stdio(false);
	cin.tie(0);
	cout.tie(0);
	//assert(freopen("input.in", "r", stdin));
	cin >> n;
	int ls = 0;
	for (int i = 0; i < n; i++) {
		cin >> a[i];
		chkmax(ls, sz(a[i]));
	}
	while (true) {
		int l =0;
		int r = n + ls + 2;
		if (!have.empty()) {
			r = have.back() - 1;
		}
	//	cout << l << ' ' << r << endl;
		while (l != r) {
			//cout << sz(have) << endl;
			int mid = (l + r) >> 1;
			have.pb(mid);
			if (can()) {
				r = mid;
			} else {
				l = mid + 1;
			}
			have.pop_back();
		}
		have.pb(l);
		if (can() == 2) {
			break;
		}
	}
	for (auto x: have) {
		need[x] = true;
	}
	bool was = false;
	for (int i = n + ls + 2; i >= 0; i--) {
		if (need[i]) {
			cout << '1';
			was = true;
		} else {
			if (was) {
				cout << '0';
			}
		}
	}
	cout << endl;
	return 0;
}