#include <bits/stdc++.h>

using namespace std;

const int N = int(3e5 + 55);

int n;
int a[N] = {};
pair<int, int> t[4 * N] = {};

int left(int v) {
    assert(2 * v < 4 * N);
    return 2 * v;
}

int right(int v) {
    assert(2 * v + 1 < 4 * N);
    return 2 * v + 1;
}

void build(int v, int l, int r) {
    if (l == r) {
        t[v] = {a[l], l};
    } else {
        int m = (l + r) / 2;
        build(left(v), l, m);
        build(right(v), m + 1, r);
        t[v] = max(t[left(v)], t[right(v)]);
    }
}

pair<int, int> get(int v, int l, int r, int nl, int nr) {
    if (nl > nr) {
        return {-1, -1};
    }
    if (l == nl && r == nr) {
        return t[v];
    }
    int m = (l + r) / 2;
    pair<int, int> res = {-1, -1};
    res = max(res, get(left(v), l, m, nl, min(m, nr)));
    res = max(res, get(right(v), m + 1, r, max(m + 1, nl), nr));
    return res;
}

int main() {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    cout.tie(nullptr);
    cin >> n;
    for (int i = 0; i < n; ++i) {
        cin >> a[i];
    }
    vector<int> nxt(n, -1);
    set<pair<int, int>> st;
    for (int i = 0; i < n; ++i) {
        vector<pair<int, int>> er;
        for (auto j : st) {
            if (j.first >= -a[i]) {
                break;
            }
            nxt[j.second] = i - 1;
            er.push_back(j);
        }
        st.insert({-a[i], i});
        for (auto j : er) {
            st.erase(j);
        }
    }
    for (auto j : st) {
        nxt[j.second] = n - 1;
    }
    build(1, 0, N - 1);
    int cur = 0;
    int cnt = 0;
    while (cur < n) {
        int r = nxt[cur];
        pair<int, int> res = get(1, 0, N - 1, cur, r);
        cur = res.second + 1;
        cnt++;
    }
    cout << cnt;
    return 0;
}
