#include <bits/stdc++.h>
#define err(...) fprintf(stderr, __VA_ARGS__), fflush(stderr)

using namespace std;

typedef long long ll;

const int dd = 507;
int G[dd][dd];
int pos[dd][dd];
int can[dd];

int was[dd], col[dd];
int cyc;
int n;

vector<vector<int> > E;

void dfs(int v) {
    col[v] = 1;
    for (int to : E[v]) {
        if (col[to] == 1) cyc = 1;
        if (col[to] == 0) dfs(to);
    }
    col[v] = 2;
}

bool check(vector<int> cur) {

    int f = 1;
    for (int v : cur) was[v] = 1;

    for (int v : cur) {
        int ok = 0;
        for (int j = 0; j < n; j++) {
            if (G[v][j] == v) break;
            if (!was[G[v][j]]) ok = 1;
        }
        if (!ok) { f = 0; break; }
    }
    for (int v : cur) was[v] = 0;
    return f;
}

int main() {
    ios_base::sync_with_stdio(0);
    cin.tie(0);

    cin >> n;

    for (int i = 0; i < n; i++) {
        for (int j = 0; j < n; j++) {
            cin >> G[i][j];
            G[i][j]--;
            pos[i][G[i][j]] = j;
        }
    }

    int p; cin >> p;

    if (p == 1) {
        int cnt = 0;
        for (int i = 0; i < n; i++) if (G[i][0] == i) cnt++;
        cout << cnt << "\n";
        for (int i = 0; i < n; i++) if (G[i][0] == i) cout << i + 1 << "\n";
    } else {

        for (int i = 0; i < n; i++) {
            vector<int> cur;

            for (int j = 0; j < n; j++) {
                can[G[i][j]] = 1;

                cur.push_back(G[i][j]);

                if (!check(cur)) break;
                if (G[i][j] == i) break;
            }
        }

        cout << accumulate(can, can + n, 0) << "\n";
        for (int i = 0; i < n; i++) if (can[i])
            cout << i + 1 << " ";
        cout << "\n";
    }

    return 0;
}
