#pragma GCC optimize ("Ofast")
#define _CRT_SECURE_NO_WARNINGS
#include <iostream>
#include <vector>
#include <algorithm>
#include <queue>
#include <set>

using namespace std;

#define all(a) (a).begin(), (a).end()
#define forn(i, a, b) for (int i = a; i < b; ++i)
#define mp make_pair
#define pb push_back

typedef long long LL;
typedef long double LD;

struct man {
	LL id, iP, i;
};

int main() {
	ios::sync_with_stdio(false); cin.tie(0); cout.tie(0);
	//freopen("input.txt", "r", stdin);
	LL ans = -1;
	LL n;
	cin >> n;
	vector<man> m(n);
	forn(i, 0, n) {
		cin >> m[i].iP >> m[i].i;
	}

	sort(all(m), [](const man &a, const man &b) {
		return a.iP < b.iP;
	});

	if (n <= 3000) {
		for (int i = n - 1; i >= 0; i--) {
			LL cp = (n - i) * m[i].iP;
			ans = max(ans, cp);
			sort(m.begin(), m.begin() + i, [](const man &a, const man &b) {
				return a.i < b.i;
			});

			for (int j = i - 1; j >= 0; j--) {
				ans = max(ans, cp + (i - j) * m[j].i);
			}

			sort(m.begin(), m.begin() + i, [](const man &a, const man &b) {
				return a.iP < b.iP;
			});
		}
	}
	else {
		m.pb(man{ 0, 0, 0 });
		int i = n - 1, iP = n;
		while (i > 0 || iP > 0) {
			ans = max(ans, (iP - i) * m[i].i + (n - iP) * m[iP].iP);
			if (i == iP) {
				i--;
			}
			else {
				if (i == 0) {
					iP--;
				}
				else if (-(n - iP) * (m[iP].iP - m[iP - 1].iP) > 
					     -(iP - i) * (m[i].iP - m[i - 1].iP) + m[i - 1].iP) {
					iP--;
				}
				else
					i--;
			}
		}
		m.pop_back();

		for (LL i = n - 1; i >= 0; i--) {
			LL cp = (n - i) * m[i].iP;
			LL L = 0, R = i;
			while (R - L > 10) {
				LL M1 = L + 5 * (R - L) / 11;
				LL M2 = L + 6 * (R - L) / 11;

				LL c1 = (i - M1) * (m[M1].i);
				LL c2 = (i - M2) * (m[M2].i);

				forn(j, M1 - 3, M1 + 4) {
					if (j >= i || j < 0)
						continue;
					ans = max(ans, cp + ((LL)i - j) * m[j].i);
				}
				forn(j, M2 - 3, M2 + 4) {
					if (j >= i || j < 0)
						continue;
					ans = max(ans, cp + ((LL)i - j) * m[j].i);
				}

				if (c1 > c2) {
					R = M2;
				}
				else {
					L = M1;
				}
			}

			forn(j, L - 3000, R + 3000) {
				if (j >= i || j < 0)
					continue;
				ans = max(ans, cp + ((LL)i - j) * m[j].i);
			}
		}
	}



	cout << ans << endl;
}