#pragma GCC optimize ("Ofast")
#define _CRT_SECURE_NO_WARNINGS
#include <iostream>
#include <vector>
#include <algorithm>
#include <queue>
#include <set>

using namespace std;

#define all(a) (a).begin(), (a).end()
#define forn(i, a, b) for (int i = a; i < b; ++i)
#define mp make_pair
#define pb push_back

typedef long long LL;
typedef long double LD;

struct man {
	LL id, iP, i;
};

int main() {
	ios::sync_with_stdio(false); cin.tie(0); cout.tie(0);
	//freopen("input.txt", "r", stdin);
	LL ans = -1;
	LL n;
	cin >> n;
	vector<man> m(n);
	forn(i, 0, n) {
		cin >> m[i].iP >> m[i].i;
	}

	sort(all(m), [](const man &a, const man &b) {
		return a.iP < b.iP;
	});

	if (n <= 3000) {
		for (int i = n - 1; i >= 0; i--) {
			LL cp = (n - i) * m[i].iP;
			ans = max(ans, cp);
			sort(m.begin(), m.begin() + i, [](const man &a, const man &b) {
				return a.i < b.i;
			});

			for (int j = i - 1; j >= 0; j--) {
				ans = max(ans, cp + (i - j) * m[j].i);
			}

			sort(m.begin(), m.begin() + i, [](const man &a, const man &b) {
				return a.iP < b.iP;
			});
		}
	}
	else {
		for (LL i = n - 1; i >= 0; i--) {
			LL cp = (n - i) * m[i].iP;
			LL L = 0, R = i;
			while (R - L > 10) {
				LL M = (L + R) / 2;
				LL down = ((LL)i - M) * (m[M].i - m[M - 1].i);
				LL up = m[M - 1].i;
				if (up > down)
					R = M;
				else
					L = M;
			}

			forn(j, L - 3, R + 4) {
				if (j >= i || j < 0)
					continue;
				ans = max(ans, cp + ((LL)i - j) * m[j].i);
			}
		}
	}

	cout << ans << endl;
}