#include <bits/stdc++.h>

using namespace std;

#define int long long

bitset<510> ZERO(0);
bitset<510> ONE(1);
bitset<510> ALL(0);

signed main() {
    ios_base::sync_with_stdio(false);
    cin.tie(0);
    cout.tie(0);

    int n, x, p;
    cin >> n;
    vector<vector<int>> v(n, vector<int> (n));
    for (int i = 0; i < 510; ++i)
        ALL |= (1 << i);
    for (int i = 0; i < n; ++i)
        for (int j = 0; j < n; ++j)
            cin >> v[i][j];
    cin >> p;
    vector<bitset<510>> got(n);
    for (int k = 0; k < n; ++k) {
        got[k] = ZERO;
        for (int t = 0; t < n; ++t) {
            got[k] |= (ONE << (v[k][t] - 1));
            if (v[k][t] == k + 1) break;
        }
    }
    if (p == 1) {
        vector<int> ans;
        for (int i = 0; i < n; ++i)
            if (v[i][0] == i + 1)
                ans.push_back(i);
        cout << ans.size() << endl;
        for (int i : ans) cout << i + 1 << ' ';
    } else {
        set<int> ans;
        for (int j = 0; j < n; ++j) {
            vector<bitset<510>> bads(n);
            bitset<510> bad = ALL;
            for (int k = 0; k < n; ++k) {
                bads[k] = bad;
                bad ^= (ONE << (v[j][k] - 1));
            }
            int L = -1, R = n;
            while (R != L + 1) {
                int M = (L + R) / 2;
                bool good = true;
                for (int k = 0; k < n; ++k) {
                    if ((got[k] & bads[M]) == ZERO) {
                        good = false;
                        break;
                    }
                }
                if (good)
                    L = M;
                else
                    R = M;
            }
            for (int k = 0; k <= L; ++k)
                ans.insert(v[j][k]);
            // cout << i << ' ' << j << ' ';
            // for (auto i : bad) cout << i << ' '; cout << endl;
        }
        cout << ans.size() << endl;
        for (int i : ans) cout << i << ' ';
    }
}

/*
4
3 2 4 1
1 4 2 3
3 1 2 4
1 4 2 3
2
*/
