#pragma GCC optimize ("O3,Ofast")
#include <bits/stdc++.h>
using namespace std;
#define int long long

int n, m, q;

vector <vector <int> > arr;

bool chgeck(int x, int y) {
	bool flag = true;
	for (int t = 0; t < n; t++) {
		flag &= arr[x][y] >= arr[t][y];
	}
	for (int t = 0; t < m; t++) {
		flag &= arr[x][y] >= arr[x][t];
	}
	return flag;
}

signed main() {
	ios_base::sync_with_stdio(false);
	cin >> n >> m >> q;
	arr.resize(n, vector <int> (m));
	for (int i = 0; i < n; i++) {
		for (int j = 0; j < m; j++) {
			cin >> arr[i][j];
		}
	}
	vector <int> row_max(n, 0), col_max(m, 0);
	for (int i = 0; i < n; i++) {
		for (int j = 0; j < m; j++) {
			if (arr[i][row_max[i]] < arr[i][j]) {
				row_max[i] = j;
			}
			if (arr[col_max[j]][j] < arr[i][j]) {
				col_max[j] = i;
			}
		}
	}
	
	int cnt = 0;
	for (int i = 0; i < n; i++) {
		cnt += col_max[row_max[i]] == i;
	}

	for (int j = 0; j < q; j++) {
		int a, b, t;
		cin >> a >> b >> t;
		a--; b--;
		arr[a][b] = t;

		if (col_max[row_max[a]] == a) {
			if (row_max[a] != b && arr[a][b] > arr[a][row_max[a]]) {cnt--; /*cout << "A\n";*/}
		}
		if (row_max[col_max[b]] == b) {
			if (col_max[b] != a && arr[a][b] > arr[col_max[b]][b]) {cnt--; /*cout << "B\n";*/}
		}


		if (row_max[a] == b && col_max[b] == a) {
			if (arr[a][row_max[a]] < arr[a][b]) row_max[a] = b;
			if (arr[col_max[b]][b] < arr[a][b]) col_max[b] = a;
		} else {
			// cout << "HERE \n";
			if (arr[a][row_max[a]] < arr[a][b]) row_max[a] = b;
			if (arr[col_max[b]][b] < arr[a][b]) col_max[b] = a;
			if (row_max[a] == b && col_max[b] == a) {
				cnt++;
			}
		}

		

		cout << cnt << "\n";
	}

	return 0;
}