#include <bits/stdc++.h>

using namespace std;

#define int long long

vector <vector<int> > h, v, a, ok;
int ans = 0;

void buildh(int u, int num, int l, int r) {
    if (l + 1 == r) {
        h[num][u] = l;
        return;
    }
    int m = (l + r) / 2;
    buildh(u * 2 + 1, num, l, m);
    buildh(u * 2 + 2, num, m, r);
    if (a[num][h[num][u * 2 + 1]] > a[num][h[num][u * 2 + 2]])
        h[num][u] = h[num][u * 2 + 1];
    else
        h[num][u] = h[num][u * 2 + 2];
}

void buildv(int u, int num, int l, int r) {
    if (l + 1 == r) {
        v[num][u] = l;
        return;
    }
    int m = (l + r) / 2;
    buildv(u * 2 + 1, num, l, m);
    buildv(u * 2 + 2, num, m, r);
    if (a[v[num][u * 2 + 1]][num] > a[v[num][u * 2 + 2]][num])
        v[num][u] = v[num][u * 2 + 1];
    else
        v[num][u] = v[num][u * 2 + 2];
}

void updateh(int u, int num, int tl, int tr, int x, int val) {
    if (tl > x || tr <= x)
        return;
    if (tl + 1 == tr && tl == x) {
        h[num][u] = x;
        a[num][x] = val;
        return;
    }
    int tm = (tl + tr) / 2;
    updateh(u * 2 + 1, num, tl, tm, x, val);
    updateh(u * 2 + 2, num, tm, tr, x, val);
    if (a[num][h[num][u * 2 + 1]] > a[num][h[num][u * 2 + 2]])
        h[num][u] = h[num][u * 2 + 1];
    else
        h[num][u] = h[num][u * 2 + 2];
}

void updatev(int u, int num, int tl, int tr, int x, int val) {
    if (tl > x || tr <= x)
        return;
    if (tl + 1 == tr && tl == x) {
        v[num][u] = x;
        a[x][num] = val;
        return;
    }
    int tm = (tl + tr) / 2;
    updatev(u * 2 + 1, num, tl, tm, x, val);
    updatev(u * 2 + 2, num, tm, tr, x, val);
    if (a[v[num][u * 2 + 1]][num] > a[v[num][u * 2 + 2]][num])
        v[num][u] = v[num][u * 2 + 1];
    else
        v[num][u] = v[num][u * 2 + 2];
}

signed main() {
    //freopen("input.txt", "r", stdin);freopen("output.txt", "w", stdout);
    int n, m, q;
    cin >> n >> m >> q;
    a.resize(n);
    for (int i = 0; i < n; i++)
        a[i].resize(m);

    for (int i = 0; i < n; i++)
        for (int j = 0; j < m; j++)
            cin >> a[i][j];

    h.resize(n);
    for (int i = 0; i < n; i++)
        h[i].resize(m * 4);

    v.resize(m);
    for (int i = 0; i < m; i++)
        v[i].resize(n * 4);

    for (int i = 0; i < n; i++)
        buildh(0, i, 0, m);

    for (int i = 0; i < m; i++)
        buildv(0, i, 0, n);

    ok.resize(n);
    for (int i = 0; i < n; i++)
        ok[i].resize(m, 0);

    for (int i = 0; i < n; i++) {
        int f = h[i][0];
        int g = v[f][0];
        if (g == i) {
            ans++;
            ok[i][f] = 1;
        }
    }

    for (int t = 0; t < q; t++) {
        int x, y, z;
        cin >> x >> y >> z;
        x--;
        y--;
        int f = h[x][0];
        int g = v[y][0];

        updateh(0, x, 0, m, y, z);
        int f1 = h[x][0];
        if (f != f1 && ok[x][f] == 1) {
            ans--;
            ok[x][f] = 0;
        }

        updatev(0, y, 0, n, x, z);
        int g1 = v[y][0];
        if (g != g1 && ok[g][y] == 1) {
            ans--;
            ok[g][y] = 0;
        }
        if (g1 == x && f1 == y && ok[x][y] == 0) {
            ok[x][y] = 1;
            ans++;
        }
        cout << ans << endl;
    }
    return 0;
}
