#include <iostream>
#include <vector>
#include <algorithm>
#include <set>

using namespace std;

int main() {
    int n, k, p;
    bool flag1, flag2;
    cin >> n;
    vector <vector <int> > v(n, vector <int> (n));
    vector <int> position(n);
    for (int i = 0; i < n; i++) {
        for (int j = 0; j < n; j++) {
            cin >> v[i][j];
            v[i][j]--;
            if (v[i][j] == i) {
                position[i] = j;
            }
        }
    }

    bool cross[n][n][n + 1];
    for (int i = 0; i < n; i++) {
        vector <bool> used(n, false);
        for (int j = position[i] - 1; j >= 0; j--) {
            used[v[i][j]] = true;
        }
        for (int j = 0; j < n; j++) {
            cross[i][j][n] = false;
            for (int l = n - 1; l >= 0; l--) {
                if (used[v[j][l]]) {
                    cross[i][j][l] = true;
                }
                else {
                    cross[i][j][l] = cross[i][j][l + 1];
                }
            }
        }
    }

    vector <bool> live(n, false);
    vector <bool> can(n, false);
    for (int i = 0; i < n; i++) {
        if (v[i][0] == i) {
            live[i] = true;
        }
    }
/*
    for (int i = 0; i < n; i++) {
        cout << i << '\n';
        for (int j = 0; j < n; j++) {
            for (int l = 0; l <= n; l++) {
                cout << cross[i][j][l] << ' ';
            }
            cout << '\n';
        }
        cout << '\n';
    }
*/
    for (int i = 0; i < n; i++) {
        for (int cell = 0; cell < n; cell++) {
            vector <bool> good(n, false);
            flag1 = true;
            int j = n - 1;
            for (; j >= 0; j--) {
                if (v[cell][j] == i) {
                    break;
                }
                good[v[cell][j]] = true;
            }
            j--;
            p = j;
            for(; j >= 0; j--) {
                if (!cross[v[cell][j]][cell][p]) {
                    flag1 = false;
                }
            }
            if (flag1) {
                can[i] = true;
            }
        }
    }
    vector <int> res1;
    vector <int> res2;
    for (int i = 0; i < n; i++) {
        if (live[i]) {
            res1.push_back(i + 1);
        }
        if (can[i]) {
            res2.push_back(i + 1);
        }
    }
    cin >> k;
    if (k == 1) {
        cout << res1.size() << '\n';
        for (int i = 0; i < int(res1.size()); i++) {
            cout << res1[i] << ' ';
        }
    }
    else {
        cout << res2.size() << '\n';
        for (int i = 0; i < int(res2.size()); i++) {
            cout << res2[i] << ' ';
        }
    }
    return 0;
}
