#include <bits/stdc++.h>
#define x first
#define y second
#define pb push_back
using namespace std;
 
typedef pair<short, short> point;

const int LOG = 30;
const long long MAXV = (1LL << LOG);

struct big_num {
	vector<long long> q;

	void add(int i) {
		int id = i / LOG;
		while (q.size() <= id)
			q.pb(0);
		q[id] += (1LL << (i % LOG));
		if (q[id] >= MAXV) {
			q[id] -= MAXV;
			add((id + 1) * LOG);
		}
	}
};

bool operator < (big_num &a, big_num &b) {
	if (a.q.size() != b.q.size()) {
		return a.q.size() < b.q.size();
	}
	for (int i = a.q.size(); i--;) {
		if (a.q[i] != b.q[i]) {
			return a.q[i] < b.q[i];
		}
	}
	return false;
}

int n, m, k;
point a[501];
int t[501];
int p[501];
big_num dist[501];


int main() {
    ios::sync_with_stdio(0);
    //assert(freopen("input.in", "r", stdin));
    cin >> n >> m >> k;
    for (int i = 0; i < k; ++i) {
    	cin >> a[i].x >> a[i].y;
    }
    t[0] = 1;
    for (int i = 0; i < k; ++i) {
    	int v = -1;
    	for (int j = 0; j < k; ++j) {
    		if (t[j] == 1) {
    			if (v == -1 || dist[j] < dist[v]) {
    				v = j;
    			}
    		}
    	}
    	assert(v != -1);
    	t[v] = 2;
    	if (v == k - 1) {
    		vector<int> ans;
    		ans.pb(v);
    		while (v) {
    			v = p[v];
    			ans.pb(v);
    		}
    		reverse(ans.begin(), ans.end());
    		cout << ans.size() << '\n';
    		for (auto i : ans) cout << i + 1 << ' ';
    		cout << '\n';
    		exit(0);
    	}
     	for (int j = 0; j < k; ++j) {
    		if (t[j] == 2) continue;
    		int d = max(abs(a[i].x - a[j].x), abs(a[i].y - a[j].y));
    		big_num nd = dist[v];
    		nd.add(d);
    		if (t[j] == 0 || nd < dist[j]) {
    			dist[j] = nd;
    			p[j] = v;
    			t[j] = 1;
    		}
    	}
    }
}