#include <algorithm>
#include <iostream>
#include <vector>
#include <cmath>
#include <set>
using namespace std;

int main(){
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);
    int n, m, q;
    cin >> n >> m >> q;
    vector<int> r(n, 0), c(m, 0);
    for(int i = 0; i<n; i++){
        for(int j = 0; j<m; j++){
            int a;
            cin >> a;
            r[i] = max(r[i], a);
            c[j] = max(c[j], a);
        }
    }
    set<int> ans;
    for(int i = 0; i<n; i++){
        for(int j = 0; j<m; j++){
            if(r[i]==c[j]){
                ans.insert(i);
            }
        }
    }
    for(int i = 0; i<q; i++){
        int x, y, v;
        cin >> x >> y >> v;
        x--;
        y--;
        if(r[x]<v){
            ans.erase(x);
        }
        r[x] = max(r[x], v);
        c[y] = max(c[y], v);
        if(r[x]==c[y]&&c[y]==v){
            ans.insert(x);
        }
        cout << ans.size() << '\n';
        /*for(set<int>::iterator it = ans.begin(); it!=ans.end(); it++)
            cout << *it << ' ';
        cout << '\n';*/
    }

    return 0;
}
/*
2 3 3
1 4 3
6 5 2
2 2 9
1 3 5
2 2 10

2 2 5
1 2
3 4
1 1 5
1 2 6
2 1 7
2 2 8
1 1 9
*/
