#include <algorithm>
#include <iostream>
#include <vector>
#include <cmath>
#include <set>
using namespace std;

vector<int> a, d;

void build(int l, int r, int it){
    if(r-l==1){
        d[it] = l;
        return;
    }
    int m = (l+r)/2;
    build(l, m, 2*it);
    build(m, r, 2*it+1);
    d[it] = d[2*it];
    if(a[d[2*it]]<=a[d[2*it+1]])
        d[it] = d[2*it+1];
    //cout << l << ' ' << r << ' ' << d[it] << endl;
}

int maxx(int l, int r, int x, int y, int it){
    if(r<=l||r<=x||y<=l)
        return a.size()-1;
    if(x<=l&&r<=y)
        return d[it];
    int m = (l+r)/2;
    int ans = maxx(l, m, x, y, 2*it),
        ans1 = maxx(m, r, x, y, 2*it+1);
    int itog = ans;
    if(a[itog]<=a[ans1])
        itog = ans1;
    //cout << l << ' ' << r << ' ' << itog << endl;
    return itog;
}

int main(){
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);
    int n;
    cin >> n;
    d.resize(4*n);
    a.resize(n+1);
    a[n] = 0;
    for(int i = 0; i<n; i++)
        cin >> a[i];
    build(0, n, 1);
    vector<int> minn(n+1), next(n, n), minn1;
    vector<int> s(n);
    int it = 0, itog = 0;
    for(int i = 0; i<n; i++){
        while(it>0&&a[s[it-1]]>a[i]){
            next[s[it-1]] = i;
            it--;
        }
        s[it] = i;
        it++;
    }
    //for(int i = 0; i<n; i++)
        //cout << next[i] << ' ';
    it = 0;
    //cout << maxx(0, 1, 0, n, 1) << endl;
    while(it<n){
        //cout << it << ' ' << next[it]  << ' ' << maxx(0, n, it, next[it], 1) << endl;
        it = maxx(0, n, it, next[it], 1)+1;
        itog++;
    }
    cout << itog;

    return 0;
}
/*
5
5 4 3 2 1

4
1 3 2 4

6
2 3 1 1 5 1

6
2 3 2 1 5 1

5
2 3 2 1 5

4
1 2 1 2
*/
