#include <bits/stdc++.h>
#include <ext/pb_ds/assoc_container.hpp>
#include <ext/pb_ds/tree_policy.hpp>

using namespace std;
using namespace __gnu_pbds;

#ifndef LOCAL
#define endl "\n"
#define DBG(x)
#else
#define DBG(x) cout << #x << " = " << x << endl;
#endif

int check(vector<int> &maxa, vector<int> &maxb, vector<vector<int> > &field) {
    int res = 0;
    int n = maxa.size();
    int m = maxb.size();
    for (int i = 0; i < n; ++i) {
        for (int j = 0; j < m; ++j) {
            if (field[i][j] == maxa[i] && field[i][j] == maxb[j]) {
                ++res;
            }
        }
    }
    return res;
}

template<typename t>
istream &operator>>(istream &in, vector<t> &x) {
    for (auto &y : x) {
        in >> y;
    }
    return in;
};

signed main() {
    ios::sync_with_stdio(false);
    cin.tie(0);
    cout.tie(0);
    int n, m, q;
    cin >> n >> m >> q;
    vector<vector<int> > field(n, vector<int>(m));
    cin >> field;
    vector<int> maxa(n);
    vector<int> maxb(m);
    for (int i = 0; i < n; ++i) {
        for (int j = 0; j < m; ++j) {
            maxa[i] = max(maxa[i], field[i][j]);
            maxb[j] = max(maxb[j], field[i][j]);
        }
    }
    for (int i = 0; i < q; ++i) {
        int r, c, x;
        cin >> r >> c >> x;
        --r, --c;
        field[r][c] = x;
        maxa[r] = max(maxa[r], x);
        maxb[c] = max(maxb[c], x);
        cout << check(maxa, maxb, field) << endl;
    }
    return 0;
}