#include <bits/stdc++.h>
#include <ext/pb_ds/assoc_container.hpp>
#include <ext/pb_ds/tree_policy.hpp>

using namespace std;
using namespace __gnu_pbds;

#ifndef LOCAL
#define endl "\n"
#endif

template<typename t>
istream &operator>>(istream &in, vector<t> &a) {
    for (auto &x : a) {
        in >> x;
    }
    return in;
}

template<typename t1, typename t2>
ostream &operator<<(ostream &out, const pair<t1, t2> &a) {
    out << a.first << " " << a.second;
    return out;
};

template<typename t>
ostream &operator<<(ostream &out, const vector<t> &a) {
    for (auto &x : a) {
        out << x << endl;
    }
    return out;
}

ostream &operator<<(ostream &out, const vector<int> &a) {
    for (auto &x : a) {
        out << x << endl;
    }
    return out;
}

vector<int> p1(int n, vector<int> &a) {
    vector<int> ans(n, -1);
    for (int i = 0; i < n; ++i) {
        vector<int> f(n);
        for (int j = 0; j < n; ++j) {
            f[j] = a[j] + abs(i - j);
        }
        sort(f.begin(), f.end());
        ans[i] = lower_bound(f.begin(), f.end(), a[i]) - f.begin() + 1;
    }
    return ans;
}

vector<int> p2(int n, vector<int> &a) {
    vector<int> ans(n, -1);
    for (int i = 0; i < n; ++i) {
        vector<int> f(n);
        for (int j = 0; j < n; ++j) {
            f[j] = a[j] + j;
        }
        sort(f.begin(), f.end());
        ans[i] = max<int>(ans[i], lower_bound(f.begin(), f.end(), a[i] + i) - f.begin() + 1);

        f = vector<int>(n);
        for (int j = 0; j < n; ++j) {
            f[j] = a[j] + n - j - 1;
        }
        sort(f.begin(), f.end());
        ans[i] = max<int>(ans[i], lower_bound(f.begin(), f.end(), a[i] + n - i - 1) - f.begin() + 1);

        f = vector<int>(n);
        for (int j = 0; j < n; ++j) {
            f[j] = a[j] + min(j, n - j - 1);
        }
        sort(f.begin(), f.end());
        ans[i] = max<int>(ans[i], lower_bound(f.begin(), f.end(), a[i] + min(i, n - i - 1)) - f.begin() + 1);
    }
    return ans;
}

signed main() {
    ios::sync_with_stdio(false);
    cin.tie(0);
    cout.tie(0);
#ifdef LOCAL
    freopen("/home/roi/CLionProjects/A/input.txt", "rt", stdin);
#endif
    int n, p;
    cin >> n >> p;
    vector<int> a(n);
    cin >> a;
    if (p == 1) {
        cout << p1(n, a) << endl;
    } else {
        cout << p2(n, a) << endl;
    }
    return 0;
}