#include <bits/stdc++.h>
#include <ext/pb_ds/assoc_container.hpp>
#include <ext/pb_ds/tree_policy.hpp>
using namespace std;
using namespace __gnu_pbds;

#ifndef LOCAL
#define endl "\n"
#endif

template<typename t>
istream &operator>>(istream &in, vector<t> &a) {
    for (auto &x : a) {
        in >> x;
    }
    return in;
}

template<typename t1, typename t2>
ostream &operator<<(ostream &out, const pair<t1, t2> &a) {
    out << a.first << " " << a.second;
    return out;
};

template<typename t>
ostream &operator<<(ostream &out, const vector<t> &a) {
    for (auto &x : a) {
        out << x << endl;
    }
    return out;
}

ostream &operator<<(ostream &out, const vector<int> &a) {
    for (auto &x : a) {
        out << x << " ";
    }
    return out;
}


signed main() {
    ios::sync_with_stdio(false);
    cin.tie(0);
    cout.tie(0);
    int n;
    cin >> n;
    vector<int> ind(n);
    for (int i = 0; i < n; ++i) {
        string s;
        cin >> s;
        while (s[s.size() - ind[i] - 1] != '1') {
            ++ind[i];
        }
    }
    sort(ind.begin(), ind.end());
    int cind = -1;
    string ans;
    for (auto x : ind) {
        cind = max(cind, x);
        while (ans.size() < cind) {
            ans.push_back('0');
        }
        ans.push_back('1');
        ++cind;
    }
    reverse(ans.begin(), ans.end());
    cout << ans << endl;
    return 0;
}