#include <bits/stdc++.h>

using namespace std;

typedef long long ll;
typedef long double ld;

mt19937_64 rnd(239);

const int M = 1e4 + 10;
const ll INF = 1e18;
const int BIG = 1e9 + 239;
const int B = (1 << 60);
const int K = 17;
const int S = 60;

struct number
{
    int mx;
    vector<ll> v;

    number()
    {
        mx = 0;
        v.assign(K, 0);
    }

    void add(int i)
    {
        int in = i / S;
        ll d = (1LL << (ll)(i % S));
        while (d != 0)
        {
            ll nd = (v[in] + d) >> 60LL;
            v[in] = (v[in] + d) & (B - 1);
            d = nd;
            in++;
        }
    }

    bool operator<(const number &a) const
    {
        for (int i = K - 1; i >= 0; i--)
        {
            if (v[i] == a.v[i]) continue;
            return (v[i] < a.v[i]);
        }
        return false;
    }
};

int n, m, k;
pair<int, int> p[M];
number dist[M];
int pr[M];
bool used[M];

int main()
{   /*
    freopen("test.in", "r", stdin);
    freopen("test.out", "w", stdout); /**/
    cin.sync_with_stdio(0);
    cin >> n >> m >> k;
    for (int i = 0; i < k; i++)
        cin >> p[i].first >> p[i].second;
    for (int i = 0; i < k; i++)
    {
        int x = p[i].first;
        int y = p[i].second;
        p[i].first = (x + y);
        p[i].second = (x - y);
    }
    for (int i = 1; i < k; i++)
        dist[i].add(K * S - 1);
    for (int z = 0; z < k; z++)
    {
        int t = -1;
        for (int i = 0; i < k; i++)
            if (!used[i])
                if (t == -1 || (dist[i] < dist[t]))
                    t = i;
        used[t] = true;
        if (t == k - 1) break;
        for (int i = t + 1; i < k; i++)
            if (!used[i])
            {
                number now = dist[t];
                now.add((abs(p[i].first - p[t].first) + abs(p[i].second - p[t].second)) >> 1);
                if (now < dist[i])
                {
                    dist[i] = now;
                    pr[i] = t;
                }
            }
    }
    vector<int> ans;
    int x = k - 1;
    while (x != 0)
    {
        ans.push_back(x);
        x = pr[x];
    }
    ans.push_back(x);
    reverse(ans.begin(), ans.end());
    cout << ans.size() << "\n";
    for (int t : ans)
        cout << (t + 1) << " ";
    return 0;
}
