#include <iostream>
#include <vector>
#include <algorithm>

using namespace std;

int dist(int x, vector<int> &sir) {
	int ans = 100;
	for (auto elem : sir) ans = min(ans, abs(elem - x));
	return ans;
}

int main() {
	int n, p;
	cin >> n >> p;
	int el;
	vector<int> a(n);
	vector<int> minpos(n);
	for (int i = 0; i < n; i++) {
		cin >> el;
		a[i] = el;
		minpos[i] = 1;
	}
	int place;
	int last;
	//int i3;
	vector<pair<int, int> > res(n);
	vector<int> sir(6);
	for (int ijk = 0; ijk < 100000; ijk++) {
		for (int i = 0; i < 5; i++) sir[i] = rand() % n;
		for (int j = 0; j < n; j++) {
			res[j] = { a[j] + dist(j, sir), j };
		}
		sort(res.begin(), res.end());
		last = -1;
		place = 0;
		for (int j = 0; j < n; j++) {
			if (last != res[j].first) place = j + 1;
			minpos[res[j].second] = max(minpos[res[j].second], place);
			last = res[j].first;
		}
	}

	for (auto elem : minpos) cout << elem << endl;
	//cin >> n;
}