#ifdef _DEV
#define DEV 1
#else
#define DEV 0
#pragma GCC optimize("Ofast")
#endif
#define _CRT_SECURE_NO_WARNINGS
#include <iostream>
#include <vector>
#include <algorithm>
using namespace std;
void entry(int testId);
int main() {
	if (DEV) {
		string fileName = "pub";
		string fin = fileName + ".txt";
		string fout = fileName + "-out.txt";
		freopen(fin.c_str(), "r", stdin);
		freopen(fout.c_str(), "w", stdout);
	}
	else {
		ios_base::sync_with_stdio(false);
		cin.tie(nullptr);
	}
	int i = 0;
	int k = 1e8;
	if (!DEV) k = 1;
	while (!cin.eof() && (k--)) {
		entry(i++);
		if (DEV) {
			cout << "--------\n";
		}
	}
}
using ll = long long;
#define endl "\n"
void entry(int testId) {
	int n;
	cin >> n;
	vector<pair<int, int>> d(n);
	for (int i = 0; i < n; ++i) cin >> d[i].first >> d[i].second;
	ll ans = -1;
	for (int pivot = 0; pivot < n; ++pivot) {
		int x = d[pivot].first;
		int y = d[pivot].second;
		if (x < y) continue;
		ll profit = 0;
		for (int i = 0; i < n; ++i) {
			if (x <= d[i].first) {
				profit += x;
			}
			else if (y <= d[i].second) {
				profit += y;
			}
		}
		ans = max(ans, profit);
	}
	cout << ans;
}