import java.util.*;
import java.io.*;

public class Main {
    static int n;

    public static void main(String args[]) throws IOException {
        InReader in = new InReader();
        OutWriter out = new OutWriter();
        n = in.nextInt();
        int cells[][] = new int[n][n];
        for (int i = 0; i < n; i++) {
            for (int j = 0; j < n; j++) {
                cells[i][j] = in.nextInt() - 1;
            }
        }

        int ans = 0;
        boolean isStable[] = new boolean[n];
        ArrayList<Integer> anss = new ArrayList();
        for (int i = 0; i < n; i++) {
            if (cells[i][0] == i) {
                ans++;
                anss.add(i);
            }
        }
        int p = in.nextInt();
        if (p == 1) {

            out.println(ans);
            for (int i = 0; i < anss.size(); i++) {
                out.print((anss.get(i) + 1) + " ");
            }
        } else {
            int ans2 = 0;
            ArrayList<Integer> capture[] = new ArrayList[n];
            for (int i = 0; i < n; i++) {
                capture[i] = new ArrayList<>();
                capture[i].add(i);
            }
            boolean isLivebale[] = new boolean[n];
            for (int i = 0; i < n; i++) {
                for (int j = 0; j < n; j++) {
                    if (cells[i][j] == i) {
                        break;
                    } else {
                        capture[cells[i][j]].add(i);
                    }
                }
            }
            for (int i = 0; i < n; i++) {

                boolean used[] = new boolean[n];
                used[i] = true;
                for (int j = 0; j < capture[i].size(); j++) {
                    used[capture[i].get(j)] = true;
                }
                for (int j = 0; j < capture[i].size(); j++) {
                    int curr = capture[i].get(j);
                    boolean killed[] = new boolean[n];
                    int countKilled = 0;
                    for (int k = n - 1; k >= 0; k--) {
                        if (cells[curr][k] == i) {
                            for (int l = 0; l < capture[i].size(); l++) {
                                if (!killed[capture[i].get(l)]) {
                                    countKilled++;
                                    killed[capture[i].get(l)] = true;
                                }

                            }

                            boolean flag=true;
                            for (int l = 0; l < k; l++) {
                                if(!killed[cells[curr][l]]){
                                    flag=false;
                                    break;
                                }
                            }
                            if(flag){
                                isLivebale[i] = true;
                            }

                            break;
                        } else {
                            for (int l = 0; l < capture[cells[curr][k]].size(); l++) {

                                if (!killed[capture[cells[curr][k]].get(l)]) {
                                    countKilled++;
                                    killed[capture[cells[curr][k]].get(l)] = true;
                                }
                            }
                        }
                    }
                }

            }
            for (int i = 0; i < n; i++) {
                if (isLivebale[i]) {
                    ans2++;
                }
            }
            out.println(ans2);
            for (int i = 0; i < n; i++) {
                if (isLivebale[i]) {
                    out.print((i + 1) + " ");
                }
            }

        }


        out.close();
    }

    static class Human {
        int a;
        int b;


    }

    static class InReader {
        BufferedReader in = new BufferedReader(new InputStreamReader(System.in));
        StringTokenizer tokenizer = new StringTokenizer("");

        void update() throws IOException {
            if (!tokenizer.hasMoreTokens()) {
                String a = in.readLine();
                if (a != null) {
                    tokenizer = new StringTokenizer(a);
                }
            }
        }

        int nextInt() throws IOException {
            update();
            return Integer.parseInt(tokenizer.nextToken());
        }
    }

    static class OutWriter {
        PrintWriter out = new PrintWriter(System.out);
        StringBuilder cout = new StringBuilder();

        <T> void print(T a) {
            cout.append(a);
        }

        <T> void println(T a) {
            cout.append(a);
            cout.append('\n');
        }

        void close() {
            out.print(cout.toString());
            out.close();
        }
    }

}

