#include <bits/stdc++.h>

using namespace std;

typedef long long ll;

ll n;
vector<ll> a;
vector<ll> mx, mn;

void build(ll v, ll vl, ll vr) {
    if (vr <= vl) {
        return;
    }
    if (vr - vl == 1) {
        mx[v] = mn[v] = a[vl];
        return;
    }
    ll vm = (vl + vr) / 2;
    build(2 * v + 1, vl, vm);
    build(2 * v + 2, vm, vr);
    mx[v] = max(mx[2 * v + 1], mx[2 * v + 2]);
    mn[v] = min(mn[2 * v + 1], mn[2 * v + 2]);
}

ll getMin(ll v, ll vl, ll vr, ll l, ll r) {
    if (r <= vl || l >= vr) {
        return INT64_MAX;
    }
    if (vl >= l && vr <= r) {
        return mn[v];
    }
    ll vm = (vl + vr) / 2;
    return min(getMin(2 * v + 1, vl, vm, l, r), getMin(2 * v + 2, vm, vr, l, r));
}

ll getMax(ll v, ll vl, ll vr, ll l, ll r) {
    if (r <= vl || l >= vr) {
        return 0;
    }
    if (vl >= l && vr <= r) {
        return mx[v];
    }
    ll vm = (vl + vr) / 2;
    return max(getMax(2 * v + 1, vl, vm, l, r), getMax(2 * v + 2, vm, vr, l, r));
}

ll get(ll x) {
    ll l = x;
    ll r = n + 1;
    while (r - l > 1) {
        ll m = (r + l) / 2;
        if (getMin(0, 0, n, x, m) == a[x]) {
            l = m;
        } else {
            r = m;
        }
    }
    ll z = getMax(0, 0, n, x, l);
    r = l;
    l = x;
    while (r - l > 1) {
        ll m = (r + l) / 2;
        if (getMax(0, 0, n, x, m) <= z) {
            l = m;
        } else {
            r = m;
        }
    }
    return l + 1;
}

int main() {
    cin >> n;
    a.resize(n);
    mx.resize(4 * n);
    mn.resize(4 * n);
    for (ll i = 0; i < n; ++i) {
        cin >> a[i];
    }
    build(0, 0, n);
    ll ans = 0;
    ll z = 0;
    while (z < n) {
        z = get(z);
        ans++;
    }
    cout << ans << endl;
    return 0;
}