//#pragma GCC optimize "Ofast"

#include <bits/stdc++.h>

using namespace std;

typedef long long ll;

ll n, p;
vector<ll> a;
struct Node;
Node* nullv;

struct Node {
    Node* left, *right;
    ll key, prio, size;

    Node() {
        size = 1;
        left = nullv;
        right = nullv;
    };
};


void upd(Node* node) {
    if (node == nullv) return;
    node->size = node->left->size + node->right->size + 1;
}

void split(Node* node, ll key, Node*& left, Node*& right) {
    if (node == nullv) {
        left = nullv;
        right = nullv;
        return;
    }
    if (key < node->key) {
        Node* x, *y;
        split(node->left, key, x, y);
        node->left = y;
        left = x;
        right = node;
    } else {
        Node* x, *y;
        split(node->right, key, x, y);
        node->right = x;
        right = y;
        left = node;
    }
    upd(left);
    upd(right);
}

Node* merge(Node* a, Node * b) {
    if (a == nullv)
        return b;
    if (b == nullv)
        return a;
    if (a->prio < b->prio) {
        b->left = merge(a, b->left);
        upd(a);
        upd(b);
        return b;
    } else {
        a->right = merge(a->right, b);
        upd(a);
        upd(b);
        return a;
    }
}

void insert(Node* &root, ll val) {
    Node* x = new Node();
    x->key = val;
    x->prio = rand();
    x->size = 1;
    Node* a, *b;
    split(root, val, a, b);
    root = merge(merge(a, x), b);
}

void erase(Node* &root, ll val) {
    Node* a, *b, *c, *d;
    split(root, val, a, b);
    split(a, val - 1, c, d);
    root = merge(c, b);
}

ll countLess(Node*root, ll val) {
    if (root == nullv)
        return 0;
    if (root->key > val) {
        return countLess(root->left, val);
    } else {
        ll t = root->left->size + countLess(root->right, val);
        if (root->key < val)
            t++;
        return t;
    }
}

int main() {
    cin >> n >> p;
    a.resize(n);
    for (ll i = 0; i < n; ++i) {
        cin >> a[i];
    }

    nullv = new Node();
    nullv->size = 0;

    if (p == 1) {
        Node* left = nullv;
        Node* right = nullv;
        ll cl = 0, cr = 0;
        for (ll i = 0; i < n; ++i) {
            ll t = a[i] + i;
            insert(right, t);
        }
        for (ll i = 0; i < n; ++i) {
            ll t = a[i];
            erase(right, a[i] + i);
            // x < t - cl
            ll k = 1;
            k += countLess(left, t - cl);
            k += countLess(right, t - cr);
            cout << k << endl;
            cr--;
            insert(left, a[i] - cl);
            cl++;
        }
    } else {
     /*   for (ll i = 0; i < n; ++i) {
            ll maxdelay = max(i, n - 1 - i);
            ll kk = 1;
            for (ll delay = 0; delay <= maxdelay; ++delay) {
                ll t = a[i] + delay;
                bool rc = false, lc = false;
                if (delay > i)
                    lc = true;
                if (delay > n - 1 - i)
                    rc = true;
                ll k = 1;
                for (ll j = 0; j < n; ++j) {
                    if (j == i) continue;
                    ll d;
                    if (!lc && !rc)
                        d = max(0ll, delay - abs(j - i));
                    else if (lc)
                        d = max(0ll, i + delay - j);
                    else
                        d = max(0ll, j - i + delay);
                    if (a[j] + d < t)
                        k++;
                }
                kk = max(k, kk);
            }
            cout << kk << endl;
        }*/
    }
    return 0;
}