#include <bits/stdc++.h>

using namespace std;

const int MAXN = (int) 1e6;
const int INF = (int) 1e9;

int main() {
    ios_base::sync_with_stdio(0);
    cin.tie(NULL);
    int n;
    cin >> n;
    if (n == 2) {
        string s, t;
        cin >> s >> t;
        int was = max(s.size(), t.size());
        reverse(s.begin(), s.end());
        reverse(t.begin(), t.end());
        s += string(was - s.size(), '0');
        t += string(was - t.size(), '0');
        string ors = s, ort = t;
        reverse(ors.begin(), ors.end());
        reverse(ort.begin(), ort.end());
        string ans(was, '0');
        bool ok = true;
        int i;
        for (i = was - 1; i >= 0; --i) {
            ans[i] = max(t[i], s[i]);
            if (s[i] == '1' && t[i] == '1') break;
        }
        if (i > -1) {
            ok = false;
            for (; i < was; ++i) {
                if (ans[i] == '0') {
                    ans[i] = '1';
                    ok = true;
                    break;
                }
            }
        }
        if (!ok) {
            ans = min("1" + ors, "1" + ort);
        } else {
            string ans1 = ans, ans2 = ans;
            for (--i; i >= 0; --i) {
                ans1[i] = s[i];
                ans2[i] = t[i];
            }
            reverse(ans1.begin(), ans1.end());
            reverse(ans2.begin(), ans2.end());
//            cout << ans1 << "\n" << ans2 << "\n";
            ans = min(ans1, ans2);
        }
        cout << ans << "\n";
        return 0;
    }
    vector<int> cnt(MAXN, 0);
    for (int i = 0; i < n; ++i) {
        string s;
        cin >> s;
        reverse(s.begin(), s.end());
        for (int i = 0; i < s.size(); ++i) {
            if (s[i] == '1') {
                ++cnt[i];
            }
        }
    }
    string ans;
    for (int i = 0; i < MAXN - 1; ++i) {
        if (cnt[i]) {
            ans += '1';
            cnt[i + 1] += cnt[i] - 1;
        } else {
            ans += '0';
        }
    }
    while (ans.back() == '0') ans.pop_back();
    if (ans.empty()) ans = "0";
    reverse(ans.begin(), ans.end());
    cout << ans << "\n";
    return 0;
}
/*
6
2 3 1 1 5 1
*/
