#include <bits/stdc++.h>

using namespace std;

typedef long long ll;
typedef long double ld;

const int INF = (1 << 5);

struct T
{
    T *l, *r;
    int x;
    T()
    {
        x = 0;
        l = 0;
        r = 0;
    }
    void check()
    {
        if (!l)
            l = new T();
        if (!r)
            r = new T();
    }
    void upd(int vl, int vr, int p, int val)
    {
        if (p < vl || vr < p)
            return;
        if (vl == vr)
        {
            x += val;
            return;
        }
        check();
        l->upd(vl, (vl + vr) / 2, p, val);
        r->upd((vl + vr) / 2 + 1, vr, p, val);
        x = l->x + r->x;
    }
    void upd(int p, int val)
    {
        upd(-INF, INF, p, val);
    }
    int get(int vl, int vr, int cl, int cr)
    {
        if (cr < vl || vr < cl)
            return 0;
        if (cl <= vl && vr <= cr)
            return x;
        check();
        return l->get(vl, (vl + vr) / 2, cl, cr) + r->get((vl + vr) / 2 + 1, vr, cl, cr);
    }
    int get(int cl, int cr)
    {
        return get(-INF, INF, cl, cr);
    }
};

T *t1 = new T();
T *t2 = new T();

signed main()
{
#ifdef POSPELOV
    freopen("in.txt", "r", stdin);
#endif // POSPELOV
    ios_base::sync_with_stdio(0);
    int n, p;
    cin >> n >> p;
    vector <int> arr(n);
    for (int &i : arr)
        cin >> i;
    for (int i = 0; i < n; i++)
        t1->upd(arr[i] - i, 1);
    vector <int> ans(n);

    for (int i = n - 1; i >= 0; i--)
    {
        t1->upd(arr[i] - i, -1);
        ans[i] = t1->get(-INF, arr[i] - i - 1) + t2->get(-INF, arr[i] + i - 1) + 1;
        t2->upd(arr[i] + i, 1);
    }

    for (int i : ans)
        cout << i << " ";
    return 0;
}
