import java.io.BufferedReader;
import java.io.IOException;
import java.io.InputStreamReader;
import java.io.PrintWriter;
import java.util.ArrayList;
import java.util.BitSet;
import java.util.StringTokenizer;
import java.util.TreeSet;

public class B {
	
	BufferedReader in;
	PrintWriter out;
	StringTokenizer st;
	
	public void run() {
		in = new BufferedReader(new InputStreamReader(System.in));
		out = new PrintWriter(System.out);
		solve();
		out.close();
	}
	
	public String nextToken() {
		while (st == null || !st.hasMoreTokens()) {
			try {
				st = new StringTokenizer(in.readLine());
			} catch (IOException e) {
				e.printStackTrace();
			}
		}
		return st.nextToken();
	}
	
	public int nextInt() {
		return Integer.parseInt(nextToken());
	}
	
	public long nextLong() {
		return Long.parseLong(nextToken());
	}
	
//	4
//	3 2 4 1
//	1 4 2 3
//	3 1 2 4
//	1 4 2 3
//	1
	
	public void solve() {
		int n = nextInt();
		int[][] a = new int[n][n];
		for (int i = 0; i < a.length; i++) {
			for (int j = 0; j < a.length; j++) {
				a[i][j] = nextInt() - 1;
			}
		}
		int q = nextInt();
		ArrayList<Integer> stable = new ArrayList<>();
		for (int i = 0; i < a.length; i++) {
			if (a[i][0] == i) {
				stable.add(i + 1);
			}
		}
		if (q == 1) {
			out.println(stable.size());
			for (int i : stable) {
				out.print(i + " ");
			}
			return;
		}
		TreeSet<Integer> ans = new TreeSet<>();
		boolean[] best = new boolean[n];
		for (int i : stable) {
			best[i - 1] = true;
			ans.add(i);
		}
		BitSet[] better = new BitSet[n];
		for (int i = 0; i < better.length; i++) {
			better[i] = new BitSet();
		}
		for (int i = 0; i < a.length; i++) {
			for (int j = 0; j < a.length; j++) {
				if (a[i][j] == i) {
					break;
				}
				better[a[i][j]].set(i);
			}
		}
		for (int i = 0; i < better.length; i++) {
			int r = n - 1;
			BitSet del = new BitSet();
			for (int j = 0; j < better.length; j++) {
				ans.add(a[i][j] + 1);
				while (r >= j && !del.get(a[i][j])) {
					del.or(better[a[i][r]]);
					r--;
				}
				if (!del.get(a[i][j])) {
					break;
				}
			}
		}
		out.println(ans.size());
		for (int i : ans) {
			out.print(i + " ");
		}
//		for (int i = 0; i < a.length; i++) {
//			for (int j = 0; j < a.length; j++) {
//				if (a[i][j] == i) {
//					ans.add(i + 1);
//					break;
//				}
//				if (best[a[i][j]]) {
//					break;
//				}
//				ans.add(a[i][j] + 1);
//			}
//		}
//		out.println(ans.size());
//		for (int i : ans) {
//			out.print(i + " ");
//		}
//		System.out.println(500 * 500 * 500 / 32);
	}

	public static void main(String[] args) {
		new B().run();
	}

}
