#include <iostream>
#include <vector>
#include <algorithm>
#include <stack>


using namespace std;

#define f first
#define s second
#define mp make_pair
#define pb push_back
#define all(a) a.begin(), a.end()
#define REP(i, st, n) for (int i = (st); i < (n); ++i)

typedef long long ll;

template <typename T1, typename T2> inline void chkmin(T1 &x, T2 y) { if (y < x) x = y; };
template <typename T1, typename T2> inline void chkmax(T1 &x, T2 y) { if (y > x) x = y; };

const int N = 600005;
int b[N];
int n;

int main() {
    ios_base::sync_with_stdio(0);
    cin.tie(NULL);
    cout.tie(NULL);
#ifdef DEBUG
    freopen("D.in", "r", stdin);
#endif // DEBUG

    cin >> n;
    for (int i = 0; i < n; ++i) {
        string s;
        cin >> s;
        int len = (int)s.size();
        for (int j = 0; j < len; ++j) {
            if (s[j] == '1') {
                b[len - j - 1]++;
            }
        }
    }

    int carry = 0;
    for (int i = 0; i < 600000; ++i) {
        b[i] += carry;
        carry = 0;
        if (b[i] <= 1)
            continue;
        carry = b[i] - 1;
        b[i] = 1;
    }
    int j = 0;
    for (int i = 0; i < 600000; ++i) {
        if (b[i] > 0) j = i;
    }

    string ans = "";
    for (int i = 0; i <= j; ++i)
        ans.pb((char)('0' + b[i]));
    reverse(all(ans));
    cout << ans << endl;

    return 0;
}
