
import java.io.*;
import java.util.*;

public class Main {
    public class pair {
        int x,y;
        pair(int a,int b){
            x = a;
            y = b;
        }
    }

    public void solve() throws IOException {
        nextInt();
        nextInt();
        int k = nextInt();
        int[] dist = new int[k];
        int[] p = new int[k];
        Arrays.fill(p, -1);
        pair[] d = new pair[k];
        Arrays.fill(dist, 20 * (1 << 19) + 10);
        dist[0] = 0;
        for (int i = 0; i < k; i++) {
            d[i] = new pair(nextInt(), nextInt());
        }
        boolean[] used = new boolean[k];
        for (int i = 0; i < k; i++) {
            int y = 0;
            for (int j = 0; j < k; j++) {
                if ((used[y] && !used[j]) || (dist[y] > dist[j])) y = j;
            }
            used[y] = true;
            for (int j = 0; j < k; j++) {
                if (!used[j]) {
                    int h = (1 << (Math.max(Math.abs(d[j].x - d[y].x),Math.abs(d[j].y - d[y].y))));
                    if (dist[j] > dist[y] + h){
                        dist[j] = dist[y] + h;
                        p[j] = y;
                    }
                }
            }
        }
        ArrayList<Integer> res = new ArrayList<>();
        k--;
        while (k >= 0){
            res.add(k + 1);
            k = p[k];
        }
        out.println(res.size());
        for (int i = 0; i < res.size(); i++) {
            out.print(res.get(res.size() - 1 - i) + " ");
        }
    }

    BufferedReader br;
    StringTokenizer sc;
    PrintWriter out;

    public String nextToken() throws IOException {
        while (sc == null || !sc.hasMoreTokens()) {
            try {
                sc = new StringTokenizer(br.readLine());
            } catch (Exception e) {
                sc = null;
            }
        }
        return sc.nextToken();
    }

    public Integer nextInt() throws IOException {
        return Integer.parseInt(nextToken());
    }

    public Long nextLong() throws IOException {
        return Long.parseLong(nextToken());
    }

    public static void main(String[] args) throws IOException {
        Locale.setDefault(Locale.US);
        new Main().run();
    }

    public void run() throws IOException {
        try {
            br = new BufferedReader(new InputStreamReader(System.in));
            out = new PrintWriter(System.out);
            solve();
            out.close();
        } catch (Exception e) {
            e.printStackTrace();
            System.exit(1);
        }
    }
}