import java.io.BufferedReader;
import java.io.IOException;
import java.io.InputStreamReader;
import java.io.PrintWriter;
import java.util.ArrayList;
import java.util.Locale;
import java.util.StringTokenizer;

public class Main {

    public void solve() throws IOException {
        int n = nextInt();
        int[] a = new int[n];
        for (int i = 0; i < n; i++) {
            a[i] = nextInt() - 1;
        }
        ArrayList<Integer> res1 = new ArrayList<>();
        ArrayList<Integer> res2 = new ArrayList<>();
        int x = n - 1;
        while (x >= 0) {
            while (x >= 0 && a[x] == x) {
                if (x >= 2 && a[x - 2] == x - 1) {
                    int z = 1;
                    while (x - 2 * z >= 0 && a[x - 2 * z] == x - z) {
                        z++;
                    }
                    z--;
                    int y = x - 2 * z;
                    res1.add(y + 1);
                    res2.add(x + 1);
                    int[] b = new int[x - y + 1];
                    int k = 0;
                    for (int i = 0; i < b.length; i++) {
                        if (i % 2 == 1) {
                            b[k] = a[y + i];
                            k++;
                        }
                    }
                    for (int i = 0; i < b.length; i++) {
                        if (i % 2 == 0) {
                            b[k] = a[y + i];
                            k++;
                        }
                    }
                    for (int i = 0; i < b.length; i++) {
                        a[y + i] = b[i];
                    }
                } else x--;
            }
            if (x < 0)break;
            int y = -1;
            for (int i = n - 1; i >= 0; i--) {
                if (a[i] == x) {
                    y = i;
                }
            }
            res1.add(y + 1);
            res2.add(x + 1);
            int[] b = new int[x - y + 1];
            int k = 0;
            for (int i = 0; i < b.length; i++) {
                if (i % 2 == 1) {
                    b[k] = a[y + i];
                    k++;
                }
            }
            for (int i = 0; i < b.length; i++) {
                if (i % 2 == 0) {
                    b[k] = a[y + i];
                    k++;
                }
            }
            for (int i = 0; i < b.length; i++) {
                a[y + i] = b[i];
            }
        }
        out.println(res1.size());
        for (int i = 0; i < res1.size(); i++) {
            out.println(res1.get(i) + " " + res2.get(i));
        }
    }

    BufferedReader br;
    StringTokenizer sc;
    PrintWriter out;

    public String nextToken() throws IOException {
        while (sc == null || !sc.hasMoreTokens()) {
            try {
                sc = new StringTokenizer(br.readLine());
            } catch (Exception e) {
                sc = null;
            }
        }
        return sc.nextToken();
    }

    public Integer nextInt() throws IOException {
        return Integer.parseInt(nextToken());
    }

    public static void main(String[] args) throws IOException {
        Locale.setDefault(Locale.US);
        new Main().run();
    }

    public void run() throws IOException {
        try {
            br = new BufferedReader(new InputStreamReader(System.in));
            out = new PrintWriter(System.out);
            solve();
            out.close();
        } catch (Exception e) {
            e.printStackTrace();
            System.exit(1);
        }
    }
}