#define _CRT_SECURE_NO_WARNINGS

#include <iostream>
#include <algorithm>
#include <random>
#include <vector>
#include <set>
#include <queue>
#include <ctime>

using namespace std;

#define mp make_pair
#define all(x) x.begin(), x.end()

//#define _DEBUG

const int INF = 2e9;
const int MAXN = 600001;

void solve();

int main()
{
	ios_base::sync_with_stdio(0);
	cin.tie(0);
	cout.tie(0);
#ifdef _DEBUG
	freopen("input.txt", "r", stdin);
	freopen("output.txt", "w", stdout);
#endif
	solve();
}

/*----------------------------------------------------------------------------*/

int to_int(string &s) {
	int k = 0;
	for (int i = 0; i<s.size(); i++) {
		if (s[i] != '1') continue;
		k |= (1 << (s.size() - 1 - i));
	}
	return k;
}

void solve() {
	int n;
	cin >> n;
	vector<int> q;
	int mx = 0;
	for (int i = 0; i < n; i++) {
		string s1;
		cin >> s1;
		q.emplace_back(to_int(s1));
		mx = max(mx, int(s1.size()));
	}
	sort(all(q));
	int ans = 1e9;
	for (int i = 1; i<(1 << (mx + 1)); i++) {
		int t = i ^ q[0];
		if ((i^q[0]) >= q[1] && (i | q[0]) == i) {
			if (ans>i) {
				ans = i;
			}
		}
	}
	vector<int> otv;
	while (ans != 0) {
		otv.emplace_back(ans % 2);
		ans /= 2;
	}
	reverse(all(otv));
	for (auto i : otv) {
		cout << i;
	}
}
