#define _CRT_SECURE_NO_WARNINGS

#include <iostream>
#include <algorithm>
#include <random>
#include <vector>
#include <set>
#include <queue>
#include <ctime>
#include <string>

using namespace std;

#define mp make_pair
#define all(x) x.begin(), x.end()

//#define _DEBUG

const int INF = 2e9;
const int MAXN = 600001;

void solve();

int main()
{
	ios_base::sync_with_stdio(0);
	cin.tie(0);
	cout.tie(0);
#ifdef _DEBUG
	freopen("input.txt", "r", stdin);
	freopen("output.txt", "w", stdout);
#endif
	solve();
}

/*----------------------------------------------------------------------------*/

bool b1[MAXN], b2[MAXN], ans[MAXN];

bool mn(int n) {
	for (int i = n; i >= 0; i--) {
		if (b1[i] && !b2[i]) return 1;
		if (b2[i] && !b1[i]) return 0;
	}
	return 1;
}

void solve() {
	int n;
	cin >> n;
	string s1, s2;
	cin >> s1 >> s2;
	for (int i = 0; i < s1.size(); i++) {
		b1[s1.size() - 1 - i] = (s1[i] == '1');
	}
	for (int i = 0; i < s2.size(); i++) {
		b2[s2.size() - 1 - i] = (s2[i] == '1');
	}
	for (int i = MAXN - 1; i >= 0; i--) {
		if (b1[i] && b2[i]) {
			if (mn(i)) {
				ans[i + 1] = 1;
				for (int j = i; j >= 0; j--) {
					ans[j] = b2[j];
				}
			}
			else {
				ans[i + 1] = 1;
				for (int j = i; j >= 0; j--) {
					ans[j] = b1[j];
				}
			}
			break;
		}
		else if (i != 0 && (b1[i] || b2[i]) && b1[i - 1] && b2[i - 1]) {
			ans[i + 1] = 1;
			ans[i] = 1;
			break;
		}
		else {
			ans[i] = (b1[i] | b2[i]);
		}
	}
	bool b1 = 0;
	for (int i = MAXN - 1; i >= 0; i--) {
		b1 |= ans[i];
		if (b1) {
			cout << (ans[i] ? 1 : 0);
		}
	}
}