#include <iostream>
#include <vector>
#include <algorithm>
#include <set>
#include <stdio.h>
#include <map>


using namespace std;

template<class T>
void print(vector<T> s){
    for (int i = 0; i < s.size(); i++)
        cout << s[i];
    cout << endl;
}

const int MAX = 400000;
int cnt[MAX];
int answer[MAX];

int main()
{
    #ifdef ONPC
        freopen("test.in", "r", stdin);
    #endif // ONPC
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    int n;
    cin >> n;
    for (int i = 0; i < n; i++){
        string s;
        cin >> s;
        for (int j = 0; j < s.size(); j++){
            if (s[j] == '1')
                cnt[s.size() - 1 - j]++;
        }
    }
    int cur = 0;
    for (int i = 0; i < MAX; i++){
        cur += cnt[i];
        if (cur > 0){
            answer[i] = 1;
            cur--;
        }
    }
    int last = 0;
    for (int i = 0; i < MAX; i++)
        if (answer[i] == 1)
            last = i;
    for (int i = last; i >= 0; i--)
        cout << answer[i];
    cout << endl;
    return 0;
}
