#define _CRT_SECURE_NO_WARNINGS

#include <iostream>
#include <algorithm>
#include <cassert>
#include <vector>
#include <set>
#include <map>

using namespace std;

const int INF = (int)1e9;
const int N = (int)4e5;

int n, p, v[N], res[N], ans[N] = {};

void check(int pos, int l1, int r1, int l2, int r2) {
	if (l1 > r1 && l2 > r2)
		return;
	fill(res, res + n, INF);
	for (int i = 0; i < n; i++)
		if ((l1 <= i && i <= r1) || (l2 <= i && i <= r2))
			res[i] = v[i];
		else {
			if (l1 <= r1)
				res[i] = min(res[i], v[i] + abs(i - r1));
			if (l2 <= r2)
				res[i] = min(res[i], v[i] + abs(i - l2));
		}
	int val = 1;
	for (int i = 0; i < n; i++)
		if (res[i] < res[pos])
			val++;
	ans[pos] = max(ans[pos], val);
}

int main() {
#ifdef _DEBUG
	freopen("input.txt", "r", stdin);
	freopen("output.txt", "w", stdout);
#else
	ios_base::sync_with_stdio(0);
	cin.tie(0); cout.tie(0);
#endif
	cin >> n >> p;
	for (int i = 0; i < n; i++)
		cin >> v[i];
	for (int i = 0; i < n; i++) {
		for (int j = 0; j < n; j++) {
			int l1 = 0, r1 = i - j;
			int l2 = i + j, r2 = n - 1;
			check(i, l1, r1, l2, r2);
		}
	}
	for (int i = 0; i < n; i++)
		cout << ans[i] << endl;
}