#define _CRT_SECURE_NO_DEPRECATE

#include <iostream>
#include <set>
#include <map>
#include <vector>
#include <string>
#include <cstring>
#include <algorithm>
#include <cstdlib>
#include <bitset>

using namespace std;
void solve();

typedef long long ll;
typedef pair<int, int> pii;

#define X first
#define Y second
#define mp make_pair

int main() {
#ifdef _DEBUG
	freopen("input.txt", "r", stdin);
	freopen("output.txt", "w", stdout);
#endif
	ios_base::sync_with_stdio(false);
	cin.tie(0);
	cout.tie(0);
	solve();
	return 0;
}

const int maxn = 500;
int n;
int p;
int v[maxn][maxn];
int pos[maxn][maxn];
vector<int> lifeable;
vector<int> stable;
vector<int> ans;
set<int> s;
set<int> c;
void solve() {
	cin >> n;
	for (int i = 0; i < n; ++i)
		for (int j = 0; j < n; ++j)
			cin >> v[i][j];
	for (int i = 0; i < n; ++i)
		for (int j = 0; j < n; ++j) {
			--v[i][j];
			pos[i][v[i][j]] = j;
		}
	cin >> p;
	if (p == 1) {
		for (int i = 0; i < n; ++i)
			if (v[i][0] == i)ans.push_back(i);
		cout << ans.size() << endl;
		for (auto i : ans)cout << i + 1 << ' ';
		return;
	}

	for (int i = 0; i < n; ++i)
		stable.push_back(v[i][0] == i);
	for (int i = 0; i < n; ++i) {
		bool could = false;
		for (int j = 0; j < n && !could; ++j) {
			s.clear();
			c.clear();
			bool per = false;
			for (int k = 0; k < n; ++k) {
				if (v[j][k] == i)per = true;
				if (per) c.insert(v[j][k]);
				else s.insert(v[j][k]);
			}
			for (auto i : c) {
				for (int u = 0; u < n; ++u)
					if (pos[u][u] > pos[u][i])s.erase(u);
			}
			could |= s.empty();
		}
		if (could)ans.push_back(i);

	}
	sort(ans.begin(), ans.end());
	cout << ans.size() << endl;
	for (auto i : ans)cout << i + 1 << ' ';

}