#define _CRT_SECURE_NO_DEPRECATE

#include <iostream>
#include <set>
#include <map>
#include <vector>
#include <string>
#include <cstring>
#include <algorithm>
#include <cstdlib>

using namespace std;
void solve();

typedef long long ll;
typedef pair<int, int> pii;

#define X first
#define Y second
#define mp make_pair

int main() {
#ifdef _DEBUG
	freopen("input.txt", "r", stdin);
	freopen("output.txt", "w", stdout);
#endif
	ios_base::sync_with_stdio(false);
	cin.tie(0);
	cout.tie(0);
	solve();
	return 0;
}

const int maxn = 500;

int n, m, k;
pii p[maxn];
typedef int T;

T rs[maxn][maxn];
int pred[maxn][maxn];

vector<int> ans;
void restr(int a = 0, int b = k - 1) {
	if (pred[a][b] == a) {
		ans.push_back(a);
		return;
	}
	restr(a, pred[a][b]);
	restr(pred[a][b], b);
	
}
void solve() {
	cin >> n >> m >> k;
	for (int i = 0; i < k; ++i)
		cin >> p[i].X >> p[i].Y;
	for (int i = 0; i < k; ++i)
		for (int j = 0; j < k; ++j) {
			pred[i][j] = i;
			rs[i][j] = 1 << max(abs(p[i].X - p[j].X), abs(p[i].Y - p[j].Y));
		}
	for (int g = 0; g < k; ++g)
		for(int i = 0; i < k; ++i)
			for(int j = 0; j < k; ++j)
				if (rs[i][g] + rs[g][j] < rs[i][j]) {
					rs[i][j] = rs[i][g] + rs[k][g];
					pred[i][j] = g;
				}
	
	restr();
	ans.push_back(k - 1);
	cout << ans.size() << endl;
	for (auto i : ans)cout << i + 1 << ' ';

}