#define _CRT_SECURE_NO_DEPRECATE

#include <iostream>
#include <set>
#include <map>
#include <string>
#include <vector>
#include <algorithm>

using namespace std;

void solve();

int main() {
#ifdef _DEBUG
	freopen("input.txt", "r", stdin);
	freopen("output.txt", "w", stdout);
#endif
	ios_base::sync_with_stdio(false);
	cin.tie(0);
	cout.tie(0);
	solve();
	return 0;
}

const int maxn = 3000;
int n;
int a[maxn];
vector<int> ansL;
vector<int> ansR;
vector<int> ord;

void rvs(int l, int r) {
	ord.clear();
	for (int i = l + 1; i < r; i += 2)ord.push_back(a[i]);
	for (int i = l; i < r; i += 2)ord.push_back(a[i]);
	ansL.push_back(l + 1);
	ansR.push_back(r);
	for (int i = 0; i < r - l; ++i)
		a[l + i] = ord[i];
}

void solve() {
	cin >> n;
	for (int i = 0; i < n; ++i)
		cin >> a[i];
	for (int j = 0; j < n; ++j) {
		int mn = j;
		for (int i = j; i < n; ++i)
			if (a[mn] > a[i])mn = i;
		while (mn != j) {
			if ((mn - j) % 2 == 0) {
				rvs(mn - 1, mn + 1);
				--mn;
			}
			else {
				rvs(j, mn + 1);
				mn = j + (mn - j) / 2 - 1;
			}
		}
		
	}
	cout << ansL.size() << endl;
	for (int i = 0; i < ansL.size(); ++i)
		cout << ansL[i] << ' ' << ansR[i] << endl;
}