#define _CRT_SECURE_NO_WARNINGS

#pragma GCC optimize("Ofast,unroll-loops")
#pragma GCC target("sse,sse2,sse3,sse4,popcnt,tune=native")

#include <iostream>
#include <vector>
#include <algorithm>
#include <set>
#include <map>
#include <queue>
#include <deque>
#include <unordered_map>
#include <string>
#include <cassert>

using namespace std;

typedef long long ll;
typedef long double ld;

//#define int long long
#define sz(v) (int)v.size()
#define all(v) v.begin(),v.end()
#define rall(v) v.rbegin(),v.rend()

void run();

signed main() {
#ifdef _DEBUG
	freopen("input.txt", "r", stdin);
#endif
	iostream::sync_with_stdio(false);
	cin.tie(0);
	cout.tie(0);
	run();
#ifdef _DEBUG
	cerr << "\nOK\n";
	while (1);
#endif
}

const int N = 4e5 + 123;
const ll INF = 1e9 + 2 * N;
const int SINF = 1e6;


int a[N];
int dp[N];
int ttime[N];
int cans[N];

void run() {

	int n, p;
	cin >> n >> p;
	for (int i = 0; i < n; i++) {
		cin >> a[i];
	}

	for (int mask = 1; mask < (1 << n); mask++) {
		for (int i = 0; i < n; i++) {
			ttime[i] = INF;
			cans[i] = 0;
		}
		for (int j = 0; j < n; j++) {
			if ((mask & (1 << j)) == 0)
				continue;
			for (int i = j + 1; i < n; i++) {
				ttime[i] = min(ttime[i], a[i] + i - j);
			}
		}

		for (int j = 0; j < n; j++) {
			if ((mask & (1 << j)) == 0)
				continue;
			for (int i = 0; i < j; i++) {
				ttime[i] = min(ttime[i], a[i] + j - i);
			}
		}

		for (int i = 0; i < n; i++) {
			for (int j = i + 1; j < n; j++) {
				if (ttime[i] > ttime[j])
					cans[i]++;
				else if (ttime[j] > ttime[i])
					cans[j]++;
			}
		}
		for (int i = 0; i < n; i++)
			dp[i] = max(dp[i], cans[i]);
	}

	for (int i = 0; i < n; i++)
		cout << dp[i] + 1 << ' ';

}