#include <iostream>
#include <cstdlib>
#include <stdio.h>
#include <algorithm>
#include <vector>

using namespace std;

vector <int> g[500], stable, liveable, en;


int enemy_size, esz, u[501], v[500][500], killable[500], enemy[500], p, n, stb[500];

int dfs (int x)
{
	u[x] = 1;

	if (!killable[x]) esz--;

	for (int i = 0; i < g[x].size (); i++)
	{
		int to = g[x][i];
		if (!u[to]) dfs (to);
	}
}

int main()
{
	scanf ("%d", &n);

	for (int i = 0; i < n; i++)
	{
		for (int j = 0; j < n; j++)
		{
			scanf ("%d", &v[i][j]);
			v[i][j]--;
		}

		if (v[i][0] == i)
		{
			stable.push_back (i + 1);
			stb[i] = 1;
		}
	}

	scanf ("%d", &p);

	if (p == 1)
	{
		printf ("%d\n", stable.size ());
		for (int i = 0; i < stable.size (); i++)
		{
			printf ("%d ", stable[i]);
		}
		return 0;
	}

	for (int i = 0; i < n; i++)
	{
		for (int j = 0; v[i][j] != i; j++)
		{
			g[v[i][j]].push_back (i);
			//cout << v[i][j] << ' ' << i << endl;
		}
	}

	for (int k = 0; k < n; k++)
	{
		if (stb[k])
		{
			liveable.push_back (k + 1);
			continue;
		}

		for (int i = 0; i < n; i++)
		{
			enemy[i] = 0;
			killable[i] = 0;
			u[i] = 0;
		}
		for (int i = 0; v[k][i] != k; i++)
		{
			enemy[v[k][i]] = 1;
			//cout << k << ' ' << v[k][i] << endl;
		}
		for (int i = 0; i < n; i++)
		{
			if (!enemy[i])
			{
				for (int j = 0; j < g[i].size (); j++)
				{
					int to = g[i][j];
					if (enemy[to])
					{
						killable[to] = 1;
						//cout << k << ' ' << to << endl;
					}
				}
			}
		}

		for (int i = 0; i < n; i++)
		{
			if (enemy[i] && !killable[i]) enemy_size++;
		}

		esz = enemy_size;
		//cout << k << ' ' << esz << endl;
		if (!esz)
		{
			liveable.push_back (k + 1);
			continue;
		}
		for (int i = 0; i < n; i++)
		{
			if (!enemy[i] || !killable[i]) continue;
			dfs (i);
			if (!esz)
			{
				liveable.push_back (k + 1);
				break;
			}
		}
	}


	printf ("%d\n", liveable.size ());
	for (int i = 0; i < liveable.size (); i++)
	{
		printf ("%d ", liveable[i]);
	}
	return 0;

}