#include <stdio.h>
#include <bits/stdc++.h>

#define ll long long
#define ld long double
#define fi first
#define se second
#define rep(i, l, r) for (int i = l; i < r; i++)
#define repb(i, l, r) for (int i = l; i > r; i--)
#define sz(a) (int)a.size()
#define mp(a, b) make_pair(a, b)
#define y1 qwertyuiop

using namespace std;

inline void setmin(int &x, int y) { if (y < x) x = y; }
inline void setmax(int &x, int y) { if (y > x) x = y; }
inline void setmin(ll &x, ll y) { if (y < x) x = y; }
inline void setmax(ll &x, ll y) { if (y > x) x = y; }

const int N = 300000;
const int inf = (int)1e9 + 1;
const ll big = (ll)1e18 + 1;
const int MOD = (int)1e9 + 7;

int log_2[N + 1];
pair<int, int> st_min[19][N];
pair<int, int> st_max[19][N];

void build(int n, int *a)
{
    log_2[1] = 0;
    rep(i, 2, n + 1)
        if ((1 << (log_2[i - 1] + 1)) <= i)
            log_2[i] = log_2[i - 1] + 1;
        else
            log_2[i] = log_2[i - 1];
    int sz = 0;
    while ((1 << sz) <= n)
        sz++;
    rep(i, 0, n)
        st_min[0][i] = st_max[0][i] = {a[i], i};
    rep(j, 1, sz)
        rep(i, 0, n - (1 << j) + 1)
        {
            st_min[j][i] = min(st_min[j - 1][i], st_min[j - 1][i + (1 << (j - 1))]);
            st_max[j][i] = max(st_max[j - 1][i], st_max[j - 1][i + (1 << (j - 1))]);
        }
}

pair<int, int> get_min(int l, int r)
{
    int len = log_2[r - l];
    return min(st_min[len][l], st_min[len][r - (1 << len)]);
}

pair<int, int> get_max(int l, int r)
{
    int len = log_2[r - l];
    return max(st_max[len][l], st_max[len][r - (1 << len)]);
}

int solve(int l, int r)
{
    if (l == r)
        return 0;
    int x = get_min(l, r).se, y = get_max(x, r).se;
    return 1 + solve(l, x) + solve(y + 1, r);
}

int main()
{
    //freopen("a.in", "r", stdin);
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout.precision(20);
    cout << fixed;
    int n;
    cin >> n;
    int a[n];
    rep(i, 0, n)
        cin >> a[i];
    build(n, a);
    cout << solve(0, n) << "\n";
    return 0;
}