#include <iostream>
#include <vector>
#include <algorithm>

#define fi first
#define se second
#define re return
#define pb push_back

#define F(i, a, b) for (int (i) = (a); (i) < (b); (i)++)
#define f(i, n) F(i, 0, n)
#define all(s) (s).begin(), (s).end()

using namespace std;

typedef long long ll;
typedef pair<int, int> pii;
typedef long double ld;

int run();

int main() {
#ifdef home
  freopen("i", "r", stdin);
  freopen("d", "w", stderr);
#endif
  ios::sync_with_stdio(false);
  cin.tie(nullptr);
  cout.tie(nullptr);

  run();
}

int cnt[500500];

string ans;

int run() {
  int n;
  cin >> n;
  f(i, n) {
    string s;
    cin >> s;
    cnt[s.size() - 1]++;
  }

  int cur = 0;

  f(i, 500500) {
    cur += cnt[i];
    if (cur > 0) {
      cur--;
      ans += '1';
    } else {
      ans += '0';
    }
  }

  reverse(all(ans));

  bool found = false;
  f(i, ans.size()) {
    if (ans[i] == '0' && !found) continue;
    found = true;
    cout << ans[i];
  }

  return 0;
}