#include <iostream>
#include <vector>
#include <algorithm>

#define fi first
#define se second
#define re return
#define pb push_back

#define F(i, a, b) for (int (i) = (a); (i) < (b); (i)++)
#define f(i, n) F(i, 0, n)
#define all(s) (s).begin(), (s).end()

using namespace std;

typedef long long ll;
typedef pair<int, int> pii;
typedef long double ld;

int run();

int main() {
#ifdef home
  freopen("i", "r", stdin);
  freopen("d", "w", stderr);
#endif
  ios::sync_with_stdio(false);
  cin.tie(nullptr);
  cout.tie(nullptr);

  run();
}

int cnt[500500];

string ans;


int run() {
  int n;
  cin >> n;
  string s1, s2;
  cin >> s1 >> s2;
  reverse(all(s1));
  reverse(all(s2));
  while (s1.size() < 500500) {
    s1 += '0';
  }
  while (s2.size() < 500500) {
    s2 += '0';
  }
  int last = 0;
  f(i, min(s1.size(), s2.size())) {
    if (s1[i] == '1' && s2[i] == '1') {
      last = i + 1;
    }
  }

  if (last != 0) {
    while (true) {
      if (s1[last] == '0' && s2[last] == '0') {
        break;
      }
      last++;
    }
  }

  string c1 = string(s1.begin(), s1.begin() + last);
  string c2 = string(s2.begin(), s2.begin() + last);
  reverse(all(c1));
  reverse(all(c2));
  if (c1 < c2) {
    ans = string(s1.begin(), s1.begin() + last);
  } else {
    ans = string(s2.begin(), s2.begin() + last);
  }

//  cerr << last << ' ' << ans << '\n';

  if (last != 0) {
    ans += '1';
  }

  F(i, last, 500500) {
    if (s1[i] == '0' && s2[i] == '0') {
      ans += '0';
    } else {
      ans += '1';
    }
  }


  reverse(all(ans));

  bool found = false;
  f(i, ans.size()) {
    if (ans[i] == '0' && !found) continue;
    found = true;
    cout << ans[i];
  }

  return 0;
}