#include<iostream>
#include<vector>
#include<map>
#include<set>
#include<string>
#include<algorithm>
#include<math.h>

using namespace std;

struct tree {
	int x;
	tree* left;
	tree* right;
	tree() {
		this->x = 0;
		this->left = nullptr;
		this->right = nullptr;
	}
};

struct df {
	tree* root;
	df() {
		this->root = new tree();
	}
	void push(tree* &root, int l, int r)
	{
		if (root == nullptr)
			root = new tree();
	}

	void upd(tree* &root, int l, int r, int v, int x)
	{
		if (r < l || l > v || r < v)
			return;
		push(root, l, r);
		root->x += x;
		if (l == r && l == v)
			return;
		int m = (l + r) / 2;
		upd(root->left, l, m, v, x);
		upd(root->right, m + 1, r, v, x);
	}

	long long sum(tree* root, int l, int r, int l1, int r1)
	{
		if (r < l || l1 > r || r1 < l)
			return 0;
		push(root, l, r);
		if (l == l1 && r == r1)
			return root->x;
		int m = (l + r) / 2;
		int x = sum(root->left, l, m, l1, min(m, r1));
		int y = sum(root->right, m + 1, r, max(m + 1, l1), r1);
		return x + y;
	}
};

int main() {
	ios_base::sync_with_stdio(false);
	cin.tie(NULL);
	//cout.setf(ios::fixed);
	//cout.precision(16);
	int n, p;
	cin >> n >> p;
	vector<int> s;
	for (int i = 0; i < n; i++)
	{
		int a;
		cin >> a;
		s.push_back(a);
	}
	df f1, f2;
	for (int i = 1; i < n; i++)
		f2.upd(f2.root, 0, 1e9 + 5e6 + 113, s[i] + i, 1);
	vector<int> out;
	for (int i = 0; i < n; i++)
		out.push_back(0);
	int t1 = 0, t2 = 0;
	for (int i = 0; i < n; i++)
	{
		out[i] += f2.sum(f2.root, 0, 1e9 + 5e6 + 113, 0, s[i] + t1 - 1);
		if (i != n - 1)
		{
			f2.upd(f2.root, 0, 1e9 + 5e6 + 113, s[i + 1] + t1 + 1, -1);
			t1++;
		}
	}
	int ts = n - 1;
	for (int i = 0; i < n - 1; i++)
	{
		f1.upd(f1.root, 0, 1e9 + 5e6 + 113, s[i] + ts, 1);
		ts--;
	}
	for (int i = n - 1; i >= 0; i--)
	{
		out[i] += f1.sum(f1.root, 0, 1e9 + 5e6 + 113, 0, s[i] + t2 - 1);
		if (i != 0)
		{
			f1.upd(f1.root, 0, 1e9 + 5e6 + 113, s[i - 1] + t2 + 1, -1);
			t2++;
		}
	}

	for (int i = 0; i < out.size(); i++)
		cout << out[i] + 1 << " ";
	//system("pause");
}

/*
6
2 3 1 1 5 1

5 1
8 5 5 7 7
*/