#include <algorithm>
#include <bitset>
#include <complex>
#include <deque>
#include <exception>
#include <fstream>
#include <functional>
#include <iomanip>
#include <ios>
#include <iosfwd>
#include <iostream>
#include <istream>
#include <iterator>
#include <limits>
#include <cstring>
#include <list>
#include <locale>
#include <map>
#include <memory>
#include <new>
#include <numeric>
#include <ostream>
#include <queue>
#include <set>
#include <sstream>
#include <stack>
#include <stdexcept>
#include <streambuf>
#include <string>
#include <typeinfo>
#include <utility>
#include <valarray>
#include <vector>
using namespace std;

#pragma warning (disable : 4996)
#define ll long long int

const int N = 4e5 + 100;
char s[N];
int w[N], q[N], tp[N];

int findSet(int v) {
	return q[v] < 0 ? v : q[v] = findSet(q[v]);
}
void un(int x, int y) {
	x = findSet(x);
	y = findSet(y);
	int t = tp[y];

	if (q[x] > q[y])
		swap(x, y);
	q[x] += q[y];
	q[y] = x;
	tp[x] = t;
}

int main() {
#ifdef _DEBUG
	freopen("input.txt", "r", stdin);
	freopen("output.txt", "w", stdout);
#endif
	int n;
	scanf("%d", &n);

	for (int i = 0; i < N; i++) {
		tp[i] = i;
		q[i] = -1;
	}

	int mx = 0;
	for (int i = 0; i < n; i++) {
		scanf(" %s", s);
		int j = strlen(s) - 1;
		if (w[j])
			j = tp[findSet(j)];
		w[j] = 1;
		un(j, j + 1);
		mx = max(mx, j);
	}

	while (mx >= 0) {
		printf("%d", w[mx]);
		mx--;
	}


	return 0;
}