#include<iostream>
#include<vector>
#include<string>
#include<bitset>
#include<algorithm>

#define ll long long
#define pii pair<int,int>
#define ld long double

using namespace std;

const int NMAX = 1111;
const int inf = 1e9;

pii ver[NMAX];
bitset<NMAX> dist[NMAX];
int p[NMAX];
bitset<NMAX> rast[NMAX];
int n, m, k;
int mx = 0;

bitset<NMAX> pl(bitset<NMAX> a,int i)
{
	while (a[i])
	{
		a[i] = 0;
		i++;
	}
	a[i] = 1;
	return a;
}

bool operator <(bitset<NMAX> a, bitset<NMAX> b)
{
	for (int i = mx + 10; i >= 0; i--)
	{
		if (a[i] > b[i])
			return false;
		else if (a[i] < b[i])
			return true;
	}
	return false;
}

int main()
{
	cin.tie(0);
	cout.tie(0);
	cin.sync_with_stdio(0);
	cout.sync_with_stdio(0);
	cin >> n >> m >> k;
	mx = (max(m, n));
	for (int i = 1; i <= k; i++)
		cin >> ver[i].first >> ver[i].second;
	for (int i = 2; i <= k; i++)
	{
		dist[i] =pl(dist[i],mx);
		rast[i] = dist[i];
	}
	dist[1] = 0;
	for (int i = 1; i <= k; i++)
	{
		int v = 1;
		for(int i=2;i<=k;i++)
			if (dist[i] < dist[v])
			{
				v = i;
			}
		rast[v] = dist[v];
		dist[v] = pl(dist[0],mx);
		if (v == k)
		{
			break;
		}
		for (int i = 1; i <= k; i++)
		{
			if (rast[i][mx])
			{
				bitset<NMAX> dop = pl(rast[v], max(abs(ver[v].first - ver[i].first), abs(ver[v].second - ver[i].second)));
				if (dop<dist[i] )
				{
					dist[i]=dop;
					p[i] = v;
				}
			}
		}
	}
	int cur = k;
	vector<int> ans;
	while (cur != 1)
	{
		ans.push_back(cur);
		cur = p[cur];
	}
	ans.push_back(1);
	reverse(ans.begin(), ans.end());
	cout << ans.size() << endl;
	for (int e : ans)
		cout << e << ' ';
	return 0;
}
/*
5 6 9
1 1
4 3
4 6
2 5
3 1
3 3
3 6
5 4
5 6

*/