#include<iostream>
#include<algorithm>
#include<stack>
#include<vector>

#define ll long long
#define ld long double
#define pii pair<ll,ll>

using namespace std;

const ll NMAX = 400033;
const ll inf = 1e9 + 10;

ll a[NMAX];
ll b[NMAX];
ll cmp1(ll i, ll j)
{
	return a[i] + i < a[j] + j;
}
ll cmp2(ll i, ll j)
{
	return a[i] - i < a[j] - j;
}

ll n;
ll cmp3(ll i, ll j)
{
	return min(a[i] + i, a[i] + n - i + 1) < min(a[j] + j, a[j] + n - j + 1);
}

ll ans[NMAX];

int main()
{
	cin.tie(0);
	cout.tie(0);
	cin.sync_with_stdio(0);
	cout.sync_with_stdio(0);
	cin >> n;
	ll p;
	cin >> p;
	for (ll i = 1; i <= n; i++)
	{
		cin >> a[i];
		b[i] = i;
	}
	sort(b + 1, b + n + 1, cmp1);
	for (ll i = 1; i <= n; i++)
	{
		ans[i] = lower_bound(b + 1, b + n + 1, i, cmp1) - b;
	}
	sort(b + 1, b + n + 1, cmp2);
	for (ll i = 1; i <= n; i++)
	{
		ans[i] = max(ans[i], (ll)(lower_bound(b + 1, b + n + 1, i, cmp2) - b));
	}

	sort(b + 1, b + n + 1, cmp3);
	for (ll i = 1; i <= n; i++)
	{
		ans[i] = max(ans[i], (ll)(lower_bound(b + 1, b + n + 1, i, cmp3) - b));
	}
	for (ll i = 1; i <= n; i++)
		cout << ans[i] << endl;
	return 0;
}