#include <iostream>
#include <algorithm>
#include <vector>
#include <map>
using namespace std;

#define int long long

const int INF = 1e15;

struct buy
{
	int a = 0, b = 0;
	friend bool operator<(const buy &a, const buy &b)
	{
		if (a.a == b.a)
			return a.b > b.b;
		return a.a > b.a;
	}
};

int find(const vector<int> &a, int x)
{
	if (a.empty())
		return -1;
	int l = -1, r = a.size();
	while (r - l > 1)
	{
		int m = (l + r) >> 1;
		if (a[m] >= x)
			r = m;
		else
			l = m;
	}
	return r;
}

signed main()
{
	ios_base::sync_with_stdio(0);
	cin.tie(0); cout.tie(0);
	int n; cin >> n;
	vector<buy> v(n);
	vector<int> all;
	for (int i = 0; i < n; i++)
	{
		cin >> v[i].a >> v[i].b;
		all.push_back(v[i].a);
		all.push_back(v[i].b);
	}
	sort(v.begin(), v.end());
	/*for (auto i : v)
	cout << i.a << " " << i.b << endl;*/
	sort(all.begin(), all.end());
	all.resize(unique(all.begin(), all.end()) - all.begin());
	vector<vector<int>> d(n, vector<int>(all.size()));
	vector<int> cur;
	map<int, int> ind;
	for (int i = 0; i < all.size(); i++)
		ind[all[i]] = i;
	for (int i = n - 1; i >= 0; i--)
	{
		/*  for (auto i : cur)
		cout << i << " ";
		cout << endl;*/
		for (int j = 0; j < all.size(); j++)
		{
			if (cur.empty())
				continue;
			int x = all[j];
			int ind = 0;
			for(int i = 0; i < cur.size(); i++)
				if (cur[i] >= x)
				{
					ind = cur.size() - i;
					break;
				}
			d[i][j] = max(ind * x, j > 0 ? d[i][j - 1] : 0);
			//cout << i + 1 << " " << all[j] << ": " << ind <<  " " << d[i][j] << endl;
		}
		cur.push_back(v[i].b);
		sort(v.begin(), v.end());
	}
	int ans = 0;
	for (int i = 0; i < n; i++)
	{
		int cur = (i + 1) * v[i].a;
		ans = max(ans, d[i][ind[v[i].a]] + cur);
	}
	cout << ans << endl;
	system("pause");
}