#include <iostream>
#include <vector>
#include <string>
#include <algorithm>
using namespace std;

const int L = 3e5;

bool comp(const string &a, const string &b)
{
	if (a.size() != b.size())
		return a.size() < b.size();
	for (int i = 0; i < a.size(); i++)
		if (a[i] != b[i])
			return a[i] < b[i];
	return false;
}

int main()
{
	ios_base::sync_with_stdio(0);
	cin.tie(0); cout.tie(0);
	int n; cin >> n;
	vector<string> a(n);
	for (int i = 0; i < n; i++)
		cin >> a[i];
	sort(a.begin(), a.end(), comp);
	string x = a[0];
	string y = a[1];
	reverse(x.begin(), x.end());
	reverse(y.begin(), y.end());
	bool yes = true;
	for (int i = 0; i < x.size(); i++)
		if (x[i] == '1' && y[i] == '1')
		{
			yes = false;
			break;
		}
	if (yes)
	{
		for (int i = y.size() - 1; i >= x.size(); i--)
			cout << y[i];
		for (int i = x.size() - 1; i >= 0; i--)
			cout << max(x[i], y[i]);
		system("pause");
		return 0;
	}
	reverse(x.begin(), x.end());
	reverse(y.begin(), y.end());
	int ind = -1;
	for (int i = 0; i < y.size() - x.size(); i++)
		if (y[i] == '0')
			ind = i;
	if (ind == -1)
	{
		cout << 1;
		for (int i = 0; i < (int)y.size() - (int)x.size(); i++)
			cout << 0;
		for (auto i : x)
			cout << i;
	}
	else
	{
		for (int i = 0; i < y.size(); i++)
			if (i == ind)
				cout << 1;
			else
				cout << y[i];
	}
	system("pause");
}
/*#include <iostream>
#include <vector>
#include <string>
#include <algorithm>
using namespace std;

const int L = 3e5;

int main()
{
	ios_base::sync_with_stdio(0);
	cin.tie(0); cout.tie(0);
	int n; cin >> n;
	vector<int> a(n);
	for (int i = 0; i < n; i++)
	{
		string s; cin >> s;
		reverse(s.begin(), s.end());
		for (int j = 0; j < s.length(); j++)
			a[i] += (1 << j) * (s[j] - '0');
	}
	int x = a[0];
	int y = a[1];
	if (x > y)
		swap(x, y);
	int mn = 1e9;
	for (int i = x; i <= 10000; i++)
		for (int j = y; j <= 10000; j++)
		{
			if ((i & j) != 0)
				continue;
			mn = min(mn, (i | j));
		}
	string ans = "";
	int cur = mn;
	while (cur)
	{
		ans.push_back('0' + cur % 2);
		cur /= 2;
	}
	reverse(ans.begin(), ans.end());
	for (auto i : ans)
		cout << i;
	system("pause");
}*/