#include <bits/stdc++.h>
using namespace std;
#define int long long
#define x first
#define y second
const int MAXN = 1e5, INF = 1e12, SZ = 1024;
pair<int, int> a[MAXN];
int ans[MAXN];
int add[MAXN];
int answer = 0, n;
long double inter(pair<int, int> a, pair<int, int> b) {
    return (a.y - b.y) / (long double)(b.x - a.x);
}
bool check(pair<int, int> a, pair<int, int> b, pair<int, int> c) {
    return (a.y - b.y) * (c.x - b.x) >= (b.y - c.y) * (b.x - a.x);
}
struct convexhull {
    vector<pair<int, int>> lines;
    void add(int k, int b) {
    	if (lines.size() && lines.back().x == k)
    		return;
    	while (lines.size() > 1 && check(lines[lines.size() - 2], lines.back(), {k, b}))
        	lines.pop_back();
        lines.push_back({k, b});
    }
    int get(int x) {
        int ans = -INF;
        for (pair<int, int> l : lines)
            ans = max(ans, l.x * x + l.y);
        return ans;
    }
    convexhull() {
        lines = vector<pair<int, int>>();
    }
};
struct calculator {
    convexhull cht;
    vector<int> a;
    void add(int i) {
        a.push_back(i);
        sort(a.begin(), a.end());
        reverse(a.begin(), a.end());
        cht = convexhull();
        for (int i = (int)a.size() - 1; i >= 0; --i)
            cht.add(a[i], a[i] * i);
    }
    int get(int i) {
        return cht.get(i + 1);
    }
    int size() {
        return a.size();
    }
    calculator() {
        cht = convexhull();
        a = vector<int>();
    }
};
calculator c[MAXN + 10];
int p[MAXN];
int f() {
    int ans = 0, sum = 0;
    for (int i = 0; i < MAXN / SZ + 1; ++i) {
        ans = max(ans, c[i].get(sum));
        sum += c[i].size();
    }
    return ans;
}
void calc() {
    set<pair<int, int>> ps;
    for (int i = 0; i < n; ++i)
        ps.insert({add[i], i});
    auto it = ps.rbegin();
    for (int i = 0; i < n; ++i) {
        p[it->y] = i;
        ++it;
    }
    for (int i = 0; i < n; ++i) {
        c[p[i] / SZ].add(add[i]);
        answer = max(answer, f() + ans[i]);
    }
}
signed main() {
    ios_base::sync_with_stdio(false);
    cin >> n;
    for (int i = 0; i < n; ++i)
        cin >> a[i].x >> a[i].y;
    sort(a, a + n);
    int ptr = 0;
    for (int i = 0; i < n; ++i) {
        if (i + 1 < n)
            add[i + 1] = a[i].y;
        ans[i] = (n - i) * a[i].x;
    }
    calc();
    cout << answer;
    return 0;
}