#include <iostream>
#include <vector>
#include <algorithm>
#include <map>
#include <cassert>
#include <stack>

using namespace std;

typedef long long ll;
/*
const int N = 3e5 + 7;

struct node {
	int val, ind;
	node(int val = 0, int ind = 0) : val(val), ind(ind) {}
	node operator+(const node &other) const {
		node tmp;
		if (val == other.val) {
			tmp.ind = max(ind, other.ind);
		}
		else if (val > other.val) {
			tmp.ind = ind;
		}
		else {
			tmp.ind = other.ind;
		}
		tmp.val = max(val, other.val);
		return tmp;
	}
};

node t[4 * N];

void build(int l, int r, int v, vector <int> &a) {
	if (l == r) {
		t[v] = node(a[l], l);
	}
	else {
		int m = (l + r) >> 1;
		build(l, m, 2 * v + 1, a);
		build(m + 1, r, 2 * v + 2, a);
		t[v] = t[2 * v + 1] + t[2 * v + 2];
	}
}

node get(int ql, int qr, int l, int r, int v) {
	if (qr < l || r < ql) return node(0, 0);
	if (ql <= l && r <= qr) return t[v];
	int m = (l + r) >> 1;
	return  get(ql, qr, l, m, 2 * v + 1) + get(ql, qr, m + 1, r, 2 * v + 2);
} */

void go(vector <int> &a, int l, int r) {
	vector <int> tmp;
	for (int i = l + 1; i <= r; i += 2) {
		tmp.push_back(a[i]);
	}
	for (int i = l; i <= r; i += 2) {
		tmp.push_back(a[i]);
	}
	for (int i = 0; i < tmp.size(); ++i) {
		a[i + l] = tmp[i];
	}
}

int main() {
	ios_base::sync_with_stdio(false);
	cin.tie(0);
	//freopen("input.txt", "r", stdin);
	//freopen("output.txt", "w", stdout);
	int n;
	cin >> n;
	vector <int> a(n);
	for (int i = 0; i < n; ++i) {
		cin >> a[i];
		--a[i];
	}
	vector <pair <int, int>> x;
	for (int i = 0; i < n; ++i) {
		int pos = -1;
		for (int j = i; j < n; ++j) {
			if (a[j] == i) {
				pos = j;
				break;
			}
		}
		while (pos != i) {
			if ((pos - i) % 2 == 1) {
				x.push_back(make_pair(i, pos));
				go(a, i, pos);
				for (int j = i; j < pos; ++j) {
					if (a[j] == i) {
						pos = j;
						break;
					}
				}
			}
			else {
				if (i) {
					x.push_back(make_pair(i - 1, pos));
					go(a, i - 1, pos);
					for (int j = i; j < pos; ++j) {
						if (a[j] == i) {
							pos = j;
							break;
						}
					}
				}
				else {
					x.push_back(make_pair(i + 1, pos));
					go(a, i + 1, pos);
					for (int j = i; j < pos; ++j) {
						if (a[j] == i) {
							pos = j;
							break;
						}
					}
				}
			}
		}
	}
	cout << x.size() << "\n";
	for (auto p : x) {
		cout << p.first + 1 << " " << p.second + 1 << "\n";
	}
}