#include <bits/stdc++.h>

using namespace std;

#define fi first
#define se second

const int64_t N=1e5;
int t[4*N+4];
vector<int64_t> w, e;

void Build(int i, int l, int r) {
    if (l==r) {
        t[i]=w[l];
    }
    else {
        int m=(l+r)/2;
        Build(2*i+1, l, m);
        Build(2*i+2, m+1, r);
        t[i]=t[2*i+1]+t[2*i+2];
    }
}

void Set(int i, int l, int r, int x) {
    if (l==r) {
        t[i]--;
    }
    else {
        int m=(l+r)/2;
        if (x<=m) Set(2*i+1, l, m, x); else Set(2*i+2, m+1, r, x);
        t[i]=t[2*i+1]+t[2*i+2];
    }
}

int Ans(int i, int l, int r, int lx, int rx) {
    if (lx==l && r==rx) {
        return t[i];
    }
    else {
        int m=(l+r)/2;
        int ans=0;
        if (lx<=m) ans+=Ans(2*i+1, l, m, lx, min(m, rx));
        if (rx>=m+1) ans+=Ans(2*i+2, m+1, r, max(lx, m+1), rx);
        return ans;
    }
}

int main()
{
    ios_base::sync_with_stdio(false);
    cin.tie(0);
    int n;
    cin >> n;
    int fl1=1, fl2=1;
    vector<pair<int64_t, int64_t> > q(n);
    for (int i=0; i<n; i++) {
        cin >> q[i].fi >> q[i].se;
        if (q[i].se!=0) fl1=0;
        if (q[i].fi!=q[i].se) fl2=0;
    }
    sort(q.begin(), q.end());
    if (fl1==1) {
        int64_t ans=0;
        for (int i=0; i<n; i++) {
            ans=max(ans, q[i].fi*(n-i));
        }
        cout << ans << endl;
        return 0;
    }
    if (fl2==1) {
        vector<int64_t> z(n);
        int64_t ans=q[0].fi*n;
        z[0]=q[0].fi;
        int64_t l=0;
        for (int i=1; i<n; i++) {
            int64_t zz=0;
            for (int i2=i; i2>max(i-5000, -1); i2--) zz=max(zz, (i-i2+1)*q[i2].fi);
            while (l<i && ((i-l+1)*q[l].fi<(i-l)*q[l+1].fi || (i-l+1)*q[l].fi<zz)) l++;
            z[i]=(i-l+1)*q[l].fi;
            ans=max(ans, q[i].fi*(n-i)+z[i-1]);
        }
        cout << ans << endl;
        return 0;
    }
    for (int i=0; i<n; i++) {
        e.push_back(q[i].se);
    }
    sort(e.begin(), e.end());
    w.push_back(1);
    for (int i=1; i<n; i++)
        if (e[i]==e[i-1])
            w[w.size()-1]++;
        else
            w.push_back(1);
    e.erase(unique(e.begin(), e.end()), e.end());
    int64_t ans=0;
    Build(0, 0, w.size()-1);
    for (int i=n-1; i>-1; i--) {
        int64_t ansnow=0;
        ansnow+=(n-i)*q[i].fi;
        int64_t inc=0;
        int i3=lower_bound(e.begin(), e.end(), q[i].se)-e.begin();
        Set(0, 0, w.size()-1, i3);
        for (int i2=0; i2<i; i2++) {
            int i3=lower_bound(e.begin(), e.end(), q[i2].se)-e.begin();
            inc=max(inc, e[i3]*Ans(0, 0, w.size()-1, i3, w.size()-1));
            //cout << i << " " << i2 << " " << i3 << " " << inc << " " << ansnow+inc << endl;
        }
        ansnow+=inc;
        ans=max(ans, ansnow);
        //int l=0, r=0;
        //if (i==0) continue;
    }
    cout << ans << endl;
    return 0;
}
