#include <iostream>
#include <vector>
#include <set>
#include <fstream>

#define ll long long

using namespace std;

void prt(vector<ll> a){
    for (auto i : a){
        cout << i << ' ';
    }
    cout << endl;
}

void prt(vector<vector<ll> > a){
    for (auto i : a){
        prt(i);
    }
    cout << endl;
}

vector<vector<ll> > a;
vector<bool> used;

vector<ll> color;

vector<vector<ll> > pos;

ll n;

void dfs(ll v){
    used[v] = true;
    for (ll i = 0; i < n; i++){
        if (color[i] != color[v]){
            if (pos[i][v] < pos[i][i]){
                color[i] = color[v];
                used[i] = true;
            }
        }
    }
}

int main()
{
    //ifstream cin;
    //cin.open("input.txt");
    cin >> n;
    a.resize(n, vector<ll> (n));
    for (ll i = 0; i < n; i++){
        for (ll j = 0; j < n; j++){
            cin >> a[i][j];
            a[i][j]--;
        }
    }
    pos.resize(n, vector<ll>(n));
    for (ll i = 0; i < n; i++){
        for (ll j = 0; j < n; j++){
            pos[i][a[i][j]] = j;
        }
    }
    ll p;
    cin >> p;
    vector<ll> ans;
    if (p == 1){
        for (ll i = 0; i < n; i++){
            if (a[i][0] == i){
                ans.push_back(i + 1);
            }
        }
    }else{
        vector<bool> life(n, false);
        for (ll v = 0; v < n; v++){
            used.resize(0);
            used.resize(n, false);
            color.resize(n);
            for (ll i = 0; i < n; i++){
                color[i] = i;
            }
            for (ll i = n - 1; i >= 0; i--){
                if (!used[a[v][i]]){
                    dfs(a[v][i]);
                }
            }
            //prt(color);
            for (ll i = 0; i < n; i++){
                life[color[i]] = true;
            }
        }
        for (ll i = 0; i < n; i++){
            if (life[i]){
                ans.push_back(i + 1);
            }
        }
    }
    cout << ans.size() << endl;
    for (auto i : ans){
        cout << i << ' ';
    }
    cout << endl;
    return 0;
}
