#include <iostream>
#include <vector>
#include <set>

using namespace std;

vector<vector<int> > a;
vector<bool> used;

vector<int> color;

vector<vector<int> > pos;

int n;

void dfs(int v){
    used[v] = true;
    for (int i = 0; i < n; i++){
        if (color[i] != color[v]){
            if (pos[i][v] < pos[i][i]){
                color[i] = color[v];
                dfs(i);
            }
        }
    }
}

int main()
{
    cin >> n;
    a.resize(n, vector<int> (n));
    for (int i = 0; i < n; i++){
        for (int j = 0; j < n; j++){
            cin >> a[i][j];
            a[i][j]--;
        }
    }
    pos.resize(n, vector<int>(n));
    for (int i = 0; i < n; i++){
        for (int j = 0; j < n; j++){
            pos[i][a[i][j]] = j;
        }
    }
    int p;
    cin >> p;
    vector<int> ans;
    if (p == 1){
        for (int i = 0; i < n; i++){
            if (a[i][0] == i){
                ans.push_back(i + 1);
            }
        }
    }else{
        vector<bool> life(n, false);
        for (int v = 0; v < n; v++){
            used.resize(0);
            used.resize(n, false);
            color.resize(n);
            for (int i = 0; i < n; i++){
                color[i] = i;
            }
            dfs(v);
            for (int i = 0; i < n; i++){
                if (!used[i]){
                    dfs(i);
                }
            }
            for (int i = 0; i < n; i++){
                life[color[i]] = true;
            }
        }
        for (int i = 0; i < n; i++){
            if (life[i]){
                ans.push_back(i + 1);
            }
        }
    }
    cout << ans.size() << endl;
    for (auto i : ans){
        cout << i << ' ';
    }
    cout << endl;
    return 0;
}
