#include <bits/stdc++.h>


using namespace std;


#define int long long


int n, m, k, inf = 1e18;
vector <vector <pair<int, int> > > g;
vector <pair<int, int> > pairs;
vector <int> dist;


struct cmp
{
    bool operator()(int a, int b)
    {
        if (dist[a] == dist[b])
        {
            return a < b;
        }
        return dist[a] < dist[b];
    }
};
signed main()
{
    //freopen("last.txt", "r", stdin);
    cin >> n >> m >> k;
    g.resize(k);
    pairs.resize(k);
    for (int i = 0; i < k; i++)
    {
        cin >> pairs[i].first >> pairs[i].second;
        pairs[i].first--;
        pairs[i].second--;
    }
    for (int i = 0; i < k; i++)
    {
        for (int j = 0; j < k; j++)
        {
            if (i < j)
            {
                int temp = (1 << max(abs(pairs[i].first - pairs[j].first), abs(pairs[i].second - pairs[j].second)));
                g[i].push_back(make_pair(j, temp));
                g[j].push_back(make_pair(i, temp));
            }
        }
    }
    dist.resize(k, inf);
    dist[0] = 0;
    set<int, cmp> ss;
    ss.insert(0);
    vector <int> prev(k, -1);
    while (ss.size() > 0)
    {
        int v = *(ss.begin());
        //cout << v << endl;
        ss.erase(ss.begin());
        for (int i = 0; i < g[v].size(); i++)
        {
            //cout << i << endl;
            int u = g[v][i].first, w = g[v][i].second;
            //cout << u << " " << w << endl;
            if (dist[v] + w < dist[u])
            {
                ss.erase(u);
                //cout << i << endl;
                dist[u] = dist[v] + w;
                ss.insert(u);
                prev[u] = v;
            }
        }
    }
    vector <int> ans;
    int cur = k - 1;
    while (cur != -1)
    {
        ans.push_back(cur + 1);
        cur = prev[cur];
    }
    cout << ans.size() << endl;
    for (int i = ans.size() - 1; i > -1; i--)
    {
        cout << ans[i] << " ";
    }
    cout << endl;
    return 0;
}
