#include<iostream>
#include<vector>
#include<set>
#include<map>
#include<queue>
#include<algorithm>
typedef long long ll;
using namespace std;
vector<pair<int, int>>pos;
struct Big
{
	vector<int>ar;
	int n;
	Big()
	{
		n = 200;
		ar.resize(n,1);
	}
	Big(vector<int>a)
	{
		n = a.size();
		ar = a;
	}
	Big operator+(Big b)
	{
		vector<int>a(n);
		for (int i = 0; i < n - 1; i++)
		{
			a[i] = a[i] + ar[i] + b.ar[i];
			a[i + 1] += a[i] / 2;
			a[i] %= 2;
		}
		return Big(a);
	}
	Big operator+(int p)
	{
		vector<int>a=ar;
		a[p]++;
		for (int i = 0; i < n - 1; i++)
		{
			a[i + 1] += a[i] / 2;
			a[i] %= 2;
		}
		int y = 0;
		return Big(a);
	}
	void operator=(Big x)
	{
		ar = x.ar;
	}
	bool operator<(Big b)const
	{
		 
		for (int i = n - 1; i >= 0; i--)
			if (ar[i] < b.ar[i])
				return 1;
			else
				if (ar[i] > b.ar[i])
					return 0;

		return 0;
	}
};

int R(int i, int j)
{
	return max(abs(pos[i].first - pos[j].first), abs(pos[i].second - pos[j].second));
}

int main()
{
	int n, m, k;
	cin >> n >> m >> k;
	vector<Big>dp(k);
	vector<int>p(k,-1),nol(200,0);
	dp[0] = Big(nol);
	for (int i = 0, a, b; i < k; i++)
	{
		cin >> a >> b; 
		pos.push_back({ a - 1, b - 1 });
	}
	set<pair<Big, int>>s;
	s.insert({ dp[0],0 });
	Big l;
	int j;
	while(!s.empty())
	{
		l = (*s.begin()).first;
		j = (*s.begin()).second;
		s.erase(s.begin());
		for (int x = 0; x < k; x++)
			if (dp[j] + R(j, x)<dp[x])
			{
				pair<Big,int> pr = { dp[x],x };
				if (s.count(pr))
					s.erase(pr);
				
				dp[x] = Big((dp[j] + R(j, x)).ar);
				s.insert(make_pair(dp[x], x));
				p[x] = j;
			}
	}
	vector<int>ans;
	int c = k - 1;
	while (p[c] != -1)
	{
		ans.push_back(c + 1);
		c = p[c];
	}
	ans.push_back(1);
	cout << ans.size() << endl;
	for (int i = ans.size() - 1; i >= 0;i--)cout << ans[i] << " ";
	cin >> n;
}