#include <iostream>
#include <algorithm>
#include <vector>

using namespace std;

const int MAX_N = 400000;
bool use[MAX_N];
int n;
int ans[MAX_N], a[MAX_N], dist[MAX_N];
pair <int, int> pp[MAX_N];

void check(int num) {
    int last = - n - 1;
    for (int i = 0; i < n; i++) {
        //if (num == 5) cout << i << ' ' << (num & (1 << i)) << endl;
        if (((num) & (1 << i)) > 0) last = i;
        dist[i] = i - last;
    }
    last = 2 * n + 1;
    for (int i = n - 1; i >= 0; i--) {
        if ((num & (1 << i)) > 0) last = i;
        dist[i] = min(dist[i], last - i);
    }
    for (int i = 0; i < n; i++) pp[i] = {dist[i] + a[i], i};
    sort(pp, pp + n);
    int place = 1;
    for (int i = 0; i < n; i++) {
        //cout << now[i].first << ' ' << now[i].second << endl;
        if (i != 0 && pp[i].first != pp[i - 1].first) place = i + 1;
        ans[pp[i].second] = max(ans[pp[i].second], place);
    }
    //cout << endl << endl;
}

void gen() {
    for (int i = 1; i < (1 << n); i++) check(i);
}

/*void solve_slow_p_is_2() {
    for (int i = 0; i < n; i++) ans[i] = -1;
    gen();
    for (int i = 0; i < n; i++) {
        cout << ans[i] << "\n";
    }
}*/

void solve_p_is_2() {
    int num;
    for (int i = 0; i < n; i++) ans[i] = -1;
    for (int l = 0; l <= n; l++) {
        for (int r = 0; l + r <= n; r++) {
            num = 0;
            for (int k = 0; k < l; k++) {
                num |= (1 << k);
            }
            for (int k = 0; k < r; k++) {
                num |= (1 << (n - k - 1));
            }
            check(num);
        }
    }
    for (int i = 0; i < n; i++) cout << ans[i] << "\n";
}

void all_the_same(int p) {
    if (p == 1) {
        for (int i = 0; i < n; i++) cout << 1 << "\n";
    } else {
        for (int i = 0; i < n; i++) cout << n << "\n";
    }
}

int main() {
    ios_base :: sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);
    int p;
    cin >> n >> p;
    bool the_same = 1;
    for (int i = 0; i < n; i++) {
        cin >> a[i];
        if (i > 0 && a[i] != a[i - 1]) the_same = 0;
    }
    if (the_same) {
        all_the_same(p);
        return 0;
    }
    if (p == 2) {
        solve_p_is_2();
        return 0;
    }
    int cnt = 0;
    for (int i = 0; i < n; i++) {
        cnt = 0;
        for (int j = 0; j < n; j++) {
            if (i == j) continue;
            if (a[j] + abs(i - j) < a[i]) cnt++;
        }
        ans[i] = cnt + 1;
    }
    for (int i = 0; i < n; i++) {
        cout << ans[i] << "\n";
    }
    return 0;
}
