#include <iostream>
#include <algorithm>
#include <vector>

using namespace std;
typedef long long ll;

int n, m, q;
vector<vector<int>> p;

int query() {
	int res = 0;
	for (int i = 0; i < n; ++i)
		for (int j = 0; j < m; ++j) {
			int mxi = -1;
			for (int k = 0; k < n; ++k)
				mxi = max(mxi, p[k][j]);
			int mxj = -1;
			for (int k = 0; k < m; ++k)
				mxj = max(mxj, p[i][k]);
			if (p[i][j] == mxj && p[i][j] == mxi)
				++res;
		}
	return res;
}

int main() {
	ios_base::sync_with_stdio(false);
	cin.tie(0);
	cout.tie(0);
	cin >> n >> m >> q;
	p.resize(n, vector<int>(m));
	for (auto arr : p)
		for (auto &x : arr)
			cin >> x;
	while (q--) {
		int x, y, val;
		cin >> x >> y >> val;
		--x, --y;
		p[x][y] = val;
		cout << query() << '\n';
	}
	return 0;
}