#pragma GCC optimize("O3")
#include <iostream>
#include <algorithm>
#include <queue>
#include <string>
#include <vector>
#include <bitset>

using namespace std;
typedef long long ll;

#define size(v) ((int)v.size())
#define all(v) v.begin(), v.end()

const int maxL = 2000;
int n;
vector<bitset<maxL>> a;

bool cmp(bitset<maxL> a, bitset<maxL> b) {
	for (int i = maxL - 1; i > -1; --i)
		if (a[i] < b[i])
			return true;
		else if (a[i] > b[i])
			return false;
	return false;
}

signed main() {
	ios_base::sync_with_stdio(false);
	cin.tie(0);
	cout.tie(0);
	cin >> n;
	a.resize(n);
	for (int i = 0; i < n; ++i)
		cin >> a[i];
	sort(all(a), cmp);
	bitset<maxL> c = a[0];
	bitset<maxL> b = c;
	b.flip();
	if ((a[1] & b) == a[1])
		c |= a[1];
	else {
		int w = maxL - 1;
		for (; w > -1; --w)
			if (b[w] < a[1][w])
				break;
		while (w < maxL) {
			if (b[w])
				break;
			++w;
		}
		c[w] = 1;
	}
	int f = 0;
	for (int i = maxL; i > -1; --i) {
		if (!f)
			f = c[i];
		if (f)
			cout << c[i];
	}
	return 0;
}