#define _CRT_SECURE_NO_WARNINGS
#include <iostream>
#include <vector>
#include <algorithm>
#include <set>
#include <map>

using namespace std;

typedef vector<int> vi;
typedef long long ll;
typedef pair<int, int> pii;

#define inb push_back
#define X first
#define Y second
#define all(v) (v).begin(), (v).end()

const int INF = 2e9;
const int M = 1e5 + 5;

int n;
pii a[M];
map<int, ll> dp, dd;

int main()
{
#ifdef _DEBUG
	freopen("input.txt", "r", stdin);
	freopen("output.txt", "w", stdout);
#endif
	ios_base::sync_with_stdio(0);
	cin.tie(0);
	cout.tie(0);
	cin >> n;
	for (int i = 0; i < n; ++i)
		cin >> a[i].Y >> a[i].X;
	sort(a, a + n);
	vi d;
	for (int i = 0; i < n; ++i)
		d.inb(a[i].Y);
	sort(all(d));
	ll ans = 0, an, bal, m = 0;
	for (int i = 0; i < n; ++i)
	{
		dp[d[i]] = max(dp[d[i]], (ll)d[i] * (n - i));
		ans = max(ans, dp[d[i]]);
	}
	for (int i = n - 2; i >= 0; --i)
		if (d[i] != d[i + 1])
			dd[d[i]] = dp[d[i + 1]];
	vector<double> toc;
	vector<pair<pair<ll, ll>, int>> stoc;
	for (int i = 0; i < n; ++i)
	{
		if (!a[i].X)
			continue;
		while (stoc.size())
		{
			ll k = stoc.back().X.X, b = stoc.back().X.Y;
			ll k1 = a[i].Y, b1 = (ll)a[i].Y * -i;
			double xx = (1. * b - b1) / (k1 - k);
			if (!toc.size() || xx > toc.back())
			{
				toc.inb(xx);
				break;
			}
			toc.pop_back();
			stoc.pop_back();
		}
		stoc.inb({ { a[i].Y, (ll)a[i].Y * -i }, i });
		bal = 0;
		int j = lower_bound(all(toc), i + 1) - toc.begin();
		if (stoc.size())
		{
			bal = stoc[j].X.X * (i + 1) + stoc[j].X.Y;
			int x = 0;
			for (int k = stoc[j].Y; k <= i; ++k)
				x = max(x, a[k].Y);
			ans = max(ans, bal + dd[x]);
		}
	}
	cout << ans;
}