#define _CRT_SECURE_NO_WARNINGS
#include <iostream>
#include <vector>

using namespace std;

typedef vector<int> vi;
typedef pair<int, int> pii;

#define inb push_back
#define X first
#define Y second

const int M = 3e5 + 5;

int n, a[M], rr[M], ror[M];

int main()
{
#ifdef _DEBUG
	freopen("input.txt", "r", stdin);
	freopen("output.txt", "w", stdout);
#endif
	ios_base::sync_with_stdio(0);
	cin.tie(0);
	cout.tie(0);
	cin >> n;
	for (int i = 0; i < n; ++i) cin >> a[i];

	vi d, u;
	for (int i = n - 1; i >= 0; --i)
	{
		while (d.size() && a[d.back()] >= a[i])
			d.pop_back();
		if (d.size()) rr[i] = d.back();
		else rr[i] = n;
		d.inb(i);

		while (u.size() && a[u.back()] <= a[i])
			u.pop_back();
		if (u.size()) ror[i] = u.back();
		else ror[i] = n;
		u.inb(i);
	}
	int ans = 0, l = 0;
	while (l < n)
	{
		int x = l;
		while (x < n && ror[x] < rr[l])
			x = ror[x];
		++ans;
		l = x + 1;
	}
	cout << ans << '\n';
}