#include <iostream>
#include <vector>
#include <cmath>
#include <cstdio>
#include <cstdlib>
#include <set>
#include <map>
#include <unordered_set>
#include <unordered_map>
#include <algorithm>
#include <bitset>
#include <ctime>
#include <string>
#include <cstring>
#include <cassert>

#define fi first
#define se second

using namespace std;
const int MAXN = 3100;

int n;
int mas[MAXN];
vector<pair<int, int>> ans;

void S(int l, int r, int cnt = 1){
    if (l + 1 == r){
        return;
    }
    while (cnt--){
        vector<int> a[2];
        ans.push_back({l, r - 1});

        for (int i = l; i < r; ++i){
            a[(i - l) % 2].push_back(mas[i]);
        }

        for (int i = 0; i < (int)a[1].size(); ++i){
           mas[l + i] = a[1][i];
        }

        for (int i = (int)a[1].size(); i < (int)(a[0].size() + a[1].size()); ++i){
           mas[l + i] = a[0][i - (int)a[1].size()];
        }
    }
}

void pr(int a, int b){
    while (a < b){
        int d = mas[a];
        S(a, b + 1);
        for (int i = b; ;--i){
            if (mas[i] == d){
                a = i;
                break;
            }
        }
    }
}

void br(int a, int b){
    while (a > b){
        int d = mas[a];
        if ((a - b) % 2 == 1){
            S(b, a + 1);
            for (int i = b; ;++i){
                if (mas[i] == d){
                    a = i;
                    break;
                }
            }
        } else {
            S(b + 1, a + 1);
            for (int i = b; ;++i){
                if (mas[i] == d){
                    a = i;
                    break;
                }
            }
        }
    }
}

void f(int l, int r){
    if ((r - l) == 1){
        return;
    }

    int max_ind = l;

    for (int i = l; i < r; ++i){
        if (mas[max_ind] <= mas[i]){
            max_ind = i;
        }
    }

    int min_ind = l;

    for (int i = l; i < r; ++i){
        if (mas[min_ind] > mas[i]){
            min_ind = i;
        }
    }

    if (rand() % 2 == 0){
        pr(max_ind, r - 1);
        f(l, r - 1);
    } else {
        br(min_ind, l);
        f(l + 1, r);
    }
}

int main(){
    srand(time(NULL));
    ios::sync_with_stdio(false);
    cin.tie(0); cout.tie(0);

    cin >> n;

    for (int i = 0; i < n; ++i){
        cin >> mas[i];
    }

    for (int i = 0; i < n - 1; ++i){
        if (mas[i] > mas[i + 1]){
            S(i, i + 2);
        }
    }

    S(0, n);
    S(0, n);
    S(0, n);
    S(0, n);
    S(0, n);
    f(0, n);

    if (ans.size() > 15000){
        assert(false);
    }

    cout << ans.size() << endl;
    for (auto e : ans){
        cout << e.fi + 1 << ' ' << e.se + 1 << endl;
    }

    return 0;
}
