#include <iostream>
#include <vector>
#include <algorithm>

using namespace std;

int n, p, x;
int viruses[5000][5000], state[5000];
vector<int> answer, availl;
bool avail[5000];

bool is_living(int vir) {
	availl.clear();
	for (int i = 0; i < n; i++) state[i] = i;
	for (int i = 0; i < n; i++)
		if (viruses[i][vir] < viruses[i][state[i]]) state[i] = vir;
	for (int i = 0; i < n; i++) avail[i] = false;
	for (int i = 0; i < n; i++)
		if (state[i] != vir) {
			if (!avail[state[i]]) availl.push_back(state[i]);
			avail[state[i]] = true;
		}
	for (int i = 0; i < n; i++)
		if (state[i] == vir)
			for (int j : availl)
				if (viruses[i][state[i]] > viruses[i][j]) {
					state[i] = j;
				}
	for (int i = 0; i < n; i++)
		if (state[i] == vir) return true;
	return false;
}

int main() {
	ios::sync_with_stdio(0);
	cin.tie(0);
	cout.tie(0);

	cin >> n;
	for (int i = 0; i < n; i++)
		for (int j = 0; j < n; j++) {
			cin >> x;
			x--;
			viruses[i][x] = j;
		}
	cin >> p;
	if (p == 1) {
		for (int i = 0; i < n; i++)
			if (viruses[i][i] == 0) answer.push_back(i + 1);
	}
	else {
		for (int i = 0; i < n; i++)
			if (is_living(i)) answer.push_back(i + 1);
	}

	sort(answer.begin(), answer.end());
	cout << answer.size() << endl;
	for (int i : answer) cout << i << ' ';

	//system("pause");
	return 0;
}