#include <bits/stdc++.h>

#define x first
#define y second
#define mp make_pair
#define pb push_back
#define all(a) a.begin(), a.end()
#define ll long long
#define db long double

using namespace std;

int n;
pair<int, int> a[150007];

bool cmp(pair<int, int> a, pair<int, int> b){
	if (a.x == b.x) return a.y < b.y;
	return a.x > b.x;
}

const int magic = 300;

vector<int> d[150007 / magic + 7];
vector<pair<db, pair<ll, ll> > > st[150007 / magic + 7];

db cross(pair<ll, ll> a, pair<ll, ll> b){
	return (b.y - a.y) / (db)(a.x - b.x);
}

void rebuild(int v){
	st[v].clear();
	for (int i = (int)d[v].size() - 1; i >= 0; i--){
		pair<ll, ll> now = mp(d[v][i], (i + 1) * (ll)d[v][i]);
		//cout << "===" << now.x << ' ' << now.y << endl;
		while(st[v].size()){
			if (st[v].back().y.x == now.x){
				if (st[v].back().y.y >= now.y) break;
				else st[v].pop_back();
				continue;
			}
			db x = cross(st[v].back().y, now);
			if (x <= st[v].back().x) st[v].pop_back();
			else {
				st[v].pb(mp(x, now));
				break;
			}
		}
		if (st[v].size() == 0) st[v].pb(mp(0, now));
	}
}

void erase(int x){
	int v = -1;
	for (int i = 0; ; i++) if (d[i].size()){
		if (d[i].back() <= x){
			v = i;
			break;
		}
	}
	if (v == -1) assert(0);
	for (int i = 0; i < d[v].size(); i++){
		if (d[v][i] == x){
			for (int j = i; j + 1 < d[v].size(); j++) d[v][j] = d[v][j + 1];
			d[v].pop_back();
			break;
		}
	}
	rebuild(v);
}

ll getFunc(){
	int sum = 0;
	ll ans = 0;
	for (int v = 0; v < n / magic + 7; v++) if (d[v].size()){
		ll now = 0;
		//for (auto c : st[v]) cout << c.x << ' ' << c.y.x << ' ' << c.y.y << endl;
		for (int i = 0; i < st[v].size(); i++) if (i + 1 == st[v].size() || st[v][i].x >= sum){
			now = st[v][i].y.x * sum + st[v][i].y.y;
		}
		ans = max(ans, now);
		sum += d[v].size();
	}
	return ans;
}

int main(){
	//freopen("input.txt", "r", stdin);
	//freopen("output.txt", "w", stdout);
	ios_base::sync_with_stdio(0); cin.tie(0);
	cin >> n;
	for (int i = 0; i < n; i++) cin >> a[i].x >> a[i].y;
	sort(a, a + n, cmp);
	vector<int> t;
	for (int i = 0; i < n; i++) t.pb(a[i].y);
	sort(all(t));
	reverse(all(t));
	for (int i = 0; i < n; i++){
		d[i / magic].pb(t[i]);
	}
	

	for (int i = 0, j = 0; i < n; j++, i += magic) rebuild(j);

	ll ans = 0;
	for (int i = 0; i < n; i++){
		erase(a[i].y);
		ll now = a[i].x * (ll)(i + 1);
		ll add = getFunc();
		//cout << now << ' ' << add << endl;
		//exit(0);
		ans = max(ans, now + add);
	}
	cout << ans;
}