#include <fstream>
#include <algorithm>
#include <string>
#include <bitset>

using namespace std;

 #include <iostream>
//const string FILENAME = "test";
//ifstream cin(FILENAME + ".in");
//ofstream cout(FILENAME + ".out");

template<class C> void chkmin(C& a, C b) { if (a > b) a = b; }
template<class C> void chkmax(C& a, C b) { if (a < b) a = b; }

typedef long long ll;
typedef long double ld;

const int MAXN = 2e5 + 7;

int a[MAXN];
int mxh[MAXN];
int mxv[MAXN];

bool Cool(int i, int j) {
	return mxh[i] == j && mxv[j] == i;
}

int main() {
	int n, m, q;
	cin >> n >> m >> q;
	for (int i = 0; i < n; ++i) {
		for (int j = 0; j < m; ++j) {
			cin >> a[i * m + j];
		}
	}
	for (int i = 0; i < n; ++i) {
		for (int j = 0; j < m; ++j) {
			if (a[i * m + mxh[i]] < a[i * m + j])
				mxh[i] = j;
			if (a[mxv[j] * m + j] < a[i * m + j])
				mxv[j] = i;
		}
	}
	int res = 0;
	for (int i = 0; i < n; ++i) {
		for (int j = 0; j < m; ++j) {
			if (Cool(i, j)) {
				++res;
			}
		}
	}
	for (int qq = 0; qq < q; ++qq) {
		int i, j, val;
		cin >> i >> j >> val;
		--i; --j;
		a[i * m + j] = val;
		if (Cool(i, j)) {
			cout << res << '\n';
			continue;
		}
		if (a[mxv[j] * m + j] < a[i * m + j]) {
			if (Cool(mxv[j], j)) --res;
			mxv[j] = i;
		}
		if (a[i * m + mxh[i]] < a[i * m + j]) {
			if (Cool(i, mxh[i])) --res;
			mxh[i] = j;
		}
		if (Cool(i, j)) ++res;
		cout << res << '\n';
	}
}

