#include <bits/stdc++.h>

using namespace std;


#define ll long long
#define null NULL
#define ld long double
#define forn(i, n) for (int i = 1; i <= (int)n; ++i)
#define firn(i, n) for (int i = 0; i < (int)n; ++i)



int n, m, q;


int res = 0;


vector< vector<int> > a;


vector<int> row, col, rpos, cpos;


bool good(int x, int y) {
	return a[x][y] == row[x] && a[x][y] == col[y];
}


void init() {
	a.resize(n + 1, vector<int> (m + 1));
	row.resize(n + 1);
	col.resize(m + 1);
	rpos.resize(n + 1);
	cpos.resize(m + 1);
}


void solve() {
	int r, c, x;
	cin >> r >> c >> x;
	//cout << "r=" << r << " c=" << c << " a"
	if (a[r][c] == row[r] && a[r][c] == col[c]) ++res;
	if (x > row[r]) {
		int nc = rpos[r];
		res -= good(r, nc);
		rpos[r] = c;
	}
	if (x > col[c]) {
		int nr = cpos[c];
		res -= good(nr, c);
		cpos[c] = r;
	}
	row[r] = max(row[r], x);
	col[c] = max(col[c], x);
	a[r][c] = x;
	if (x == row[r] && x == col[c]) {
		++res;
	}
	cout << res << "\n";
}


signed main() {
	ios_base::sync_with_stdio(false);
	cin >> n >> m >> q;
	init();
	forn(i, n) {
		forn(j, m) {
			cin >> a[i][j];
			if (a[i][j] > row[i]) {
				row[i] = a[i][j];
				rpos[i] = j;
			}
			if (a[i][j] > col[j]) {
				col[j] = a[i][j];
				cpos[j] = i;
			}
		}
	}
	forn(i, n) {
		forn(j, m) {
			if (a[i][j] == row[i] && a[i][j] == col[j]) {
				++res;
			}
		}
	}
	
	for (int it = 0; it < q; ++it) {
		solve();
	}
	return 0;
}