#include <bits/stdc++.h>

using namespace std;


#define ll long long
#define null NULL
#define ld long double
#define forn(i, n) for (int i = 1; i <= (int)n; ++i)
#define firn(i, n) for (int i = 0; i < (int)n; ++i)
#define int long long


inline void uax(int &a, int b) {
	if (b > a) a = b;
}

inline void uin(int &a, int b) {
	if (b < a) a = b;
}


const int maxn = 150 * 1000 + 228;

int a[maxn], b[maxn], suff[maxn];

int n;


int solve1() {
	vector<int> cst;
	forn(i, n) {
		cst.push_back(a[i]);
		cst.push_back(b[i]);
	}
	sort(cst.begin(), cst.end());
	int res = 0;
	for (int fir = 0; fir < (int)cst.size(); ++fir) {
		for (int sec = 0; sec <= fir; ++sec) {
			int cur = 0;
			forn(i, n) {
				if (a[i] >= cst[fir]) {
					cur += cst[fir];
				} else {
					if (b[i] >= cst[sec]) {
						cur += cst[sec];
					}
				}
			}
			uax(res, cur);
		}
	}
	return res;
}



bool cmp(pair<int, int> a, pair<int, int> b) {
	return a.second > b.second;
}



int solve2() {
	vector<int> cst;
	forn(i, n) {
		cst.push_back(a[i]);
		cst.push_back(b[i]);
	}
	sort(cst.begin(), cst.end());
	vector< pair<int, int> > v;
	forn(i, n) {
		v.push_back(make_pair(a[i], b[i]));
	}
	sort(v.begin(), v.end(), cmp);
	int res = 0;
	firn(fir, cst.size()) {
		int c1 = cst[fir];
		vector<int> tmp;
		int cur = 0;
		firn(i, n) {
			if (c1 <= v[i].first) {
				cur += c1;
			} else {
				tmp.push_back(v[i].second);
			}
		}
		uax(res, cur);
		firn(i, tmp.size()) {
			if (tmp[i] <= c1) {
				uax(res, cur + tmp[i] * (i + 1));
			}
		}
	}
	return res;
}


int solve3() {
	vector<int> v;
	forn(i, n) {
		v.push_back(a[i]);
	}
	sort(v.rbegin(), v.rend());
	int res = 0;
	for (int i = 0; i < n; ++i) {
		uax(res, (i + 1) * v[i]);
	}
	return res;
}


struct line
{
	int k, b;
	line() {}
	line(int _k, int _b) {
		k = _k;
		b = _b;
	}

	int get(int x) {
		return k * x + b;
	}
};


vector<line> st;



double intersect(line l1, line l2) {
	double k1 = l1.k, k2 = l2.k;
	double b1 = l1.b, b2 = l2.b;
	return (b2 - b1) / (k1 - k2);
}



bool need(line l) {
	int sz = (int)st.size();
	if (intersect(l, st[sz - 1]) < intersect(st[sz - 1], st[sz - 2])) {
		return true;
	}
	return false;
}


void add(line l) {
	while ((int)st.size() > 1 && need(l)) {
		st.pop_back();
	}
	st.push_back(l);
}




bool lefter(int x, line l1, line l2) {
	int k1 = l1.k, k2 = l2.k;
	int b1 = l1.b, b2 = l2.b;
	if (k1 - k2 > 0) {
		return x * (k1 - k2) <= b2 - b1;
	}
	return x * (k1 - k2) >= b2 - b1;
}


int get(int x) {
	int res = 0;
	int sz = (int)st.size();
	for (int i = 0; i < min(5LL, sz); ++i) {
		uax(res, st[i].get(x));
	}
	for (int i = sz - 1; i >= max(0LL, sz - 3); --i) {
		uax(res, st[i].get(x));
	}
	int l = 1, r = (int)st.size() - 1;
	while (r - l > 1) {
		int m = (l + r) >> 1;
		if (lefter(x, st[m], st[m + 1])) {
			l = m;
		} else {
			r = m;
		}
	}
	for (int i = max(0LL, l - 5); i < min(sz, r + 5); ++i) {
		uax(res, st[i].get(x));
	}
	return res;
}



void solve5() {
	sort(a + 1, a + n + 1);
	reverse(a + 1, a + n + 1);

	int res = 0;

	for (int i = n; i > 0; --i) {
		add(line(-a[i], a[i] * i + a[i]));
		suff[i] = get(i);
	}

	for (int i = 1; i <= n; ++i) {
		int cur = a[i] * i + suff[i + 1];
		uax(res, cur);
	}
}


signed main() {
	ios_base::sync_with_stdio(false);
	cin >> n;
	bool good3 = true;
	bool good5 = true;
	forn(i, n) {
		cin >> a[i] >> b[i];
		if (b[i] != 0) {
			good3 = false;
		}
		if (a[i] != b[i]) {
			good5 = false;
		}
	}
	if (good5) {
		solve5();
	}
	if (n <= 300) {
		cout << solve1() << endl;
	} else {
		if (good3) {
			cout << solve3() << endl;
		} else {
			cout << solve2() << "\n";
		}
	}
	return 0;
}


/*






5
80 20
60 50
40 40
15 10
70 30






*/










