#include <iostream>
#include <cmath>
#include <vector>
#include <algorithm>

using namespace std;

const int SZ = 50;

int n, p;
int arr[SZ];
bool work[SZ];

int ans[SZ];

int start_time(int ind)
{
    int res = 100;
    for (int i = 0; i < n; i++) {
        if (work[i])
            res = min(res, abs(i - ind));
    }
    return res;
}

void upd()
{
    vector<pair<int, int> > vect;
    for (int i = 0; i < n; i++)
        vect.push_back({arr[i] + start_time(i), i});
    sort(vect.begin(), vect.end());
    int now_place = 1;
    ans[vect[0].second] = max(ans[vect[0].second], 1);
    for (int i = 1; i < n; i++) {
        if (vect[i].first != vect[i - 1].first)
            now_place = i + 1;
        ans[vect[i].second] = max(ans[vect[i].second], now_place);
    }
}

void action(int mask)
{
    for (int i = 0; i < n; i++)
        work[i] = false;
    int ind = 0;
    while (mask > 0) {
        if (mask & 1)
            work[ind] = true;
        ind++;
        mask >>= 1;
    }
    upd();
}

int main()
{
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    cin >> n >> p;
    for (int i = 0; i < n; i++)
        cin >> arr[i];
    int MAX_MASK = 1 << n;
    for (int mask = 1; mask < MAX_MASK; mask++)
        action(mask);
    for (int i = 0; i < n; i++)
        cout << ans[i] << "\n";
    return 0;
}
