#include <iostream>
#include <cmath>
#include <vector>
#include <algorithm>

using namespace std;

const int SZ = 50;

int n, p;
int arr[SZ];
bool work[SZ];

int ans[SZ];

int start_time(int ind)
{
    int res = 100;
    for (int i = 0; i < n; i++) {
        if (work[i])
            res = min(res, abs(i - ind));
    }
    return res;
}

void upd()
{
    vector<pair<int, int> > vect;
    for (int i = 0; i < n; i++)
        vect.push_back({arr[i] + start_time(i), i});
    sort(vect.begin(), vect.end());
    int now_place = 1;
    ans[vect[0].second] = max(ans[vect[0].second], 1);
    for (int i = 1; i < n; i++) {
        if (vect[i].first != vect[i - 1].first)
            now_place = i + 1;
        ans[vect[i].second] = max(ans[vect[i].second], now_place);
    }
}

void action(int L, int R)
{
    for (int i = 0; i < L; i++)
        work[i] = true;
    for (int i = L; i <= R; i++)
        work[i] = false;
    for (int i = R + 1; i < n; i++)
        work[i] = true;
    upd();
}

int main()
{
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    cin >> n >> p;
    for (int i = 0; i < n; i++)
        cin >> arr[i];
    for (int L = 0; L < n; L++) {
        for (int R = L; R < n; R++) {
            if (L == 0 && R == n - 1)
                continue;
            action(L, R);
        }
    }
    for (int i = 0; i < n; i++)
        cout << ans[i] << "\n";
    return 0;
}
