#include <bits/stdc++.h>

using namespace std;

const int MAXN = 200010;
int n, m;
vector<int> a[MAXN];
vector<bool> is_good[MAXN];
int max_in_str[MAXN], max_in_row[MAXN];
int good_cnt = 0;

bool check(int i, int j) {
    for (int k = 0; k < n; k++) {
        if (a[k][j] > a[i][j])
            return false;
    }
    for (int k = 0; k < m; k++) {
        if (a[i][k] > a[i][j])
            return false;
    }
    return true;
}

int main() {
    #ifdef DEBUG
    assert(freopen("input.txt", "r", stdin));
    assert(freopen("output.txt", "w", stdout));
    #endif // DEBUG
    int q;
    scanf("%d%d%d", &n, &m, &q);
    for (int i = 0; i < n; i++) {
        a[i].resize(m);
        is_good[i].resize(m, false);
        for (int j = 0; j < m; j++) {
            scanf("%d", &a[i][j]);
        }
    }
    for (int i = 0; i < n; i++) {
        for (int j = 0; j < m; j++) {
            is_good[i][j] = check(i, j);
            if (is_good[i][j]) {
                good_cnt++;
                break;
            }
            /*if (check(i, j))
                good.insert({i, j});*/
        }
    }
    for (int i = 0; i < n; i++) {
        for (int j = 0; j < m; j++) {
            if (a[i][max_in_str[i]] < a[i][j])
                max_in_str[i] = j;
            if (a[max_in_row[j]][j] < a[i][j])
                max_in_row[j] = i;
        }
    }
    for (int z = 0; z < q; z++) {
        int r, c, x;
        scanf("%d%d%d", &r, &c, &x);
        r--;
        c--;
        int cnt = 0;
        //cout << a[r][max_in_str[r]] << "=mx1\n";
        if (x > a[r][max_in_str[r]]) {
            if (is_good[r][max_in_str[r]])
                good_cnt--;
            is_good[r][max_in_str[r]] = false;
            //good.erase({r, max_in_str[r]});
            //cout << "del " << r + 1 << " " << max_in_str[r] + 1 << "\n";
            cnt++;
            max_in_str[r] = c;
        }
        //cout << a[max_in_row[c]][c] << "=mx2\n";
        if (x > a[max_in_row[c]][c]) {
            if (is_good[max_in_row[c]][c])
                good_cnt--;
            is_good[max_in_row[c]][c] = false;
            //good.erase({max_in_row[c], c});
            //cout << "del " << max_in_row[c] + 1 << " " << c + 1 << "\n";
            cnt++;
            max_in_row[c] = r;
        }
        if (cnt == 2) {
            if (!is_good[r][c])
                good_cnt++;
            is_good[r][c] = true;
            //good.insert({r, c});
            //cout << "add\n";
        }
        a[r][c] = x;
        //cout << good_cnt << "\n";
        printf("%d\n", good_cnt);
        /*for (auto i : good) {
            cout << i.first + 1 << " " << i.second + 1 << "\n";
        }*/
    }
    return 0;
}
