#include <bits/stdc++.h>

using namespace std;

const int MAXN = 300010;
int a[MAXN];
int dp[MAXN];

bool check(int l, int r) {
    int mn = INT_MAX;
    int mx = 0;
    for (int i = l; i < r; i++) {
        mn = min(mn, a[i]);
        mx = max(mx, a[i]);
    }
    return (a[l] == mn && a[r - 1] == mx);
}

int main() {
    #ifdef DEBUG
    assert(freopen("input.txt", "r", stdin));
    assert(freopen("output.txt", "w", stdout));
    #endif // DEBUG
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);
    int n;
    cin >> n;
    for (int i = 0; i < n; i++) {
        cin >> a[i];
    }
    dp[0] = 0;
    for (int i = 1; i <= n; i++) {
        dp[i] = INT_MAX;
        for (int j = 0; j < i; j++) {
            if (check(j, i)) {
                dp[i] = min(dp[i], dp[j] + 1);
            }
        }
    }
    cout << dp[n];
    return 0;
}
