#include <bits/stdc++.h>

using namespace std;

const int MAXN = 300010;
int a[MAXN];
int dp[MAXN];
int more_left_elem[MAXN];
int less_right_elem[MAXN];

bool check(int l, int r) {
    int mn = INT_MAX;
    int mx = 0;
    for (int i = l; i < r; i++) {
        mn = min(mn, a[i]);
        mx = max(mx, a[i]);
    }
    return (a[l] == mn && a[r - 1] == mx);
}

int main() {
    #ifdef DEBUG
    assert(freopen("input.txt", "r", stdin));
    assert(freopen("output.txt", "w", stdout));
    #endif // DEBUG
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);
    int n;
    cin >> n;
    for (int i = 0; i < n; i++) {
        cin >> a[i];
    }
    vector<int> st;
    for (int i = 0; i < n; i++) {
        while (st.size() && a[st.back()] <= a[i])
            st.pop_back();
        if (st.size() == 0) {
            more_left_elem[i] = -1;
        }
        else
            more_left_elem[i] = st.back();
        st.push_back(i);
    }
    st.clear();
    for (int i = n - 1; i >= 0; i--) {
            while (st.size() && a[st.back()] >= a[i])
                st.pop_back();
            if (st.size() == 0) {
                less_right_elem[i] = n;
            }
            else
                less_right_elem[i] = st.back();
            st.push_back(i);
        }
    /*for (int i = 0; i < n; i++) {
        cout << more_left_elem[i]+1 << " " << less_right_elem[i]+1 << "\n";
    }
    return 0;*/

    dp[0] = 0;
    for (int i = 1; i <= n; i++) {
        dp[i] = INT_MAX;
        for (int j = i - 1; j > more_left_elem[i - 1]; j--) {
            if (less_right_elem[j] > i - 1) {
                dp[i] = min(dp[i], dp[j] + 1);
            }
        }
    }
    cout << dp[n];
    return 0;
}
