#define _CRT_SECURE_NO_WARNINGS

#include <iostream>
#include <string>
#include <vector>
#include <set>
#include <map>
#include <cstdio>
#include <algorithm>

using namespace std;

const int INF = 1e9 + 5;

vector<pair<int, int>> a;

void s(int l, int r, vector<int> &v) {
	vector<int> ans(r - l);
	a.push_back({l, r - 1});
	int cnt = 0;
	for (int i = l + 1; i < r; i += 2) {
		ans[cnt++] = v[i];
	}
	for (int i = l; i < r; i += 2) {
		ans[cnt++] = v[i];
	}
	for (int i = l; i < r; i++)
		v[i] = ans[i - l];
}

void move(int l, int p, vector<int> &v) {
	while (p > l) {
		if ((p - l) % 2 == 0) {
			s(l + 1, p + 1, v);
		}
		else {
			s(l, p + 1, v);
		}
		for (int i = l; i < v.size(); i++) {
			if (v[i] - 1 == l)
				p = i;
		}
	}
}

int main() {
	//freopen("input.txt", "r", stdin);
	//freopen("output.txt", "w", stdout);

	int n;
	cin >> n;

	vector<int> v(n);

	for (int i = 0; i < n; i++)
		cin >> v[i];

	for (int i = 0; i < n; i++) {
		int p = -1;
		for (int j = i; j < n; j++) {
			if (v[j] - 1 == i) {
				p = j;
				break;
			}
		}
		move(i, p, v);
	}

	cout << a.size() << endl;
	for (int i = 0; i < a.size(); i++)
		cout << a[i].first + 1 << ' ' << a[i].second + 1 << endl;

	return 0;
}