#define _CRT_SECURE_NO_WARNINGS

#include <iostream>
#include <string>
#include <vector>
#include <set>
#include <map>
#include <cstdio>
#include <algorithm>

using namespace std;

const int INF = 1e9 + 5;

const int MAX_L = 50;//3e5 + 10;
const int MAX = 1e6 + 20;

int main() {
	//freopen("input.txt", "r", stdin);
	//freopen("output.txt", "w", stdout);

	ios::sync_with_stdio(false);

	int n;
	cin >> n;

	string a, b;
	cin >> a >> b;

	int x = 0, y = 0;
	reverse(a.begin(), a.end());
	reverse(b.begin(), b.end());

	for (int i = 0; i < a.size(); i++) {
		if (a[i] == '1')
			x += 1 << i;
	}

	for (int i = 0; i < b.size(); i++) {
		if (b[i] == '1')
			y += 1 << i;
	}

	int mi = INF;
	for (int i = x; i < MAX; i++) {
		if ((i & y) == 0)
			mi = min(mi, i | y);

		int curr = 0;
		for (int j = 21; j >= 0; j--) {
			if ((y & (1 << j)) == 0) {
				curr |= 1 << j;
				if(curr >= y && (curr & i) == 0)
					mi = min(mi, i | curr);
				curr ^= 1 << j;
			}
			if (y & (1 << j))
				curr |= 1 << j;
		}
	}

	string ans;
	for (int i = 0; i < 16; i++) {
		if (mi & (1 << i))
			ans += '1';
		else
			ans += '0';
	}

	bool was = false;
	for (int i = ans.size() - 1; i >= 0; i--) {
		was |= ans[i] == '1';
		if (was)
			cout << ans[i];
	}

	return 0;
}