#include <bits/stdc++.h>
using namespace std;

#define vec vector
#define pb push_back
typedef long long ll;
typedef pair<int, int> pii;

int main() {
    //freopen("input.txt", "r", stdin);
    //freopen("output.txt", "w", stdout);

    ios_base::sync_with_stdio(false);
    cin.tie(0); cout.tie(0);
    srand(time(NULL));

    int n, m, q;
    cin >> n >> m >> q;

    vec<vec<int> > table(n, vec<int>(m));
    vec<int> row(n), col(m);
    vec<int> a(n, -1), b(m, -1);

    for (int k = 0; k < n; k++) {
        for (int i = 0; i < m; i++) {
            cin >> table[k][i];
            row[k] = max(row[k], table[k][i]);
            col[i] = max(col[i], table[k][i]);
        }
    }

    int cnt = 0;
    for (int k = 0; k < n; k++) {
        for (int i = 0; i < m; i++) {
            if (row[k] == col[i]) {
                a[k] = i;
                b[i] = k;
                cnt++;
                break;
            }
        }
    }
    for (int k = 0; k < q; k++) {
        int x, y, val;
        cin >> x >> y >> val;
        x--; y--;
        if (val > row[x]) {
            row[x] = val;
            if (a[x] != -1) {
                cnt--;
                b[a[x]] = -1;
                a[x] = -1;
            }
        }
        if (val > col[y]) {
            col[y] = val;
            if (b[y] != -1) {
                cnt--;
                a[b[y]] = -1;
                b[y] = -1;
            }
        }
        if (row[x] == col[y]) {
            a[x] = y; b[y] = x;
            cnt++;
        }
        cout << cnt << '\n';
    }
    return 0;
}
