#include <bits/stdc++.h>

using namespace std;

vector<int> arr(500000);
vector<int> tmax(1000000), tmin(1000000, -1);

int n, d = 1;

void build()
{
    while(d < n) d <<= 1;
}

void updatemax(int i, int tl = 0, int tr = d - 1, int v = 1)
{
    if(tl == tr)
    {
        tmax[v] = i;
        return;
    }
    int tm = (tl + tr) >> 1;
    if(i <= tm) updatemax(i, tl, tm, v << 1);
    else updatemax(i, tm + 1, tr, v << 1 | 1);
    if(arr[tmax[v << 1]] > arr[tmax[v << 1 | 1]])
    {
        tmax[v] = tmax[v << 1];
    }
    else tmax[v] = tmax[v << 1 | 1];
}

int maxe(int l, int r, int tl = 0, int tr = d - 1, int v = 1)
{
    if(l == tl && r == tr)
    {
        return tmax[v];
    }
    int tm = (tl + tr) >> 1;
    int ans = INT_MIN, ind;
    if(l <= tm)
    {
        int i = maxe(l, min(tm, r), tl, tm, v << 1);
        if(arr[i] > ans)
        {
            ans = arr[i];
            ind = i;
        }
    }
    if(r > tm)
    {
        int i = maxe(max(l, tm + 1), r, tm + 1, tr, v << 1 | 1);
        if(arr[i] >= ans)
        {
            ans = arr[i];
            ind = i;
        }
    }
    return ind;
}

void updatemin(int i, int tl = 0, int tr = d - 1, int v = 1)
{
    if(tl == tr)
    {
        tmin[v] = i;
        return;
    }
    int tm = (tl + tr) >> 1;
    if(i <= tm) updatemin(i, tl, tm, v << 1);
    else updatemin(i, tm + 1, tr, v << 1 | 1);
    if(arr[tmin[v << 1]] < arr[tmin[v << 1 | 1]])
    {
        tmin[v] = tmin[v << 1];
    }
    else tmin[v] = tmin[v << 1 | 1];
}

int mine(int l, int r, int x, int tl = 0, int tr = d - 1, int v = 1)
{
    if(tl == tr) return tmin[v];
    int tm = (tl + tr) >> 1;
    if(l <= tm && arr[tmin[v << 1]] < x) return mine(l, min(r, tm), x, tl, tm, v << 1);
    else return mine(max(l, tm + 1), r, x, tm + 1, tr, v << 1 | 1);
}

int main()
{
    ios_base::sync_with_stdio(false);
    //freopen("input.txt", "r", stdin);
    cin >> n;
    build();
    for(int i = 0; i < n; i++)
    {
        cin >> arr[i];
        updatemax(i);
        updatemin(i);
    }
    int cnt = 0;
    int l = 0, r = n - 1;
    int prev = 0;
    while(l != n)
    {
        prev = l;
        int x = mine(l, r, arr[l]);
        //cout << l << " " << arr[l] << " " << x << " " << arr[x] << endl;
        if(x == -1) x = n - 1;
        int y = maxe(l, x);
        cnt++;
        l = y + 1;
        for(int i = prev; i < l; i++)
        {
            arr[i] = INT_MAX;
            updatemin(i);
        }
    }
    cout << cnt << endl;
}
