#include <bits/stdc++.h>

using namespace std;
const int MAXN = 4e3 + 7;

int n, p;
int a[MAXN], b[MAXN], l_ans[MAXN], ans[MAXN], c[MAXN];
vector<int> t1[4 * MAXN], t2[4 * MAXN];

void build1(int v, int vl, int vr) {
    if (vl == vr) {
        t1[v] = {b[vl]};
        return;
    }
    int m = (vl + vr) / 2;
    build1(2 * v + 1, vl, m);
    build1(2 * v + 2, m + 1, vr);
    for (int i = vl; i <= vr; i++) {
        t1[v].push_back(b[i]);
    }
    sort(t1[v].begin(), t1[v].end());
    cout << vl << " " << vr << "\n";
    for (int x : t1[v]) {
        cout << x  << " ";
    }
    cout << " : t1\n";
}

void build2(int v, int vl, int vr) {
    if (vl == vr) {
        t2[v] = {c[vl]};
        return;
    }
    int m = (vl + vr) / 2;
    build2(2 * v + 1, vl, m);
    build2(2 * v + 2, m + 1, vr);
    for (int i = vl; i <= vr; i++) {
        t2[v].push_back(c[i]);
    }
    sort(t2[v].begin(), t2[v].end());
    cout << vl << " " << vr << "\n";
    for (int x : t2[v]) {
        cout << x  << " ";
    }
    cout << " :xt2\n";
}

int query1(int v, int vl, int vr, int l, int r, int val) {
    if (vl > r || vr < l) {
        return 0;
    }
    if (vl >= l && vr <= r) {
        int ll = 0, rr = vr - vl + 1;
        while (rr > ll) {
            int m = rr - (rr - ll) / 2;
            if (t1[v][m] >= val) {
                rr = m - 1;
            } else {
                ll = m;
            }
        }
        if (t1[v][ll] < val)
            return ll + 1;
        else
            return 0;
    }
    int m = (vl + vr) / 2;
    return query1(2 * v + 1, vl, m, l, r, val) +
    query1(2 * v + 2, m + 1, vr, l, r, val);
}

int query2(int v, int vl, int vr, int l, int r, int val) {
    if (vl > r || vr < l) {
        return 0;
    }
    if (vl >= l && vr <= r) {
        int ll = 0, rr = vr - vl + 1;
        while (rr > ll) {
            int m = rr - (rr - ll) / 2;
            if (t2[v][m] >= val) {
                rr = m - 1;
            } else {
                ll = m;
            }
        }
        if (t2[v][ll] < val)
            return ll + 1;
        else
            return 0;
    }
    int m = (vl + vr) / 2;
    return query2(2 * v + 1, vl, m, l, r, val) +
    query2(2 * v + 2, m + 1, vr, l, r, val);
}

int main() {
    ios::sync_with_stdio(0);
    cin.tie(0);
    cin >> n >> p;
    for (int i = 0; i < n; i++) {
        cin >> a[i];
        b[i] = a[i] - i;
        c[i] = a[i] + i;
        //cout << a[i] << " " << b[i] << " " << c[i] << " :a, b, c\n";
    }
    set<int> se;
    for (int i = 0; i < n; i++) {
        int c1 = 0;
        auto it = se.lower_bound(b[i]);
        set<int> cur(se.begin(), it);
        c1 = cur.size();
        l_ans[i] = c1;
        se.insert(b[i]);
    }
    se.clear();
    for (int i = n - 1; i >= 0; i--) {
        auto it = se.lower_bound(c[i]);
        multiset<int> cur(se.begin(), it);
        ans[i] = cur.size() + l_ans[i] + 1;
        se.insert(c[i]);
    }
    for (int i = 0; i < n; i++) {
        cout << ans[i] << "\n";
    }
    return 0;
}

/*



*/
