#include <bits/stdc++.h>

using namespace std;

typedef long long ll;
typedef long double ld;

const int T = (1 << 20);
const int INF = 1e9;

int t[T];
int t1[T];

void upd(int v, int l, int r, int q, int val)
{
    if (q >= r || q < l)
        return;
    if (l + 1 == r)
    {
        t[v] = val;
        return;
    }
    int mid = (r + l) / 2;
    if (q < mid)
        upd(2 * v, l, mid, q, val);
    else
        upd(2 * v + 1, mid, r, q, val);
    t[v] = min(t[2 * v + 1], t[2 * v]);
}

int find(int v, int l, int r, int ql, int qr)
{
    if (ql >= r || l >= qr)
        return INF;
    if (ql <= l && r <= qr)
        return t[v];
    int mid = (r + l) / 2;
    return min(find(2 * v, l, mid, ql, qr), find(2 * v + 1, mid, r, ql, qr));
}

void upd2(int v, int l, int r, int q, int val)
{
    if (q >= r || q < l)
        return;
    if (l + 1 == r)
    {
        t1[v] = val;
        return;
    }
    int mid = (r + l) / 2;
    if (q < mid)
        upd2(2 * v, l, mid, q, val);
    else
        upd2(2 * v + 1, mid, r, q, val);
    t1[v] = max(t1[v], t1[2 * v]);
}

int find2(int v, int l, int r, int ql, int qr)
{
    if (ql >= r || l >= qr)
        return -INF;
    if (ql <= l && r <= qr)
        return t1[v];
    int mid = (r + l) / 2;
    return max(find2(2 * v, l, mid, ql, qr), find2(2 * v + 1, mid, r, ql, qr));
}

vector<int> a;

void buildtree(int v, int l, int r)
{
    if (l + 1 == r)
    {
        t[v] = t1[v] = a[l];
        return;
    }
    int mid = (r + l) / 2;
    buildtree(2 * v, l, mid);
    buildtree(2 * v + 1, mid, r);
    t[v] = min(t[2 * v], t[2 * v + 1]);
    t1[v] = max(t1[2 * v], t1[2 * v + 1]);
}

const int N = 312345, LG = 20, R = 2;

int bin[R][LG][N];

int logs[N];

int find(int q, int l, int r)
{
    int x = logs[r - l + 1];
    return (q ? max(bin[q][x][l], bin[q][x][r - (1 << x) + 1]) : min(bin[q][x][l], bin[q][x][r - (1 << x) + 1]));
}

int solve()
{
   // ios::sync_with_stdio(0);
    int n;
    scanf("%d", &n);
    vector<int> l(n), r(n);
    a.assign(n, 0);
    for (int i = 0; i < n; i++)
        scanf("%d", &a[i]);
    buildtree(1, 0, n);
    for (int i = 0; i < n; i++)
        bin[0][0][i] = bin[1][0][i] = a[i];
    for (int i = 0; i + 1 < LG; i++)
        for (int j = 0; j + (1 << i) < n; j++)
        {
            bin[0][i + 1][j] = min(bin[0][i][j], bin[0][i][j + (1 << i)]);
            bin[1][i + 1][j] = max(bin[1][i][j], bin[1][i][j + (1 << i)]);
        }
    for (int i = 0; i < n; i++)
    {
        int le = -1, ri = i;
        while (ri - le > 1)
        {
            int mid = (ri + le) / 2;
          //  if (i == 3)
             //   cout << find2(1, 0, n, mid, i + 1) << endl;
            if (find(1, mid, i) <= a[i])
                ri = mid;
            else
                le = mid;
        }
        r[i] = ri;
        le = i, ri = n;
        while (ri - le > 1)
        {
            int mid = (ri + le) / 2;
            if (find(0, i, mid) >= a[i])
                le = mid;
            else
                ri = mid;
        }
        l[i] = le;
    }
    for (int i = 0; i < T; i++)
        t[i] = INF;
    vector<vector<int> > q(n);
    vector<int> dp(n, INF);
    swap(l, r);
    for (int i = 0; i < n; i++)
        q[r[i]].push_back(i);
    for (int i = 0; i < n; i++)
    {

        if (l[i] == 0 && r[0] < i)
        {
            l[i] = 1;
        }
        if (l[i] == 0)
        {
            dp[i] = 1;
        }
        else
        {
            dp[i] = find(1, 0, n, l[i] - 1, i) + 1;
         //   for (int j = l[i]; j <= i; j++)
             //   if (r[j] >= i)
                  //  dp[i] = min(dp[i], dp[j - 1] + 1);
        }
        upd(1, 0, n, i, dp[i]);
        for (int j : q[i])
             if (j)
                upd(1, 0, n, j - 1, INF);
    }
    cout << dp[n - 1] << endl;
    return 1;
}

int main()
{
    #ifdef ONPC
        freopen("in.txt", "r", stdin);
    #endif // ONPC
    for (int i = 1;; i++)
    {
        #ifdef ONPC
            cout << "Test #" << i << ":\n";
        #endif // ONPC
        if (solve())
            break;
        #ifdef ONPC
            cout << "_________________________\n";
        #endif
    }
    return 0;
}
