#define _CRT_SECURE_NO_WARNINGS
#include <iostream>
#include <algorithm>
#include <vector>
#include <set>
#include <queue>
#include <bitset>

using namespace std;

#define X first
#define Y second

const short MAXN = 610;
short n, m, k, x[MAXN], y[MAXN];
bool used[MAXN];
short pr[MAXN];
vector<short> ans;

bitset <MAXN> INF;
bitset <MAXN> *rez;
bitset <MAXN> *d[MAXN];

struct kek
{
	bitset<MAXN> *a;
	short b;
	kek(short v)
	{
		a = d[v];
		b = v;
	}
	kek()
	{
		a = NULL;
		b = -1;
	}
};

bitset<MAXN>* add(short v, short gd)
{
	short db = 0;
	bitset<MAXN> *an = new bitset<MAXN>();
	for (short i = 0; i < MAXN; i++)
	{
		if (i == gd)
			db = 1;
		if (db == 0)
		{
			(*an)[i] = (*d[v])[i];
		}
		else
		{
			if ((*d[v])[i])
			{
				(*an)[i] = 0;
			}
			else
			{
				db = 0;
				(*an)[i] = 1;
			}
		}
	}
	return an;
}

bool operator > (const bitset<MAXN> &A, const bitset<MAXN> &B)
{
	for (short i = MAXN - 1; i >= 0; i--)
	{
		if (A[i] != B[i])
			return A[i] > B[i];
	}
	return false;
}

bool operator < (const kek &A, const kek &B)
{
	return (*A.a) > (*B.a);
}

short ras(short a, short b)
{
	return max(abs(x[a] - x[b]), abs(y[a] - y[b]));
}

int main()
{
#if _DEBUG
	freopen("input.txt", "r", stdin);
	freopen("output.txt", "w", stdout);
#endif
	ios_base::sync_with_stdio(0);
	cin >> n >> m >> k;
	for (short i = 0; i < n + 10; i++)
	{
		INF[i] = 1;
	}

	for(short i = 0; i < k; i++)
		cin >> x[i] >> y[i];

	d[0] = new bitset<MAXN>();
	for (short i = 1; i < k; i++)
	{
		d[i] = new bitset<MAXN>(INF);
	}
	priority_queue<kek> q;
	q.push(kek(0));
	pr[0] = -1;
	while (q.size() > 0)
	{
		short tc = q.top().b;
		q.pop();
		if (used[tc])
			continue;
		used[tc] = true;
		for (short i = 0; i < k; i++)
		{
			rez = add(tc, ras(i, tc));
			if (*d[i] > *rez)
			{
				d[i] = rez;
				pr[i] = tc;
				q.push(kek(i));
			}
		}
	}


	short tc = k - 1;
	while (tc != -1)
	{
		ans.push_back(tc + 1);
		tc = pr[tc];
	}
	reverse(ans.begin(), ans.end());
	cout << ans.size() << endl;
	for (short i : ans)
		cout << i << " ";
	return 0;
}