#define _CRT_SECURE_NO_WARNINGS

#include <iostream>
#include <vector>
#include <string>
#include <algorithm>

using namespace std;

#define X first
#define Y second

const int MAXN = 110, LOG = 22;

int n;
string s[MAXN];
bool used[MAXN + LOG];
bool f;

bool chek(string &s)
{
	for (int i = 0; i < s.size(); i++)
	{
		if (s[i] == '1')
			return false;
	}
	return true;
}

bool chek(string &s, int po)
{
	for (int i = 0; i < s.size(); i++)
	{
		if (s[i] == '1' && i > po)
			return true;
	}
	return false;
}

bool build(int v, int st)
{
	if (st == -1)
	{
		return chek(s[v]);
	}

	if (chek(s[v], st))
		return false;

	if (used[st])
	{
		return build(v, st - 1);
	}
	if (build(v, st - 1))
		return true;
	if (st >= s[v].size() || s[v][st] == '0')
	{
		used[st] = true;
		return true;
	}
	else
	{
		s[v][st] = '0';
		used[st] = true;
		if (build(v, st - 1))
			return true;

		s[v][st] = '1';
		used[st] = false;
		return false;
	}
}

bool key(const string &a, const string &b)
{
	if (a.size() != b.size())
		return a.size() < b.size();
	for (int i = (int)a.size() - 1; i >= 0; i--)
	{
		if (a[i] != b[i])
			return a[i] < b[i];
	}
	return false;
}

int main()
{
#if _DEBUG
	freopen("input.txt", "r", stdin);
	freopen("output.txt", "w", stdout);
#endif
	ios_base::sync_with_stdio(0);
	cin >> n;
	for (int i = 0; i < n; i++)
	{
		cin >> s[i];
		reverse(s[i].begin(), s[i].end());
	}
	sort(s, s + n, key);
	for (int i = 0; i < n; i++)
	{
		build(i, 4);
	}

	f = false;
	for (int i = n + LOG; i >= 0; i--)
	{
		if (used[i])
		{
			cout << 1;
			f = true;
		}
		else
		{
			if (f)
				cout << 0;
		}
	}
	return 0;
}