#include <bits/stdc++.h>

using namespace std;

typedef long long ll;
typedef long double ld;

#define len(v) ((int)v.size())
#define all(v) v.begin(), v.end()
#define pb push_back
#define mp make_pair
// #define int ll

template<class t1, class t2>
bool cmin(t1 &a, const t2 &b)
{
	if (a > b)
	{
		a = b;
		return true;
	}
	return false;
}

template<class t1, class t2>
bool cmax(t1 &a, const t2 &b)
{
	if (a < b)
	{
		a = b;
		return true;
	}
	return false;
}

void run();

signed main()
{
	iostream::sync_with_stdio(0);
	cin.tie(0);
	cout.tie(0);
	run();
	return 0;
}

struct Sparse
{
	vector<vector<pair<int, int>>> table;
	vector<int> lg;

	Sparse(const vector<int> &arr)
	{
		lg.resize(len(arr) + 10);
		lg[0] = -1;
		for (int i = 1; i < len(lg); ++i)
			lg[i] = lg[i >> 1] + 1;
		table.pb(vector<pair<int, int>>());
		for (int i = 0; i < len(arr); ++i)
			table[0].pb({arr[i], i});
		for (int i = 0; len(arr) - (1 << (i + 1)) + 1 > 0; ++i)
		{
			table.pb(vector<int>(len(arr) - (1 << (i + 1)) + 1));
			for (int j = 0; j < len(table.back()); ++j)
				table.back()[j] = max(table[i][j], table[i][j + (1 << i)])
		}
	}

	int query(int l, int r)
	{
		int lvl = lg[r - l];
		auto x = max(table[lvl][l], table[lvl][r - (1 << lvl)]);
		return x.second;
	}
};

void run()
{
	int n;
	cin >> n;
	vector<int> arr(n);
	Sparse table(arr);
	for (auto &x : arr)
		cin >> x;
	vector<int> suf_max(n + 1, n);
	for (int i = n - 2; i > -1; --i)
	{
		suf_max[i] = suf_max[i + 1];
		if (arr[i] > arr[suf_max[i + 1] - 1])
			suf_max[i] = i + 1;
	}
	vector<pair<int, int>> st;
	vector<int> nxt(n, -1);
	for (int i = n - 1; i > -1; --i)
	{
		while (!st.empty() && st.back().first >= arr[i])
			st.pop_back();
		if (!len(st))
			nxt[i] = n;
		else
			nxt[i] = st.back().second;
		st.pb({arr[i], i});
	}
	int cnt = 0;
	int cur = 0;
	while (cur < n)
	{
		int c = min(table.query(cur, n), nxt[cur]);
		c = table.query(cur, c) + 1;
		cur = c;
		++cnt;
	}
	cout << cnt << endl;
}