#include <bits/stdc++.h>

using namespace std;

typedef long long ll;
typedef long double ld;

#define len(v) ((int)v.size())
#define all(v) v.begin(), v.end()
#define pb push_back
#define mp make_pair
// #define int ll

template<class t1, class t2>
bool cmin(t1 &a, const t2 &b)
{
	if (a > b)
	{
		a = b;
		return true;
	}
	return false;
}

template<class t1, class t2>
bool cmax(t1 &a, const t2 &b)
{
	if (a < b)
	{
		a = b;
		return true;
	}
	return false;
}

void run();

signed main()
{
	iostream::sync_with_stdio(0);
	cin.tie(0);
	cout.tie(0);
	run();
	return 0;
}

void make_op(vector<int> &arr, int l, int r)
{
	int k = ((r - l) >> 1);
	vector<int> a(r - l);
	for (int i = 0; i < r - l; ++i)
		a[(i >> 1) + ((i + 1) & 1) * k] = arr[i + l];
	for (int i = 0; i < r - l; ++i)
		arr[i + l] = a[i];
}

void run()
{
	int n;
	cin >> n;
	vector<int> arr(n);
	for (auto &x : arr)
	{
		cin >> x;
		--x;
	}
	vector<pair<int, int>> hist;
	for (int i = 0; i < n - 1; ++i)
	{
		int pos = 0;
		for (int j = 0; j < n; ++j)
			if (arr[j] == i)
			{
				pos = j;
				break;
			}
		assert(pos >= i);
		while (pos > i)
		{
			int l = i + (pos - i + 1) % 2;
			make_op(arr, l, pos + 1);
			hist.pb({l, pos + 1});
			pos = i + ((pos - i) >> 1);
		}
	}
	cout << len(hist) << endl;
	for (auto &x : hist)
		cout << x.first + 1 << " " << x.second << endl;
}