#include <bits/stdc++.h>

using namespace std;

int n;
vector<int> a;

vector<pair<int, int> > ans;

int shuffle(int l, int r)
{
    if ((r - l) % 2 == 0)
    {
        shuffle(r - 1, r);
        return shuffle(l, r - 1);
    }
    ans.push_back({l + 1, r + 1});
    int bck = a[r];
    vector<int> res;
    for (int i = l + 1; i <= r; i += 2) res.push_back(a[i]);
    for (int i = l; i <= r; i += 2) res.push_back(a[i]);
    for (int i = l; i <= r; ++i) a[i] = res[i - l];
    for (int i = l; i <= r; ++i)
        if (a[i] == bck) return i;

}

void nice_shuffle()
{
    for (int i = 0; i < n; ++i)
    {
        int pos = 0;
        for (int j = i; j < n; ++j)
            if (a[j] == i) pos = j;
        while (pos != i)
        {
            pos = shuffle(i, pos);
        }
    }
}

int main()
{
    for (int i = 0; i < n; ++i)
    {
        int pos = 0;
        for (int j = i; j < n; ++j)
            if (a[j] == i) pos = j;
        while (pos != i)
        {
            pos = shuffle(i, pos);
        }
    }
    cin >> n;
    a.resize(n);
    for (int i = 0; i < n; ++i) cin >> a[i];
    for (int i = 0; i < n; ++i) --a[i];
    nice_shuffle();
    vector<pair<int, int> > res;
    while (ans.size() > 15000)
    {
        shuffle(0, n - 1);
        res.push_back({1, n});
        ans.resize(0);
        nice_shuffle();
    }
    cout << ans.size() + res.size() << endl;
    for (int i = 0; i < res.size(); ++i) cout << res[i].first << " " << res[i].second << endl;
    for (int i = 0; i < ans.size(); ++i) cout << ans[i].first << " " << ans[i].second << endl;
}
