#include <iostream>

using namespace std;
int n;
int a[524288];
const int h = 524288;
pair<int, int> tmin[1048576];
void buildmin(int v, int vl, int vr) {
    if (vl + 1 == vr) {
        tmin[v] = {a[vl], vl};
        return;
    }
    int m = (vl + vr) / 2;
    buildmin(2 * v, vl, m);
    buildmin(2 * v + 1, m, vr);
    if (tmin[2 * v].first < tmin[2 * v + 1].first) {
        tmin[v] = tmin[2 * v];
    } else {
        tmin[v] = tmin[2 * v + 1];
    }
}
pair<int, int> getmin(int v, int vl, int vr, int al, int ar) {
    if (vl >= ar) {
        return {2e9, -1};
    }
    if (vr <= al) {
        return {2e9, -1};
    }
    if (al <= vl && ar >= vr) {
        return tmin[v];
    }
    int m = (vl + vr) / 2;
    pair<int, int> g1 = getmin(2 * v, vl, m, al, ar);
    pair<int, int> g2 = getmin(2 * v + 1, m, vr, al, ar);
    if (g1.first < g2.first) {
        return g1;
    }
    return g2;
}
pair<int, int> tmax[1048576];
void buildmax(int v, int vl, int vr) {
    if (vl + 1 == vr) {
        tmax[v] = {a[vl], vl};
        return;
    }
    int m = (vl + vr) / 2;
    buildmax(2 * v, vl, m);
    buildmax(2 * v + 1, m, vr);
    if (tmax[2 * v].first > tmax[2 * v + 1].first) {
        tmax[v] = tmax[2 * v];
    } else {
        tmax[v] = tmax[2 * v + 1];
    }
}
pair<int, int> getmax(int v, int vl, int vr, int al, int ar) {
    if (vl >= ar) {
        return {-1, -1};
    }
    if (vr <= al) {
        return {-1, -1};
    }
    if (al <= vl && ar >= vr) {
        return tmax[v];
    }
    int m = (vl + vr) / 2;
    pair<int, int> g1 = getmax(2 * v, vl, m, al, ar);
    pair<int, int> g2 = getmax(2 * v + 1, m, vr, al, ar);
    if (g1.first > g2.first) {
        return g1;
    }
    return g2;
}
int main() {
    cin >> n;
    for (int i = 0; i < n; i++) {
        cin >> a[i];
    }
    buildmax(1, 0, h);
    buildmin(1, 0, h);
    int i = 0;
    int cnt = 0;
    while (i < n) {
        int left = i;
        int right = n;
        while (right - left > 1) {
            int mid = (left + right) / 2;
            pair<int, int> g = getmin(1, 0, h, i, mid + 1);
            //cout << i << ' ' << mid << ' ' << g.first << endl;
            if (g.first == a[i]) {
                left = mid;
            } else {
                right = mid;
            }
        }
        //cout << left << endl;
        i = getmax(1, 0, h, i, right).second + 1;
        cnt++;
    }
    cout << cnt << endl;
}
