#include <iostream>
#include <vector>
#include <algorithm>
#include <stack>

using namespace std;

typedef long long ll;
typedef unsigned long long ull;

int main()
{
    int n;
    cin >> n;
    vector <int> a(n + 1);
    for (int i = 0; i < n; ++i)
    {
        cin >> a[i];
    }
    vector <int> next_up(n, -1);
    vector <int> next_low(n, -1);
    stack <int> cur;
    stack <int> idx;
    for (int i = n - 1; i >= 0; --i)
    {
        while (!cur.empty() && cur.top() >= a[i])
        {
            cur.pop();
            idx.pop();
        }
        if (cur.empty())
        {
            next_low[i] = n;
        }
        else
        {
            next_low[i] = idx.top();
        }
        cur.push(a[i]);
        idx.push(i);
    }
    while (!cur.empty())
    {
        cur.pop();
    }
    for (int i = n - 1; i >= 0; --i)
    {
        while (!cur.empty() && cur.top() < a[i])
        {
            cur.pop();
            idx.pop();
        }
        if (cur.empty())
        {
            next_up[i] = n;
        }
        else
        {
            next_up[i] = idx.top();
        }
        cur.push(a[i]);
        idx.push(i);
    }
    int L = 0, R = next_low[0];
    int i = 0;
    int ans = 0;
    while (i < n)
    {
        //cout << L << " " << R << endl;
        while (i < n && i < R && next_up[i] < R)
        {
            ++i;
        }
        ans++;
        ++i;
        if (i != n){
            L = i;
            R = next_low[i];
        }
    }
    cout << ans << endl;
    return 0;
}
