#include <iostream>
#include <vector>
#include <cmath>
#include <unordered_set>
#include <algorithm>

using namespace std;

namespace std
{
template<>
struct hash<pair<long double, int> >
{
auto operator()(const pair<long double, int>&it) const
{
    return std::hash<long double>()(it.first)^std::hash<int>()(it.second);
}
};
}

int main()
{
    int n, m, k;
    cin >> n >> m >> k;
    pair<int, int> items[k];
    for(int i = 0; i < k; i++)
        cin >> items[i].first >> items[i].second;
    sort(items, items + k);
    vector<int> ans;
    ans.push_back(1);
    int cur = 1;
    while(cur != n - 1)
    {
        int j = cur + 1;
        pair<int, int> it = make_pair((1 << 31) - 1, -1);
        while(j - cur < abs(items[j].second - items[cur].second))
        {
            it = min(it, make_pair(min(j - cur, abs(items[j].second - items[cur].second)), j));
        }
        cur = it.second;
        ans.push_back(cur);
    }
    cout << ans[0];
    for(int i = 1; i < ans.size(); i++)
        cout << ' ' << ans[i];
    cout << endl;
    return 0;
}
