#include <iostream>
#include <vector>
using namespace std;

const int MAXN = 3e5 + 10;
const int INF = 1e9 + 7;
int a[MAXN];

int nx[MAXN];


int getmx(int L, int R){
    int MX = -INF;
    int mxid = 0;
    for (int i = L; i <= R; i++){
        if (MX < a[i]){
            mxid = i;
            MX = a[i];
        }
    }
    return mxid;
}

int get(int L, int R){
    if (L == R){
        return 1;
    }
    if (L > R){
        return 0;
    }
    int mxid = getmx(L, R);
    int i = mxid;
    while ((nx[i] != -1) and (nx[i] >= L)){
        i = nx[i];
    }
    /*
    cout << L + 1 << ' ' << R + 1 << ' ' << endl;
    cout << mxid + 1 << ' ' << i << ' ' << endl;
    cout << endl;
    */
    return get(L, i - 1) + 1 + get(mxid + 1, R);
}

int main(){
    int n;
    ios_base::sync_with_stdio(false);
    cin.tie(0);
    cout.tie(0);
    cin >> n;
    for (int i = 0; i < n; i++){
        cin >> a[i];
    }
    /*
    vector <pair <int, int> > st;

    for (int i = 0; i < n; i++){
        while ((st.size() > 0) and (a[i] < st[st.size() - 1].first)){
            st.pop_back();
        }
        if (st.size() == 0){
            nx[i] = -1;
        }
        else{
            nx[i] = st[st.size() - 1].second;
        }
        if ((st.size() > 0) and (st[st.size() - 1].first == a[i])){
            st.pop_back();
        }
        st.push_back(make_pair(a[i], i));
    }
    */
    /*
    for (int i = 0; i < n; i++){
        cout << a[i] << ' ';
    }
    cout << endl;
    for (int i = 0; i < n; i++){
        cout << nx[i] + 1 << ' ';
    }
    cout << endl;
    for (int i = 0; i < n; i++){
        if (nx[i] == -1){
            cout << 0;
        }
        else{
            cout << a[nx[i]];
        }
        cout << ' ';
    }
    cout << endl;
*/

    /*
    cout << get(0, n - 1) << endl;
    */
    int ans = 0;
    int L = 0;

    while (L < n){
        int MXR = L + 1;
        int mx = a[L];
        int mn = a[L];
        for (int R = L + 1; R < n; R++){
            mx = max(mx, a[R]);
            mn = min(mn, a[R]);
            if (mn < a[L]){
                break;
            }
            if (mx == a[R]){
                MXR = R + 1;
            }
        }
        ans += 1;
        L = MXR;
    }
    cout << ans << endl;

}
