#include <iostream>
#include <algorithm>
#include <vector>
#include <string>

using namespace std;

#define all(x) x.begin(),x.end()

void S(vector <int> &B, int l, int r)
{
	vector <int> check;
	for (int i = l + 1; i <= r; i+=2)
	{
		check.push_back(B[i]);
	}
	for (int i = l; i <= r; i += 2)
	{
		check.push_back(B[i]);
	}
	for (int i = l, j = 0; i <= r; i++, j++)
	{
		B[i] = check[j];
	}
}

signed main()
{
#ifdef  _DEBUG
	freopen("input.txt", "r", stdin);
	freopen("output.txt", "w", stdout);
#endif 
	ios_base::sync_with_stdio(0);
	cin.tie(0);
	int n;
	cin >> n;
	vector <int> A(n + 1);
	vector <int> maxs;
	vector <int> mins(n + 1);

	for (int i = 0; i < n; i++)
	{
		cin >> A[i];
		if (i != 0)
		{
			if (A[mins[i - 1]] >= A[i])
				mins[i] = i;
			else
				mins[i] = mins[i - 1];
		}
		if (maxs.size() == 0 || A[maxs.back()] <= A[i])
		{
			maxs.push_back(i);
		}
	}
	A[n] = 1e9;
	if (A[mins[n - 1]] >= A[n])
		mins[n] = n;
	else
		mins[n] = mins[n - 1];

	int last = -1;
	int lastMax = 0;
	int cnt = 0;
	for (int i = 0; i < n; i = last + 1)
	{
		cnt++;
		if (i == n - 1)
			maxs.push_back(n);

		int l = lastMax - 1, r = maxs.size(), m;
		while (r - l > 1)
		{
			m = (r + l) / 2;
			if (A[mins[maxs[m]]] < A[i])
			{
				r = m;
			}
			else
			{
				l = m;
			}
		}
		if (l == lastMax - 1)
		{
			last++;
		}
		else
		{
			lastMax = l + 1;
			last = maxs[l];
		}
	}
	cout << cnt << endl;
	return 0;
}
