#include <iostream>
#include <vector>

using namespace std;

const int INF = 1e9;

int main() {
    cin.sync_with_stdio(0);
    cin.tie(0);
    int n;
    cin >> n;
    vector<int> arr(n + 1);
    for (int i = 1; i <= n; i++) cin >> arr[i];
    vector<int> dp(n + 1);
    for (int i = 1; i <= n; i++) {
        int mn = arr[i];
        dp[i] = dp[i - 1] + 1;
        for (int j = i; j > 0; j--) {
            if (arr[j] <= mn) {
                dp[i] = min(dp[i], dp[j]);
            }
            if (arr[j] > arr[i]) break;
            mn = min(mn, arr[j]);
        }
    }
    cout << dp[n] << endl;
    return 0;
}