#include <bits/stdc++.h>

using namespace std;

#define int int64_t
#define se second
#define fi first
#define mp make_pair
#define endl '\n'

template <typename T1, typename T2>
ostream & operator << (ostream & out, pair <T1, T2> p)
{
    out << p.fi << " " << p.se << endl;
    return out;
}

template <typename T1, typename T2>
istream & operator >> (istream & in, pair <T1, T2> & p) {
    in >> p.fi >> p.se;
    return in;
}

template <typename T>
istream & operator >> (istream & in, vector <T> & arr) {
    for (auto & x : arr)
        in >> x;
    return in;
}

template <typename T>
ostream & operator << (ostream & out, vector <T> arr) {
    for (auto x : arr)
        out << x << " ";
    out << endl;
    return out;
}

vector <vector <int> > g;

void dijkstra(int s, int f) {
    int n = g.size();
    vector <int> d(n, 1e18);
    vector <bool> used(n, false);
    d[s] = 0;
    vector <int> prev(n);

    prev[s] = -1;
    for (int i = 0; i < n; ++i) {
        int u = -1;
        for (int j = 0; j < n; ++j) {
            if (!used[j] && (u == -1 || d[u] > d[j]))
                u = j;
        }
        used[u] = true;
        for (int j = 0; j < n; ++j) {
            if (d[j] > d[u] + g[u][j]) {
                d[j] = d[u] + g[u][j];
                prev[j] = u;
            }
        }
    }
    int now = f;
    vector <int> ans;
    while (now != -1) {
        ans.push_back(now + 1);
        now = prev[now];
    }
    reverse(ans.begin(), ans.end());
    cout << ans.size() << endl;
    cout << ans << endl;
}

signed main()
{
    //ios::sync_with_stdio(false);
    //cin.tie(0);
    //cout.tie(0);


    int n, m, k;
    cin >> n >> m >> k;
    vector <pair <int, int> > arr(k);
    cin >> arr;
    g.resize(k, vector <int> (k));
    for (int i = 0; i < k; ++i) {
        for (int j = 0; j < k; ++j) {
            if (i == j)
                continue;
            g[i][j] = (1ll << (max(abs(arr[i].fi - arr[j].fi), abs(arr[i].se - arr[j].se))));
        }
    }
    //cout << "g = " << endl << " " << g << endl;
    dijkstra(0, k - 1);

    return 0;
}
