#pragma GCC optimize("O3")
#include <bits/stdc++.h>

using namespace std;

#define fi first
#define se second
#define mp make_pair
#define endl '\n'

template <typename T1, typename T2>
ostream & operator << (ostream & out, pair <T1, T2> p) {
    out << p.fi << ' ' << p.se;
    return out;
}

template <typename T1, typename T2>
istream & operator >> (istream & in, pair <T1, T2> & p) {
    in >> p.fi >> p.se;
    return in;
}

template <typename T>
ostream & operator << (ostream & out, vector <T> arr) {
    for (auto x : arr)
        out << x << ' ';
    out << endl;
    return out;
}

template <typename T>
istream & operator >> (istream & in, vector <T> & arr) {
    for (auto & x : arr)
        in >> x;
    return in;
}

signed main()
{
    ios::sync_with_stdio(false);
    cin.tie(0);
    cout.tie(0);

    int n;
    cin >> n;
    vector <int> arr(n);
    cin >> arr;

    vector <int> mn, mx;
    vector <int> mxp(n), mnx(n);
    for (int i = n - 1; i >= 0; --i) {
        while (mx.size() > 0 && arr[i] > arr[-mx.back()]) {
            mx.pop_back();
        }
        while (mn.size() > 0 && arr[i] <= arr[-mn.back()]) {
            mn.pop_back();
        }
        //cout << "i = " << i << endl;
        //cout << "mxp = " << mx << endl;
        //cout << "mn = " << mn << endl;
        int r = n;
        if (mn.size() > 0)
            r = -mn.back();
        mn.push_back(-i);
        mx.push_back(-i);
        //cout << "r = " << r << endl;
        auto it = lower_bound(mx.begin(), mx.end(), -r);
        mxp[i] = -*it;
    }
    int cnt = 0;
    int j = 0;
    while (j < n) {
        cnt++;
        //cout << "J = " << j << endl;
        j = mxp[j] + 1;
    }
    //cout << mxp << endl;
    cout << cnt << endl;
    return 0;
}
