#define _CRT_SECURE_NO_WARNINGS

#pragma gcc ooptimize("Ofast,unroll-loops")
#pragma gcc options("sse,sse2,sse3,sse4,popcnt")

#include <iostream>
#include <iomanip>
#include <string>
#include <vector>
#include <set>
#include <unordered_set>
#include <map>
#include <unordered_map>
#include <bitset>
#include <math.h>
#include <deque>
#include <iterator>
#include <algorithm>
#include <climits>

using namespace std;
using ll = long long;
using ld = long double;
using ipair = pair<int, int>;

#define all(x) x.begin(), x.end()
#define rall(x) x.rbegin(), x.rend()
#define pb push_back
#define pf push_front
#define ppb pop_back
#define ppf pop_front
#define vect vector

signed main() {
	int n, m, q; scanf("%d%*c%d%*c%d%*c", &n, &m, &q);
	vect<vect<int>> vals(n, vect<int>(m));
	vect<set<int>> xs(n), ys(m);
	set<int> ans;
	for (int i = 0; i < n; ++i) {
		for (int j = 0; j < m; ++j) {
			scanf("%d%*c", &vals[i][j]);
			xs[i].insert(vals[i][j]);
			ys[j].insert(vals[i][j]);
		}
	}
	for (int i = 0; i < n; ++i) {
		for (int j = 0; j < m; ++j) {
			if (*xs[i].rbegin() == *ys[j].rbegin()) {
				ans.insert(*xs[i].rbegin());
			}
		}
	}

	for (int i = 0; i < q; ++i) {
		int x, y, nv; scanf("%d%*c%d%*c%d%*c", &x, &y, &nv); --x; --y;
		int cx = *xs[x].rbegin();
		int cy = *ys[y].rbegin();
		if (nv > cx) { ans.erase(cx); }
		if (nv > cy) { ans.erase(cy); }
		xs[x].erase(vals[x][y]); ys[y].erase(vals[x][y]);
		xs[x].insert(nv); ys[y].insert(nv);
		if (*xs[x].rbegin() == nv && *ys[y].rbegin() == nv) { ans.insert(nv); }
		vals[x][y] = nv;
		printf("%d\n", ans.size());
	} 
	system("pause");
}