#include <iostream>
#include <algorithm>
#include <cstdio>
#include <cassert>
#include <vector>
#include <map>

using namespace std;

#define int int64_t

const int MAXN = 100;

int res[MAXN][MAXN];

int32_t main() {
    //freopen("input.txt", "r", stdin);

    ios_base::sync_with_stdio(false);

    for (int i = 0; i < MAXN; i++)
        for (int j = 0; j < MAXN; j++)
            res[i][j] = 0;

    int n; cin >> n;
    for (int i = 0; i < n; i++) {
        int a, b; cin >> a >> b;
        for (int x = 0; x < MAXN; x++)
            for (int y = 0; y <= a; y++)
                res[x][y] += y;
        for (int x = 0; x <= b; x++)
            for (int y = a + 1; y < MAXN; y++)
                res[x][y] += x;
    }

    int ans = 0;
    for (int i = 0; i < MAXN; i++)
        for (int j = 0; j < MAXN; j++)
            ans = max(ans, res[i][j]);

    cout << ans << endl;

    return 0;
}
