#include <iostream>
#include <algorithm>
#include <cstdio>
#include <vector>
#include <cassert>
#include <set>

using namespace std;

const int MAXN = 1000;

int n;
int a[MAXN], res[MAXN];

int main() {
    //freopen("input.txt", "r", stdin);
    ios_base::sync_with_stdio(false);

    int p; cin >> n >> p;
    for (int i = 0; i < n; i++)
        cin >> a[i];

    for (int i = 0; i < n; i++) {
        int maxcnt = 0;
        for (int j = 0; i + j < n - 1 && i - j > 0; j++) {
            int cnt = 0;
            for (int k = 0; k < n; k++)
                res[k] = a[k];
            for (int k = max(0, i - j); k <= min(n - 1, i + j); k++)
                res[k] = a[k] + j + 1 - abs(i - k);
            for (int k = 0; k < n; k++)
                if (res[k] < res[i])
                    cnt++;
            if (cnt > maxcnt)
                maxcnt = cnt;
        }

        for (int j = 0; j < n; j++) {
            int cnt = 0;
            for (int k = 0; k < n; k++)
                res[k] = a[k] + max(k - j, 0);
            for (int k = 0; k < n; k++)
                if (res[k] < res[i])
                    cnt++;
            if (cnt > maxcnt)
                maxcnt = cnt;
        }
        for (int j = n - 1; j >= 0; j--) {
            int cnt = 0;
            for (int k = 0; k < n; k++)
                res[k] = a[k] + max(j - k, 0);
            for (int k = 0; k < n; k++)
                if (res[k] < res[i])
                    cnt++;
            if (cnt > maxcnt)
                maxcnt = cnt;
        }

        cout << maxcnt + 1 << endl;
    }

    return 0;
}
