#include <iostream>
#include <algorithm>
#include <cstdio>
#include <vector>
#include <cassert>
#include <set>

using namespace std;

const int MAXN = 5e5;

int n;
int a[MAXN], res[MAXN];

vector <int> all;
int add;

void init() {
    all.clear();
}

void insert(int v) {
    all.push_back(v);
}

int get_lt(int v) {
    int res = 0;
    for (int i = 0; i < (int)all.size(); i++)
        if (all[i] < v)
            res++;
    return res;
}

int main() {
    //freopen("input.txt", "r", stdin);
    ios_base::sync_with_stdio(false);

    int p; cin >> n >> p;
    for (int i = 0; i < n; i++)
        cin >> a[i];

    fill(res, res + MAXN, 0);

    init(); add = 0;
    for (int i = 0; i < n; i++) {
        res[i] += get_lt(a[i] - add);
        insert(a[i] - add);
        add++;
    }
    init(); add = 0;
    for (int i = n - 1; i >= 0; i--) {
        res[i] += get_lt(a[i] - add);
        insert(a[i] - add);
        add++;
    }

    for (int i = 0; i < n; i++)
        cout << res[i] + 1 << endl;

    return 0;
}
