#include <iostream>
#include <vector>
#include <cassert>
#include <set>
#include <string>
#include <algorithm>
#include <cstdio>
#define FOR(i, n) for (int i = 0; i < n; ++i)
typedef long long ll;
const int N = 3e5;
std::string lexmin(std::string a, std::string b) {
	for (int i = 0; i < std::min(a.size(), b.size()); ++i) {
		if (a[i] < b[i]) {
			return a;
		}
		if (a[i] > b[i]) {
			return b;
		}
	}
	return a;
}

int main() {
	int n;
	std::cin >> n;
	std::vector<std::string>a(n);
	FOR(i, n) {
		std::cin >> a[i];
		std::reverse(a[i].begin(), a[i].end());
	}
	if (n != 2) {
		std::vector<int> used(10000);
		FOR(i, n) {
			FOR(j, a[i].size()) {
				if (a[i][j] == '1') {
					for (int q = j; q < 10000; ++q) {
						if (!used[q]) {
							used[q] = 1;
							break;
						}
					}
				}
			}
		}
		bool fl = false;
		for (int i = used.size() - 1; i >= 0; --i) {
			if (used[i] == 1) {
				fl = 1;
			}
			if (fl) {
				std::cout << used[i];
			}
		}
	}
	else {
		std::string first = a[0], second = a[1];
		int n1 = std::min(first.size(), second.size());
		while (second.size() < std::max(first.size(), second.size())) {
			second.push_back('0');
		}
		while (first.size() < std::max(first.size(), second.size())) {
			first.push_back('0');
		}
		n1 = first.size();
		std::string now = "";
		for (int i = n1 - 1; i >= 0; --i) {
			if (first[i] == '1' && second[i] == '1') {
				int j;
				for (j = i; j < n1; ++j) {
					if (first[j] != '1' && second[j] != '1') {
						break;
					}
					if ((int)now.size() - (j - i) - 1 >= 0)
						now[now.size() - (j - i) - 1] = '0';
				}
				std::string firstSuf = first.substr(0, j), secondSuf = second.substr(0, j);
				std::reverse(firstSuf.begin(), firstSuf.end());
				std::reverse(secondSuf.begin(), secondSuf.end());
				std::string normnow = now;
				std::string answer = normnow + lexmin(firstSuf, secondSuf);
				if (((int)answer.size() - j - 1) < 0)
					answer = "1" + answer;
				else
					answer[(answer.size() - j - 1)] = '1';
				bool fl = false;
				FOR(q, answer.size()) {
					if (answer[q] == '1') {
						fl = true;
					}
					if (fl) {
						std::cout << answer[q];
					}
				}
				return 0;
			}
			if (first[i] == '1' || second[i] == '1') {
				now.push_back('1');
			}
			else {
				now.push_back('0');
			}
		}
		std::cout << now;
	}
	return 0;
}