#include <bits/stdc++.h>

using namespace std;

typedef long long ll;

const int INF = (int) 1e9 + 1e6 + 123;
const ll LINF = (ll) 1e18 + 1e9 + 123;

#define rep(i, s, t) for (auto i = (s); i < (t); ++(i))
#define per(i, s, t) for (auto i = (s); i >= (t); --(i))
#define sz(x) ((int)(x).size())
#define all(x) (x).begin(), (x).end()
#define mp make_pair
#define pb push_back

bool mini(auto &x, const auto &y) {
	if (y < x) {
		x = y;
		return 1;
	}
	return 0;
}

bool maxi(auto &x, const auto &y) {
	if (y > x) {
		x = y;
		return 1;
	}
	return 0;
}

void run();

int main() {
	ios::sync_with_stdio(0);
	cin.tie(0);
	cout.tie(0);
	run();
	return 0;
}

const int N = (int) 3e5 + 123;
const int LEN = 550;
const int K = N / LEN;

int n;
pair<int, int> a[N];
int ptr;
map<int, int> kek;
int lol[N];
ll f[N];
ll ans;
vector<pair<ll, int>> st[K];
int qq[K];
int made_ops[K];

ll div_up(ll x, ll y) {
	return (x + y - 1) / y;
}

ll steps(int i, int j) {
	return max(0LL, div_up(f[i] - f[j], lol[j] - lol[i]));
}

void rebuild(int id) {
	qq[id] = 0;
	st[id].clear();
	rep(i, LEN * id, LEN * id + LEN) {
		f[i] += made_ops[id] * 1LL * lol[i];
		while (sz(st[id]) && steps(st[id].back().second, i) <= st[id].back().first) {
			st[id].pop_back();
		}
		if (sz(st[id])) {
			st[id].pb({steps(st[id].back().second, i), i});
		} else {
			st[id].pb({0, i});
		}
	}
	made_ops[id] = 0;
}

void add(int pos) {
	int bl = pos / LEN;
	rep(i, 0, bl) {
		made_ops[i]++;
	}
	rep(i, bl * LEN, pos + 1) {
		f[i] += lol[i];
	}
	rebuild(bl);
}

ll get(int id) {
	while (qq[id] < sz(st[id]) && st[id][qq[id]].first <= made_ops[id]) qq[id]++;
	//~ int ind = (int) (upper_bound(all(st[id]), mp((ll)made_ops[id], INF)) - st[id].begin()) - 1;
	//~ assert(ind >= 0);
	int ind = qq[id] - 1;
	int ps = st[id][ind].second;
	return f[ps] + made_ops[id] * 1LL * lol[ps];
}

void run() {
	cin >> n;
	rep(i, 0, n) {
		cin >> a[i].first >> a[i].second;
		kek[a[i].first]++;
		kek[a[i].second]++;
	}
	for (auto &it : kek) {
		lol[ptr] = it.first;
		it.second = ptr++;
	}
	rep(j, ptr, N) lol[j] = lol[j - 1] + 1;
	
	rep(i, 0, n) {
		a[i].first = kek[a[i].first];
		a[i].second = kek[a[i].second];
	}
	
	sort(a, a + n);
	rep(bl, 0, K) rebuild(bl);
	rep(i, 0, n) {
		ll cur = (n - i) * 1LL * lol[a[i].first];
		rep(bl, 0, K) maxi(ans, cur + get(bl));
		add(a[i].second);
	}
	
	cout << ans << "\n";
}
