#include <iostream>
#include <vector>
#include <algorithm>

using namespace std;

vector <vector <int> > g;
vector <bool> used;
vector <bool> anc;

void dfs(int v) {
	used[v] = true;
	for (int i = 0; i < g[v].size(); i++)
		if (!used[g[v][i]]) {
			anc[v] = true;
			dfs(g[v][i]);
		}
}

int main() {
	int n, v, c, p, ans = 0;
	cin >> n;
	g.resize(n);
	for (int i = 0; i < n; i++) {
		cin >> v;
		v--;
		c = 1;
		while (v != i) {
			g[i].push_back(v);
			cin >> v;
			c++;
			v--;
		}
		for (int j = c; j < n; j++)
			cin >> v;
	}
	cin >> p;
	if (p == 1) {
		for (int i = 0; i < n; i++)
			if (g[i].empty())
				ans++;
		cout << ans << endl;
		for (int i = 0; i < n; i++)
			if (g[i].empty())
				cout << i + 1 << " ";
	}
	else {
		bool cond;
		used.resize(n);
		anc.resize(n);
		vector <bool> for_ans(n, false);
		for (int i = 0; i < n; i++) {
			cond = true;
			for (int j = 0; j < n; j++) {
				used[i] = false;
				anc[i] = false;
			}
			dfs(i);
			for (int j = 0; j < g[i].size(); j++) {
				if (!anc[g[i][j]])
					cond = false;
			}
			if (cond) {
				ans++;
				for_ans[i] = true;
			}
		}
		cout << ans << endl;
		for (int i = 0; i < n; i++) {
			if (for_ans[i])
				cout << i + 1 << " ";
		}
	}
    return 0;
}

