#include <iostream>
#include <iomanip>
#include <vector>
#include <set>
#include <map>
#include <string>
#include <queue>
#include <deque>
#include <algorithm>
#include <ctime>
#include <cmath>

using namespace std;

#define int long long
#define sz(a) ((int)a.size())
#define pb emplace_back

int check(int inno_plus, int inno, vector<int> &a, vector<int> &b) {
	int ans = 0;
	for (int i = 0; i < sz(a); i++) {
		if (a[i] >= inno_plus) {
			ans += inno_plus;
		}
		else if (b[i] >= inno) {
			ans += inno;
		}
	}
	return ans;
}

signed main() {
	int n;
	cin >> n;
	vector<int> a(n), b(n);
	int ans = -1;
	for (int i = 0; i < n; i++) {
		cin >> a[i] >> b[i];
	}
	if (count(b.begin(), b.end(), 0) != sz(b)) {
		for (int i = 0; i < n; i++) {
			for (int j = 0; j < n; j++) {
				ans = max(ans, check(a[i], b[j], a, b));
			}
		}
	}
	else {
		sort(a.begin(), a.end());
		for (int i = sz(a) - 1; i >= 0; i--) {
			ans = max(ans, a[i] * (sz(a) - i));
		}
	}
	cout << ans;
	return 0;
}