#include <bits/stdc++.h>
 
#define mp make_pair
 
typedef std::pair<int, int> pii;
 
void solve(int* a, int* b, int* c, int n)
{
    for (int i = 0; i <= n; ++i)
        c[i] = 0;
    int yk = n - 1;
    while (yk >= 0 && (!a[yk] || !b[yk]))
        --yk;
    if (yk >= 0)
    {
        while (yk < n && (a[yk] || b[yk]))
            ++yk;
        int memyk = yk - 1;
        while (memyk >= 0 && a[memyk] == b[memyk])
            --memyk;            
        if (memyk >= 0 && a[memyk] > b[memyk])
            for (int i = 0; i < yk; ++i)
                a[i] = 0;
        else
            for (int i = 0; i < yk; ++i)
                b[i] = 0;        
        c[yk] = 1;
    }
    yk = n - 1;        
    while (yk >= 0)
    {
        c[yk] = a[yk] | b[yk] | c[yk];
        --yk;
    }
}

void print(int* c, int n)
{
    int yk = n;
    while (c[yk] == 0)
        --yk;
    for (; yk >= 0; --yk)
        printf("%d", c[yk]);
    printf("\n");
}

namespace alpha
{
void get_ans()
{
    std::string s1;
    std::string s2;
    std::cin >> s1 >> s2;
    int len1 = s1.length(), len2 = s2.length();
    int n = std::max(len1, len2);
    int a[n], b[n];
    for (int i = 0; i < len1; ++i)
        a[len1 - i - 1] = s1[i] - '0';
    for (int i = 0; i < s2.length(); ++i)
        b[len2 - i - 1] = s2[i] - '0';
    for (int i = len1; i < n; ++i)
        a[i] = 0;
    for (int i = len2; i < n; ++i)
        b[i] = 0;
    int c[n + 1];
    solve(a, b, c, n);
    print(c, n);
}
}

namespace beta
{
    int hlp(int* ans, int* nxt, int a)
    {
        if (ans[a] == 0)
            return a;
        int res = hlp(ans, nxt, nxt[a]);
        nxt[a] = res + 1;
        return res;
    }

    void get_ans(int n)
    {
        int a[n];
        for (int i = 0; i < n; ++i)
        {
            std::string s;
            std::cin >> s;
            a[i] = 0;
            int len = s.length();
            while (s[len - a[i] - 1] == '0')
                ++a[i];
        }
        int ans[600000];
        for (int i = 0; i < 600000; ++i)
            ans[i] = 0;
        int nxt[6000000];
        for (int i = 0; i < 600000; ++i)
            nxt[i] = i + 1;
        for (int i = 0; i < n; ++i)
             ans[hlp(ans, nxt, a[i])] = 1;
        print(ans, 600000 - 1);
    }
}

int main()
{
    int n;           
    while (scanf("%d", &n) == 1)
        if (n == 2) 
            alpha::get_ans();
        else
            beta::get_ans(n);
    return 0;
}