import java.util.*;

public class B {
    static int n, a[][], b[][], p;
    static TreeSet<Integer> set[];

    public static void main(String[] args) {
        Scanner in = new Scanner(System.in);
        n = in.nextInt();
        a = new int[n][n];
        b = new int[n][n];
        for (int i = 0; i < n; i++) {
            for (int j = 0; j < n; j++) {
                a[i][j] = in.nextInt() - 1;
                b[i][a[i][j]] = j;
            }
        }
        if (in.nextInt() == 1) {
            ArrayList<Integer> ans = new ArrayList();
            for (int i = 0; i < n; i++) {
                if (b[i][i] == 0) {
                    ans.add(i + 1);
                }
            }
            Collections.sort(ans);
            System.out.println(ans.size());
            for (int i = 0; i < ans.size(); i++) {
                System.out.print(ans.get(i) + " ");
            }
        } else {
            set = new TreeSet[n];
            for (int i = 0; i < n; i++) {
                set[i] = new TreeSet<>();
                for (int j = 0; j < n; j++) {
                    set[i].add(a[i][j]);
                    if (a[i][j] == i) {
                        break;
                    }
                }
            }
            int[] max = new int[n];
            Arrays.fill(max, -1);
            for(int i = 0; i < n; i++){
                for(int j = 0; j < n; j++){
                    max[i]++;
                    boolean flag = true;
                    for(int k = 0; k < n; k++){
                        if(!intersect(j, a[i], set[k])){
                            flag = false;
                        }
                    }
                    if(!flag){
                        break;
                    }
                }
            }
            boolean good[] = new boolean[n];
            for(int i = 0; i < n; i++){
                for(int j = 0; j <= max[i]; j++){
                    good[a[i][j]] = true;
                }
            }
            int counter = 0;
            for(int i = 0; i < n; i++){
                if(good[i]){
                    counter++;
                }
            }
            System.out.println(counter);
            for(int i = 0; i < n; i++){
                if(good[i]){
                    System.out.print((i + 1) + " ");
                }
            }
        }
    }
    static boolean intersect(int m, int x[], TreeSet s){
        for(int i = m; i < n; i++){
            if(s.contains(x[i])){
                return true;
            }
        }
        return false;
    }
}
