#include <iostream>
#include <vector>

using namespace std;
int n;
vector<int> a;
int k;
vector<vector<int>> x;
vector<vector<int>> y;
vector<int> pow;

int log(int m) {
    int ans = 0;
    while (m > 1) {
        m /= 2;
        ans++;
    }
    return ans;
}

int compMin(int i, int j) {
    int p = min(i, j);
    int q = max(i, j);
    if (q >= n) {
        return p;
    }
    if (a[p] <= a[q]) {
        return p;
    }
    return q;
}

int compMax(int i, int j) {
    int p = min(i, j);
    int q = max(i, j);
    if (q >= n) {
        return p;
    }
    if (a[p] > a[q]) {
        return p;
    }
    return q;
}

int Min(int l, int r) {
    if (l > r) {
        return n;
    }
    if (l == r) {
        return l;
    }
    int Log = log(r - l + 1);
    return compMin(x[Log][l], Min(l + pow[Log], r));
}

int Max(int l, int r) {
    if (l > r) {
        return n;
    }
    if (l == r) {
        return l;
    }
    int Log = log(r - l + 1);
    return compMax(y[Log][l], Max(l + pow[Log], r));
}
void table() {
    k = log(n);
    vector<int> buffer;
    buffer.resize(n);
    for (int i = 0; i = k; i++) {
        x.push_back(buffer);
        y.push_back(buffer);
    }
    pow.resize(k + 1);
    pow[0] = 1;
    for (int j = 1; j <= k; j++) {
        pow[j] = 2 * pow[j - 1];
    }
    for (int i = 0; i < n; i++) {
        x[0][i] = i;
        y[0][i] = i;
    }
    for (int j = 1; j <= k; j++) {
        for (int i = 0; i < n; i++) {
            x[j][i] = compMin(x[j - 1][i], x[j - 1][min(i + pow[j - 1], n - 1)]);
            y[j][i] = compMax(y[j - 1][i], y[j - 1][min(i + pow[j - 1], n - 1)]);
        }
    }
}
int solve(int l, int r) {
    if (l > r) {
        return 0;
    }
    if (l == r) {
        return 1;
    }
    int max = Max(l, r);
    int min = Min(l, r);
    if (a[min] != a[l]) {
        return solve(l, min - 1) + solve(min, r);
    }
    if (a[max] != a[r]) {
        return solve(l, max) + solve(max + 1, r);
    }
    return 1;
}

int main() {
    cin >> n;
    a.resize(n);
    for (int i = 0; i < n; i++) {
        cin >> a[i];
    }
    table();
    cout << solve(0, n - 1);
    return 0;
}
