#define _CRT_SECURE_NO_WARNINGS
#include <iostream>
#include <vector>
#include <algorithm>
#include <set>
#include <bitset>
using namespace std;

int p[500][500], n;
bitset<4> atack[500], tmp, good;

bool check(int x) {
	vector<int> enemy;
	int i;
	good.reset();
	for (i = 0; i < n; i++) {
		if (p[i][x] > p[i][i])
			enemy.emplace_back(i), good.set(i);
	}
	for (i = 0; i < n; i++) {
		if (!atack[x][i])
			continue;
		tmp.reset();
		for (int j : enemy)
			if (p[i][j] > p[i][x])
				tmp = (tmp | atack[j]);
		if ((tmp & good) == good)
			return 1;
	}
	return 0;
}

int main() {
	//-------------------------------------------------------------
	ios::sync_with_stdio(0), cin.tie(0), cout.tie(0);//
	//freopen("Text.txt", "r", stdin);                           //
	//-------------------------------------------------------------
	cin >> n;
	int i, j, temp;
	for (i = 0; i < n; i++)
		for (j = 0; j < n; j++) {
			cin >> temp;
			p[i][temp - 1] = j;
		}
	vector<int> ans;
	int type;
	cin >> type;
	if (type == 1) {
		for (i = 0; i < n; i++)
			if (0 == p[i][i])
				ans.emplace_back(i + 1);
	}
	else {
		for (i = 0; i < n; i++)
			for (j = 0; j < n; j++)
				if (p[j][j] >= p[j][i])
					atack[i].set(j);
		for (i = 0; i < n; i++)
			if (check(i))
				ans.emplace_back(i + 1);
	}
	cout << ans.size() << '\n';
	for (int j : ans)
		cout << j << ' ';
}