#define _CRT_SECURE_NO_WARNINGS
#include <iostream>
#include <algorithm>
#include <vector>
//#include "Source.h"

using namespace std;

typedef long long ll;

const int MSIZE = 3e5;
const ll INF = 2e9;

vector<int> v;

int make_rev(int start, int pos, int val) {
	vector<int> temp;
	for (int j = start + 1; j <= pos; j += 2)
		temp.push_back(v[j]);
	for (int j = start; j < pos; j += 2)
		temp.push_back(v[j]);
	for (int j = 0; j < temp.size(); ++j) {
		v[start + j] = temp[j];
		if (temp[j] == val)
			pos = start + j;
	}
	return pos;
}

void solve() {
	int n;
	cin >> n;
	v.resize(n);
	for (int i = 0; i < n; ++i)
		cin >> v[i];
	vector<pair<int, int>  > output;
	if (n != 1) {
		output.push_back({ 0, n - 1 });
		output.push_back({ 0, n / 2 });
		output.push_back({ n / 2 - 1, n - 1 });
		make_rev(0, n - 1, 0);
		make_rev(0, n / 2, 0);
		make_rev(n / 2 - 1, n - 1, 0);
	}
	for (int i = 0; i < n - 1; ++i) {
		int pos;
		for (pos = i; pos < n; ++pos)
			if (v[pos] == i + 1)
				break;
		while (pos != i) {
			int len = pos - i;
			int start;
			if (len % 2 == 0)
				output.push_back({ i + 1, pos }), start = i + 1;
			else
				output.push_back({ i, pos }), start = i;
			pos = make_rev(start, pos, i + 1);
		}
	}
	cout << output.size() << '\n';
	for (int i = 0; i < output.size(); ++i)
		cout << output[i].first + 1 << " " << output[i].second + 1 << '\n';
}

int main() {
	ios_base::sync_with_stdio(0);
	cin.tie(0);
	cout.tie(0);

#ifdef Sam
	freopen("input.in", "r", stdin);
	freopen("output.out", "w", stdout);
#endif 
	solve();

	return 0;
}
