#define _CRT_SECURE_NO_WARNINGS
#include <iostream>
#include <algorithm>
#include <vector>
#include <set>
#include <map>
#include <unordered_map>
#include <string>

//#include "Source.h"

using namespace std;

typedef long long ll;

const int MSIZE = 600000;
const ll INF = 2e9;

void solve() {
	int n;
	cin >> n;
	vector<string> v(n);
	for (int i = 0; i < n; ++i)
		cin >> v[i];
	set<int> st;
	sort(v.begin(), v.end());
	for (int i = 0; i < MSIZE + 1; ++i)
		st.insert(i);
	vector<int> output(MSIZE + 1);
	for (int i = 0; i < v.size(); ++i) {
		auto it = st.lower_bound(v[i].length() - 1);
		output[*it] = 1;
		st.erase(it);
	}
	while (output.back() == 0)
		output.pop_back();
	reverse(output.begin(), output.end());
	for (int i = 0; i < output.size(); ++i)
		cout << output[i];
}

int main() {
	ios_base::sync_with_stdio(0);
	cin.tie(0);
	cout.tie(0);
#ifdef Sam
	freopen("input.in", "r", stdin);
	freopen("output.out", "w", stdout);
#endif 
	solve();
	return 0;
}
