#include <iostream>
#include <algorithm>
#include <vector>

using namespace std;

const int MX = 501;
vector <int> g[MX];
int used[MX];

void dfs(int v)
{
    used[v] = 1;
    for (int u : g[v])
        if (!used[u]) dfs(u);
}

int main()
{
    int n;
    cin >> n;
    int a[n][n];
    for (int i = 0; i < n; i++)
        for (int j = 0; j < n; j++) cin >> a[i][j];
        
    int p;
    cin >> p;
    if (p == 1)
    {
        vector <int> ans;
        for (int i = 0; i < n; i++)
            if (a[i][0] == i+1) ans.push_back(i+1);
            
        cout << ans.size() << "\n";
        for (int i = 0; i < (int)ans.size(); i++) cout << ans[i] << " ";
        cout << "\n";
        return 0;
    }
    
    
    for (int i = 0; i < n; i++)
    {
        int t = 0;
        while (t < n && a[i][t] != i+1) 
        {
            g[i].push_back(a[i][t]-1);
            t++;
        }
    }
    
    vector <int> ans;
    
    for (int i = 0; i < n; i++)
    {
        //cout << i << "\n";
        for (int j = 0; j < n; j++)
        {
            int ti = 0, tj = 0;
            while (ti < n && a[j][ti] != i+1) ti++;
            while (tj < n && a[j][tj] != j+1) tj++;
            if (tj < ti) continue;
            for (int k = 0; k < n; k++) used[k] = 1;
            for (int k = 0; k < ti; k++) used[a[j][k]-1] = 0;
            
            int fl = 1;
            for (int k = 0; k < ti; k++)
            {
                int t = 0, ff = 0, col = a[j][k]-1;
                while (t < n && a[col][t] != col+1)
                {
                    ff += used[a[col][t]-1];
                    t++;
                }
                if (ff == 0) fl = 0;
            }
                
            if (fl) 
            {
                ans.push_back(i+1);
                break;
            }
        }
    }
    
    cout << ans.size() << "\n";
    for (int i = 0; i < (int)ans.size(); i++) cout << ans[i] << " ";
    cout << "\n";
        
    return 0;
}