#include <stdio.h>
#include <iostream>
#include <vector>
#include <algorithm>
#include <math.h>
#include <iterator>
#include <map>
#include <stack>

using namespace std;

#define lli long long int
#define pb push_back
#define mp make_pair
vector<pair<int, int>> tre;
vector<int> a;

void build(int v, int gl, int gr)
{
	if (gl == gr)
	{
		tre[v].first = a[gl];
		tre[v].second = gl;
	}
	else {
		int m = (gl + gr) / 2;
		build(2 * v, gl, m);
		build(2 * v + 1, m + 1, gr);
		if (tre[2 * v + 1].first >= tre[2 * v].first)
		{
			tre[v] = tre[2 * v + 1];
		}
		else
			tre[v] = tre[2 * v];
	}
}

pair<int, int> get_m(int v, int gl, int gr, int l, int r)
{
	if (l > r) return mp(0, 0);
	if (gl == l && gr == r) return tre[v];
	int m = (gr + gl) / 2;
	pair<int, int> x = get_m(2 * v, gl, m, l, min(r, m));
	pair<int, int> y = get_m(2 * v + 1, m + 1, gr, max(m + 1, l), r);
	if (y.first >= x.first) return y;
	else return x;
}

int main() {
	ios_base::sync_with_stdio(false);
	cin.tie(nullptr);
	int n;
	cin >> n;
	a.resize(n);
	tre.resize(4 * n + 1);
	for (int i = 0; i < n; i++)
		cin >> a[i];
	build(1, 0, n - 1);
	stack<int> s;
	vector<int> ma(n);
	s.push(0);
	for (int i = 1; i < n; i++)
	{
		while (!s.empty() && a[i] < a[s.top()])
		{
			ma[s.top()] = i - 1;
			s.pop();
		}
		s.push(i);
	}
	while (!s.empty())
	{
		ma[s.top()] = n - 1;
		s.pop();
	}
	int k = 1;
	int r = get_m(1, 0, n - 1, 0, ma[0]).second;
	while (r != n - 1)
	{
		k++;
		r = get_m(1, 0, n - 1, r + 1, ma[r + 1]).second;
	}
	cout << k;
	//system("pause");
	return 0;
}