import java.io.BufferedReader;
import java.io.IOException;
import java.io.InputStreamReader;
import java.util.ArrayList;
import java.util.HashSet;
import java.util.StringTokenizer;

public class B {
    public static void main(String[] args) throws IOException {
        BufferedReader b = new BufferedReader(new InputStreamReader(System.in));
        StringTokenizer s = new StringTokenizer(b.readLine());
        int n = Integer.parseInt(s.nextToken());
        int[][] all = new int[n][n];
        for (int i = 0; i < n; i++) {
            s = new StringTokenizer(b.readLine());
            for (int j = 0; j < n; j++) {
                all[i][j] = Integer.parseInt(s.nextToken());
            }
        }
        s = new StringTokenizer(b.readLine());
        int p = Integer.parseInt(s.nextToken());
        if (p == 1) {
            ArrayList<Integer> res = new ArrayList<>();
            for (int i = 0; i < n; i++) {
                if (all[i][0] == (i + 1)) {
                    res.add(i);
                }
            }
            System.out.println(res.size());
            for (int i = 0; i < res.size(); i++) {
                System.out.print((res.get(i) + 1) + " ");
            }
        } else {
            ArrayList<Integer> res = new ArrayList<>();
            boolean[] stable = new boolean[n];
            for (int i = 0; i < n; i++) {
                if (all[i][0] == (i + 1)) {
                    stable[i] = true;
                }
            }
            HashSet<Integer> in;
            for (int i = 0; i < n; i++) {
                if (stable[i]) {
                    res.add(i);
                } else {
                    in = new HashSet<>();
                    boolean stableUpper = false;
                    int j = 0;
                    while (all[i][j] != (i + 1)) {
                        if (stable[all[i][j]]) {
                            stableUpper = true;
                        }
                        in.add(j);
                        j++;
                    }
                    if (!stableUpper) {
                        j = 0;
                        while (all[i][j] != (i + 1)) {
                            int k = 0;
                            while (all[j][k] != (j + 1)) {
                                if (in.contains(all[i][k])) {
                                    k++;
                                    continue;
                                } else {
                                    break;
                                }
                            }
                            if (all[j][k] == (j + 1)) {
                                j = -1;
                                break;
                            }
                            j++;
                        }
                        if (j != -1) {
                            res.add(i);
                        }
                    }
                }
            }
            System.out.println(res.size());
            for (int i = 0; i < res.size(); i++) {
                System.out.print((res.get(i) + 1) + " ");
            }
        }
    }
}