import java.io.BufferedReader;
import java.io.IOException;
import java.io.InputStreamReader;
import java.util.ArrayList;
import java.util.Collections;
import java.util.HashSet;
import java.util.StringTokenizer;

public class B {
    public static void main(String[] args) throws IOException {
        BufferedReader b = new BufferedReader(new InputStreamReader(System.in));
        StringTokenizer s = new StringTokenizer(b.readLine());
        int n = Integer.parseInt(s.nextToken());
        int[][] all = new int[n][n];
        for (int i = 0; i < n; i++) {
            s = new StringTokenizer(b.readLine());
            for (int j = 0; j < n; j++) {
                all[i][j] = Integer.parseInt(s.nextToken());
            }
        }
        s = new StringTokenizer(b.readLine());
        int p = Integer.parseInt(s.nextToken());
        if (p == 1) {
            ArrayList<Integer> res = new ArrayList<>();
            for (int i = 0; i < n; i++) {
                if (all[i][0] == (i + 1)) {
                    res.add(i);
                }
            }
            System.out.println(res.size());
            for (int i = 0; i < res.size(); i++) {
                System.out.print((res.get(i) + 1) + " ");
            }
        } else {
            ArrayList<Integer> res = new ArrayList<>();
            boolean[] stable = new boolean[n];
            for (int i = 0; i < n; i++) {
                if (all[i][0] == (i + 1)) {
                    stable[i] = true;
                }
            }
            HashSet<Integer> in;
            boolean[] wasAdd = new boolean[n];
            for (int i = 0; i < n; i++) {
                for (int yy = 0; yy < n; yy++) {
                    if (wasAdd[yy]) {
                        continue;
                    }
                    if (stable[yy]) {
                        res.add(yy);
                        wasAdd[yy] = true;
                    } else {
                        in = new HashSet<>();
                        boolean stableUpper = false;
                        int j = 0;
                        while (all[i][j] != (yy + 1)) {
                            if (stable[all[i][j] - 1] || all[i][j] == i) {
                                stableUpper = true;
                            }
                            in.add(all[i][j]);
                            j++;
                        }
                        if (!stableUpper) {
                            j = 0;
                            while (all[i][j] != (yy + 1)) {
                                int k = 0;
                                while (all[j][k] != (j + 1)) {
                                    if (in.contains(all[i][k])) {
                                        k++;
                                        continue;
                                    } else {
                                        break;
                                    }
                                }
                                if (all[j][k] == (j + 1)) {
                                    j = -1;
                                    break;
                                }
                                j++;
                            }
                            if (j != -1) {
                                res.add(yy);
                                wasAdd[yy] = true;
                            }
                        }
                    }
                }
            }
            System.out.println(res.size());
            Collections.sort(res);
            for (int i = 0; i < res.size(); i++) {
                System.out.print((res.get(i) + 1) + " ");
            }
        }
    }
}