import java.io.BufferedReader;
import java.io.IOException;
import java.io.InputStreamReader;
import java.io.PrintWriter;
import java.util.*;

public class C {
    public static void main(String[] args) throws IOException {
        BufferedReader b = new BufferedReader(new InputStreamReader(System.in));
        StringTokenizer st = new StringTokenizer(b.readLine());
        int n = Integer.parseInt(st.nextToken());
        int p = Integer.parseInt(st.nextToken());
        int[] all = new int[n];
        st = new StringTokenizer(b.readLine());
        for (int i = 0; i < n; i++) {
            all[i] = Integer.parseInt(st.nextToken());
        }
        int[] ans = new int[n];
        if (p == 1) {
            ArrayList<Integer> prev = new ArrayList<>(n);
            for (int i = 0; i < n; i++) {
                int a = Collections.binarySearch(prev, all[i] + n - i);
                if (a >= 0) {
                    while (a > -1 && all[i] + n - i == prev.get(a)) {
                        a--;
                    }
                    a++;
                } else {
                    a++;
                    a = -a;
                }
                prev.add(a, all[i] + n - i);
                ans[i] = a + 1;
            }
            prev = new ArrayList<>(n);
            for (int i = n - 1; i > -1; i--) {
                int a = Collections.binarySearch(prev, all[i] + i);
                if (a >= 0) {
                    while (a > -1 && all[i] + i == prev.get(a)) {
                        a--;
                    }
                    a++;
                } else {
                    a++;
                    a = -a;
                }
                prev.add(a, all[i] + i);
                ans[i] += a;
            }
        } else {
            for (int i = 0; i < n / 2; i++) {
                int count = 1;
                for (int j = n - 1; j > -1; j--) {
                    if (all[j] + n - j < all[i] + n - i) {
                        count++;
                    }
                }
                int count2 = 1;
                for (int j = 0; j < n; j++) {
                    if (all[j] + Math.max(i - Math.abs(i - j), 0) < all[i] + i) {
                        count2++;
                    }
                }
                ans[i] = Math.max(count, count2);
            }
            for (int i = n / 2; i < n; i++) {
                int count = 1;
                for (int j = 0; j < n; j++) {
                    if (all[j] + j < all[i] + i) {
                        count++;
                    }
                }
                int count2 = 1;
                for (int j = 0; j < n; j++) {
                    if (all[j] + Math.max(n - i - 1 - Math.abs(i - j), 0) < all[i] + n - i - 1) {
                        count2++;
                    }
                }
                ans[i] = Math.max(count, count2);
            }
        }
        StringBuilder sb = new StringBuilder(ans[0] + " ");
        for (int i = 1; i < n; i++) {
            sb.append(ans[i] + " ");
        }
        System.out.println(sb);
    }
}