#include <iostream>
#include <vector>
#include <algorithm>
#include <cstdio>

using namespace std;

long long icnt(vector<pair<long long, long long> > &b, long long c1, long long c2)
{
	long long res = 0;
	for (long long i = 0; i < b.size(); i++)
	{
		if (b[i].first >= c1)
			res += c1;
		else if (b[i].second >= c2)
			res += c2;
	}
	return res;
}

long long tse2(long long c2, vector<pair<long long, long long> > &b)
{
	long long rc = icnt(b, 1e12 + 7, c2);
	long long n = b.size();
	long long l = 0;
	while (b[l].first < c2)
		l++;
	long long r = b.size() - 1;
	while (r - l > 2)
	{
		long long m1 = (r - l) / 3 + l, m2 = r - (r - l) / 3;
		long long r1 = icnt(b, b[m1].first, c2), r2 = icnt(b, b[m2].first, c2);
		if (r1 < r2)
		{
			l = m1;
		}
		else
		{
			r = m2;
		}
	}
	return max(icnt(b, b[l].first, c2), max(icnt(b, b[r].first, c2), icnt(b, b[(r - l) / 2 + l].first, c2)));
}

long long tse1(vector <pair<long long, long long> > &b)
{
	long long maxel = 0;
	for (long long i = 0; i < b.size(); i++)
	{
		maxel = max(maxel, tse2(b[i].second, b));
	}
	return maxel;
}

void bgen(vector<pair<long long, long long> > &b)
{
	for (long long i = 0; i < b.size(); i++)
	{
		b[i].second = rand() % 50;
		b[i].first = rand() % 50 + b[i].second;
	}
}

long long ch(vector<pair<long long, long long> > &b)
{
	long long maxv = 0;
	for (long long i = 0; i <= 100; i++)
	{
		for (long long j = 0; j <= i; j++)
		{
			maxv = max(maxv, icnt(b, i, j));
		}
	}
	return maxv;
}


int main()
{
	//while (true)
	//{
		long long n = rand() % 5 + 1;
		cin >> n;
		vector<pair<long long, long long> > b(n);
		//bgen(b);
		for (long long i = 0; i < n; i++)
		{
			cin >> b[i].first >> b[i].second;
		}
		sort(b.begin(), b.end());
		cout << ch(b);
		/*if (tse1(b) != ch(b))
		{
			cout << "WRONG: " << endl;
			cout << tse1(b) << " " << ch(b) << endl;
			cout << n << endl;
			for (long long i = 0; i < n; i++)
			{
				cout << b[i].first << " " << b[i].second << endl;
			}
			cout << endl;
		}
		*/
	//}
	cin >> n;
    return 0;
}

