#include <bits/stdc++.h>
using namespace std;

using ll = long long;
using ld = long double;
using pii = pair<int, int>;
using pll = pair<ll, ll>;

#define all(x) (x).begin(), (x).end()
#define rep(i, n) for (int (i) = 0; (i) < (n); ++(i))

const int MAXN = 200005;

int n, m, q;
vector<vector<int>> a;
vector<vector<bool>> v;
int mx1[MAXN];
int mx2[MAXN];
int res = 0;

void t_erase(int x, int y) {
	if (mx1[x] == y && mx2[y] == x && v[x][y]) {
		res--;
		v[x][y] = false;
	}
}

void t_add(int x, int y) {
	if (mx1[x] == y && mx2[y] == x && !v[x][y]) {
		res++;
		v[x][y] = true;
	}
}

int main() {
	ios_base::sync_with_stdio(false);
	cin.tie(0);
	cin >> n >> m >> q;
	a.assign(n, vector<int>(m));
	v.assign(n, vector<bool>(m));
	rep(i, n) {
		rep(j, m) {
			cin >> a[i][j];
		}
	}

	rep(i, n) {
		int mx = 0;
		rep(j, m) {
			if (a[i][j] > a[i][mx]) {
				mx = j;
			}
		}
		mx1[i] = mx;
	}

	rep(j, m) {
		int mx = 0;
		rep(i, n) {
			if (a[i][j] > a[mx][j]) {
				mx = i;
			}
		}
		mx2[j] = mx;
	}

	rep(i, n) {
		if (mx2[mx1[i]] == i) {
			res++;
			v[i][mx1[i]] = true;
		}
	}

	rep(i, q) {
		int x, y, val;
		cin >> x >> y >> val;
		x--;
		y--;
		if (val > a[x][mx1[x]]) {
			t_erase(x, mx1[x]);
			mx1[x] = y;
		}
		if (val > a[mx2[y]][y]) {
			t_erase(mx2[y], y);
			mx2[y] = x;
		}
		a[x][y] = val;
		t_add(x, y);
		cout << res << '\n';
	}
}