#include <bits/stdc++.h>
using namespace std;

using ll = long long;
using ld = long double;
using pii = pair<int, int>;
using pll = pair<ll, ll>;

#define rep(i, n) for (int (i) = 0; (i) < (n); ++(i))
#define f first
#define s second
#define all(x) (x).begin(), (x).end()

#define int long long

const int MAXN = 10000;
int n, p;
int a[MAXN];
int worst[MAXN];

void relax(int pos, int p1, int p2) {
	int base = min(abs(p1 - pos), abs(p2 - pos)) + a[pos];
	int cnt = 0;
	for (int i = 0; i < n; ++i) {
		int t;
		if (i <= p1) {
			t = a[i];
		} else if (i >= p2) {
			t = a[i];
		} else {
			t = min(abs(p1 - i), abs(p2 - i)) + a[i];
		}
		if (t < base) {
			cnt++;
		}
	}
	worst[pos] = max(worst[pos], cnt + 1);
}

signed main() {
	cin >> n >> p;
	rep(i, n) {
		cin >> a[i];
	}

	for (int pos = 0; pos < n; ++pos) {
	// int pos = 3;
		relax(pos, 0, INT_MAX);
		relax(pos, INT_MIN, n - 1);
		// if (pos + pos < n) relax(pos, 0, pos + pos);
		// if (pos + pos - (n - 1) >= 0) relax(pos, pos + pos - (n - 1), n - 1);
	}

	rep(i, n) {
		cout << worst[i] << '\n';
	}
}